#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MMAX 2008

#define isAdjacent(x, y) (((c[x][0] == c[y][0]) || (c[x][0] == c[y][1]) || (c[x][1] == c[y][0]) || (c[x][1] == c[y][1])) ? 1 : 0)
#define isEqual(x, y) ((c[x][0] == c[y][0] && c[x][1] == c[y][1]) || (c[x][0] == c[y][1] && c[x][1] == c[y][0]))

char A[MMAX][MMAX], viz[MMAX];
int c[MMAX][2];
int i, j, k, N, M, MM;

void nosol(void)
{
	fprintf(stderr, "no solution\n");

	printf("-1\n");
	exit(0);
}

int processEdges(int idx, int nnodes)
{
	int m1, m2, m3, ii, jj, ok;

	if (idx > M)
		return nnodes;

	for (m1 = 1; m1 < idx; m1++)
		if (A[m1][idx])
			break;

	if (m1 >= idx)
	{
		//fprintf(stderr, "edge %d/%d not adjacent to any previous edge!\n", idx, M);
		
		c[idx][0] = nnodes + 1;
		c[idx][1] = nnodes + 2;

		return processEdges(idx + 1, nnodes + 2);
	}

	for (ii = 0; ii < 2; ii++)
	{
		c[idx][0] = c[m1][ii];

		// try to fix the second endpoint

		c[idx][1] = -1;
		ok = 1;

		for (m2 = 0; m2 < idx; m2++)
			if (m2 != m1 && !A[m2][idx] && isAdjacent(m2, idx))
			{
				ok = 0;
				break;
			}

		if (!ok)
			continue;

		// let the second endpoint loose (equal to nnodes + 1)
		c[idx][1] = nnodes + 1;

		for (m2 = 0; m2 < idx; m2++)
			if (A[m2][idx] != isAdjacent(m2, idx))
			{
				ok = 0;
				break;
			}

		if (ok)
		{
			ok = processEdges(idx + 1, nnodes + 1);

			if (ok > 0)
				return ok;

			//fprintf(stderr, "unsuccessful attempt at %d/%d\n", idx, M);
		}

		// the second endpoint must be one of the endpoints already selected

		for (m2 = 0; m2 < idx; m2++)
			if (m2 != m1 && A[m2][idx] && !isAdjacent(m2, idx))
				break;

		if (m2 >= idx)
		{
			//fprintf(stderr, "could not find an unsatisfied adjacent edge for %d/%d!\n", idx, M);
			continue;
		}

		for (jj = 0; jj < 2; jj++)
			if (c[m2][jj] != c[idx][0])
			{
				c[idx][1] = c[m2][jj];

				ok = 1;

				for (m3 = 0; m3 < idx; m3++)
					if ((A[m3][idx] != isAdjacent(m3, idx)) || isEqual(m3, idx))
					{
						ok = 0;
						break;
					}

				if (!ok)
					continue;

				ok = processEdges(idx + 1, nnodes);

				if (ok > 0)
					return ok;

				//fprintf(stderr, "unsuccessful attempt at %d/%d\n", idx, M);
			}
	}

	return 0;
}

int main()
{
	freopen("promo.in", "r", stdin);
	freopen("promo.out", "w", stdout);

	scanf("%d %d", &M, &MM);

	memset(A, 0, sizeof(A));

	for (k = 1; k <= MM; k++)
	{
		scanf("%d %d", &i, &j);
		A[i][j] = A[j][i] = 1;
	}

	memset(c, 0, sizeof(c));
	memset(viz, 0, sizeof(viz));

	c[1][0] = 1;
	c[1][1] = 2;

	N = processEdges(2, 2);

	if (N <= 0)
		nosol();

	printf("%d\n", N);

	for (k = 1; k <= M; k++)
		printf("%d %d\n", c[k][0], c[k][1]);

	return 0;
}
