#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MMAX 2008

#define isAdjacent(x, y) (((c[x][0] == c[y][0]) || (c[x][0] == c[y][1]) || (c[x][1] == c[y][0]) || (c[x][1] == c[y][1])) ? 1 : 0)
#define isEqual(x, y) ((c[x][0] == c[y][0] && c[x][1] == c[y][1]) || (c[x][0] == c[y][1] && c[x][1] == c[y][0]))

char A[MMAX][MMAX], viz[MMAX];
int c[MMAX][2];
int i, j, k, N, M, MM;

void nosol(void)
{
	fprintf(stderr, "no solution\n");

	printf("-1\n");
	exit(0);
}

int processEdges(int idx, int nnodes)
{
	int p1, p2, m, ok;

	if (idx > M)
		return nnodes;

	ok = 1;

	for (m = 1; m < idx; m++)
		if (A[m][idx])
		{
			ok = 0;
			break;
		}

	if (ok)
	{
		c[idx][0] = nnodes + 1;
		c[idx][1] = nnodes + 2;
		return processEdges(idx + 1, nnodes + 2);
	}

	for (p1 = 1; p1 <= nnodes; p1++)
		for (p2 = p1 + 1; p2 <= nnodes + 1; p2++)
		{
			c[idx][0] = p1;
			c[idx][1] = p2;

			ok = 1;

			for (m = 0; m < idx; m++)
				if ((A[m][idx] != isAdjacent(m, idx)) || isEqual(m, idx))
				{
					ok = 0;
					break;
				}

			if (ok)
			{
				if (p2 > nnodes)
					ok = processEdges(idx + 1, nnodes + 1);
				else
					ok = processEdges(idx + 1, nnodes);

				if (ok)
					return ok;
			}
		}

	return 0;
}

int main()
{
	freopen("promo.in", "r", stdin);
	freopen("promo.out", "w", stdout);

	scanf("%d %d", &M, &MM);

	memset(A, 0, sizeof(A));

	for (k = 1; k <= MM; k++)
	{
		scanf("%d %d", &i, &j);
		A[i][j] = A[j][i] = 1;
	}

	memset(c, 0, sizeof(c));
	memset(viz, 0, sizeof(viz));

	c[1][0] = 1;
	c[1][1] = 2;

	N = processEdges(2, 2);

	if (N <= 0)
		nosol();

	printf("%d\n", N);

	for (k = 1; k <= M; k++)
		printf("%d %d\n", c[k][0], c[k][1]);

	return 0;
}
