#include <stdio.h>

#define Cdim 1025
#define Hdim 2000001
#define Ldim 1000001

int C[Cdim], Hmin[Hdim]; char Use[Hdim];

long Position[Hdim], Inter[Ldim], st[Ldim], c[Ldim];

long N, L, Min, Cm, Pos, x, d, dc;

void get_data();
void solve();
void print();

void updateM(long n, long st, long dr, int value, long poz);
void updateU(long n, long st, long dr, long poz, int value);

long deep(long);

int askU(long n, long st, long dr, long a, long b);
int askM(long n, long st, long dr, long a, long b);

int main()
{
    get_data();
    solve();
    print();

    return 0;
}

void get_data()
{
    freopen("cover.in", "r", stdin);

    scanf("%ld %ld", &N, &L);

    long i, a, b;

    for(i=1; i<=2000000; ++i)
		Hmin[i] = 1025;

    for(i=1; i<=L; ++i)
    {
        scanf("%d", C+i);
        updateM(1, 1, L, C[i], i);
        Inter[i] = -1;
    }

	for(i=1; i<=N; ++i)
    {
        scanf("%ld %ld", &a, &b);

        if(b > Inter[a])
            Inter[a] = b;
    }

    fclose(stdin);
}

long deep(long i)
{
	if(Inter[i] == -1)
		x = i;
    else if(Inter[i] != i)
	{
		deep(Inter[i]);
        st[++d] = i;
	}
}

void solve()
{
    long i, j, Candidate, Cost;

    for(i=1; i<=L; ++i)
		if(Inter[i] != -1 && Inter[i] != i)
		{
            d = Candidate = Cost = dc = 0;
			deep(i);

            if(d > 1)
            {
			Min = 1025;
			askM(1, 1, L, st[d], Inter[st[d]]);
            Cost += Min;
            c[++dc] = Pos;
			updateU(1, 1, L, Pos, 1);

			for(j=d-1; j; --j)
			{
				Candidate += C[st[j]];
				Min = 1025;
				askM(1, 1, L, st[j], Inter[st[j]]);
                Cost += Min;
                updateU(1, 1, L, Pos, 1);
				c[++dc] = Pos;
			}

			if(Cost < Candidate)
			{
				Cm += Cost;
				for(j=d; j; --j)
					Inter[st[j]] =  -1;
			}
			else
			{
				Cm += Candidate;
				Inter[i] = x;

				for(j=1; j<=dc; ++j)
					updateU(1, 1, L, c[j], 0);

				for(j=d; j; --j)
					Inter[st[j]] =  -1;
			}
            }
		}

	for(i=1; i<=L; ++i)
	{
		if(Inter[i] != -1 && !askU(1, 1, L, i, Inter[i]))
		{
			Min = 1025;
			askM(1, 1, L, i, Inter[i]);
			Cm += Min;
            updateU(1, 1, L, Pos, 1);
        }
    }
}

void updateM(long n, long st, long dr, int value, long poz)
{
	if(st == dr)
	{
		if(poz == st && value < Hmin[n])
		{
			Hmin[n] = value;
			Position[n] = poz;
		}

		return;
	}

	if(poz >= st && poz <= dr)
	{
		if(value < Hmin[n])
		{
			Hmin[n] = value;
            Position[n] = poz;
        }
    }

    long m = (st + dr) >> 1;

    if(poz <= m)
        updateM(n<<1, st, m, value, poz);
    if(poz > m)
        updateM((n<<1)+1, m+1, dr, value, poz);
}

int askU(long n, long st, long dr, long a, long b)
{
    if(st >= a && dr <= b)
	{
		if(Use[n]) return 1;
		else return 0;
	}
    else
    {
        long m = (st + dr) >> 1, t = 0;

        if(a <= m)
            t += askU(n<<1, st, m, a, b);
        if(b > m)
            t += askU((n<<1)+1, m+1, dr, a, b);

        return t;
	}
}

void updateU(long n, long st, long dr, long poz, int value)
{
	if(st == dr)
	{
		if(poz >= st && poz <= dr)
			Use[n] = value;

		return;
	}

    if(poz >= st && poz <= dr)
        Use[n] = value;

    long m = (st + dr) >> 1;

    if(poz <= m)
		updateU(n<<1, st, m, poz, value);
	if(poz > m)
		updateU((n<<1)+1, m+1, dr, poz, value);
}

int askM(long n, long st, long dr, long a, long b)
{
	if(st >= a && dr <= b)
	{
		if(Hmin[n] < Min)
		{
        	Pos = Position[n];
			Min = Hmin[n];
			return Hmin[n];
		}
	}
	else
	{
		long m = (st + dr) >> 1, t;

		if(a <= m)
		{
			t = askM(n<<1, st, m, a, b);

			if(t < Min)
				Min = t;
		}

		if(b > m)
		{
			t = askM((n<<1)+1, m+1, dr, a, b);

			if(t < Min)
				Min = t;
		}

		return t;
    }
}

void print()
{
    freopen("cover.out", "w", stdout);

    printf("%ld", Cm);

    fclose(stdout);
}

