#include <stdio.h>
#include <string.h>

#define Pdim 501
#define Wdim 21
#define NWdim 101

#define inf 0x3f3f3f3f3f

char P[Pdim], P1[NWdim][Wdim];

int N, M, N1;
int Cm[Pdim][NWdim], Op[Pdim][NWdim], Len[NWdim], A[Pdim];

void get_data();
void init();
void dynamics();
void print();

int eval(int n, int ls, int ld);
int oper(int ls, int ld);

int main()
{
	get_data();
	init();
	dynamics();
	print();

    return 0;
}

void get_data()
{
    freopen("dist.in", "r", stdin);

    gets(P);

    char *p = strtok(P, " ");

	while(p != NULL)
    {
        ++ N;
        strcpy(P1[N], p);
        p = strtok(NULL, " ");
    }

    gets(P);

	int i, last = -1;
	N1 = 1;

	for(i=0; i<strlen(P); ++i)
	{
		if(P[i] == ' ')
		{
			strcpy(P+i, P+i+1);
			-- i;

			if(last != i)
			{
				Len[N1] = i - last;
				++ N1;
				last = i;
			}
		}
		else
			A[i+1] = N1;
	}
               
	Len[N1] = strlen(P) - 1 - last;

	M = strlen(P);

    fclose(stdin);
}

void init()
{
    int i, j;

    for(i=0; i<strlen(P); ++i)
		for(j=1; j<=N; ++j)
			Cm[i+1][j] = inf;
}

void dynamics()
{
	int i, j, k, ii, lj, lk, c;

	for(ii=0; ii<strlen(P); ++ii)
	{
		i = ii + 1;
		lj = i < N ? i : N;

		if(i <= 20)
        {
			Cm[i][1] = eval(1, 0, ii);
            Op[i][1] = Len[1] > i ? Len[1] - i : i - Len[1];
        }

		for(j=2; j<=lj; ++j)
		{
			lk = 0 > i-20 ? 0 : i-20;
			lk = lk > j-1 ? lk : j-1;

			for(k=ii; k>=lk; --k)
			{
				c = eval(j, ii-k+1, ii);

				if(Cm[i][j] > Cm[i-k][j-1] + c)
				{
					Cm[i][j] = Cm[i-k][j-1] + c;
					Op[i][j] = Op[i-k][j-1] + oper(ii-k+1, ii);
				}
                else if(Cm[i][j] == Cm[i-k][j-1] + c && Op[i][j] > Op[i-k][j-1] + oper(ii-k+1, ii))
                {
                    Op[i][j] = Op[i-k][j-1] + oper(ii-k+1, ii);
                }
			}
		}
	}
}

void print()
{
	freopen("dist.out", "w", stdout);

	printf("%d %d", Cm[M][N], Op[M][N]);

	fclose(stdout);
}

int eval(int n, int ls, int ld)
{
    char Q1[Pdim], Q2[Pdim];

    strcpy(Q1, P1[n]);
    strcpy(Q2, P+ls);

	Q2[ld-ls+1] = '\0';

    int i, ret = 0, x;

    if(strlen(Q1) < strlen(Q2))
    {
        for(i=strlen(Q1); i<strlen(Q2); ++i)
			Q1[i] = '@';
		Q1[strlen(Q2)] = '\0';
	}
	else
	{
		for(i=strlen(Q2); i<strlen(Q1); ++i)
			Q2[i] = '@';
		Q2[strlen(Q1)] = '\0';
	}

    for(i=0; i<strlen(Q1); ++i)
    {
        x = Q1[i] > Q2[i] ? Q1[i] - Q2[i] : Q2[i] - Q1[i];
        ret += x;
    }

    return ret;
}

int oper(int ls, int ld)
{
	int x1 = Len[A[ls]] - ls;
	int x2 = ld - ls + 1;

	int ret = x1 > x2 ? x1 - x2 : x2 - x1;

	return ret;
}

