#include <stdio.h>
#include <string.h>

#define NMAX 510
#define INF 1000000000

char s1[NMAX];
char s2[NMAX];

char s[NMAX];

int q;
char cuv[NMAX][NMAX];

int ant[NMAX];
int cur[NMAX];

inline int MIN(int a, int b) { return (a < b) ? a : b; }
inline int MAX(int a, int b) { return (a > b) ? a : b; }
inline int ABS(int x) { return (x < 0) ? -x : x; }

inline int calc_cost(int x, int y, int cv)
{
	int i, j, cst = 0;

	for (i = x, j = 0; i <= y || cuv[cv][j]; i++, j++) 
		cst += ABS( ((i <= y) ? s[i] : 64) - ( (cuv[cv][j]) ? cuv[cv][j] : 64) );

	return cst;
}

inline int calc_rest(int x)
{
	int i, j, cst = 0;

	for (i = x; i <= q; i++) {
		for (j = 0; cuv[i][j]; j++)
			cst += ABS(64 - ( (cuv[i][j]) ? cuv[i][j] : 64) );

	}

	return cst;
}

int main()
{
	int i, j, w, k;
	
	freopen("dist.in", "r", stdin);
	freopen("dist.out", "w", stdout);

	fgets(s1, 510, stdin);
	fgets(s2, 510, stdin);

	q = 0;
	
	for (i = 0; s1[i]; ) {
		if (!('A' <= s1[i] && s1[i] <= 'Z')) { i++; continue; }

		q++;
		for (j = i, w = 0; 'A' <= s1[j] && s1[j] <= 'Z'; j++)
			cuv[q][w++] = s1[j];
		cuv[q][w] = 0;

		i = j;
	}

	w = 0;
	for (i = 0; s2[i]; i++)
		if ('A' <= s2[i] && s2[i] <= 'Z') s[++w] = s2[i];

	ant[0] = 0;

	for (i = 1; i < 500; i++) ant[i] = INF;

	int cc;

	int min = INF;

	for (i = 1; i <= w; i++) {
		cur[0] = INF;
		for (j = 1; j <= w; j++) {
			cur[j] = INF;
			for (k = MAX(1, j - 20 + 1); k <= j; k++) {
				if (ant[k - 1] == INF) continue;
				cur[j] = MIN(cur[j], ant[k - 1] + calc_cost(k, j, i));
			}
		}

//		for (j = 1; j <= w; j++) printf("%d ", cur[j]);
//		printf("\n");

		cc = cur[w];
		if (i < q) cc += calc_rest(i + 1);

		if (cc < min) min = cc;

		memcpy(ant, cur, sizeof(cur));
	}

	printf("%d %d\n", min, 0);

fclose(stdin);
fclose(stdout);
return 0;
}

