#include <stdio.h>
#include <algorithm>
#include <values.h>
#include <math.h>
using std::sort;

#define FIN "puncte.in"
#define FOUT "puncte.out"
#define MAXN 100000
#define MAXM 200000
#define INF 0xffffffffffffffff

typedef unsigned long long ull;

struct punct { int x; ull y; } ;
punct A[MAXN];
int n, m;
int ord[MAXN];
ull DIST[MAXN];

inline ull sqr(int x) {
	return (ull) x * x;
}

bool comp1(const int &a, const int &b) {
	return DIST[a] < DIST[b] || DIST[a] == DIST[b] && A[a].x < A[b].x;
}

void omg_optimize()
{
	int i;
	for (i=0; i<n; ++i)
		ord[i] = i;
	for (i=0; i<n; ++i) DIST[i] = sqr(A[i].x) + A[i].y;
	sort(ord, ord+n, comp1);
}

void citire()
{
	int i, x, y;
	freopen(FIN, "r", stdin);
	freopen(FOUT,"w",stdout);
	scanf("%d %d", &n, &m);
	for (i=0; i<n; ++i) {
		scanf("%d %d", &x, &y);
		if (i && x == A[i-1].x) {
			--i, --n; continue;
		}
		A[i] = (punct) { x, y*y };
	}
}

inline int bsearch(int x, int lo, int hi)
{
	// primul elem cu x mai mic sau egal cu al punctului meu (x)
    int i, step, N = (hi-lo);
	for (step=1; step < N; step <<= 1);
	for (i=0; step; step >>= 1)
		if (lo+i+step <= hi && A[ord[i+step]].x <= x)
			i += step;
	return lo + i;
}

ull distanta(int d)
{
	int i, j;
	ull distmare = INF, k, miny = INF;
	int mij = bsearch(d, 0, n-1);
	
	miny = A[ord[mij]].y + sqr(A[ord[mij]].x-d);
	if (mij+1<n && A[ord[mij]+1].y+sqr(A[ord[mij]+1].x-d) < miny)
		miny = A[ord[mij]+1].y + sqr(A[ord[mij]+1].x-d);
	miny = (ull) ceil(sqrt((double) miny));
	
	for (i=mij; i>=0 && d-A[ord[i]].x <= miny; --i)
		if ((k=sqr(A[ord[i]].x-d) + A[ord[i]].y) < distmare )
			distmare = k;
	for (i=mij+1; i<n && A[ord[i]].x-d <= miny; ++i)
		if ((k=sqr(A[ord[i]].x-d) + A[ord[i]].y) < distmare)
			distmare = k;
	//for (i=0; i<n; ++i)
	//	if ((k=sqr(A[i].x-d) + A[i].y) < distmare) 
	//		distmare = k;

	return distmare;
}

int main()
{
	int i;
	citire();
	omg_optimize();
	while (m--) {
		scanf("%d", &i);
		//printf("%llu\n", dist(i));
		printf("%llu\n", distanta(i));
	}
	return 0;
}
