#include <cstdio>
#include <algorithm>
#include <utility>
using namespace std;

#define	FIN "cover.in"
#define FOUT "cover.out"
#define MAX 1000020
#define MAXQ 60010
#define inf 0x3f3f3f
#define __debug__ 0

inline long min(long a, long b) {
	return a<b ? a : b;
}

class arb {
	private:
		long A[4*MAX];	
		long *Base;
		long n;
		long a, b;		// flags
		void build(long r, long st, long dr) {
			if ( __debug__ )
				printf("%ld => %ld %ld\n", r,st,dr);
			if ( st==dr ) {
				A[r] = st;
				return;
			}
			if ( st>dr )
				return;
			long m = (st+dr)/2;
			build(2*r+1, st, m);
			build(2*r+2, m+1, dr);
			if ( Base[A[2*r+1]] <= Base[A[2*r+2]] )
				A[r] = A[2*r+1];
			else
				A[r] = A[2*r+2];
		}
		long ask(long r, long st, long dr) {
			if ( a<=st && dr<=b ) 
				return A[r];
			long m = (st+dr)/2;
			long f1=0,f2=0;
			if ( a<=m )
				f1 = ask(2*r+1, st, m);
			if ( m<b )
				f2 = ask(2*r+2, m+1, dr);
			if ( Base[f1] <= Base[f2] )
				return f1;
			else
				return f2;
		}
		
	public: 
		void init(long x, long *p) {
			n=x;
			Base = p;
			Base[0] = inf;
			build(0,1,n);
		}
		long query(long st, long dr) {
			a = st; b = dr;
			return ask(0,1,n);
		}
} Int;

long n,m;
long L[MAX];
pair<long,long> Q[MAXQ];
long long S;

void greedy() {
	long i,x,y;
	long prev=0, sp1, sp2, act;
	long xp=0, yp=0;
	for (i=0; i<n; ++i, prev = act, xp = x, yp = y) {
		x = Q[i].first;
		y = Q[i].second;
		act = Int.query(x,y);

		if ( i==0 ) {
			S = L[act];
		}
		else {
			if ( yp<x )
				S+=L[act];
			else {
				if ( x<=prev )
					continue;
				else {
					sp1 = S+L[act];
					
					sp2 = L[ Int.query(x,min(y,yp)) ] ;
					S = min(sp1, sp2);
				}
			}
		}
	}
}

long long SM[MAXQ];

void wtf() {

	long i,x,y;
	long prev=0, sp1, sp2, act;
	long xp=0, yp=0;
	for (i=1; i<=n; ++i, xp = x, yp = y) {
		x = Q[i].first;
		y = Q[i].second;
		act = Int.query(x,y);

		if ( i==1 ) {
			SM[i] = L[act];
			prev = act;
		}
		else {
			if ( yp<x ) {
				SM[i]=SM[i-1]+L[act];
				prev = act;
			}
			else {
				if ( x<=prev )
					SM[i] = SM[i-1];
				else {
					long p1;
					sp1 = SM[i-1]+L[act];
					sp2 = L[ p1=Int.query(x,min(y,yp)) ]+SM[i-2] ;
					if ( sp1<sp2 ) {
						SM[i] = sp1;
						prev = act;
					}
					else {
						SM[i] = sp2;
						prev = p1;
					}
				}
			}
		}
	}
	S = SM[n];
}

int main() {
	long i;

	freopen(FIN, "r", stdin);
	scanf("%ld %ld", &n, &m);
	for (i=1; i<=m; ++i)
		scanf("%ld", L+i);

	long x, y;
	for (i=1; i<=n; ++i) {
		scanf("%ld %ld", &x, &y);
		Q[i].first = x;
		Q[i].second = y;
	}
	sort(Q+1,Q+n+1);
        
	Int.init(m,L);
//	greedy();
	wtf();

	fclose(stdin);
	freopen(FOUT, "w", stdout);
	printf("%lld\n", S);
	fclose(stdout);
	return 0;
}
