#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

typedef struct punct {int x; int y;} point;

#define nm 60010
#define lm 1000010

punct s[nm];

int v[nm], viz[nm];
int ai[2*lm], pai[2*lm];
int n, l, i, sol, poz, pmin1, pmin2, pmin3, min1, min2, min3;

vector <int> V;


void read()

{
	scanf("%d %d", &n, &l);

	for (i=1; i<=l; ++i)
	{
		scanf("%d ", &v[i]);
	}

	for (i=1; i<=n; ++i)
	{
		scanf("%d %d", &s[i].x, &s[i].y);
	}
}


int cmp (punct a, punct b)

{
	if (a.x == b.x)
		return (a.y < b.y);
	return (a.x < b.x);
}


void construct(int a, int b, int p)

{
	if (a != b)
	{
        construct(a, (a+b)/2, 2*p);
		construct((a+b)/2+1, b, 2*p+1);
		ai[p] = ai[2*p];
		pai[p] = pai[2*p];

		if (ai[p] > ai[2*p+1])
		{
			ai[p] = ai[2*p+1];
			pai[p] = pai[2*p+1];
		}
	}
	else
	{
		ai[p] = v[a];
		pai[p] = a;
	}
}


int query(int a, int b, int x, int y, int p)

{
	if (a == x && b == y)
	{
		poz = pai[p];
		return ai[p];
	}
	int mid = (x + y) / 2;

	if (a > mid)
	{
		return query(a, b, mid+1, y, 2*p+1);
	}
	else
	if (b <= mid)
	{
		return query(a, b, x, mid, 2*p);
	}
	else
	{
		int X, Y, pmin1, pmin2;
		X = query(a, mid, x, mid, 2*p);
		pmin1 = poz;
		Y = query(mid+1, b, mid+1, y, 2*p+1);
		pmin2 = poz;
		if (X > Y)
		{
			poz = pmin2;
			return Y;
		}
		poz = pmin1;
		return X;
		
	}
}


void solve()

{
	sort(s + 1, s + n + 1, cmp);

	V.push_back(1);

	for (i=2; i<=n; ++i)
	{
		if (s[i].x <= s[V[V.size()-1]].y && s[i].y <= s[V[V.size()-1]].y)
		{
			V[V.size()-1] = i;
		}
		else
			V.push_back(i);
	}

	n = V.size();

	construct(1, l, 1);

	for (i=0; i<n-1; ++i)
	{
		if (s[V[i+1]].x > s[V[i]].y)
		{
			sol += query(s[V[i]].x, s[V[i]].y, 1, l, 1);
			viz[i] = 1;
		}
		else
		{
			viz[i] = 1;
			viz[i+1] = 1;
			min1 = query(s[V[i]].x, s[V[i]].y, 1, l, 1);
			pmin1 = poz;
			min2 = query(s[V[i+1]].x, s[V[i]].y, 1, l, 1);
			pmin2 = poz;
			min3 = query(s[V[i+1]].x, s[V[i+1]].y, 1, l, 1);
			pmin3 = poz;

			if (pmin1 == pmin2 == pmin3)
			{
				sol += min2;
				++i;
			}
			else
			{
				if (min1 + min3 > min2)
				{
					sol += min2;
					++i;
				}
				else
				{
					sol += min1 + min3;
					if (pmin3 >= s[V[i+2]].x && i + 2 < n)
					{
						viz[i+2] = 1;
						++i;
					}
					++i;
				}
			}
		}
	}
	if (viz[n-1] == 0)
	{
		sol += query(s[V[n-1]].x, s[V[n-1]].y, 1, l, 1);
	}
}


void write()

{
	printf("%d\n", sol);
}


int main()

{
	freopen("cover.in", "r", stdin);
	freopen("cover.out","w",stdout);

	read();
	solve();
	write();

	fclose(stdin);
	fclose(stdout);

	return 0;
}


