#include <stdio.h>
#include <stdlib.h>
#define maxim(a, b) ((a > b) ? a : b)
#define minim(a, b) ((a < b) ? a : b)
#define INF 2000000001
#define LMax 1000005
#define NMax 60005
#define AMax 2097152

typedef struct { int x, y; } interval;

int N, L;
interval v[NMax];
int M[LMax], C[LMax], A[AMax];

int cmp(const void *a, const void *b)
{
    interval *A1 = (interval *)a, *B1 = (interval *)b;

    return A1->y - B1->y;
}

void init(int nod, int l, int r)
{
    int m;
    
    if (l < r)
    {
        m = (l + r) / 2;
        init(2 * nod, l, m);
        init(2 * nod + 1, m+1, r);
    }
    A[nod] = INF;    
}

void update(int nod, int l, int r, int poz, int val)
{
    int m;

    if (l == r)
       A[nod] = val;
    else
    {
        m = (l + r) / 2;
        if (poz <= m) update(2 * nod, l, m, poz, val);
        else update(2 * nod + 1, m+1, r, poz, val);

        A[nod] = minim(A[2 * nod], A[2 * nod + 1]);
    }
    
}

int query(int nod, int l, int r, int a, int b)
{
    int m, i1, i2;

    if (a <= l && r <= b)
        return A[nod];
    else
    {    
        m = (l + r) / 2;
        i1 = i2 = INF;
        
        if (a <= m) i1 = query(2 * nod, l, m, a, b);
        if (b > m) i2 = query(2 * nod + 1, m+1, r, a, b);

        return minim(i1, i2);
    }
    
    
}

int main(void)
{
    int i, j = 0, min = 0, max = 0;
    
    freopen("cover.in", "r", stdin);
    freopen("cover.out", "w", stdout);

    scanf("%d %d", &N, &L);
    for (i = 1; i <= L; i++)
        scanf("%d", &C[i]);
    for (i = 0; i < N; i++)
        scanf("%d %d", &v[i].x, &v[i].y);

    qsort(v, N, sizeof(interval), cmp);
    for (i = N; i >= 1; i--)
        v[i].x = v[i-1].x, v[i].y = v[i-1].y;
    v[0].x = v[0].y = 0;

    init(1, 1, L);

    j = 1;
    for (i = 1; i <= L; i++)
    {
        max = -1;
        while (j <= N && v[j].y == i)
        {
            max = maxim(max, v[j].x);
            j++;
        }

        update(1, 1, L, i, M[i-1] + C[i]);
        
        if (max == -1)
            M[i] = M[i-1];
        else
            M[i] = query(1, 1, L, max, i);

    }

    printf("%d\n", M[L]);

    return 0;
}

