#include <cstdio>
#include <cstring>

class MARE {
	private:
	static const int LMAX = 10;
	static const int BAZA = 1000000000;
	int N, X[LMAX];
	public:
	MARE();
	void clear();
	void operator=(int);
	MARE operator+(MARE);
	void write(FILE*);
};

void MARE::clear(void) {
	N = 0;
	memset(X, 0x00, sizeof(X));
}

MARE::MARE(void) {
	this->clear();
}

void MARE::operator=(int k) {
	this->clear();
	X[N++] = k;
}

MARE MARE::operator+(MARE A) {
	int i, t;
	MARE R;

	for (i = 0, t = 0; i < N || i < A.N || t; ++i, t /= BAZA)
		R.X[i] = (t += X[i] + A.X[i]) % BAZA;
	
	R.N = i;

	return R;
}

void MARE::write(FILE *fout) {
	int i;

	fprintf(fout, "%d", X[N - 1]);
	for (i = N - 2; i >= 0; --i)
		fprintf(fout, "%.9d", X[i]);
}

// END OF CLASS DESCRIPTION

const int NMAX = 108;

int N;
MARE DP[NMAX << 1][NMAX];

void read(void) {
	FILE *fin = fopen("munte.in", "rt");

	fscanf(fin, " %d", &N);

	fclose(fin);
}

void dinamica(void) {
	int i, j, stop;

	stop = 2 * (N - 1);

	DP[0][0] = 1;
	for (i = 1; i <= stop; ++i)
		for (j = 0; j < N; ++j) {
			DP[i][j] = DP[i - 1][j + 1];
			if (j > 0) DP[i][j] = DP[i][j] + DP[i - 1][j - 1];
			if (i > 1 && j > 0) DP[i][j] = DP[i][j] + DP[i - 2][j];
		}
}

void write(void) {
	FILE *fout = fopen("munte.out", "wt");

	DP[2 * (N - 1)][0].write(fout);
	fprintf(fout, "\n");

	fclose(fout);
}

int main(void) {

	read();

	dinamica();

	write();

	return 0;

}

