#include <cstdio>
#include <vector>
#include <queue>

using namespace std;

#define PB push_back

const int NMAX = 2048;

int N, M;
vector <int> G[NMAX];
int A[NMAX], B[NMAX], cnt;

void read(void) {
	FILE *fin = fopen("promo.in", "rt");
	int i, u, v;

	fscanf(fin, " %d %d", &N, &M);

	for (i = 0; i < M; ++i) {
		fscanf(fin, " %d %d", &u, &v);

		G[u].PB(v);
		G[v].PB(u);
	}

	fclose(fin);
}

void BFS(int s) {
	queue <int> Q;
	int i, u, v;

	for (Q.push(s); !Q.empty(); Q.pop()) {
		u = Q.front();

		if (u != s) B[u] = ++cnt;

		for (i = 0; i < (int) G[u].size(); ++i) {
			v = G[u][i];

			if (A[v] == 0 || B[v] == 0)
				if (A[v] == 0) {
					A[v] = cnt;
					Q.push(v);
				} else if (A[v] != A[u] && A[v] != B[u])
					B[v] = cnt;
		}
	}
}

void solve(void) {
	int i;

	cnt = 0;

	for (i = 1; i <= N; ++i)
		if (A[i] == 0 || B[i] == 0)
			if (A[i] == 0) {
				A[i] = ++cnt;
				BFS(i);
			} else {
				B[i] = ++cnt;
				BFS(i);
			}
}

void write(void) {
	FILE *fout = fopen("promo.out", "wt");

	int i;

	for (i = 1; i <= N; ++i)
		if (B[i] == 0) B[i] = ++cnt;
	
	fprintf(fout, "%d\n", cnt);

	for (i = 1; i <= N; ++i)
		fprintf(fout, "%d %d\n", A[i], B[i]);

	fclose(fout);
}

int main(void) {

	read();

	solve();

	write();

	return 0;

}

