#include <cstdio>
#include <algorithm>

using namespace std;

#define x first
#define y second

typedef pair <int, int> coor;

const int NMAX = 1 << 17;
const int MMAX = 1 << 18;
const int INF = 0x3f3f3f3f;

int N, M;
coor A[NMAX], X[MMAX];
int l[NMAX];
long long rez[MMAX];

int get(void) {
	char s[16];
	int i, rez = 0;

	scanf(" %s", s);

	for (i = 0; s[i] >= '0' && s[i] <= '9'; ++i)
		rez = rez * 10 + (s[i] - '0');
	
	return rez;
}
	
int drum(coor a, coor b) {
	long long t;
	
	t = ((long long)a.x * a.x - (long long)b.x * b.x + 
	(long long)a.y * a.y - (long long)b.y * b.y) / 
	(2 * (a.x - b.x));

	return t > INF ? INF : t;
}
	
int main(void) {

	freopen("puncte.in", "rt", stdin);

	int i, j, v;
	coor c;

	N = get(); M = get();

	A[0].x = get(); A[0].y = get();
	v = 0;
	
	for (i = 1; i < N; ++i) {
		c.x = get();
		c.y = get();

		if (c.x != A[v].x) {
			while (v > 0 && drum(c, A[v]) < l[v - 1]) --v;
			
			l[v++] = drum(c, A[v]);
			A[v] = c;
		}
	}

	for (i = 0; i < M; ++i) {
		X[i].x = get();
		X[i].y = i;
	}

	sort(X, X + M);

	for (i = j = 0; i < M; ++i) {
		
		while (j < v && l[j] < X[i].x) ++j;

		rez[X[i].y] = (long long)(A[j].x - X[i].x) * (A[j].x - X[i].x) + (long long)A[j].y * A[j].y;
	}

	FILE *fout = fopen("puncte.out", "wt");
	for (i = 0; i < M; ++i)
		fprintf(fout, "%lld\n", rez[i]);
	fclose(fout);
	
	return 0;

}

