#include <stdio.h>

#define NMAX 1000
#define LMAX 10001
#define LLOG 15

struct interval
{
    int a;
    int b;
};

bool operator< (interval i1, interval i2)
{
    return (i1.a<i2.a || (i1.a == i2.a && i1.b < i2.b));
}

int N, L;
int C[LMAX];
int Cmin[LMAX][LLOG];
interval I[NMAX];
int A[NMAX];
int poz[NMAX];


inline int minim(int a, int b)
{
    if (a<b)
        return a;
    else
        return b;
}

void qsort(int l, int r)
{
  int i, j;
  interval x,y;
  i = l;
  j = r;
  x = I[(l+r) / 2];
  do
  {
    while (I[i] < x)
        ++i;
    while (x < I[j])
        --j;
    if (i <= j)
    {
      y = I[i];
      I[i] = I[j];
      I[j] = y;
      ++i; --j;
    }
  }
  while (i <= j);
  if (l < j) qsort(l, j);
  if (i < r) qsort(i, r);
}

int query(int a, int b)
{
    int len = b-a+1;
    int p, k;
    for (p = 1, k = 0; p<=len; ++k, p*=2);
    --k;
    p/=2;
    if (k<0) k = 0;
    return minim(Cmin[a][k], Cmin[b-p+1][k]);
}


int main()
{
    freopen("cover.in", "r", stdin);
    freopen("cover.out", "w", stdout);

    scanf("%d %d", &N, &L);

    for (int i = 1; i<=L; ++i)
    {
        scanf("%d", &C[i]);
        Cmin[i][0] = i;
    }

    for (int i = 1; i<=N; ++i)
    {
        scanf("%d %d", &I[i].a, &I[i].b);
    }

    // build RMQ table
    for (int k = 1, p = 2; p<=L; p*=2, ++k)
    {
        for (int i = 1; i<=L-p+1; ++i)
        {
            int pp = p/2;
            Cmin[i][k] = Cmin[i][k-1];
            if (C[Cmin[i][k-1]] > C[Cmin[i+pp][k-1]])
                Cmin[i][k] = Cmin[i+pp][k-1];
        }
    }

    qsort(1, N);

    poz[1] = query(I[1].a, I[1].b);
    A[1] = C[poz[1]];

    for (int i = 2; i<=N; ++i)
    {
        if (I[i].a <= I[i-1].b)
        {
            if (I[i].a <= poz[i-1] && poz[i-1] <= I[i].b)
            {
                A[i] = A[i-1];
                poz[i] = poz[i-1];
            }
            else
            {
                int p2 = query(I[i].a, I[i].b);
                int p1;
                if (I[i].b <= I[i-1].b)
                    p1 = p2;
                else
                    p1 = query(I[i-1].b, I[i].a);
                if (A[i-1] + C[p1] - C[poz[i-1]] < A[i-1] + C[p2])
                {
                    A[i] = A[i-1] + C[p1] - C[poz[i-1]];
                    poz[i] = p1;
                }
                else
                {
                    A[i] = A[i-1] + C[p2];
                    poz[i] = p2;
                }
            }
        }
        else
        {
            poz[i] = query(I[i].a, I[i].b);
            A[i] = A[i-1] + C[poz[i]];
        }
    }

    printf("%d\n", A[N]);
}
