#include <stdio.h>
#include <string>

#define MMAX 2008
#define KMAX 100001

struct Nod
{
    int inf;
    Nod* urm;
};

typedef Nod* PNod;

int N, M, K;
PNod G[MMAX];
int st[MMAX][3];
int X[MMAX], Y[MMAX];
int comp[MMAX];
int cnt, cntN, cntM;
int viz[MMAX];
int ok;

void comp_conex(int k, int par)
{
    viz[k] = 1;
    comp[cntN++] = k;
    PNod pnod = G[k];
    while (pnod)
    {
        int nod = pnod->inf;;
        if (nod != par)
        {
            X[cntM] = k;
            Y[cntM++] = nod;
        }
        if (!viz[nod])
        {
            comp_conex(nod, k);
        }
        pnod = pnod->urm;
    }
}

inline int cazu11(int x, int y)
{
    return (st[x][0] == 2 && st[y][0] == 2 &&
        ((st[x][1] == st[y][1] && st[x][2] == st[y][2]) ||
        (st[x][1] == st[y][2] && st[y][1] == st[x][2])));
}

inline int cazu1(int x, int y)
{
    if (!st[x][0] || !st[y][0])
        return 0;
    for (int i = 1; i<=st[x][0]; ++i)
    {
        for (int j = 1; j<=st[y][0]; ++j)
        {
            if (st[x][i] == st[y][j])
                return 1;
        }
    }
    return 0;
}

inline int cazu2(int x, int y)
{
    return (st[x][0] < 2 && st[y][0] < 2);
}

inline int cazu3(int x, int y)
{
    return ((st[x][0] < 2 || st[y][0] < 2) && (st[x][0] > 0 || st[y][0] > 0));
}

void solve(int k)
{
    if (k == cntM)
    {
        ok = 1;
        return;
    }

    // cazu11 (prea rezolvat)
    if (cazu11(X[k], Y[k]))
    {
        return;
    } // cazu 1 (deja rezolvat)
    else
    if (cazu1(X[k],Y[k]))
    {
        solve(k+1);
    }
    else
    {
        // cazu 2 (bag la ambele unu neutru)
        if (cazu2(X[k], Y[k]))
        {
            st[X[k]][++st[X[k]][0]] = ++cnt;
            st[Y[k]][++st[Y[k]][0]] = cnt;
            solve(k+1);
            if (ok)
                return;
            --st[X[k]][0];
            --st[Y[k]][0];
            --cnt;
        }

        // cazu 3(combinatii)
        if (cazu3(X[k],Y[k]))
        {
            for (int i = 1; i<=st[X[k]][0]; ++i)
            {
                if (st[Y[k]][0] < 2)
                {
                    st[Y[k]][++st[Y[k]][0]] = st[X[k]][i];
                    solve(k+1);
                    if (ok)
                        return;
                    --st[Y[k]][0];
                }
            }

            for (int i = 1; i<=st[Y[k]][0]; ++i)
            {
                if (st[X[k]][0] < 2)
                {
                    st[X[k]][++st[X[k]][0]] = st[Y[k]][i];
                    solve(k+1);
                    if (ok)
                        return;
                    --st[Y[k]][0];
                }
            }
        }
    }
    
}


int main()
{
    freopen("promo.in", "r", stdin);
    freopen("promo.out", "w", stdout);

    scanf("%d %d", &M, &K);

    for (int i = 0; i<K; ++i)
    {
        int x,y;
        scanf("%d %d", &x, &y);
        PNod nod = new Nod;
        nod->inf = y;
        nod->urm = G[x];
        G[x] = nod;

        nod = new Nod;
        nod->inf = x;
        nod->urm = G[y];
        G[y] = nod;
    }

    cnt = 0;

    for (int i = 1; i<=M; ++i)
    {
        // trag linie verticala bashita
        cntN = 0;
        cntM = 0;

        // gasesc noduri si muchii din comp conexa
        memset(viz, 0, sizeof(viz));
        comp_conex(i, 0);

        // rezolv muchiile
        ok = 0;
        solve(0);

        // dualizez nodurile ramase
        for (int i = 0; i<cntN; ++i)
        {
            int x = comp[i];
            while (st[x][0] < 2)
                st[x][++st[x][0]] = ++cnt;
        }
        
    }

    printf("%d\n", cnt);
    for (int i = 1; i<=M; ++i)
    {
        printf("%d %d\n", st[i][1], st[i][2]);
    }
}
