//
// Compl: O(N*M)
//


#include <stdio.h>

#define NMAX 100001
#define MMAX 200001
#define INF 0x3f3f3f3f

int N, M;
int X[NMAX], Y[NMAX];
int cnt;

// O(1)
void update(int x, int y)
{
    X[cnt] = x;
    Y[cnt++] = y;
}

int calc(int x1, int y1, int x2)
{
    return (x1-x2)*(x1-x2) + y1*y1;
}

// O(N)
int query(int x)
{
    int min = INF;
    for (int i = 0; i<N; ++i)
    {
        int d = calc(X[i], Y[i], x);
        if (d < min)
            min = d;
    }
    return min;
}

int main()
{
    freopen("puncte.in", "r", stdin);
    freopen("puncte.out", "w", stdout);

    cnt = 0;

    scanf("%d %d", &N, &M);
    for (int i = 1; i <=N; ++i)
    {
        int x, y;
        scanf("%d %d", &x, &y);
        update(x, y);
    }

    for (int i = 1; i<=M; ++i)
    {
        int x;
        scanf("%d", &x);
        printf("%d\n", query(x));
    }
}

