#include <cstdio>
#include <cassert>
#include <string>

#define FIN "puncte.in"
#define FOUT "puncte.out"
#define NMAX 100001
#define MMAX 200001
#define INF 0x3f3f3f3f

int N, M;
long long Px[NMAX], Py[NMAX], X[MMAX];
char s[50];


void read ()
{
    int ct, j;
    scanf ("%d %d\n", &N, &M);

    for (int i = 1; i <= N; ++ i)
    {
        gets (s);
        ct = 1;
        j = strlen (s) - 1;
        while (s[j] != ' ')
        {
            Py[i] += (ct * (s[j] - '0'));
            ct *= 10;
            -- j;
        }

        -- j;
        ct = 1;
        while (j >= 0)
        {
            Px[i] += (ct * (s[j] - '0'));
            ct *= 10;
            -- j;
        }
    }

    for (int i = 1; i <= M; ++ i)
    {
        gets (s);
        j = strlen (s) - 1;

        ct = 1;
        while (j >= 0)
        {
            X[i] += (ct * (s[j] - '0'));
            ct *= 10;
            -- j;
        }
    }
}

int binsearch1 (int val)
{
    int step, i;

    for (step = 1; step <= N; step <<= 1);
    for (i = 0; step; step >>= 1)
        if (i + step <= N && Px[i + step] <= val)
            i += step;

    return i;
}

int binsearch2 (int val)
{
    int step, i;

    for (step = 1; step < N; step <<= 1);
    for (i = 0; step; step >>= 1)
        if (N - i - step > 0 && Px[N - i - step] >= val)
            i += step;

    return  N - i;
}

void solve ()
{
    int x1, x2;
    long long min1, min2, y1, y2;
    
    for (int i = 1; i <= M; ++ i)
    {
        x1 = binsearch1 (X[i]);
        x2 = binsearch2 (X[i]);

        while (Px[x1 - 1] == Px[x1])
            -- x1;
        //printf ("%d %d\n", x1, x2);
        min1 = (X[i] - Px[x1]) * (X[i] - Px[x1]) + Py[x1] * Py[x1];
        min2 = (X[i] - Px[x2]) * (X[i] - Px[x2]) + Py[x2] * Py[x2];
        //printf ("%d %d\n", min1, min2);
        -- x1;
        ++ x2;
        y1 = Py[x1];
        y2 = Py[x2];
        if (x1 > 0)
        while (X[i] - Px[x1] <= y1)
        {
            if (min1 > (X[i] - Px[x1]) * (X[i] - Px[x1]) + Py[x1] * Py[x1])
            {
                min1 = (X[i] - Px[x1]) * (X[i] - Px[x1]) + Py[x1] * Py[x1];
                y1 = Py[x1];
            }

            if (x1 == 1)
                break;
                
            -- x1;
        }
        if (x2 <= N)
        while (X[i] - Px[x2] <= y2)
        {
            if (min2 > (X[i] - Px[x2]) * (X[i] - Px[x2]) + Py[x2] * Py[x2])
            {
                min2 = (X[i] - Px[x2]) * (X[i] - Px[x2]) + Py[x2] * Py[x2];
                y2 = Py[x2];
            }

            if (x2 >= N)
                break;
            ++ x2;
        }
        //min2 = (X[i] - Px[x2]) * (X[i] - Px[x2]) + Py[x2] * Py[x2];

        if (min1 < min2)
            printf ("%lld\n", min1);
        else
            printf ("%lld\n", min2);
    }
}

int
 main ()
{
    freopen (FIN, "rt", stdin);
    freopen (FOUT, "wt", stdout);

    read ();
    solve ();

    return 0;
}

