#include <cstdio>
#include <algorithm>
using namespace std;

const char iname[] = "cover.in";
const char oname[] = "cover.out";

#define MAX_N 60007
#define MAX_L 1000007
#define MAX_T 2097152

int N, L, C[MAX_L];  int Ai[MAX_T];

struct entry {
    int lo;
    int hi;
} E[MAX_N], T[MAX_N];

int MAX;

void read_in(void) {
    scanf("%d %d", & N, & L);
    for (int i = 1; i <= L; ++ i)
        scanf("%d", C + i);
    for (int i = 0; i < N; ++ i) {
        scanf("%d %d", & E[i].lo, & E[i].hi);
        if (MAX < E[i].hi)
            MAX = E[i].hi;
    }
}

int cmp(entry z, entry w) {
    if (z.lo != w.lo)  return z.lo > w.lo;
    return z.hi < w.hi;
}

int update(int n, int lo, int hi) {
    int mid = (hi + lo) >> 1;
    if (hi == lo)
        Ai[n] = C[hi];
    else {
       update(2 * n, lo, mid);
       update(2 * n + 1, mid + 1, hi);
       Ai[n] = Ai[2 * n] < Ai[2 * n + 1] ? Ai[2 * n] : Ai[2 * n + 1];
    }
}

int query(int n, int lo, int hi, int a, int b) {
    int mid = (hi + lo) >> 1;
    if (a <= lo && hi <= b)
        return Ai[n];
    int ans = 1024;
    if (a <= mid) {
        int tmp = query(2 * n, lo, mid, a, b);
        if (ans > tmp)
            ans = tmp;
    }
    if (b > mid) {
        int tmp = query(2 * n + 1, mid + 1, hi, a, b);
        if (ans > tmp)
            ans = tmp;
    }
    return ans;
}

int ans[MAX_N];

int main(void) {
    freopen(iname, "r", stdin);
    read_in();
    sort(E, E + N, cmp);
    int cnt = 0;
    int index;
    T[++ cnt] = E[0];
    for (int i = index = 0; i < N; ++ i) {
        if (E[index].hi <= E[i].hi)
            continue ;
        T[++ cnt] = E[i], index = i;
    }
    update(1, 1, MAX);
    for (int i = 1; i <= cnt; ++ i) {
        ans[i] = ans[i - 1] + query(1, 1, MAX, T[i].lo, T[i].hi);
        for (int j = i - 1; j > 0; -- j) {
            if (T[i].hi < T[j].lo)
                break ;
            int q = query(1, 1, MAX, T[j].lo, T[i].hi);
            if (ans[i] > ans[j - 1] + q)
                ans[i] = ans[j - 1] + q;
        }
    }
    freopen(oname, "w", stdout);
    printf("%d\n", ans[cnt]);
    return 0;
}
