#include <fstream>
#include <string.h>
using namespace std;

const char iname[] = "dist.in";
const char oname[] = "dist.out";

#define MAX_P 507
#define MAX_W 27
#define MAX_N 107

char A[MAX_N][MAX_W];

int  L[MAX_N], N, M;

char B[MAX_P];

int  X[MAX_P];

int  C[MAX_N][MAX_P], D[MAX_N][MAX_P];

void read_in(void) {
    ifstream fin(iname);
    int cnt = 1;
    fin.getline(B, MAX_P);
    int len = strlen(B);
    for (int i = 0; i < len; cnt ++) {
        while (i < len && B[i] == ' ')
            i ++;
        while (i < len && B[i] != ' ')
            A[cnt][L[cnt] ++] = B[i], i ++;
    }
    N = cnt - 1;
    cnt = 1;
    for (char ch; !fin.eof(); ) {
        fin >> ch;
        if (!fin.eof())
            B[++ M] = ch, X[M] = cnt;
        if (fin.peek() == ' ')
            cnt ++;
    }
}

#define modul(z) ((z) < 0 ? (-(z)) : (z))
inline int dist(int index, int lo, int len) {
    int sum = 0;
    int i;
    for (i = 0; i < L[index] && i < len; ++ i)
        sum = sum + modul(A[index][i] - B[lo + i]);
    while (i < L[index])
        sum = sum + A[index][i]  - 64, i ++;
    while (i < len)
        sum = sum + B[lo + i]    - 64, i ++;
    return sum;
}

int op(int num, int lo, int len) {
    int sum = 0;
    for (int i = 0; i < len; ++ i)
        sum = sum + modul(num - X[lo + i]);
    return sum;
}

#define INF int(1e7)
void solve(void) {
    int tmp;
    int nop;
    for (int j = 1; j <= M; ++ j)
        C[0][j] = INF;
    for (int i = 1; i <= N + 1; ++ i) {
        for (int j = 1; j <= M; ++ j) {
            C[i][j] = INF;
            for (int k = 1; k <= 20; ++ k) {
                if (j < k)   break ;
                tmp = C[i - 1][j - k] + dist(i, j-k+1, k);
                nop = op(i, j-k+1, k);
                if (C[i][j] > tmp)
                    C[i][j] = tmp, D[i][j] = D[i - 1][j - k] + nop;
                else if (C[i][j] == tmp)
                     if (D[i][j] > D[i - 1][j - k] + nop)
                         D[i][j] = D[i - 1][j - k] + nop;
            }
        }
    }
    int ans = C[N + 1][M];
    int num = D[N + 1][M];
    for (int i = N; i > 0; -- i)
        if (ans > C[i][M] || (ans == C[i][M] && num > D[i][M]))
            ans = C[i][M], num = D[i][M];
    printf("%d %d\n", ans, num);
}

int main(void) {
    read_in();
    freopen(oname, "w", stdout);
    solve();
    return 0;
}


