#include <stdio.h>
#include <stdlib.h>

#define MAX_N 60010
#define INF (1 << 30)
#define MAX_L 1000010
#define MAXARB (1 << 17)
#define mid ((st+dr) >> 1)
#define left (nod << 1)
#define right ((nod << 1) | 1)
#define MIN(a,b) ((a) < (b) ? (a) : (b))

typedef struct seg { int x, y; } seg;

int N, L, cost[MAX_L], Min[MAXARB];
seg A[MAX_N];

int a, b, val;

void update(int nod, int st, int dr)
{
    if(a <= st && dr <= b)
        Min[nod] = MIN(Min[nod], val);
    else
    {
        if(a <= mid) update(left, st, mid);
        if(b > mid) update(right, mid+1, dr);
    }
}

int tval;

void query(int nod, int st, int dr)
{
    int t;
    
    if(a <= st && dr <= b)
        return ;
    else
    {
        if(a <= mid) tval = MIN(Min[left], tval), query(left, st, mid);
        if(b > mid) tval = MIN(Min[right], tval), query(right, mid+1, dr);
    }
}

void baga(int nod, int st, int dr)
{
    Min[nod] = INF;
    if(st == dr) return ;
    baga(left, st, mid), baga(right, mid+1, dr), Min[nod] = INF;
}

int cmp(const void *a, const void *b)
{
    if( ((seg*)a)->x == ((seg*)b)->x )
        return ((seg*)b)->y - ((seg*)a)->y;
    return ((seg*)a)->x - ((seg*)b)->x;
}

void solve(void)
{
    int start, end, j, i;

    for(i = 1; i <= N; i++)
        Min[i] = INF;

    qsort(A+1, N, sizeof(A[0]), cmp);

    baga(1, 1, N+1);
    val = 0, a = b = N+1, update(1, 1, N+1);
    
    for(start = N+1, end = N+1, i = L; i >= 1; i--)
    {
        while(end-1 >= 1 && A[end-1].x > i)
            end--;
        while(start-1 >= 1 && A[start-1].y >= i && A[start-1].x <= i)
            start--;

        tval = Min[1], a = b = end, query(1, 1, N+1);

        a = start, b = end-1, val = cost[i]+tval;

        if(a <= b)
            update(1, 1, N+1);
    }
}

char input[6000000];

void read_data(void)
{
    int i, j, k, ind, p;
    char sir[256];

    scanf("%d %d\n", &N, &L);

    fgets(input, 5999999, stdin);
    
    for(ind = 0, i = 1; i <= L; i++)
    {
        for(p = 0; input[ind] >= '0' && input[ind] <= '9'; ind++)
            p = p*10 + (input[ind]-48);
        ind++;
        cost[i] = p;
    }
    
    for(i = 1; i <= N; i++)
    {
        fgets(sir, 256, stdin), ind = 0;
        for(p = 0; sir[ind] >= '0' && sir[ind] <= '9'; ind++)
            p = p*10 + (sir[ind]-48);
        A[i].x = p;
        for(p = 0, ind++; sir[ind] >= '0' && sir[ind] <= '9'; ind++)
            p = p*10 + (sir[ind]-48);
        A[i].y = p;
    }
}

void write_data(void)
{
    tval = Min[1], a = b = 1, query(1, 1, N+1);
    printf("%d\n", tval);
}

int main(void)
{
    freopen("cover.in", "rt", stdin);
    freopen("cover.out", "wt", stdout);

    read_data();
    solve();
    write_data();

    return 0;
}




