#include <stdio.h>
#include <string.h>

#define MAX_WORDS 105
#define MAX_TEXT 2048
#define MAX_N 512
#define INF (1 << 29)
#define abs(x) ((x) < 0 ? (-(x)) : (x))

int N, M, P, K, L[MAX_WORDS];
int A[MAX_WORDS][MAX_N], R[MAX_WORDS][MAX_N], Ind[MAX_N];
char B[MAX_WORDS][32];
char T[MAX_N];


int calc_dist(int j, int s, int e); // cuvantul j, intre s si e
int calc_cost(int j, int s, int e); // costul sa mut literele

void solve(void)
{
    int i, j, k, aux, p;

    K = 100;

    for(j = 0; j <= K; j++)
     for(i = 0; i <= N; i++)
        A[j][i] = R[j][i] = INF;

    A[0][0] = R[0][0] = 0;
    
    for(j = 1; j <= K; j++)
     for(i = 1; i <= N; i++)
     {
        for(k = 1; k <= 20 && i-k+1 >= 1; k++)
        {
            aux = calc_dist(j, i-k+1, i) + A[j-1][i-k];
            p = calc_cost(j, i-k+1, i) + R[j-1][i-k];
            if(aux < A[j][i] || (aux == A[j][i] && p < R[j][i]))
                A[j][i] = aux, R[j][i] = p;
        }
     }
}

int calc_dist(int j, int s, int e)
{
    int k, r, p;
    char a[32], b[32];

    for(k = 1; k <= e-s+1; k++)
        a[k] = T[s+k-1];
    for(k = 1; k <= L[j]; k++)
        b[k] = B[j][k];

    if(e-s+1 > L[j])
    {
        for(p = e-s+1, k = L[j]+1; k <= e-s+1; k++)
            b[k] = '@';
    }
    else
    {
        for(p = L[j], k = e-s+2; k <= L[j]; k++)
            a[k] = '@';
    }
    
    for(r = 0, k = 1; k <= p; k++)
        r += abs(a[k]-b[k]);

    return r;
}

int calc_cost(int j, int s, int e)
{
    int i, r = 0;
    
    for(i = s; i <= e; i++)
        r += abs(Ind[i]-j);

    return r;
}

void read_data(void)
{
    int i, j, k, ind, len, ok;
    char c;
    char sir[1<<16];

    fgets(sir, 1<<16, stdin), len = strlen(sir);

    for(ind = 1, j = 0, i = 0; i < len; i++)
    {
        if( !(sir[i] >= 'A' && sir[i] <= 'Z') && !(sir[i] == ' ') )
            break ;
            
        c = sir[i];
        if(c == ' ')
        {
            if(j > 0)
                L[ind] = j, ind++, j = 0;
        }
        else
            B[ind][++j] = c;
    }
    if(j != 0)
        L[ind] = j;

    P = ind;
    
    fgets(sir, 1<<16, stdin), len = strlen(sir);
    for(ind = 1, ok = 1, i = 0; i < len; i++)
    {
        if( !(sir[i] >= 'A' && sir[i] <= 'Z') && !(sir[i] == ' ') )
            break ;
            
        c = sir[i];
        if(c == ' ')
        {
            if(ok == 0)
                ind++, ok = 1;
        }
        else
            ok = 0, T[++N] = c, Ind[N] = ind;
    }
}

void write_data(void)
{
    int i, j, k, res = INF, nrmin = INF, cost, moves;
    
    for(i = 1; i <= K; i++)
    {
        if(i >= P)
            cost = A[i][N], moves = R[i][N];
        else
        {
            moves = R[i][N], cost = A[i][N];
            for(j = i+1; j <= P; j++)
             for(k = 1; k <= L[j]; k++)
                cost += abs('@'-B[j][k]);
        }
        if(cost < res || (cost == res && moves < nrmin))
            res = cost, nrmin = moves;
    }

    printf("%d %d\n", res, nrmin);
}

int main(void)
{
    freopen("dist.in", "rt", stdin);
    freopen("dist.out", "wt", stdout);

    read_data();
    solve();
    write_data();

    return 0;
}


        





    


