#include <cstdio>
#include <algorithm>

using namespace std;

#define punct pair<int, int>
#define x first
#define y second
#define ll long long

#define Nmax 100005
#define Mmax 200005
#define inf (double)(2*1e9)

punct v[Nmax];
int st[Nmax];
long double loc[Nmax];
punct u[Mmax];
int n, m;
ll ret[Mmax];

void readdata()
{
	freopen("puncte.in", "r", stdin);
    freopen("puncte.out", "w", stdout);

    int i;

    scanf("%d %d", &n, &m);
    for (i = 1; i <= n; ++i)
    	scanf("%d %d", &v[i].x, &v[i].y);
    for (i = 1; i <= m; ++i)
    {
    	scanf("%d", &u[i].x);
        u[i].y = i;
    }
}

long double where(int a, int b)
{
	long long d1 = v[a].y, d2 = v[b].y, d = v[b].x - v[a].x;
    long double rez;

    rez = (long double)(d*d + d2*d2 - d1*d1) / (long double)(2*d);
    rez += (long double) v[a].x;

    return rez;
}

int sorted()
{
	int i;

    for (i = 2; i <= m; ++i)
    	if (u[i].x < u[i-1].x) return 0;
    return 1;
}

void solve()
{
	int i, cnt, cap, pt;
    long long rez, d1, d2;

    if (!sorted()) sort(u+1, u+m+1);
    
    st[cnt = 1] = 1;
    loc[1] = -inf;
    
    for (i = 2; i <= n;++i)
    {
		if (v[i].x == v[i-1].x) continue;
        
        while (cnt && where(st[cnt], i) <= loc[cnt]) --cnt;
        
        st[++cnt] = i;
        loc[cnt] = where(st[cnt-1], i);
    }
    
    cap = 1;
    for (i = 1; i <= m; ++i)
    {
    	while (cap < cnt && loc[cap+1] <= (long double)u[i].x) ++cap;
        
        pt = st[cap];
        d1 = u[i].x-v[pt].x;
        d2 = v[pt].y;
        rez = d1*d1 + d2*d2;
        
        ret[ u[i].y ] = rez;
    }

    for (i = 1; i <= m; ++i)
    	printf("%lld\n", ret[i]);
}

int main()
{
	readdata();
    solve();
	return 0;
}
