#include <stdio.h>
#include <algorithm>
using namespace std;

#define infile "cover.in"
#define outfile "cover.out"
#define NMAX 10005
#define LMAX 100005
#define INF 100000000
#define INTERV_MAX 262200
struct interval{int a,b;};

FILE *fin,*fout;
int N,L,c[LMAX];
interval I[NMAX];
short int maxstart[NMAX];
int cost[2][LMAX];
int ARB[INTERV_MAX],IND,A,B;

void read_data()
  {
   fin=fopen(infile,"r");
   fscanf(fin,"%d %d",&N,&L);
   for(int i=1;i<=L;i++)
      fscanf(fin,"%d",&c[i]);
   for(int i=0;i<N;i++)
      fscanf(fin,"%d %d",&I[i].a,&I[i].b);
   fclose(fin);
  }

inline bool cmp(interval A, interval B)
  {
   if(A.b!=B.b)
     return A.b<B.b;
   return A.a>B.a;
  }

void init()
  {
   int i;
   sort(I,I+N,cmp);
   maxstart[0]=I[0].a;
   for(i=1;i<N;i++)
      {
       maxstart[i]=maxstart[i-1];
       if(maxstart[i]<I[i].a)
         maxstart[i]=I[i].a;
      }
  }

inline int min(int x, int y)
  {
   return (x<y)?x:y;
  }

void build(int n, int li, int ls)
  {
   if(li==ls)
     {
      ARB[n]=cost[IND][li];
      return;
     }
   build(2*n,li,(li+ls)/2);
   build(2*n+1,(li+ls)/2+1,ls);
   ARB[n]=min(ARB[2*n],ARB[2*n+1]);
  }

int query(int n, int li, int ls)
  {
   if(A<=li && ls<=B)
     return ARB[n];
   int sol=INF;
   if(A<=(li+ls)/2)
     sol=query(2*n,li,(li+ls)/2);
   if(B>(li+ls)/2)
     sol=min(sol,query(2*n+1,(li+ls)/2+1,ls));
   return sol;
  }

void solve()
  {
   int i,j,cur=0,prec=1;
   for(j=1;j<=L;j++)
      if(I[0].a<=j && j<=I[0].b)
        cost[0][j]=c[j];
      else
        cost[0][j]=INF;
   IND=0;
   build(1,1,L);
   for(i=1;i<N;i++)
      {
       cur=!cur;
       prec=!prec;
       IND=!IND;
       for(j=1;j<=L;j++)
          if(I[i].a<=j && j<=I[i].b)
            if(I[i-1].a<=j && j<=I[i-1].b)
              cost[cur][j]=cost[prec][j];
            else
              {
               A=maxstart[i-1];
               B=I[i-1].b;
               if(j>B)
                 cost[cur][j]=query(1,1,L)+c[j];
               else
                 cost[cur][j]=INF;
              }
          else
            cost[cur][j]=INF;
       build(1,1,L);
      }
  }


int main()
{
read_data();
init();
solve();
fout=fopen(outfile,"w");
fprintf(fout,"%d\n",ARB[1]);
fclose(fout);
return 0;
}
