#include <cstdio>
#include <cstring>
#include <vector>
#include <deque>
#include <algorithm>
#include <cassert>
#include <set>
using namespace std;

#define TESTREAD 0
#define SHOWCLEAN 0

typedef pair<int, int>interval;
const int LMAX = 1000001;
const int BSIZE = 7000000;
const int NMAX = 61000;

char s[BSIZE];
int mat[NMAX];
int cost[LMAX];
interval v[NMAX];
bool red[NMAX]; //Interval redundant

class capat {
	public:
	int i, val, tip; //i - intervalul de care apartine, val - valoarea, tip - 1 pt deschidere / 2 - inchidere
	capat() {
	}
	capat(int a, int b, int c) {
		i = a;
		val = b;
		tip = c;
	}
}c[2 * NMAX];

inline bool operator < (capat a, capat b) {
	if (a.val == b.val) {
		if (a.tip == b.tip) {
			return a.i > b.i ? 1 : 0;
		}
		return a.tip < b.tip ? 1 : 0;
	}
	return a.val < b.val ? 1 : 0;
}


inline int cmp(interval a, interval b) {
	return a.second == b.second ? a.first > b.first : a.second < b.second;
}

int main() {
	FILE *fin = fopen ("cover.in", "r");
	FILE *fout = fopen ("cover.out", "w");
	int n, l, i;
	fscanf (fin, "%d %d\n", &n, &l);
	//Parsez citirea
	//Mai intai costurile
	fgets(s, BSIZE, fin);
	int ii = 1, x = 0, dig = 0;
	for (i = 0; ii <= l; ++i) {
		if (s[i] >= '0' && s[i] <= '9') {
			dig = 1;
			x = x * 10 + s[i] - '0';
		} else if (dig) {
			dig = 0;
			cost[ii++] = x;
			x = 0;
		}
	}
	//Acum intervalele
	for (i = 1; i <= n; ++i) {
		fgets(s, BSIZE, fin);
		int j, x = 0;
		v[i].first = 0;
		v[i].second = 0;
		for (j = 0; ;++j) {
			if (s[j] >= '0' && s[j] <= '9') {
				x = x * 10 + s[j] - '0';
			} else if (x) {
				if (v[i].first == 0) {
					v[i].first = x;
					x = 0;
				} else {
					v[i].second = x;
					break;
				}
			}
		}
	}
	if (TESTREAD) {
		printf ("%d %d\n", n, l);
		int i;
		for (i = 1; i <= l; ++i) {
			printf ("%d ", cost[i]);
		}
		printf ("\n");
		for (i = 1; i <= n; ++i) {
			printf ("%d %d\n", v[i].first, v[i].second);
		}
	}
	//Calculul propriu-zis
	sort(v + 1, v + n + 1, cmp); //Le sortez dupa capatul din dreapta
	int r = 1;
	for (i = 1; i <= n; ++i) {
// 		printf ("(%d, %d)\n", v[i].first, v[i].second);
		c[r].i = i;
		c[r].val = v[i].first;
		c[r].tip = 1;
		r++;
		//
		c[r].i = i;
		c[r].val = v[i].second;
		c[r].tip = 2;
		r++;
	}
	sort(c + 1, c + r);
	//Scot intervalele care contin in interiorul lor alte intervale
	vector<int>stack; //O stiva
	ii = 1;
	for (i = 1; i <= l; ++i) {
		for (; ii < r && c[ii].val == i; ++ii) {
			if (c[ii].tip == 1) { //Capat de deschidere
				int x = c[ii].i; //Intervalul care il deschid
//   				printf ("Il deschid pe %d (%d, %d)\n", x, v[x].first, v[x].second);
				while (stack.size() && stack.back() > x) {
//   					printf ("%d e redundant\n", stack.back());
					red[stack.back()] = 1; //E redundant
					stack.pop_back();
				}
				stack.push_back(x);
			}
		}
	}
	stack.clear(); //Curat stiva ca sa nu pierd memorie
	//Acuma fac curat in vectorul cu intervale
	int nn = 0;
	for (i = 1; i <= n; ++i) {
		if (red[i] == 0) {
			v[++nn] = v[i];
		}
	}
	n = nn;	
	if (SHOWCLEAN) {
// 		printf ("Vectorul curatat\n");
		for (i = 1; i <= n; ++i) {
			printf ("%d %d\n", v[i].first, v[i].second);
		}
	}
	//Acum construiesc din nou
	r = 1;
	for (i = 1; i <= n; ++i) {
		c[r].i = i;
		c[r].val = v[i].first;
		c[r].tip = 1;
		r++;
		//
		c[r].i = i;
		c[r].val = v[i].second;
		c[r].tip = 2;
		r++;
	}
	sort(c + 1, c + r);
	
	int lClosed = 0; //Ultimul interval inchis
	for (i = 1; i <= n; ++i) {
		mat[i] = 1<<30; //Infinit;
	}
	mat[0] = 0;
	ii = 1;
	set<int>deschise;
// 	printf ("%d\n", n);
	for (i = 1;i <= l; ++i) {
		//Deschid intervalele care trebuie
		for (; ii < r && c[ii].val == i && c[ii].tip == 1; ++ii) {
			deschise.insert(c[ii].i);
		}
		if (deschise.size() == 0) { //Nu am deschis nici un interval deci nu este nici un capat aici
			continue;
		}
		int xx = *deschise.rbegin();
		mat[xx] = min(mat[xx], mat[lClosed] + cost[i]);
		//Inchid alea care trebuie
		for (; ii < r && c[ii].val == i && c[ii].tip == 2; ++ii) {
			lClosed = max(lClosed, c[ii].i);
			deschise.erase(c[ii].i);
		}
	}
// 	printf ("Am terminat calculul\n");
	fprintf (fout, "%d\n", mat[n]);
	return 0;
}
