#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

int gr1[2007];
int neigh[200000];
int start[2008];
char usedm[200000];

int gr2[4014];

FILE *in, *out;
struct arc {
	int a;
	int b;
} *arcs;

int arccmp (const struct arc *x, const struct arc *y) {
	return x->a-y->a;
}

int posnodes[2007];
char used[2007];
int npos;
int maxnodes;
int rez[2007];
char fnd;

int heap[4014];

void siftdown (int i) {
	if (gr2[heap[i]] > gr2[heap[2*i+1]] && gr2[heap[i]] > gr2[heap[2*i+2]]) return;
	if (gr2[heap[2*i+1]]<gr2[heap[2*i+2]]) {
		int cval;
		cval = heap[i]
		heap[i] = heap[2*i+2];
		heap[2*i+2] = cval;
		percolate (2*i+2);
	}
	else {
		int cval;
		cval = heap[i];
		heap[i] = heap[2*i+1];
		heap[2*i+1] = cval;
		percolate (2*i+1)
	}
}

void gen (int k) {
	int i, j, l;
	if (fnd == 1) return;
	if (k == maxnodes) {
		fnd = 1;
	}
	else {
		for (i=0;i<npos;i++) {
			if (used[i] == 0) {
				for (j=0;j<k;j++) {
					for (l=start[posnodes[i]];l<start[posnodes[i]+1];l++) {
						if (usedm[l] == 0 && neigh[l] == rez[j]) {
							break;
						}
					}
					if (l == start[posnodes[i]+1]) {
						break;
					}
				}
				if (j == k) {
					used[i] = 1;
					rez[k] = posnodes[i];
					gen (k+1);
					if (fnd == 1) return;
					used[i] = 0;
				}
			}
		}
	}
}

int main () {
	int i, j, l;
	FILE *in, *out;
	int n, m, k;
	int maxgr;
	int cgr;

	in = fopen ("promo.in", "r");
	out = fopen ("promo.out", "w");
	
	fscanf (in, "%d %d", &m, &k);
	arcs = (struct arc *) malloc (2*k*sizeof (struct arc));
	for (i=0;i<k;i++) {
		fscanf (in, "%d %d", &arcs[2*i].a, &arcs[2*i].b);
		arcs[2*i+1].a = --arcs[2*i].b;
		arcs[2*i+1].b = --arcs[2*i].a;
		gr1[arcs[2*i].a]++;
		gr1[arcs[2*i].b]++;
	}
	qsort (arcs, 2*k, sizeof (struct arc), (int (*)(const void*,const void*))arccmp);
	memset (start, -1, m*sizeof (int));
	start[arcs[0].a] = 0;
	for (i=0;i<2*k;i++) {
		neigh[i]=arcs[i].b;
		if (i > 0 && arcs[i-1].a != arcs[i].a) {
			start[arcs[i].a] = i;
		}
	}
	start[m] = i;
	maxgr = 0;
	for (i=m-1;i>=0;i--) {
		if (maxgr < gr1[i]) maxgr = gr1[i];
		if (start[i] == -1) start[i] = start[i+1];
	}

/*	for (i=0;i<m;i++) {
		printf ("%d: ", i+1);
		for (j=start[i];j<start[i+1];j++) {
			printf ("%d ", neigh[j]+1);
		}
		printf ("\n");
	}*/
	
	n = 0;
	cgr = 0;
	for (i=maxgr;i>0;i--) {
		// find (i+1)-complete graphs
		fnd = 0;
		maxnodes = i+1;
		npos = 0;
		for (j=0;j<m;j++) {
			if (gr1[j] >= i) {
				posnodes[npos++] = j;
			}
		}
		memset (used, 0, npos*sizeof(char));
		gen (0);
		if (fnd == 1) {
			for (j=0;j<=i;j++) {
				gr1[rez[j]] -= i;
				for (l=start[rez[j]];l<start[rez[j]+1];l++) {
					if (used[neigh[l]]) {
						usedm[l] = 1;
					}
				}
			}
			// exista un nod de grad i+1;
			gr2[n++] = i+1;
			cgr += i+1;
			i++;
		}
	}
	// 2*m = grad total
	// 2*m - cgr = nr de noduri de grad 1
	for (i=0;i<2*m-cgr;i++) {
		gr2[n++] = 1;
	}
	fprintf (out, "%d\n", n);
	maxgr = 0;
	for (i=n-1;i>=0;i--) {
		fprintf (out, "%d %d\n", i+1, maxgr+1);
		gr2[i]--;
		if (--gr2[maxgr] == 0) maxgr++;
	}

	return 0;
}
