#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define MAXN 60005
#define MAXL 1000005
#define MAXT 2097152

int N, L, c[MAXL];

vector< pair<int, int> > x, tmp;
int bst[MAXN];
int aint[MAXT], Min[MAXT], MIN[MAXT];

inline void build_tree( int n, int l, int r )
{
	if (l == r)
	{
		Min[n] = c[l];
		return;
	}

	int m = (l + r) >> 1, lc = (n << 1), rc = lc + 1;
	build_tree( lc, l, m );
	build_tree( rc, m + 1, r );

	Min[n] = Min[lc] < Min[rc] ? Min[lc] : Min[rc];
}

inline void update( int n, int l, int r, int vl, int vr, int val )
{
	if (vl <= l && r <= vr)
	{
		aint[n] = val;
		MIN[n] = aint[n] + Min[n];
		return;
	}

	int m = (l + r) >> 1, lc = (n << 1), rc = lc + 1;
	if (aint[n] != -1)
	{
		aint[lc] = aint[rc] = aint[n];
		aint[n] = -1;
	}

	if (vl <= m)
		update( lc, l, m, vl, vr, val );
	if (vr > m)
		update( rc, m + 1, r, vl, vr, val );
	MIN[n] = MIN[lc] < MIN[rc] ? MIN[lc] : MIN[rc];
}

inline int query( int n, int l, int r, int vl, int vr )
{
	int M1, M2;
	int m = (l + r) >> 1, lc = (n << 1), rc = lc + 1;
	if (vl <= l && r <= vr)
		return MIN[n];
	
	if (aint[n] != -1)
	{
		aint[lc] = aint[rc] = aint[n];
		MIN[lc] = aint[lc] + Min[lc];
		MIN[rc] = aint[rc] + Min[rc];
	}

	M1 = M2 = 0x3f3f3f3f;
	if (vl <= m)
		M1 = query( lc, l, m, vl, vr );
	if (vr > m)
		M2 = query( rc, m + 1, r, vl, vr );
	
	return (M1 < M2 ? M1 : M2);
}

int aib[MAXL];
inline int aibquery( int poz )
{
	int rez = 0;
	for (; poz; poz -= (poz ^ (poz - 1)) & poz)
		rez += aib[poz];
	return rez;
}

inline void aibadd( int poz, int val )
{
	for (; poz < MAXL; poz += (poz ^ (poz - 1)) & poz)
		aib[poz] += val;
}

int main()
{
	freopen("cover.in", "rt", stdin);
	freopen("cover.out", "wt", stdout);

	scanf("%d %d", &N, &L);
	for (int i = 1; i <= L; i++)
		scanf("%d", c + i);
	
	for (int i = 1; i <= N; i++)
	{
		int l, r;
		scanf("%d %d", &l, &r);
		tmp.push_back( make_pair(l, r) );
	}
	sort( tmp.begin(), tmp.end() );
	tmp.resize( unique( tmp.begin(), tmp.end() ) - tmp.begin() );
	N = (int)tmp.size();
	for (int i = 0; i < N; i++)
		aibadd( tmp[i].second, 1 );

	x.clear(); x.push_back( make_pair(0, 0) );
	for (int i = 0; i < N; i++)
	{
		aibadd( tmp[i].second, -1 );	
		if (!aibquery( tmp[i].second ))
			x.push_back( tmp[i] );
	}
	N = (int)x.size() - 1;

	aint[1] = 0x3f3f3f3f; MIN[1] = Min[1] + aint[1]; build_tree(1, 0, L);

	bst[0] = 0;
	for (int i = 1; i <= N; i++)	
	{
		update( 1, 0, L, x[i - 1].second + 1, x[i].second, bst[i - 1] );
		bst[i] = query( 1, 0, L, x[i].first, x[i].second );
	}

	printf("%d\n", bst[N]);
	
	return 0;
}
