{  C " ࠠ"                                        }
{ 襭: ⠭ ३                                     }

program StaC;

const
  InputFileName = 'INPUT.TXT';
  OutputFileName = 'OUTPUT.TXT';

  MaxN = 20;

  dX: array [1..6] of Integer = (1, -1, 0, 0, 0, 0);
  dY: array [1..6] of Integer = (0, 0, 1, -1, 0, 0);
  dZ: array [1..6] of Integer = (0, 0, 0, 0, 1, -1);

type
  TPoint = record
    X, Y, Z: ShortInt;
  end;

  TQue = array [0..MaxN * MaxN * MaxN + 1] of TPoint;

var
  I, J, K, L: LongInt;
  A, B, F: array [0..MaxN+1, 0..MaxN+1, 0..MaxN+1] of Integer;
  M, N: LongInt;
  StX, StY, StZ, FinX, FinY, FinZ: LongInt;
  MainQue, NextQue: ^TQue;
  H1, T1, T2: LongInt;
  X, Y, Z: Integer;

procedure ReadData;
var
  C: Char;
begin
  Assign(Input, InputFileName);
  Reset(Input);

  ReadLn(M, N);

  FillChar(A, Sizeof(A), $ff);
  FillChar(B, Sizeof(B), $ff);

  for K := 1 to M do
  begin
    for I := 1 to N do
    begin
      for J := 1 to N do
      begin
        Read(C);
        if C = 'I' then
        begin
          StX := I;
          StY := J;
          StZ := K;
        end;

        if C = 'G' then
        begin
          FinX := I;
          FinY := J;
          FinZ := K;
        end;

        if C = '#' then
          A[I, J, K] := 0
        else
          A[I, J, K] := 1;
      end;
      ReadLn;
    end;
    ReadLn;
  end;

  Close(Input);
end;

procedure InitQueues;
begin
  New(MainQue);
  New(NextQue);
  T2 := 1;
  NextQue^[0].X := StX;
  NextQue^[0].Y := StY;
  NextQue^[0].Z := StZ;
  B[StX, StY, StZ] := 0;
  F[StX, StY, StZ] := 0;
end;

procedure NextStep;
var
  Temp: Pointer;
begin
  Temp := MainQue;
  MainQue := NextQue;
  NextQue := Temp;

  H1 := 0;
  T1 := T2;
  T2 := 0;

  while H1 <> T1 do
  begin
    X := MainQue^[H1].X;
    Y := MainQue^[H1].Y;
    Z := MainQue^[H1].Z;
    Inc(H1);

    for I := 1 to 6 do
      case A[X + dX[I], Y + dY[I], Z + dZ[I]] of
        0: if B[X + dX[I], Y + dY[I], Z + dZ[I]] = -1 then
           begin
             NextQue^[T2].X := X + dX[I];
             NextQue^[T2].Y := Y + dY[I];
             NextQue^[T2].Z := Z + dZ[I];
             B[X + dX[I], Y + dY[I], Z + dZ[I]] := B[X, Y, Z] + 1;
             F[X + dX[I], Y + dY[I], Z + dZ[I]] := I;
             Inc(T2);
           end;
        1: if B[X + dX[I], Y + dY[I], Z + dZ[I]] = -1 then
           begin
             MainQue^[T1].X := X + dX[I];
             MainQue^[T1].Y := Y + dY[I];
             MainQue^[T1].Z := Z + dZ[I];
             B[X + dX[I], Y + dY[I], Z + dZ[I]] := B[X, Y, Z];
             F[X + dX[I], Y + dY[I], Z + dZ[I]] := I;
             Inc(T1);
           end;
      end;
  end;
end;

procedure ProcessMap;
var
  X, Y, Z, From: Integer;
begin
  X := FinX;
  Y := FinY;
  Z := FinZ;
  while (X <> StX) or (Y <> StY) or (Z <> StZ) do
  begin
    if A[X, Y, Z] = 0 then
      A[X, Y, Z] := 2;
    From := F[X, Y, Z];
    X := X - dX[From];
    Y := Y - dY[From];
    Z := Z - dZ[From];
  end;
end;

procedure WriteAnswer;
begin
  Assign(Output, 'OUTPUT.TXT');
  Rewrite(Output);

  WriteLn(B[FinX, FinY, FinZ]);
  for K := 1 to M do
  begin
    for I := 1 to N do
    begin
      for J := 1 to N do
      begin
        if (I = StX) and (J = StY) and (K = StZ) then
          Write('I')
        else
        if (I = FinX) and (J = FinY) and (K = FinZ) then
          Write('G')
        else
        case A[I, J, K] of
          0: Write('#');
          1: Write('.');
          2: Write('-');
        end;
    {    Write(B[I, J, K]);}
      end;
      WriteLn;
    end;
    WriteLn;
  end;

  Close(Output);
end;

begin
  ReadData;
  InitQueues;
  while T2 > 0 do
    NextStep;
  ProcessMap;
  WriteAnswer;
end.