{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
uses testlib;

const MAXLEN = 10000;

type TCoord = record x,y : integer; was : boolean; end;
     PTCoord = ^TCoord;
     TArray = array[0..MAXLEN-1] of TCoord;
     PTArray = ^TArray;

var a : array[0..10] of PTArray;
    i,len : longint;
    p : TCoord;
    q : PTCoord;

procedure Put(p:TCoord;i: longint);
begin
  if a[i div MAXLEN] = nil then new (a[i div MAXLEN]);
  a[i div MAXLEN]^[i mod MAXLEN] := p;
end;

function Get(i: longint): PTCoord;
begin
  Get := @a[i div MAXLEN]^[i mod MAXLEN];
end;

function Less(p,q : PTCoord):boolean;
begin
  if p^.y < q^.y then Less := true
  else if p^.y > q^.y then Less := false
  else Less := p^.x < q^.x;
end;

function Equal(p,q : PTCoord):boolean;
begin
  Equal := not Less (p,q) and not Less (q,p);
end;


procedure Swap(p,q : PTCoord);
var x : TCoord;
begin
  x := p^;
  p^ := q^;
  q^ := x;
end;

procedure Sort(l, r: longint);
var
  i, j: longint;
  x : TCoord;
begin
  i := l; j := r; x := Get((l+r) DIV 2)^;
  repeat
    while Less ( Get(i), @x) do i := i + 1;
    while Less ( @x, Get(j)) do j := j - 1;
    if i <= j then
    begin
      Swap ( Get(i), Get(j));
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

function Str (x : longint): string;
var s : string;
begin
  System.str (x,s);
  Str := s;
end;

function Found (p : TCoord): PTCoord;
var l, r, m : longint;
    pm : PTCoord;
begin
  l := 1; r := len;
  while l <= r do begin
    m := (l + r) div 2;
    pm := Get (m);
    if Less ( @p, pm) then r := m - 1
    else if Less ( pm, @p) then l := m + 1
    else begin
      Found := pm;
      Exit;
    end;
  end;
  if (l=r) and (Equal ( Get(l), @p)) then Found := Get (l)
  else Found := nil;
end;


begin
  fillchar(a, sizeof(a), 0);
  len := 0;
  while not ouf.seekeof do begin
    inc (len);
    p.x := ouf.Readlongint;
    p.y := ouf.Readlongint;
    p.was := true;
    Put (p, len);
  end;

  Sort (1,len);

  while not ans.seekeof do begin
    p.x := ans.readlongint;
    p.y := ans.readlongint;
    q := Found (p);
    if q = nil then QUIT (_WA,' ⨫  (' + Str(p.x) +',' + Str(p.y) + ')');
    if not q^.was then QUIT (_WA,' (' + Str(p.x) +',' + Str(p.y) + ') ⨫ ');
    q^.was := false;
  end;

  for i := 1 to len do begin
    q := Get (i);
    if q^.was then QUIT (_WA,'譨  (' + Str(q^.x) +',' + Str(q^.y) + ')');
  end;
  QUIT (_OK, str (len) + ' ⮢');
end.