{  D " ᫮ N"                                    }
{ 襭: ⠭ ३                                     }

{$G+,I+,R-,Q-,S+}

program StaD;

const
  InputFileName = 'INPUT.TXT';
  OutputFileName = 'OUTPUT.TXT';

  DigNum = 103;

type
  TLong = array [0..DigNum] of ShortInt;
  TDigit = 0..9;

var
  N, M: TLong;
  Poses: array [1..100] of Integer;
  PosNum: LongInt;
  A, B, C: array [0..103] of TLong;
  R, S: LongInt;

procedure ReadLong(var A: TLong);
var
  S: string;
  I: LongInt;
begin
  ReadLn(S);
  FillChar(A, Sizeof(A), 0);
  for I := 1 to Length(S) do
    A[Length(S) - I + 1] := Ord(S[I]) - Ord('0');
  A[0] := Length(S);
end;

procedure InitLong(var A: TLong; Digit: TDigit);
begin
  FillChar(A, Sizeof(A), 0);
  A[0] := 1;
  A[1] := Digit;
end;

procedure TenIn(N: Integer; var A: TLong);
var
  I, R: LongInt;
begin
  FillChar(A, Sizeof(A), 0);
  if N >= 0 then
    A[N+1] := 1;
end;

procedure AddLong(A, B: TLong; var C: TLong);
var
  Carry, I: LongInt;
begin
  FillChar(C, Sizeof(C), 0);
  Carry := 0;
  for I := 1 to DigNum do
  begin
    Carry := A[I] + B[I] + Carry;
    C[I] := Carry mod 10;
    Carry := Carry div 10;
  end;
end;

procedure SubLong(A, B: TLong; var C: TLong);
var
  Carry, I: LongInt;
begin
  FillChar(C, Sizeof(C), 0);
  Carry := 0;
  for I := 1 to DigNum do
  begin
    C[I] := A[I] - B[I] + Carry;
    if C[I] < 0 then
    begin
      C[I] := C[I] + 10;
      Carry := -1;
    end
    else
      Carry := 0;
  end;
end;

procedure Mult(A: TLong; B: LongInt; var C: TLong);
var
  Carry, I: LongInt;
begin
  FillChar(C, Sizeof(C), 0);
  Carry := 0;
  for I := 1 to DigNum do
  begin
    Carry := Carry + A[I] * B;
    C[I] := Carry mod 10;
    Carry := Carry div 10;
  end;
end;

procedure Shift(A: TLong; K: Integer; var B: TLong);
var
  I: LongInt;
begin
  FillChar(B, Sizeof(B), 0);
  for I := 1 to DigNum - K do
    B[I + K] := A[I];
end;

procedure CutFrom(A: TLong; X: LongInt; var B: TLong);
var
  Res, I: LongInt;
begin
  FillChar(B, Sizeof(B), 0);
  for I := 1 to X do
    B[I] := A[I];
end;

procedure Print(const A: TLong);
var
  I: LongInt;
begin
  I := DigNum;
  while (I > 0) and (A[I] = 0) do
    Dec(I);
  if I = 0 then
    Write(0)
  else
    while I > 0 do
    begin
      Write(A[I]);
      Dec(I);
    end;
  WriteLn;
end;

procedure ReadData;
begin
  Assign(Input, InputFileName);
  Reset(Input);

  ReadLong(N);
  ReadLong(M);

  R := N[0] - 1;

  S := M[0];

  Close(Input);
end;

{  樨,    ந ᫥饥:           }
{       12463821246                                             }
{              12463821246                                      }
procedure FindPoses;
var
  I, J: LongInt;
  Flag: Boolean;
begin
  PosNum := 0;
  for I := 2 to S do
  begin
    Flag := True;
    for J := I to S do
      if M[S-J+1] <> M[S-J+I] then
      begin
        Flag := False;
        Break;
      end;
    if Flag then
    begin
      Inc(PosNum);
      Poses[PosNum] := I;
    end;
  end;
end;

procedure Solve;
var
  I, J: LongInt;
  WasGreater: Boolean;
  Temp: TLong;
begin
  InitLong(B[0], 0);

  for I := 1 to R do
  begin
    TenIn(I-S, B[I]);
    for J := 1 to PosNum do
      if I - Poses[J] + 1 > 0 then
        SubLong(B[I], B[I - Poses[J] + 1], B[I]);
    for J := 1 to I - S do
    begin
      Shift(B[J], I - S - J, Temp);
      SubLong(B[I], Temp, B[I]);
    end;
  end;

  for I := 1 to N[0] do
  begin
    InitLong(A[I], 0);
    if I >= S then
    begin
      if N[I] > M[S] then
      begin
        TenIn(I - S, A[I]);
        for J := 1 to PosNum do
          if I - Poses[J] + 1 > 0 then
            SubLong(A[I], B[I - Poses[J] + 1], A[I]);
        for J := 1 to I - S do
        begin
          Shift(B[J], I - S - J, Temp);
          SubLong(A[I], Temp, A[I]);
        end;
      end;

      if N[I] = M[S] then
      begin
        J := I;
        WasGreater := False;
        while (J > I-S) and (N[J] = M[S-I+J]) do
        begin
          if N[J] > M[S-I+J] Then WasGreater := True;
          Dec(J);
        end;
        if (J > I-S) and (N[J] > M[S-I+J]) Then WasGreater := True;
        if (J <= I-S) or (N[J] > M[S-I+J]) then
        begin
          if WasGreater then
          begin
            TenIn(I - S, A[I]);
            for J := 1 to PosNum do
              if I - Poses[J] + 1 > 0 then
                SubLong(A[I], B[I - Poses[J] + 1], A[I]);
            for J := 1 to I - S do
            begin
              Shift(B[J], I - S - J, Temp);
              SubLong(A[I], Temp, A[I]);
            end;
          end
          else
          begin
            CutFrom(N, I-S, A[I]);
            InitLong(Temp, 1);
            AddLong(A[I], Temp, A[I]);

            for J := 1 to PosNum do
              if I - Poses[J] + 1 > 0 then
                SubLong(A[I], C[I - Poses[J] + 1], A[I]);
            SubLong(A[I], A[I-S], A[I]);
          end;
        end;
      end;
    end;
    C[I] := A[I];
    for J := 1 to I-1 do
    begin
      Shift(B[J], I - J - 1, Temp);
      Mult(Temp, N[I], Temp);
      AddLong(A[I], Temp, A[I]);
    end;
    AddLong(A[I], A[I-1], A[I]);
  end;
end;

procedure WriteAnswer;
var
  I, Sum: LongInt;
begin
  Assign(Output, OutputFileName);
  Rewrite(Output);

  Print(A[N[0]]);

  Close(Output);
end;

begin
  ReadData;
  FindPoses;
  Solve;
  WriteAnswer;
end.