
{.$define Debug}

program Solution;
{$M 16384,0,0}

{$ifndef Debug}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'output.txt';
{$else}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  maxN                          = 60;

type
  TInfo                         = record
    v                           : integer;
    prev                        : integer;
  end;

var
  m                             : integer;
  a,b                           : integer;
  n                             : integer;
  c                             : array[1..maxN,1..maxN] of boolean;
  f                             : array[1..maxN,1..maxN] of boolean;
  mapIn                         : array[1..maxN] of integer;
  mapOut                        : array[1..maxN] of integer;
  rev                           : array[1..maxN] of integer;
  q                             : array[1..maxN] of TInfo;
  head,tail                     : integer;
  visited                       : array[1..maxN] of boolean;
  nAB                           : integer;

procedure Push( a, prev : integer );
begin
  if visited[a] then exit;
  visited[a] := true;
  inc( head );
  q[head].v := a;
  q[head].prev := prev;
end;

procedure Pop( var a, prev : integer );
begin
  a := q[tail].v;
  prev := q[tail].prev;
  inc( tail );
end;

function Upgrade : boolean;
var
  i,j                           : integer;
  prev                          : integer;
  newPrev                       : integer;

begin
  head := 0;
  tail := 1;
  fillchar( visited, sizeof(visited), false );
  Push( mapOut[a], 0 );
  while head >= tail do begin
    newPrev := tail;
    Pop( i, prev );
    if i = mapIn[b] then begin
      while prev <> 0 do begin
        j := q[prev].v;
        if c[j,i] and not f[j,i] then f[j,i] := true else
        if c[i,j] and f[i,j] then f[i,j] := false;
        i := q[prev].v;
        prev := q[prev].prev;
      end;
      Upgrade := true;
      exit;
    end;
    for j := 1 to n do
      if c[i,j] and not f[i,j] or
         c[j,i] and f[j,i] then Push( j, newPrev );
  end;
  Upgrade := false;
end;

procedure Solve;
begin
  fillchar( f, sizeof(f), false );
  while Upgrade do ;
end;

procedure ReadData;
var
  i,j				: integer;

begin
  read( m, a, b );
  fillchar( c, sizeof(c), false );
  n := 2 * m - 2;
  j := 1;
  for i := 1 to m do begin
    mapIn[i] := j;
    rev[j] := 0;
    if (i <> a) and (i <> b) then begin
      mapOut[i] := j + 1;
      rev[j+1] := i;
      inc( j, 2 )
    end else begin
      mapOut[i] := j;
      rev[j] := i;
      inc( j );
    end;
  end;
  nAB := 0;
  while not SeekEOF( input ) do begin
    read( i, j );
    if j = a then continue;
    if (i = a) and (j = b) then
      inc( nAB )
    else begin
      if i <> j then
        c[mapOut[i],mapIn[j]] := true;
    end;
  end;
  for i := 1 to m do
    if mapIn[i] <> mapOut[i] then c[mapIn[i],mapOut[i]] := true;
end;

procedure WriteData;
var
  i,j				: integer;

  function Trace( i : integer ) : integer;
  var
    j                           : integer;

  begin
    for j := 1 to n do
      if f[i,j] then begin
        Trace := j;
        exit;
      end;
  end;

begin
  j := 0;
  for i := 1 to n do
    if f[mapOut[a],i] then inc( j );
  writeln( j + nAB );
  for i := 1 to n do
    if f[mapOut[a],i] then begin
      j := i;
      write( a, ' ' );
      repeat
        if rev[j] <> 0 then write( rev[j], ' ' );
        if rev[j] = b then break;
        j := Trace( j );
      until false;
      writeln;
    end;
  for i := 1 to nAB do writeln( a, ' ', b );
end;

procedure Initialize;
begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  WriteData;
  Finalize;
end.