
{.$define Debug}

program Solution;
{$M 16384,0,0}

{$ifndef Debug}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'output.txt';
{$else}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  maxN                          = 60;

type
  TInfo                         = record
    v                           : integer;
    prev                        : integer;
  end;

var
  m                             : integer;
  a,b                           : integer;
  n                             : integer;
  c                             : array[1..maxN,1..maxN] of boolean;
  f                             : array[1..maxN,1..maxN] of boolean;
  g                             : array[1..maxN,1..maxN] of boolean;
  mapIn                         : array[1..maxN] of integer;
  mapOut                        : array[1..maxN] of integer;
  q                             : array[1..maxN] of TInfo;
  head,tail                     : integer;
  visited                       : array[1..maxN] of boolean;
  idxS                          : integer;
  idxT                          : integer;

procedure Push( a, prev : integer );
begin
  if visited[a] then exit;
  visited[a] := true;
  inc( head );
  q[head].v := a;
  q[head].prev := prev;
end;

procedure Pop( var a, prev : integer );
begin
  a := q[tail].v;
  prev := q[tail].prev;
  inc( tail );
end;

function Upgrade : boolean;
var
  i,j                           : integer;
  prev                          : integer;
  newPrev                       : integer;

begin
  head := 0;
  tail := 1;
  fillchar( visited, sizeof(visited), false );
  Push( idxS, 0 );
  while head >= tail do begin
    newPrev := tail;
    Pop( i, prev );
    if i = idxT then begin
      while prev <> 0 do begin
        j := q[prev].v;
        if c[j,i] and not f[j,i] then f[j,i] := true else
        if c[i,j] and f[i,j] then f[i,j] := false;
        i := q[prev].v;
        prev := q[prev].prev;
      end;
      Upgrade := true;
      exit;
    end;
    for j := 1 to n do
      if c[i,j] and not f[i,j] or
         c[j,i] and f[j,i] then Push( j, newPrev );
  end;
  Upgrade := false;
end;

procedure Solve;
begin
  fillchar( f, sizeof(f), false );
  while Upgrade do ;
end;

procedure ReadData;
var
  i,j				: integer;

begin
  read( m );
  fillchar( c, sizeof(c), false );
  n := 2 * m + 2;
  idxS := n - 2;
  idxT := n - 1;
  j := 1;
  for i := 1 to m do begin
    mapIn[i] := j;
    mapOut[i] := j + 1;
    inc( j, 2 )
  end;
  while not SeekEOF( input ) do begin
    read( i, j );
    if i <> j then c[mapOut[i],mapIn[j]] := true;
  end;
  for i := 1 to m do begin
    c[mapIn[i],idxT] := true;
    c[idxS,mapOut[i]] := true;
  end;
end;

procedure WriteData;
var
  i,j,k				: integer;
  degIn                         : array[1..maxN] of integer;
  degOut                        : array[1..maxN] of integer;

  function Trace( i : integer ) : integer;
  var
    j                           : integer;

  begin
    for j := 1 to m do
      if g[i,j] then begin
        Trace := j;
        exit;
      end;
    Trace := 0;
  end;

begin
  fillchar( visited, sizeof(visited), false );
  fillchar( g, sizeof(g), false );
  for i := 1 to m do
    for j := 1 to m do g[i,j] := f[mapOut[i],mapIn[j]];

  fillchar( degIn, sizeof(degIn), 0 );
  fillchar( degOut, sizeof(degOut), 0 );

  k := 0;
  for i := 1 to m do
    for j := 1 to m do
      if g[i,j] then begin
        inc( k );
        inc( degOut[i] );
        inc( degIn[j] );
      end;

  writeln( m - k );

  for i := 1 to m do
    if (degIn[i] = 0) and (degOut[i] > 0) then begin
      j := i;
      while j <> 0 do begin
        write( j, ' ' );
        visited[j] := true;
        j := Trace( j );
      end;
      writeln;
    end;

  for i := 1 to m do
    if not visited[i] then writeln( i );
end;

procedure Initialize;
begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  WriteData;
  Finalize;
end.
