{ ----------------- Compiler directives ------------------- }
{$A+,B-,E-,F-,G-,N+,O-,P-,Q-,T-,V+,X+}
{$M 65520,0,655360}

{ ------------------ Debug mode on/off -------------------- }

{
{$DEFINE __DEBUG__}

{$IFDEF __DEBUG__}
{$D+,I+,L+,R+,S+,Y+}
{$ELSE}
{$D-,I-,L-,R-,S-,Y-}
{$ENDIF}
{ --------------- End Compiler directives ----------------- }

program p01_06_a;

const
    max_num = 100;

type
	OtkrKonv = array [1..max_num, 1..max_num] of boolean;

var
	O, K : array [1..max_num] of record
    							d1, d2 : longint;
                                end;
    num_o, num_k : longint;

    CanPut : OtkrKonv;

    i, j : longint;

    Otkr, Konv : array [0..100] of record
    								marked : boolean;
                                    toWhich : longint;
                                    end;

    num_best : longint;

function CanPutInto (i, j : longint) : boolean;
	function TryPut (l1, l2, m1, m2 : longint) : boolean;
	    type
	    	Area =
				record
	            	num_prom : longint;
	                p1l, p1r, p2l, p2r : real;
	            end;

        var
            a1, a2 : Area;

        procedure Solve (l1, l2, m1 : real; var a : Area);
        	var
            	x1, x2, d : real;

        	begin
            	d := l1*l1 + l2*l2 - m1*m1;
                if d <= 0
                	then
                    	begin
                        	a.num_prom := 1;
                            a.p1l := 0;
                            a.p1r := 1;
                            Exit;
                        end;
                x1 := (l1 - sqrt (d)) / (m1 + l2);
                x2 := - x1 + ((2*l1) / (m1 + l2));
                if (x1 <= 0) and (x2 >= 1)
                	then
                    	begin
                        	a.num_prom := 0;
                            Exit;
                        end
                else if (x1 <= 0) and (x2 <= 1)
                	then
                    	begin
                        	a.num_prom := 1;
                            a.p1l := x2;
                            a.p1r := 1;
                            Exit;
                        end
                else if (x1 >= 0) and (x2 <= 1)
                	then
                    	begin
                        	a.num_prom := 2;
                            a.p1l := 0;
                            a.p1r := x1;
                            a.p2l := x2;
                            a.p2r := 1;
                            Exit;
                        end
                else if (x1 >= 0) and (x1 <= 1) and (x2 >= 1)
                	then
                    	begin
                        	a.num_prom := 1;
                            a.p1l := 0;
                            a.p1r := x1;
                            Exit;
                        end
                else if (x1 >= 1) and (x2 >= 1)
                	then
                    	begin
                        	a.num_prom := 1;
                            a.p1l := 0;
                            a.p1r := 1;
                            Exit;
                        end;
            end;

		function Intercepts (a, b : Area) : boolean;
        	begin
            	if (a.num_prom = 0) or (b.num_prom = 0)
                	then
                    	begin
                        	Intercepts := false;
                            Exit;
                        end
                else if (a.num_prom = 1) and (b.num_prom = 1)
                	then
                    	if ((a.p1r >= b.p1l) and (a.p1r <= b.p1r)) or
                        		((b.p1r >= a.p1l) and (b.p1r <= a.p1r))
                        	then
		                    	begin
		                        	Intercepts := true;
		                            Exit;
		                        end
                            else
                            	begin
		                        	Intercepts := false;
		                            Exit;
		                        end
                else Intercepts := true;
            end;

        begin
        	Solve (l1, l2, m1, a1);
            Solve (l2, l1, m2, a2);
            if Intercepts (a1, a2)
            	then TryPut := true
                else TryPut := false;
        end;

	begin
    	if ((O [i].d1 > K [j].d1) and (O [i].d2 > K [j].d2)) or
        	((O [i].d1 > K [j].d2) and (O [i].d2 > K [j].d1))
            then
            	begin
                	CanPutInto := false;
                    Exit;
                end
        else if ((O [i].d1 <= K [j].d1) and (O [i].d2 <= K [j].d2)) or
        	((O [i].d1 <= K [j].d2) and (O [i].d2 <= K [j].d1))
            then
            	begin
                	CanPutInto := true;
                    Exit;
                end
            else
            	if TryPut (O [i].d1, O [i].d2, K [j].d1, K [j].d2)
                	then
                    	begin
                        	CanPutInto := true;
                            Exit;
                        end
            else CanPutInto := false;
    end;

procedure Initialize;
	begin
    	fillchar (Otkr, Sizeof (Otkr), 0);
    	fillchar (Konv, Sizeof (Konv), 0);
        num_best := 0;

        for i := 1 to num_o do
        	begin
	        	for j := 1 to num_k do
	            	if CanPut [i, j] and (not Konv [j].marked)
                    	then
                        	begin
                            	Otkr [i].marked := true;
                                Konv [j].marked := true;
                                Otkr [i].toWhich := j;
                                Konv [j].toWhich := i;
                                inc (num_best);
                                break;
                            end;
            end;
    end;

procedure Maximize;
	label Stop;
	var
    	path_found : boolean;
        reachedO, reachedK : array [1..100] of boolean;
        prevO, prevK : array [1..100] of longint;
        seeO, seeK : array [1..100] of longint;

        firstO, lastO, firstK, lastK : longint;

        k, m : longint;

	begin
        repeat
	       	path_found := false;
            for i := 1 to num_o do
            	if (not Otkr [i].marked)
                	then
                    	begin
                            { 設 Konv, ⨦  Otkr [i]}
                            firstO := 1;
                            lastO := 1;
                            firstK := 1;
                            lastK := 0;
                            fillchar (reachedO, sizeof (reachedO), 0);
                            fillchar (reachedK, sizeof (reachedK), 0);
                            fillchar (seeO, sizeof (seeO), 0);
                            fillchar (seeK, sizeof (seeK), 0);
                            fillchar (prevO, sizeof (prevO), 0);
                            fillchar (prevK, sizeof (prevK), 0);

                            seeO [1] := i;
                            reachedO [i] := true;
                            while (firstO <= lastO) or (firstK <= lastK) do
                            	begin
                                	for k := firstO to lastO do
                                    	for m := 1 to num_k do
                                        	if CanPut [seeO [k], m]
													and (not reachedK [m]) and (Otkr [seeO [k]].toWhich <> m)
                                    		then begin
                                            	reachedK [m] := true;
                                                prevK [m] := seeO [k];
                                                inc (lastK);
                                                seeK [lastK] := m;
                                                end;
                                    firstO := lastO + 1;
                                	for k := firstK to lastK do
										if (Konv [seeK [k]].toWhich <> 0) and (not reachedO [Konv [seeK [k]].toWhich])
                                    		then begin
                                            	m := Konv [seeK [k]].toWhich;
                                            	reachedO [m] := true;
                                                prevO [m] := seeK [k];
                                                inc (lastO);
                                                seeO [lastO] := m;
                                                end;
                                    firstK := lastK + 1;
                                end;

                            for k := 1 to num_k do
                            	if (not Konv [k].marked) and (reachedK [k])
                                	then
                                    	begin
                                            { 諨 㢥稢 楯 }
                                            m := k;
                                            repeat
                                                Konv [m].marked := true;
                                                Konv [m].toWhich := prevK [m];
                                                Otkr [prevK [m]].marked := true;
                                                Otkr [prevK [m]].toWhich := m;
                                                m := prevK [m];
                                                m := prevO [m];
                                            until m = 0;

                                            path_found := true;
                                            inc (num_best);

                                            goto Stop;
                                        end;

                        end;
Stop:
        until not (path_found);
    end;

begin
	assign (input, 'input.txt');
    reset (input);
    readln (num_k, num_o);

    for i := 1 to num_k do
    	begin
        	read (K [i].d1);
            read (K [i].d2);
        end;

    for i := 1 to num_o do
    	begin
        	read (O [i].d1);
            read (O [i].d2);
        end;

	close (input);

    if (num_o = 0) or (num_k = 0)
    	then
        	begin
            	assign (output, 'output.txt');
                rewrite (output);
                Write ('0');
                close (output);
                Halt (0);
            end;

    fillchar (CanPut, sizeof (CanPut), 0);
    for i := 1 to num_o do
    	for j := 1 to num_k do
        	if CanPutInto (i, j)
            	then CanPut [i, j] := true;
{			if ((O [i].d1 <= K [j].d1) and (O [i].d2 <= K [j].d2))
            		or ((O [i].d1 <= K [j].d2) and (O [i].d2 <= K [j].d1))
                then
                	CanPut [i, j] := true;
}
    Initialize;

    Maximize;

    assign (output, 'output.txt');
    rewrite (output);
    writeln (num_best);

    i := 1;
    for j := 1 to num_best - 1 do
    	begin
        	while (not Otkr [i].marked) do
            	inc (i);
            Write (i, ' ', Otkr [i].toWhich, ' ');
            inc (i);
        end;
    if (num_best <> 0)
    	then
        	begin
			   	while (not Otkr [i].marked) do
			       	inc (i);
			    Write (i, ' ', Otkr [i].toWhich, ' ');
            end;
    close (output);
end.
