{ ----------------- Compiler directives ------------------- }
{$A+,B-,E-,F-,G-,N+,O-,P-,Q-,T-,V+,X+}
{$M 65520,0,655360}

{ ------------------ Debug mode on/off -------------------- }

{
{$DEFINE __DEBUG__}

{$IFDEF __DEBUG__}
{$D+,I+,L+,R+,S+,Y+}
{$ELSE}
{$D-,I-,L-,R-,S-,Y-}
{$ENDIF}
{ --------------- End Compiler directives ----------------- }

program p01_06_B;

type
	dorogi = array [1..25, 1..25] of boolean;

    Tway = array [1..25] of longint;

var
	map, ways : dorogi;
    n : longint;
    marked : array [1..25] of boolean;

    paths : array [1..25] of
						record
							length : longint;
							way : Tway;
    					end;

    c1, c2 : longint;

    i, j : longint;
    num1, num2 : longint;

    max_ways : longint;

procedure Initialize; { 樠  ⬮ }
	var
		i : longint;

    function FindWay (p1, p2 : longint) : boolean;
    	var
        	i : longint;

    	begin
        	if p1 = p2
            	then
					begin
                    	marked [p2] := false;
						FindWay := true;
                        Exit;
                    end;
            for i := 1 to n do
            	if map [p1, i] and (not marked [i]) and (not ways [p1, i])
					then
						begin
							marked [i] := true;
                            ways [p1, i] := true;
                            if FindWay (i, p2)
                            	then
                                	begin
                                    	FindWay := true;
                                        Exit;
                                    end;
                            marked [i] := false;
                            ways [p1, i] := false;
                        end;
            FindWay := false;
        end;

	begin
        marked [c1] := true;
    	while FindWay (c1, c2) do;
        marked [c2] := true;
    end;

procedure Maximize;
	var
    	path_found : boolean;
        vertexes, shortest : TWay;
        used : array [1..25] of boolean;
        length : longint;
        best : longint;

    procedure FindIncrementingPath (p1, p2 : longint);
    	var
        	i : longint;
            good : boolean;

        begin
        	if (p1 = p2)
            	then
                	begin
                    	good := false;
                        for i := 1 to length - 1 do
                        	if ways [vertexes [i + 1], vertexes [i]]
                            	then good := true;

                    	if (good) and (not path_found) or (length < best)
                        	then
                            	begin
                                	path_found := true;
                                    shortest := vertexes;
                                    best := length;
                                end;
                    end
                else
                	for i := 1 to n do
                    	if (not used [i]) and (not ways [p1, i])
                        	and (
							(ways [i, p1])
							or (
							((map [p1, i]) and (not ways [i, p1]) and (((not marked [p1]) or (p1 = c1)) or (ways [p1, vertexes [length - 1]])))
                            ) { or }
							) { and }

							then
								begin

									inc (length);
                                    vertexes [length] := i;
                                    used [i] := true;
                                    FindIncrementingPath (i, p2);
                                    used [i] := false;
                                    dec (length);
                                end;
        end;


	begin
    	repeat
        	path_found := false;
            length := 1;
            vertexes [1] := c1;
            fillchar (used, sizeof (used), 0);
            used [c1] := true;
            FindIncrementingPath (c1, c2);
            if (path_found)
            	then
                	begin
                    	for i := 1 to best do
                        	marked [shortest [i]] := false;

                    	for i := 1 to best - 1 do
                        	if ways [shortest [i + 1], shortest [i]]
								then
									ways [shortest [i + 1], shortest [i]] := false
								else
									begin
										ways [shortest [i], shortest [i + 1]] := true;
                                        marked [shortest [i]] := true;
                                        marked [shortest [i + 1]] := true;
                                    end;
                    end;
        until (not path_found);
    end;

var
	vertexes : TWay;
	length : longint;

procedure RestoreWays (p1, p2 : longint);
	var
    	i : longint;

    begin
    	if (p1 = p2)
        	then
            	begin
                	inc (max_ways);
                    paths [max_ways].way := vertexes;
                    paths [max_ways].length := length;
                end
            else for i := 1 to n do
            	if ways [p1, i]
                	then
                    	begin
                        	inc (length);
                            vertexes [length] := i;
                            RestoreWays (i, p2);
                            dec (length);
                        end;
    end;



begin
	assign (input, 'input.txt');
    reset (input);
	readln (n, c1, c2);

    fillchar (map, sizeof (map), 0);

    while (not SeekEof (input)) do
    	begin
        	read (num1);
            read (num2);
            map [num1, num2] := true;
        end;

    close (input);

    fillchar (ways, sizeof (ways), 0);
    fillchar (marked, sizeof (marked), 0);

    Initialize;

    Maximize;

    max_ways := 0;
    length := 1;
	vertexes [1] := c1;
    RestoreWays (c1, c2);

    assign (output, 'output.txt');
    rewrite (output);
    Writeln (max_ways);

    for i := 1 to max_ways do
    	begin
        	for j := 1 to paths [i].length - 1 do
            	Write (paths [i].way [j], ' ');
            Writeln (paths [i].way [paths [i].length]);
        end;

	close (output);
end.