{ ----------------- Compiler directives ------------------- }
{$A+,B-,E-,F-,G-,N+,O-,P-,Q-,T-,V+,X+}
{$M 65520,0,655360}

{ ------------------ Debug mode on/off -------------------- }


{$DEFINE __DEBUG__}

{$IFDEF __DEBUG__}
{$D+,I+,L+,R+,S+,Y+}
{$ELSE}
{$D-,I-,L-,R-,S-,Y-}
{$ENDIF}
{ --------------- End Compiler directives ----------------- }

program WaysInGraph;

const
    max_num = 25;

type
	OtkrKonv = array [1..max_num, 1..max_num] of boolean;

var
    num_o, num_k : integer;

    CanPut : OtkrKonv;

    i, j : integer;

    Otkr, Konv : array [0..100] of record
    								marked : boolean;
                                    toWhich : integer;
                                    end;

    num_best : integer;

    num1, num2 : integer;

    ways : array [1..25] of
				record
					v : array [1..25] of integer;
                    num : integer;
                end;

    num_ways : integer;

    marked : array [1..25] of boolean;

procedure Initialize;
	begin
    	fillchar (Otkr, Sizeof (Otkr), 0);
    	fillchar (Konv, Sizeof (Konv), 0);
        num_best := 0;

        for i := 1 to num_o do
        	begin
	        	for j := 1 to num_k do
	            	if CanPut [i, j] and (not Konv [j].marked)
                    	then
                        	begin
                            	Otkr [i].marked := true;
                                Konv [j].marked := true;
                                Otkr [i].toWhich := j;
                                Konv [j].toWhich := i;
                                inc (num_best);
                                break;
                            end;
            end;
    end;

procedure Maximize;
	label Stop;
	var
    	path_found : boolean;
        reachedO, reachedK : array [1..100] of boolean;
        prevO, prevK : array [1..100] of integer;
        seeO, seeK : array [1..100] of integer;

        firstO, lastO, firstK, lastK : integer;

        k, m : integer;

	begin
        repeat
	       	path_found := false;
            for i := 1 to num_o do
            	if (not Otkr [i].marked)
                	then
                    	begin
                            { 設 Konv, ⨦  Otkr [i]}
                            firstO := 1;
                            lastO := 1;
                            firstK := 1;
                            lastK := 0;
                            fillchar (reachedO, sizeof (reachedO), 0);
                            fillchar (reachedK, sizeof (reachedK), 0);
                            fillchar (seeO, sizeof (seeO), 0);
                            fillchar (seeK, sizeof (seeK), 0);
                            fillchar (prevO, sizeof (prevO), 0);
                            fillchar (prevK, sizeof (prevK), 0);

                            seeO [1] := i;
                            reachedO [i] := true;
                            while (firstO <= lastO) or (firstK <= lastK) do
                            	begin
                                	for k := firstO to lastO do
                                    	for m := 1 to num_k do
                                        	if CanPut [seeO [k], m]
													and (not reachedK [m]) and (Otkr [seeO [k]].toWhich <> m)
                                    		then begin
                                            	reachedK [m] := true;
                                                prevK [m] := seeO [k];
                                                inc (lastK);
                                                seeK [lastK] := m;
                                                end;
                                    firstO := lastO + 1;
                                	for k := firstK to lastK do
										if (Konv [seeK [k]].toWhich <> 0) and (not reachedO [Konv [seeK [k]].toWhich])
                                    		then begin
                                            	m := Konv [seeK [k]].toWhich;
                                            	reachedO [m] := true;
                                                prevO [m] := seeK [k];
                                                inc (lastO);
                                                seeO [lastO] := m;
                                                end;
                                    firstK := lastK + 1;
                                end;

                            for k := 1 to num_k do
                            	if (not Konv [k].marked) and (reachedK [k])
                                	then
                                    	begin
                                            { 諨 㢥稢 楯 }
                                            m := k;
                                            repeat
                                                Konv [m].marked := true;
                                                Konv [m].toWhich := prevK [m];
                                                Otkr [prevK [m]].marked := true;
                                                Otkr [prevK [m]].toWhich := m;
                                                m := prevK [m];
                                                m := prevO [m];
                                            until m = 0;

                                            path_found := true;
                                            inc (num_best);

                                            goto Stop;
                                        end;

                        end;
Stop:
        until not (path_found);
    end;

begin
	assign (input, 'input.txt');
    reset (input);
    read (num_k);
	num_o := num_k;

    fillchar (CanPut, sizeof (CanPut), 0);

    while not SeekEof (input) do
    	begin
        	read (num1);
            read (num2);
            CanPut [num1, num2] := true;
        end;

	close (input);

    Initialize;

    Maximize;

    fillchar (marked, sizeof (marked), 0);

    num_ways := 0;
    repeat
        i := 1;
        while (i <= num_k) and ((marked [i]) or (Konv [i].marked)) do
        	inc (i);
        if (i <= num_k)
        	then
            	begin
                	inc (num_ways);
                    ways [num_ways].num := 1;
                    ways [num_ways].v [1] := i;
                    marked [i] := true;
                    while (Otkr [i].marked) do
                    	begin
                        	i := Otkr [i].toWhich;
		                    inc (ways [num_ways].num);
		                    ways [num_ways].v [ways [num_ways].num] := i;
                            marked [i] := true;
                        end;
                end;
    until i > num_k;

    assign (output, 'output.txt');
    rewrite (output);
    writeln (num_ways);

    for i := 1 to num_ways do
    	begin
        	for j := 1 to ways [i].num - 1 do
            	Write (ways [i].v [j], ' ');
            Writeln (ways [i].v [ways [i].num]);
        end;

    close (output);
end.
