(* ⭨ ᡮ  ଠ⨪. 02  1999 *)
(*   "㡪 "                     *)
(* 襭  ஭                     *)

const MAXN=14;
type
    TCoord = record x,y : integer;
             end;
    TTree=record P : TCoord;
                 l,v : integer;
           end;

var N     : integer;
    trees : array[1..MAXN] of TTree;
{    a     : array[0..MAXN+1] of TCoord;}
    chop,bestchop  : array[1..MAXN+1] of boolean;
    bestN,bestV : longint;
    hull  : array[0..MAXN+1] of byte;
    nhull : byte;

procedure ReadData;
var i : integer;
begin
  assign(input,'input.txt');reset(input);
  assign(output,'output.txt');rewrite(output);
  read(N);
  for i := 1 to N do begin
    read(trees[i].P.x,trees[i].P.y,trees[i].v,trees[i].l);
  end;
end;

function det(const p0,p1,p2 : TCoord): longint;
begin
  det := longint(p1.x-p0.x)*(p2.y-p0.y)-longint(p2.x-p0.x)*(p1.y-p0.y);
end;

function scalar(const p0,p1,p2 : TCoord): longint;
begin
  scalar := longint(p1.x-p0.x)*(p2.x-p0.x)+longint(p1.y-p0.y)*(p2.y-p0.y);
end;

function Points012(p0,p1,p2: TCoord):boolean;
begin
  Points012 := scalar(p1,p0,p2) < 0;
end;

procedure FillHull;
var i,j,k : integer;
    f     : boolean;
begin
  nhull := 0;
  for i := 1 to N do
    if not chop[i] then begin
      f := false;
      for j := 1 to i-1 do
        if not chop[j] then begin
           f := f or ((trees[i].P.x=trees[j].P.x) and (trees[i].P.y=trees[j].P.y));
        if not f then begin
          for k := 1 to N do
            if not chop[k] then
              f := f or ((k<>i) and (k<>j) and (det(trees[i].P,trees[j].P,trees[k].P)=0)
                         and Points012(trees[j].P,trees[i].P,trees[k].P));
        end;
      end;
      if not f then begin
        inc (nhull);
        hull[nhull] := i;
      end;
  end;
  hull[0] := hull[nhull];
end;

function dist(const i,j: integer): real;
var  r : real;
begin
  dist := sqrt(sqr(1.0*(trees[i].P.x-trees[j].P.x))+sqr(1.0*(trees[i].P.y-trees[j].P.y)));
end;

function HullLength: real;
var i,j,k : integer;
    signpos,signneg,fin : boolean;
    d : longint;
    s : real;
begin
  FillHull;
  if nhull<2 then HullLength := 0
  else if nhull = 2 then HullLength := 2*dist(hull[1],hull[2])
  else begin
    s := 0;
    fin := false;
    for i := 1 to nhull do
      for j := 1 to i-1 do begin
        signpos := false;
        signneg := false;
        for k := 1 to nhull do
          if (i <> k) and (j <> k) then begin
            d := det(trees[hull[i]].P,trees[hull[j]].P,trees[hull[k]].P);
            signpos := signpos or (d > 0);
            signneg := signneg or (d < 0);
            if d = 0 then
              fin := Points012(trees[hull[i]].P,trees[hull[k]].P,trees[hull[j]].P);
            if fin or (signpos and signneg) then break;
          end;
        if not fin and not (signpos and signneg) then
          s := s + dist(hull[i],hull[j]);
      end;
    HullLength := s;
  end;
end;

function ChoppedValue: longint;
var i : integer;
    s : longint;
begin
  s := 0;
  for i := 1 to N do if chop[i] then Inc(s,trees[i].v);
  ChoppedValue := s;
end;

function ChoppedNum: longint;
var i : integer;
    s : longint;
begin
  s := 0;
  for i := 1 to N do if chop[i] then Inc(s);
  ChoppedNum := s;
end;

function ChoppedWood: longint;
var i : integer;
    s : longint;
begin
  s := 0;
  for i := 1 to N do if chop[i] then Inc(s,trees[i].l);
  ChoppedWood := s;
end;

function ChoppedFenceGood: boolean;
var hull : longint;
begin
  ChoppedFenceGood := HullLength <= ChoppedWood;
end;

procedure Solve;
var i : integer;
begin
  fillchar(chop,sizeof(chop),0);
  bestV := 0;
  for i := 1 to N do inc(bestV,trees[i].V);
  bestN := N;
  fillchar(bestchop,sizeof(bestchop),1);
  repeat
    i := 1;
    while chop[i] do begin chop[i] := false; inc(i); end;
    chop[i] := true;
    if ((ChoppedValue < bestV) or ((ChoppedValue = bestV) and (ChoppedNum < bestN)))
       and ChoppedFenceGood then begin
      bestchop := chop;
      bestV := ChoppedValue;
      bestN := ChoppedNum;
    end;
  until chop[N+1];
end;

procedure PrintResult;
var i : integer;
begin
  write('Cut these trees:');
  for i := 1 to N do if bestchop[i] then write(' ',i);
  writeln;
  chop := bestchop;
  writeln('Extra wood: ',ChoppedWood-HullLength:0:2);
end;

begin
  ReadData;
  Solve;
  PrintResult;
end.