{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const
  Pi=3.14159265358979323846264338;
  MaxN=500;
  Eps=1E-5;
Var
  Res:Extended;
  R:Extended;
  N:Word;
  Nails:Array[0..MaxN]Of Record X,Y:Extended; End;
  Angle:Array[1..MaxN+1]Of Extended;
  What:Array[1..MaxN+1]Of Word;
  Where:Array[1..MaxN+1]Of Word;
  Center:Word;
  Len:Extended;
  CurAng:Extended;
Procedure Load;
Var
  I:Word;
Begin
  Assign(Input,'INPUT.TXT');
  ReSet(Input);
  Read(N,R);
  For I:=1 To N Do If Not SeekEOF Then Read(Nails[I].X,Nails[I].Y);
  Nails[0].X:=0;
  Nails[0].Y:=0;
  Len:=R;
  Center:=0;
  Res:=0;
  CurAng:=Pi;
  Close(Input);
End;
Procedure FillAngles;
Var
  I:Word;
  DeltaX,DeltaY:Extended;
Function Sign(R:Extended):ShortInt;
Begin
  If Abs(R)<Eps Then Sign:=0 Else If R<0 Then Sign:=-1 Else Sign:=1;
End;
Begin
  If Len>-Nails[Center].Y-Eps Then Begin
    Nails[N+1].Y:=0;
    Nails[N+1].X:=Nails[Center].X+Sqrt(Sqr(Len)-Sqr(Nails[Center].Y));
  End;
  For I:=1 To N+1 Do Begin
    DeltaX:=Nails[I].X-Nails[Center].X;
    DeltaY:=Nails[I].Y-Nails[Center].Y;
    Case Sign(DeltaX) Of
      -1:Case Sign(DeltaY) Of
        -1:Angle[I]:=Pi+ArcTan(Abs(DeltaY/DeltaX));
        0:Angle[I]:=Pi;
        1:Angle[I]:=Pi-ArcTan(Abs(DeltaY/DeltaX));
      End;
      0:Case Sign(DeltaY) Of
        -1:Angle[I]:=Pi*3/2;
        0:Angle[I]:=1000.0;
        1:Angle[I]:=Pi/2;
      End;
      1:Case Sign(DeltaY) Of
        -1:Angle[I]:=2*Pi-ArcTan(Abs(DeltaY/DeltaX));
        0:Angle[I]:=0;
        1:Angle[I]:=ArcTan(Abs(DeltaY/DeltaX));
      End;
    End;
    If Angle[I]<500.0 Then Begin
      Angle[I]:=Angle[I]-CurAng;
      If Angle[I]<-Eps Then Angle[I]:=Angle[I]+2*Pi;
    End;
  End;
End;
Procedure QSort(A,B:Word);
Var
  I,J,Y:Word;
  X:Extended;
Begin
  X:=Angle[What[(A+B) Div 2]];
  I:=A;
  J:=B;
  Repeat
    While Angle[What[I]]<X Do Inc(I);
    While Angle[What[J]]>X Do Dec(J);
    If I<J Then Begin
      Where[What[I]]:=J;
      Where[What[J]]:=I;
      Y:=What[I];
      What[I]:=What[J];
      What[J]:=Y;
      Inc(I);
      Dec(J);
    End;
  Until I>=J;
  If I>A Then QSort(A,I-1);
  If J<B Then QSort(J+1,B);
End;
Procedure Run;
Var
  I,J:Word;
  Ok:Boolean;
Begin
  Repeat
    FillAngles;
    For I:=1 To N+1 Do Begin
      Where[I]:=I;
      What[I]:=I;
    End;
    QSort(1,N+1);
    Ok:=True;
    For I:=1 To N+1 Do If (Angle[What[I]]<500.0) And
                          (Sqr(Nails[What[I]].X-Nails[Center].X)+Sqr(Nails[What[I]].Y-Nails[Center].Y)<Len*Len+Eps) Then Begin
      Res:=Res+Angle[What[I]]*Len;
      If What[I]=N+1 Then Begin Res:=Res*2; Exit; End;
      Ok:=False;
      Len:=Len-Sqrt(Sqr(Nails[What[I]].X-Nails[Center].X)+Sqr(Nails[What[I]].Y-Nails[Center].Y));
      CurAng:=CurAng+Angle[What[I]];
      If CurAng>2*Pi-Eps Then CurAng:=CurAng-2*Pi;
      Center:=What[I];
      Break;
    End;
    If Ok Then Begin
      Res:=2*Pi*Len;
      Exit;
    End;
  Until False;
End;
Procedure Save;
Begin
  Assign(Output,'OUTPUT.TXT');
  ReWrite(Output);
  WriteLn(Res:0:2);
  Close(Output);
End;
Begin
  Load;
  Run;
  Save;
End.