
{.$define Debug}

program Solution;
{$M 16384,0,655360}

{$ifndef Debug}
{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'output.txt';
{$else}
{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  maxN                          = 500;
  pi				= 3.1415926535897932385;
  eps				= 1e-6;

type
  float                         = extended;

var
  n                             : integer;
  x,y				: array[0..maxN] of float;
  answer			: float;
  r				: float;

function GetAngle( xx, yy : float ) : float;
begin
  if abs( xx ) < eps then begin
    if yy > 0 then GetAngle := pi / 2 else GetAngle := 3 * pi / 2;
    exit;
  end else
  if abs( yy ) < eps then begin
    if xx > 0 then GetAngle := 0 else GetAngle := pi;
    exit;
  end;
  if xx > 0 then begin
    if yy > 0 then
      GetAngle := arctan( yy / xx )
    else
      GetAngle := 2 * pi - arctan( - yy / xx )
  end else begin
    if yy > 0 then
      GetAngle := pi / 2 + arctan( - yy / xx )
    else
      GetAngle := pi + arctan( yy / xx )
  end;
end;

function GetDist( a, b : integer ) : float;
begin
  GetDist := sqrt( sqr(x[a] - x[b]) + sqr(y[a] - y[b]) );
end;

procedure Solve;
var
  i,j,k				: integer;
  psi,newPsi			: float;
  angle				: float;
  rr				: float;
  rot                           : boolean;

begin
  i := 0;
  psi := 0;
  rr := r;
  answer := 0;
  rot := false;

  repeat
    newPsi := 4 * pi;
    k := 0;
    for j := 1 to n do
      if (i <> j) and (GetDist( i, j ) < rr) then begin
        angle := GetAngle( x[j] - x[i], y[j] - y[i] );
        if (angle >= psi - eps) and (angle < newPsi) then begin
          k := j;
          newPsi := angle;
        end;
      end;

    if k = 0 then begin
      if y[i] >= rr - eps then begin
        if rot then begin
          answer := 2 * pi * rr;
          exit;
        end else begin
          answer := answer + (2 * pi - psi) * rr;
          psi := 0;
          rot := true;
        end;
      end else begin
        newPsi := GetAngle( - sqrt( sqr( rr ) - sqr( y[i] ) ), - y[i] );
        answer := answer + (newPsi - psi) * rr;
        answer := answer * 2;
        exit;
      end;
    end else begin
      rot := false;
      answer := answer + (newPsi - psi) * rr;
      rr := rr - GetDist( i, k );
      i := k;
      psi := newPsi;
    end;

  until false;
end;

procedure ReadData;
var
  i				: integer;
  m				: integer;
  xx,yy				: float;

begin
  read( m, r );
  n := 0;
  x[0] := 0;
  y[0] := 0;
  for i := 1 to m do begin
    read( xx, yy );
    if yy < eps then begin
      if (abs( xx ) < eps) and (abs( yy ) < eps) then continue;
      inc( n );
      x[n] := -xx;
      y[n] := -yy;
    end;
  end;
end;

procedure WriteData;
begin
  writeln( answer:0:2 );
end;

procedure Initialize;
begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  WriteData;
  Finalize;
end.