{ ----------------- Compiler directives ------------------- }
{$A+,B-,E-,F-,G-,N+,O-,P-,Q-,T-,V+,X+}
{$M 65520,0,655360}

{ ------------------ Debug mode on/off -------------------- }

{
{$DEFINE __DEBUG__}

{$IFDEF __DEBUG__}
{$D+,I+,L+,R+,S+,Y+}
{$ELSE}
{$D-,I-,L-,R-,S-,Y-}
{$ENDIF}
{ --------------- End Compiler directives ----------------- }

program p02_06_c;

type
	TTrees = array [1..14] of
				record
					x, y : longint;
					price : longint;
					fence_len : longint;
				end;

    TSet = set of 1..14;

var
	trees : TTrees;
    n : longint;

    i, j, num : longint;

    best_p, best_num : longint;
    best_extra : extended;
    best : TSet;

    found : boolean;

var {  㪫 窨 }
    vertexes : array [1..15] of longint;
    num_v : longint;

    length : extended;

    a, ang : extended;
    smallest : extended;
    cur_i : longint;

function Distance (i, j : longint) : extended;
	begin
    	Distance := sqrt (sqr (trees [i].x - trees [j].x) + sqr (trees [i].y - trees [j].y));
    end;

function Angle (x1, y1, x2, y2 : extended) : extended;
	begin
    	if (y1 = y2) and (x1 > x2)
        	then Angle := 0.0
        else if (y1 = y2) and (x1 < x2)
        	then Angle := pi
        else if (x1 = x2) and (y1 > y2)
        	then Angle := pi / 2
        else if (x1 = x2) and (y1 < y2)
        	then Angle := 3 * pi / 2
        else if (x1 > x2) and (y1 > y2)
        	then Angle := ArcTan ((y1 - y2) / (x1 - x2))
        else if (x2 > x1) and (y1 > y2)
        	then Angle := pi / 2 + ArcTan ((x2 - x1) / (y1 - y2))
        else if (x2 > x1) and (y2 > y1)
        	then Angle := pi + ArcTan ((y2 - y1) / (x2 - x1))
            else Angle := 3 * pi / 2 + ArcTan ((x1 - x2) / (y2 - y1));
    end;

function Obolotchka (t : TSet; num : integer) : extended;
	var
    	i, j : longint;

	begin
		if (num = 1) or (num = 0)
        	then
				begin
                    Obolotchka := 0;
					Exit;
                end
        else if num = 2
        	then
            	begin
                	i := 1;
                    while (not (i in t)) do
						inc (i);
                    j := i + 1;
                    while (not (j in t)) do
                    	inc (j);
                	Obolotchka := 2 * Distance (i, j);
                    Exit;
                end;

        vertexes [1] := 1;
        while not (vertexes [1] in t) do
        	inc (vertexes [1]);
        for i := vertexes [1] + 1 to n do
        	if (i in t) and (trees [i].y > trees [vertexes [1]].y)
            	then vertexes [1] := i;

        num_v := 1;
        a := 0.0;
        length := 0;

        while (num_v = 1) or (vertexes [num_v] <> vertexes [1]) do
        	begin
		        i := 0;
                smallest := 2*pi;
		        while (i < n) do begin
		        	inc (i);
                    if not (i in t)
                    	then Continue;
		        	if (trees [i].x = trees [vertexes [num_v]].x) and (trees [i].y = trees [vertexes [num_v]].y)
						then Continue;
		           	ang := Angle (trees [vertexes [num_v]].x, trees [vertexes [num_v]].y, trees [i].x, trees [i].y) - a;
		            if ang < 0
		            	then ang := ang + 2*pi;
		            if ang < smallest
		            	then
							begin
								smallest := ang;
		                        cur_i := i;
		                    end;
		        end;

			length := length + Distance (vertexes [num_v], cur_i);
            inc (num_v);
            a := a + smallest;
            vertexes [num_v] := cur_i;
        end;

        Obolotchka := length;
    end;


procedure CheckSet (t : TSet; num : integer);
	var
    	l, len : extended;
        i : longint;
        p : longint;

	begin
       	p := 0;
        for i := 1 to n do
	       	if i in t
               	then p := p + trees [i].price;
    	if (found) and (p >= best_p)
        	then Exit;

    	l := 0;
        for i := 1 to n do
        	if i in t
            	then l := l + trees [i].fence_len;
        len := Obolotchka ([1..n] - t, n - num);
        if l < len
        	then Exit
            else
            	begin
                    if (not found) or ((p < best_p) or ((p = best_p) and (num < best_num)))
                    	then
                        	begin
                            	best_num := num;
                                best_extra := l - len;
                                best := t;
                                best_p := p;
                                found := true;
                            end;
                end;
	end;

procedure ComposeTrees (t : TSet; i : longint; num : integer);
	begin
    	if (i > n)
        	then CheckSet (t, num)
            else
            	begin
			    	ComposeTrees (t, i + 1, num);
                    ComposeTrees (t + [i], i + 1, num + 1);
                end;
    end;

begin
	assign (input, 'input.txt');
    reset (input);
    readln (n);
    for i := 1 to n do
    	begin
        	read (trees [i].x);
			read (trees [i].y);
			read (trees [i].price);
			read (trees [i].fence_len);
        end;
    close (input);

    found := false;

    ComposeTrees ([], 1, 0);

    assign (output, 'output.txt');
	rewrite (output);
    Write ('Cut these trees: ');
    i := 1;
    j := 0;
    num := best_num;
    while (j < num) do
    	begin
            inc (j);
        	while (not (i in best)) do
            	inc (i);
            Write (i);
            if (j = num)
            	then Writeln
                else Write (' ');
        	inc (i);
        end;

    Writeln ('Extra wood: ', best_extra : 1 : 2);
    close (output);

end.