{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const              MaxN=550;
type               TGC=Real;
var N: Integer;
    R: Real;
    X,Y:array [0..MaxN] of TGC;

const Eps=10e-4;

procedure ReadIn;
var       J, I: Integer;
begin
 Assign (Input,'input.txt'); reset (Input);
 Read (N, R); J := 0;
 for I := 1 to N do
 begin
  Read (X[J+1],Y[J+1]);
  if Y[J+1]<Eps then Inc (J);
 end; X[0]:=0; Y[0]:=0; N := J;
 close (input);
end;

procedure WriteOut(Ans: real);
begin
 assign (output,'output.txt'); rewrite (output);
 WriteLn (Ans:0:2);
 Close(output);
 Halt;
end;

procedure Solve;
var
          SP: Integer;
          P: array [1..MaxN] of Integer;
          T, I, C: Integer;
          DT: TGC;
          XO,YO,Sum, XM, YM, L, K: Real;

function D(I, J: integeR): Real;
begin
 D := Sqr(X[I]-X[J])+Sqr (Y[I]-Y[J]);
end;

function aCos (X: Real): Real;
begin
 if (Abs (X)<Eps) or (Abs (1-X)<Eps) then aCos := 0 else
 aCos := arcTan (Sqrt(1-X*X)/X);
end;

function aSin (X: Real): Real;
begin
 if (Abs (X)<Eps) or (Abs (1-X)<Eps) then aSin := 0 else
 aSin := arcTan (X/Sqrt(1-X*X));
end;

function SLen (X0, Y0, X1, Y1, X2, Y2,R: Real): Real;
var      A: Real;
begin
 A := Sqrt (Sqr(X2-X1)+Sqr(Y2-Y1))/2/R;
 A := ASin (A);
 if Abs (A)<Eps then
 begin
  if (Abs (X2-X1)>Eps) or (Abs (Y2-Y1)>Eps) then SLen := Pi*R else
                                                 SLen := 0;
 end else
 SLen := A*R*2;
end;

begin
 C := 0; SP := 1; P[SP] := 0; Sum := 0; XM := -R; YM := 0;
 repeat
  T := 0;
  L := Sqrt(Sqr(XM-X[C])+Sqr(YM-Y[C]));
  for I := 1 to N do
  begin
   DT := (X[I]-X[C])*(YM-Y[C])-(XM-X[C])*(Y[I]-Y[C]);
   if DT>-Eps then Continue;
   if Sqrt (D(C,I))>L then Continue;
   DT := (X[T]-X[C])*(Y[I]-Y[C])-(X[I]-X[C])*(Y[T]-Y[C]);
   if (DT<0) or (T=0) then T := I else
   if Abs (DT)<Eps then
    if D(C,I)<D(C,T) then T := I;
  end;
  if T=0 then
  begin
   L := Sqrt(Sqr(XM-X[C])+Sqr(YM-Y[C]));
   if L<-Y[C] then {Rot}
    WriteOut (2*PI*Sqrt(Sqr(XM-X[C])+Sqr(YM-Y[C])))
   else
   begin
    K := X[C]+Sqrt (L*L-Y[C]*Y[C]);
    Sum:=Sum+SLen (X[C],Y[C],XM,YM,K,0,L);
    WriteOut (Sum*2);
   end;
  end else
  begin
   L := Sqrt(Sqr(XM-X[C])+Sqr(YM-Y[C]));
   K := Sqrt(D(T,C));
   XO := XM; YO := YM;
   XM := X[C]+(X[T]-X[C])*L/K;
   YM := Y[C]+(Y[T]-Y[C])*L/K;
   Sum := Sum+SLen (X[C],Y[C],XO,YO,XM,YM,L);
   Inc (SP); P[SP]:=T; C := T;
  end;
 until False;
end;

begin
 ReadIn;
 solve;
end.