{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program TaskB;
var     X, Y, Z: array [1..8] of Real;
        V1, V2, V3, V4, V5, V6, V7, V8: Integer;
        AA: Real;
const   Eps=1e-10;
        Epp=1e-3;

procedure ReadIn;
var       I: Integer;
begin
 Assign (Input,'input.txt'); reset (Input);
 for I := 1 to 8 do
  Read (X[I],Y[I]);
 close (input);
end;

procedure No;
begin
 Assign (Output,'output.txt'); Rewrite (Output);
 WriteLn ('NO SOLUTIONS');
 Close(output);
end;

procedure WriteOut;
var       I: Integer;
begin
 Assign (Output,'output.txt'); Rewrite (Output);
 for I := 1 to 8 do
  WriteLn (X[i]:0:3,' ',Y[I]:0:3, ' ',Z[i]:0:3);
 Halt;
 Close(output);
end;

procedure Solve;

procedure Second; forward;
procedure Third; forward;
procedure CheckAll; forward;

procedure First{ (V1, V2, V3: Integer)}; {Known Z[V1]}
var       T1, T2, Dt, C, D: Real;
          X4, Y4, Z4: Real;
          I: Integer;
begin
 C := Sqr(X[V3]-X[V1])+Sqr(Y[V3]-Y[V1])-Sqr(X[V2]-X[V1])-Sqr(Y[V2]-Y[V1]);
 D := -(X[V2]-X[V1])*(X[V3]-X[V1])-(Y[V2]-Y[V1])*(Y[V3]-Y[V1]);
 Dt := Sqrt (D*D+4*C*C);
 T1 := (-D-Dt)/2; T2 := (-D+Dt)/2;

 for I := 1 to 2 do
 begin
  if I=1 then if T1>=0 then Z[V3]:=Sqrt(T1) else Continue else
              if T2>=0 then Z[V3]:=Sqrt(T2) else Continue;
  if Abs(Z[V3])<Eps then
  begin
   if (Abs(C)<Eps) and (D>=0) then
    Z[V2] := Sqrt(D) else
    Continue;
  end else
  Z[V2]:=C/Z[V3];
  {!} AA := Sqr (X[V2]-X[V1])+Sqr (Y[V2]-Y[V1])+Sqr (Z[V2]-Z[V1]);
  {!} if Abs(Sqrt(AA)-Round(Sqrt(AA)))>Epp then Continue;
  X4 := X[V2]+X[V3]-X[V1];
  Y4 := Y[V2]+Y[V3]-Y[V1];
  Z4 := Z[V2]+Z[V3]-Z[V1];
  for V4 := 1 to 8 do if (V4<>V1) and (V4<>V2) and (V4<>V3) then
   if (Abs(X[V4]-X4)<Eps) and (Abs(Y[V4]-Y4)<Eps) then
   begin
    Z[V4] := Z4;
    for V5 := 1 to 8 do if (V5<>V1) and (V5<>V2) and (V5<>V3) and (V5<>V4) then
     Second;
   end;
 end;
end; {First}

procedure Second;
var       X6, Y6, Z6, D, B, C: Real;
          I: Integer;
begin
 {(Z5-Z1)^=AA-(X5-X1)^2-(Y5-Y1)^2}
 D := AA-Sqr(X[V5]-X[V1])-Sqr(Y[V5]-Y[V1]);
 if D<0 then Exit; D := Sqrt(D);
 for I := 1 to 2 do
 begin
  if I=1 then Z[V5] := Z[V1]+D else
              Z[V5] := Z[V1]-D;
  X6 := X[V5]+X[V2]-X[V1];
  Y6 := Y[V5]+Y[V2]-Y[V1];
  Z6 := Z[V5]+Z[V2]-Z[V1];
  for V6 := 1 to 8 do
   if (V6<>V5) and (V6<>V4) and (V6<>V3) and (V6<>V2) and (V6<>V1) then
    if (Abs (X[V6]-X6)<eps) and (Abs (Y[V6]-Y6)<eps) then
    begin
     Z[V6]:=Z6;
     for V7 := 1 to 8 do
      if (V7<>V6) and (V7<>V5) and (V7<>V4) and (V7<>V3) and (V7<>V2) and (V7<>V1) then
      Third;
    end;
 end;
end; {Second}

procedure Third;
var       X8, Y8, Z8, D: Real;
          I: Integer;
begin
 D := AA-Sqr(X[V7]-X[V3])-Sqr(Y[V7]-Y[V3]);
 if D<0 then Exit; D := Sqrt(D);
 for I := 1 to 2 do
 begin
  if I=1 then Z[V7] := Z[V3]+D else
              Z[V7] := Z[V3]-D;
  X8 := X[V7]+X[V4]-X[V3];
  Y8 := Y[V7]+Y[V4]-Y[V3];
  Z8 := Z[V7]+Z[V4]-Z[V3];
  for V8 := 1 to 8 do
   if (V8<>V7) and (V8<>V6) and (V8<>V5) and (V8<>V4) and (V8<>V3) and
      (V8<>V2) and (V8<>V1) then
    if (Abs (X[V8]-X8)<eps) and (Abs (Y[V8]-Y8)<eps) then
    begin
     Z[V8]:=Z8;
     CheckAll;
    end;
 end;
end; {Third}

procedure CheckAll;

function CheckRect(v1,v2,v3,v4: integer): Boolean;

function FailP (i, j,k: integeR): boolean;
begin
 FailP:=(Abs ((x[i]-x[k])*(x[j]-x[k])+
              (y[i]-y[k])*(y[j]-y[k])+
              (z[i]-z[k])*(z[j]-z[k]))>Eps);
end;

begin
 if Abs (sqr (x[v1]-x[v2])+sqr (y[v1]-y[v2])+sqr (z[v1]-z[v2])-AA)>Eps then
  begin CheckRect := False; Exit; end;
 if Abs (sqr (x[v2]-x[v3])+sqr (y[v2]-y[v3])+sqr (z[v2]-z[v3])-AA)>Eps then
  begin CheckRect := False; Exit; end;
 if Abs (sqr (x[v3]-x[v4])+sqr (y[v3]-y[v4])+sqr (z[v3]-z[v4])-AA)>Eps then
  begin CheckRect := False; Exit; end;
 if Abs (sqr (x[v4]-x[v1])+sqr (y[v4]-y[v1])+sqr (z[v4]-z[v1])-AA)>Eps then
  begin CheckRect := False; Exit; end;

 if FailP (v4,v2,v1) then begin CheckRect := False; Exit; end;
 if FailP (v1,v3,v2) then begin CheckRect := False; Exit; end;
 if FailP (v2,v4,v3) then begin CheckRect := False; Exit; end;
 if FailP (v3,v1,v4) then begin CheckRect := False; Exit; end;

 CheckRect := True;
end;

begin
 if not CheckRect (v1, v2, v4, v3) then Exit;
 if not CheckRect (v5, v6, v8, v7) then Exit;
 if not CheckRect (v2, v6, v8, v4) then Exit;
 if not CheckRect (v1, v3, v7, v5) then Exit;
 if not CheckRect (v3, v4, v8, v7) then Exit;
 if not CheckRect (v1, v2, v6, v5) then Exit;
 WriteOut;
end; {CheckAll}

begin
{
 (x2-x1)^2+ (y2-y1)^2+ (z2-z1)^2=(x3-x1)^2+ (y3-y1)^2+ (z3-z1)^2

 z2*z2-2*z2*z1-z3*z3+2*z3*z1=(x3-x1)^2+ (y3-y1)^2-(x2-x1)^2-(y2-y1)^2

 z1=0 => z2*z2-z3*z3=(x3-x1)^2+ (y3-y1)^2-(x2-x1)^2- (y2-y1)^2
         z2*z3==-(x2-x1)*(x3-x1)-(y2-y1)*(y3-y1);

 a*b=c
 a*a-b*b=d

 a=c/b
 c*c/b/b-b*b=d



 (x2-x1)
}
 Z[1] := 0;
 V1 := 1;
  for V2 := 1 to 8 do if (V2<>V1) then
   for V3 := 1 to 8 do if (V2<>V3) and (V3<>V1) then First;
end;

begin
 ReadIn;
 solve;
 No;
end.