{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 16384,0,655360}
Type TPoint=Record X,Y:Real;End;
     TLine=Record A,B,C:Real;End;
     TPolygon=Record N:Byte;A:Array[1..20] Of TPoint;End;
Const Eps=0.001;
Var Mas,Otv:Array[1..20] Of Byte;
    Tree:Array[1..20] Of Record Coor:TPoint;
                                Cost:Integer;
                                Lumber:Integer;
                         End;
    OtvWood:Real;
    MinCost:LongInt;
    MinCut:LongInt;
    N:Integer;
    SL:Real;
    Poly:TPolygon;

Procedure Input;
Var F:Text;
    I:Integer;
Begin
Assign(F,'Input.Txt');
Reset(F);
ReadLn(F,N);
For I:=1 To N Do ReadLn(F,Tree[I].Coor.X,Tree[I].Coor.Y,Tree[I].Cost,Tree[I].Lumber);
Close(F);
End;

Function Compare(A1,A2:Real):ShortInt;
Begin
If A1-A2>Eps Then Compare:=1 Else
  If A2-A1>Eps Then Compare:=-1 Else Compare:=0;
End;

Procedure MakeLine(Var L:TLine;P1,P2:TPoint);
Begin
 L.A:=P1.Y-P2.Y;
 L.B:=P2.X-P1.X;
 L.C:=P1.X*P2.Y-P2.X*P1.Y;
End;
Function EqlPoints(P1,P2:TPoint):Boolean;
Begin
EqlPoints:=(Compare(P1.X,P2.X)=0) And (Compare(P1.Y,P2.Y)=0);
End;

Function CosAngle(P1,P2,P3:TPoint):Real;
Var X1,X2,Y1,Y2:Real;
Begin
X1:=P2.X-P1.X;
X2:=P3.X-P1.X;
Y1:=P2.Y-P1.Y;
Y2:=P3.Y-P1.Y;
If (Sqrt(X1*X1+Y1*Y1)*Sqrt(X2*X2+Y2*Y2))=0 Then Begin CosAngle:=10000;Exit;End;
CosAngle:=(X1*X2+Y1*Y2)/(Sqrt(X1*X1+Y1*Y1)*Sqrt(X2*X2+Y2*Y2));
End;

Procedure BuildShell(Var Poly,Mas:TPolygon);
Var I,Z:Integer;
    P,P1,P2,P0:TPoint;
    C,C1:Real;
    S:Set Of Byte;
Begin
 S:=[];
 If Mas.N<2 Then Exit;
 P2:=Mas.A[1];
 For I:=2 To Mas.N Do
  If Compare(P2.X,Mas.A[I].X)=1 Then P2:=Mas.A[I];
 P2:=Mas.A[I];
 Poly.A[1]:=P2;
 Poly.N:=1;P1.X:=P2.X;P1.Y:=P2.Y-1;
 Repeat
  C:=-2;
  For I:=1 To Mas.N Do
   If Not EqlPoints(P2,Mas.A[I]) And Not (I In S) Then Begin
    P0.X:=Mas.A[I].X-P2.X+P1.X;
    P0.Y:=Mas.A[I].Y-P2.Y+P1.X;
    C1:=CosAngle(P1,P2,P0);
    If Compare(C1,C)=1 Then Begin Z:=I;P:=Mas.A[I];C:=C1;End;
    End;
    S:=S+[Z];
   Inc(Poly.N);
   Poly.A[Poly.N]:=P;
   P1:=P2;
   P2:=P;
  Until EqlPoints(Poly.A[Poly.N],Poly.A[1]);
End;

Function Rast(A,B:TPoint):Real;
Begin
Rast:=Sqrt(Sqr(A.X-B.X)+Sqr(A.Y-B.Y));
End;

Procedure DoIt;
Var I,KolCut:Integer;
    Stoim,Lumber:LongInt;
    Temp:TPolygon;
Begin
Stoim:=0;Lumber:=0;KolCut:=0;Poly.N:=0;
FillChar(Poly,SizeOf(Poly),0);
For I:=1 To N Do
Begin
If Mas[I]=0 Then Begin Inc(Stoim,Tree[I].Cost);Inc(Lumber,Tree[I].Lumber);Inc(KolCut);End;
If Mas[I]=1 Then Begin Inc(Poly.N);Poly.A[Poly.N]:=Tree[I].Coor;End;
End;
BuildShell(Temp,Poly);
If Poly.N>1 Then Begin
Sl:=Rast(Temp.A[1],Temp.A[Temp.N]);
For I:=1 To Temp.N-1 Do Sl:=Sl+Rast(Temp.A[I],Temp.A[I+1]);
If SL<=Lumber Then Begin
If Stoim<MinCost Then Begin MinCost:=Stoim;MinCut:=KolCut;Otv:=Mas;OtvWood:=Lumber-SL;End;
If Stoim=MinCost Then
If KolCut<MinCut Then Begin MinCost:=Stoim;MinCut:=KolCut;Otv:=Mas;OtvWood:=Lumber-SL;End;
End;
End;
End;

Procedure Work;
Var I,Q,J,P:Integer;
Begin
WriteLn;WriteLn;WriteLn;
FillChar(Mas,SizeOf(Mas),0);
I:=0;
Repeat
DoIt;
Inc(I);
P:=1;J:=I;
While J Mod 2=0 Do Begin J:=J Div 2;P:=P+1;End;
If P<=n Then Mas[P]:=1-Mas[P];
Until P>N;
End;

Procedure Out;
Var F:Text;
    I:Integer;
Begin
Assign(F,'OutPut.Txt');
ReWrite(F);
Write(F,'Cut these trees: ');
For I:=1 To N Do If Otv[I]=0 Then Write(F,I,' ');
WriteLn(F);
WriteLn(F,'Extra wood: ',OtvWood:2:2);
Close(F);
End;

Begin
MinCost:=1000000;
MinCut:=1000000;
Input;
Work;
Out;
End.