program Cube;
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}

const
{$ifdef ILIA}
  InFile='b.in';
  OutFile='b.out';
{$else}
  InFile='input.txt';
  OutFile='output.txt';
{$endif}

type Real=Extended;
type TPoint  = record x,y:real; end;
     TPoint3 = record x,y,z:real; end;
var  v: array[1..8] of TPoint;

procedure ReadData;
  var i:byte;
  begin
  Assign(input,InFile);
  Reset(Input);
  for i:=1 to 8 do
    with v[i] do
      read(x,y);
  Close(Input);
  end;

var Sol:boolean;
    rA,rB,rC:TPoint3;

procedure WriteSol;
  var ha,hb,hc:boolean;
  begin
  Assign(Output,OutFile);
  Rewrite(Output);
  if not Sol then
    writeln('NO SOLUTIONS')
  else begin
    for ha:=false to true do
      for hb:=false to true do
        for hc:=false to true do
          writeln(v[1].x+ord(ha)*ra.x+ord(hb)*rb.x+ord(hc)*rc.x:0:4,' ',
                  v[1].y+ord(ha)*ra.y+ord(hb)*rb.y+ord(hc)*rc.y:0:4,' ',
                    0   +ord(ha)*ra.z+ord(hb)*rb.z+ord(hc)*rc.z:0:4);
  end;
  Close(Output);
  end;

procedure PAdd(var a:TPoint; const b:TPoint);
  begin
  a.x:=a.x+b.x;
  a.y:=a.y+b.y;
  end;

procedure PMinus(const a,b:TPoint; var x:TPoint);
  begin
  with x do begin
    x:=a.x+b.x;
    y:=a.y+b.y;
  end;
  end;

function PLen(const x:TPoint):real;
  begin
  PLen:=sqrt(sqr(x.x)+sqr(x.y));
  end;

FUNCTION Ort(CONST A,B:TPoint3):boolean;
  begin
  Ort:=(a.x*b.x+a.y*b.y+a.z*b.z)<1e-4;
  end;

const eeps=2e-5;

procedure Think(const vA,vB,vC:TPoint);
  var edge:real;
  begin
  edge:=sqrt((sqr(vA.x)+sqr(vA.y)+sqr(vB.x)+sqr(vB.y)+sqr(vC.x)+sqr(vC.y))/2);
  if edge-round(edge)<1e-3 then begin
    rA.x:=vA.x;
    rA.y:=vA.y;
    if sqr(edge)-sqr(vA.x)-sqr(vA.y)<-eeps then exit;
    if sqr(edge)-sqr(vA.x)-sqr(vA.y)<0 then rA.z:=0
    else rA.z:=sqrt(sqr(edge)-sqr(vA.x)-sqr(vA.y));
    rB.x:=vB.x;
    rB.y:=vB.y;
    if sqr(edge)-sqr(vB.x)-sqr(vB.y)<-eeps then exit;
    if sqr(edge)-sqr(vB.x)-sqr(vB.y)<0 then rB.z:=0
    else rB.z:=sqrt(sqr(edge)-sqr(vB.x)-sqr(vB.y));
    rC.x:=vC.x;
    rC.y:=vC.y;
    if sqr(edge)-sqr(vC.x)-sqr(vC.y)<-eeps then exit;
    if sqr(edge)-sqr(vC.x)-sqr(vC.y)<0 then rC.z:=0
    else rC.z:=sqrt(sqr(edge)-sqr(vC.x)-sqr(vC.y));
    Sol:=(Ort(rA,rB) and Ort(rB,rC) and Ort(rA,rC));
  end;
  end;

procedure Run;
  var A,B,C:byte;
      mark:set of 2..8;
      p:TPoint;
      vA,vB,vC:TPoint;
      procedure try(const x:TPoint);
        var i:byte;
        begin
        for i:=2 to 8 do
          if (not(i in mark)) and (v[i].x=x.x) and (v[i].y=x.y) then begin
            include(mark,i);
            exit;
          end;
        end;
  begin
  Sol:=false;
  for A:=2 to 8 do
    for B:=A+1 to 8 do
      for C:=B+1 to 8 do begin
        fillchar(mark,SIZEOF(MARK),FALSE);
        PMinus(v[A],v[1],vA);
        PMinus(v[B],v[1],vB);
        PMinus(v[C],v[1],vC);
        mark:=[A,B,C];
        p:=v[1];
        PAdd(p,vA);
        PAdd(p,vB);
        try(p);
        Padd(p,vC);
        try(p);
        p:=v[1];
        PAdd(p,vA);
        PAdd(p,vC);
        try(p);
        p:=v[1];
        PAdd(p,vB);
        PAdd(p,vC);
        try(p);
        if mark=[2..8] then begin
          Think(vA,vB,vC);
          if Sol then exit;
        end;
      end;
  end;

begin
ReadData;
Run;
WriteSol;
end.