{ 㡨 }

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
type float = extended;
const eps = 1.0e-10;
var x, y: array [1..8] of float;
    i0, i1, i2, i3: integer;
    f, s, P, Q, d, zs, z1, z2, k: float;
    w: array [1..8] of boolean;
    x3, y3, z3: float;
    v: array [0..7, 0..2] of float;
    l1, l2, l3: float;

procedure Readall;
var i: integer;
begin
  Assign(input, 'input.txt'); Reset(input);
  Assign(output, 'output.txt'); Rewrite(output);
  for i := 1 to 8 do
    Read(x[i], y[i]);
end;

function IsThat(j: integer): boolean;
var i: integer;
begin
  for i := 1 to 8 do
    if (not w[i]) and (Abs(x[i]-v[j,0]) < eps) and
      (Abs(y[i] - v[j,1]) < eps) then
    begin
      v[j, 0] := x[i];
      v[j, 1] := y[i];
      w[i] := True;
      IsThat := True;
      Exit;
    end;
  IsThat := False;
end;

procedure GenAll;
var i: integer;
begin
  for i := 0 to 7 do begin
    v[i,0] := x[i0] + (x[i1]-x[i0]) * (i and 1) +
                      (x[i2]-x[i0]) * ((i shr 1) and 1) +
                      (x3 -  x[i0]) * ((i shr 2) and 1);
    v[i,1] := y[i0] + (y[i1]-y[i0]) * (i and 1) +
                      (y[i2]-y[i0]) * ((i shr 1) and 1) +
                      (y3 -  y[i0]) * ((i shr 2) and 1);
    v[i,2] := z1 * (i and 1) +
              z2 * ((i shr 1) and 1) +
              z3 * ((i shr 2) and 1);
  end;
end;

procedure Vmul(x1, y1, z1, x2, y2, z2: float; var x, y, z: float);
begin
  x := y1*z2 - y2*z1;
  y := -(x1*z2 - x2*z1);
  z := x1*y2 - x2*y1;
end;

procedure Zed;
const maxf = 0.0008;
var i: integer;
begin
  l1 := Sqr(x[i1]-x[i0]) + Sqr(y[i1]-y[i0]) + Sqr(z1);
  l2 := Sqr(x[i2]-x[i0]) + Sqr(y[i2]-y[i0]) + Sqr(z2);
  Fillchar(w, Sizeof(w), 0);
  f := Frac(Sqrt(l1));
  if (Abs(l1 - l2) < eps) and ((f < maxf) or (1-f < maxf)) then
  begin
    Vmul(x[i1]-x[i0], y[i1]-y[i0], z1,
         x[i2]-x[i0], y[i2]-y[i0], z2,
         x3, y3, z3);
    l1 := Sqrt(l1);
    x3 := x3 / l1;
    y3 := y3 / l1;
    z3 := z3 / l1;

    l3 := Sqr(x3) + Sqr(y3) + Sqr(z3);
    if Abs(l3 - l2) >= eps then Exit;
    x3 := x3 + x[i0];
    y3 := y3 + y[i0];
    GenAll;
    for i := 0 to 7 do
      if not IsThat(i) then Exit;
    for i := 0 to 7 do
      Writeln(v[i,0], ' ', v[i, 1], ' ', v[i, 2]);
    Halt;
  end;
end;

procedure Zed1;
begin
  if Abs(k) < eps then begin
    s := p + Sqr(z1);
    if s >= 0 then begin
      s := Sqrt(s);
      z2 := -s;
      Zed;
      z2 := s;
      Zed;
    end;
  end else begin
    z2 := k/z1;
    Zed;
  end;
end;

procedure Zsquare;
begin
  if zs >= 0 then begin
    z1 := Sqrt(zs);
    Zed1;
  end;
end;

procedure Check;
begin
  P := (Sqr(x[i1]-x[i0])+Sqr(y[i1]-y[i0])-Sqr(x[i2]-x[i0])-Sqr(y[i2]-y[i0]));
  k := -((x[i1]-x[i0])*(x[i2]-x[i0]) + (y[i1]-y[i0])*(y[i2]-y[i0]));
  d := Sqr(P)*0.25 + Sqr(k);
  if d >= 0 then begin
    d := Sqrt(d);
    zs := -P*0.5 - d;
    Zsquare;
    zs := -P*0.5 + d;
    Zsquare;
  end;
end;

procedure Solve;
begin
  for i0 := 1 to 8 do
    for i1 := 1 to 8 do if i1 <> i0 then
      for i2 := 1 to 8 do if (i2 <> i0) and (i2 <> i1) then Check;
  Writeln('NO SOLUTIONS');
end;

begin
  ReadAll;
  Solve;
end.