{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Type
  T3DPoint=Record X,Y,Z:Extended; End;
  T3DVector=T3DPoint;
Const
  Eps=1E-7;
Var
  Points:Array[1..8]Of T3DPoint;
  GotIt:Boolean;
  Used:Array[1..8]Of Boolean;
Procedure Load;
Var
  I:Byte;
Begin
  Assign(Input,'INPUT.TXT');
  ReSet(Input);
  For I:=1 To 8 Do If Not SeekEOF Then Begin
    Read(Points[I].X,Points[I].Y);
    Points[I].Z:=0;
  End;
  Close(Input);
End;
Procedure Save;
Var
  I:Byte;
Begin
  Assign(Output,'OUTPUT.TXT');
  ReWrite(Output);
  For I:=1 To 8 Do WriteLn(Points[I].X:0:10,' ',Points[I].Y:0:10,' ',Points[I].Z:0:10);
  Close(Output);
End;
Procedure Run;
Var
  I,J,K,L:Byte;
  V1,V2:T3DVector;
  Koef,X1,X2:Extended;
function Solve(A,B,C:Extended; var X1,X2:Extended):Byte;
var
  D:Extended;
begin
  D:=B*B - 4*A*C;
  if d>-Eps then
  begin
  If Abs(D)<Eps Then Begin
    Solve:=1;
    X1:=-B/(2*A);
  End Else Begin
    X1:=(-B + Sqrt(D))/(2*A);
    X2:=(-B - Sqrt(D))/(2*A);
    Solve:=2;
  End;
  end
  else Solve:=0;
end;
Function GetPoint(Const P:T3DPoint):Boolean;
Var
  I:Byte;
Begin
  For I:=1 To 8 Do If Not Used[I] And (Abs(P.X-Points[I].X)<Eps) And (Abs(P.Y-Points[I].Y)<Eps) Then Begin
    Used[I]:=True;
    Points[I].Z:=P.Z;
    GetPoint:=False;
    Exit;
  End;
  GetPoint:=True;
End;
Procedure AddVector(Const P:T3DPoint; Const V:T3DVector; Var Res:T3DPoint);
Begin
  Res.X:=P.X+V.X;
  Res.Y:=P.Y+V.Y;
  Res.Z:=P.Z+V.Z;
End;
Procedure Cube(Const NX,NY,NZ:T3DVector);
Var
  PP:T3DPoint;
Begin
  AddVector(Points[I],NZ,PP);
  If GetPoint(PP) Then Exit;
  AddVector(Points[J],NZ,PP);
  If GetPoint(PP) Then Exit;
  AddVector(Points[K],NZ,PP);
  If GetPoint(PP) Then Exit;
  AddVector(Points[J],NY,PP);
  If GetPoint(PP) Then Exit;
  AddVector(PP,NZ,PP);
  If GetPoint(PP) Then Exit;
  Save;
  Halt(0);
End;
Procedure Try;
Var
  NewZ:T3DVector;
  NewP:T3DPoint;
  L:Byte;
  Fr:Real;
  Len:Real;
Function Min(A,B:Extended):Extended;
Begin
  If A<B Then Min:=A Else Min:=B;
End;
Begin
  Fr:=Sqrt(Sqr(V1.X)+Sqr(V1.Y)+Sqr(V1.Z));
  If Abs(Fr)<Eps Then Exit;
  Fr:=Frac(Fr);
  If Abs(Min(Fr,1-Fr))<1.00000001E-3 Then Begin
    Points[I].Z:=0;
    Points[J].Z:=V1.Z;
    Points[K].Z:=V2.Z;
    NewZ.X:={Sqrt(}Abs(V1.Y*V2.Z-V2.Y*V1.Z){)};
    NewZ.Y:={Sqrt(}Abs(V1.Z*V2.X-V2.Z*V1.X){)};
    NewZ.Z:={Sqrt(}Abs(V1.X*V2.Y-V2.X*V1.Y){)};
    Len:=Sqrt((Sqr(NewZ.X)+Sqr(NewZ.Y)+Sqr(NewZ.Z))/(Sqr(V1.X)+Sqr(V1.Y)+Sqr(V1.Z)));
    NewZ.X:=NewZ.X/Len;
    NewZ.Y:=NewZ.Y/Len;
    NewZ.Z:=NewZ.Z/Len;
    Cube(V1,V2,NewZ);
    NewZ.X:=-NewZ.X;
    NewZ.Y:=-NewZ.Y;
    NewZ.Z:=-NewZ.Z;
    Cube(V1,V2,NewZ);
  End;
End;
Function Vect2DLen(Const V:T3DVector):Extended;
Begin
  Vect2DLen:=Sqr(V.X)+Sqr(V.Y);
End;
Begin
  For I:=1 To 8 Do
    For J:=2 To 8 Do If J<>I Then
      For K:=1 To J-1 Do If K<>I Then Begin
        FillChar(Used,SizeOf(Used),False);
        Used[I]:=True;
        Used[J]:=True;
        Used[K]:=True;
        V1.X:=Points[J].X-Points[I].X;
        V1.Y:=Points[J].Y-Points[I].Y;
        V2.X:=Points[K].X-Points[I].X;
        V2.Y:=Points[K].Y-Points[I].Y;
        Koef:=-(V1.X*V2.X+V1.Y*V2.Y);
        Case Solve(1,Sqr(V1.X)+Sqr(V1.Y)-Sqr(V2.X)-Sqr(V2.Y),-Sqr(Koef),X1,X2) Of
          0:Continue;
          1:If X1>Eps Then Begin
              V1.Z:=Sqrt(X1);
              V2.Z:=Koef/V1.Z;
              Try;
              V1.Z:=-V1.Z;
              V2.Z:=-V2.Z;
              Try;
            End Else If (Abs(X1)<Eps) And (Abs(V1.X)>Eps) And (Vect2DLen(V1)=Vect2DLen(V2)) Then Begin
              V1.Z:=0;
              V2.Z:=0;
              Try;
            End;
          2:Begin
            If X1>Eps Then Begin
              V1.Z:=Sqrt(X1);
              V2.Z:=Koef/V1.Z;
              Try;
              V1.Z:=-V1.Z;
              V2.Z:=-V2.Z;
              Try;
            End Else If (Abs(X1)<Eps) And (Abs(V1.X)>Eps) And (Vect2DLen(V1)=Vect2DLen(V2)) Then Begin
              V1.Z:=0;
              V2.Z:=0;
              Try;
            End;
            If X2>Eps Then Begin
              V1.Z:=Sqrt(X2);
              V2.Z:=Koef/V1.Z;
              Try;
              V1.Z:=-V1.Z;
              V2.Z:=-V2.Z;
              Try;
            End Else If (Abs(X2)<Eps) And (Abs(V1.X)>Eps) And (Vect2DLen(V1)=Vect2DLen(V2)) Then Begin
              V1.Z:=0;
              V2.Z:=0;
              Try;
            End;
          End;
        End;
      End;
End;
Procedure NoSolutions;
Begin
  Assign(Output,'OUTPUT.TXT');
  ReWrite(Output);
  WriteLn('NO SOLUTIONS');
  Close(Output);
End;
Begin
  Load;
  Run;
  NoSolutions;
End.