{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const
  MaxAgents=27;
  MaxVisits=101;
  NRooms=100;
  MaxEvents=MaxAgents*2;
  MaxItems=MaxVisits*6+2;
  NElevators=10;
Type
  TEventType=(etEntry,etExit,etArriveRoom,etOutRoom,etArriveElevator,etOutElevator,etInElevator);
  TItemType=(itEntry,itExit,itStay,itWaiting,itTransfer);
  TStreetItem=Record NAg,NVi:Byte; End;
  TEvent=Record
    EventType:TEventType;
    NAg:Byte;
    NVi:Byte;
    Time:LongInt;
  End;
  TPlan=Record
    NItems:Word;
    Items:Array[1..MaxItems]Of Record
      ItemType:TItemType;
      R1,R2:Byte;
      Start,Finish:LongInt;
    End;
  End;
Var
  Agents:Array[0..MaxAgents]Of Record
    C:Char;
    Start:LongInt;
    NVis:Byte;
    LastEv:LongInt;
    CurFloor:Byte;
    Visits:Array[0..MaxVisits]Of Record
      Where:Byte;
      Time:LongInt;
    End;
  End;
  Rooms:Array[1..NRooms]Of Record
    Inside:Boolean;
    NS:Byte;
    Street:Array[1..MaxAgents]Of TStreetItem;
  End;
  Elevators:Array[1..NElevators]Of Record
    NS:Byte;
    Street:Array[1..MaxAgents]Of TStreetItem;
  End;
  Events:Array[1..MaxEvents]Of TEvent;
  Plans:Array[1..MaxAgents]Of ^TPlan;
  NE:Word;
  N:Byte;
Function InputTime(Const St:String):LongInt;
Var
  H,M,S:Byte;
  Err:Integer;
Begin
  Val(Copy(St,1,2),H,Err);
  Val(Copy(St,4,2),M,Err);
  Val(Copy(St,7,2),S,Err);
  InputTime:=LongInt(H)*3600+M*60+S;
End;
Function InputRoom(I:Word):Byte;
Begin
  InputRoom:=(I Div 100-1)*10+I Mod 100;
End;
Procedure Load;
Var
  CabInd:Word;
  TimeSt:String;
Begin
  Assign(Input,'INPUT.TXT');
  ReSet(Input);
  N:=0;
  Repeat
    Inc(N);
    With Agents[N] Do Begin
      If Not SeekEOF Then Read(C);
      If C='.' Then Begin Dec(N); Break; End;
      If Not SeekEOF Then Begin
        ReadLn(TimeSt);
        Start:=InputTime(TimeSt);
      End;
      NVis:=0;
      Visits[0].Where:=1;
      Repeat
        If Not SeekEOF Then Read(CabInd);
        If CabInd=0 Then Break;
        Inc(NVis);
        Visits[NVis].Where:=InputRoom(CabInd);
        If Not SeekEOF Then Read(Visits[NVis].Time);
      Until False;
      New(Plans[N]);
      Plans[N]^.NItems:=0;
    End;
  Until False;
  Close(Input);
End;
Function Earlier(Const A,B:TEvent):Boolean;
Begin
  Earlier:=(A.Time<B.Time) Or ((A.Time=B.Time) And (Ord(A.EventType)<Ord(B.EventType))) Or
           ((A.Time=B.Time) And (Ord(A.EventType)=Ord(B.EventType)) And (Agents[A.NAg].C<Agents[B.NAg].C));
End;
Procedure AddEvent(EType:TEventType; Ag,Vi:Byte; Tim:LongInt);
Var
  Cur:Word;
  Temp:TEvent;
Begin
  Inc(NE);
  With Events[NE] Do Begin
    EventType:=EType;
    NAg:=Ag;
    NVi:=Vi;
    Time:=Tim;
  End;
  Cur:=NE;
  While (Cur>1) And Earlier(Events[Cur],Events[Cur Div 2]) Do Begin
    Temp:=Events[Cur];
    Events[Cur]:=Events[Cur Div 2];
    Events[Cur Div 2]:=Temp;
    Cur:=Cur Div 2;
  End;
End;
Procedure DeleteFirstEvent;
Var
  Cur:Word;
  Temp:TEvent;
Begin
  Events[1]:=Events[NE];
  Dec(NE);
  Cur:=1;
  While ((Cur*2<=NE) And Earlier(Events[Cur*2],Events[Cur])) Or
        ((Cur*2+1<=NE) And Earlier(Events[Cur*2+1],Events[Cur])) Do Begin
    If (Cur*2+1>NE) Or Earlier(Events[Cur*2],Events[Cur*2+1]) Then Begin
      Temp:=Events[Cur];
      Events[Cur]:=Events[Cur*2];
      Events[Cur*2]:=Temp;
      Cur:=Cur*2;
    End Else Begin
      Temp:=Events[Cur];
      Events[Cur]:=Events[Cur*2+1];
      Events[Cur*2+1]:=Temp;
      Cur:=Cur*2+1;
    End;
  End;
End;
Procedure AddToPlan(Ag:Byte; IType:TItemType; AR1,AR2:Byte; TStart,TFinish:LongInt);
Begin
  Inc(Plans[Ag]^.NItems);
  With Plans[Ag]^.Items[Plans[Ag]^.NItems] Do Begin
    ItemType:=IType;
    R1:=AR1;
    R2:=AR2;
    Start:=TStart;
    Finish:=TFinish;
  End;
End;
Function RoomFloor(R:Byte):Byte;
Begin
  RoomFloor:=(R-1) Div 10+1;
End;
Procedure AddToStreet(RN:Byte; Ag,Vi:Byte);
Var
  Cur:Byte;
  Temp:TStreetItem;
Begin
  With Rooms[RN] Do Begin
    Inc(NS);
    Street[NS].NAg:=Ag;
    Street[NS].NVi:=Vi;
    Cur:=NS;
    While (Cur>1) And (Agents[Street[Cur].NAg].C<Agents[Street[Cur Div 2].NAg].C) Do Begin
      Temp:=Street[Cur];
      Street[Cur]:=Street[Cur Div 2];
      Street[Cur Div 2]:=Temp;
      Cur:=Cur Div 2;
    End;
  End;
End;
Procedure AddToEStreet(RN:Byte; Ag,Vi:Byte);
Var
  Cur:Byte;
  Temp:TStreetItem;
Begin
  With Elevators[RN] Do Begin
    Inc(NS);
    Street[NS].NAg:=Ag;
    Street[NS].NVi:=Vi;
    Cur:=NS;
    While (Cur>1) And (Agents[Street[Cur].NAg].C<Agents[Street[Cur Div 2].NAg].C) Do Begin
      Temp:=Street[Cur];
      Street[Cur]:=Street[Cur Div 2];
      Street[Cur Div 2]:=Temp;
      Cur:=Cur Div 2;
    End;
  End;
End;
Procedure DeleteFirstFromStreet(RN:Byte);
Var
  Cur:Byte;
  Temp:TStreetItem;
Begin
  With Rooms[RN] Do Begin
    Street[1]:=Street[NS];
    Dec(NS);
    Cur:=1;
    While ((Cur*2<=NS) And (Agents[Street[Cur].NAg].C>Agents[Street[Cur*2].NAg].C)) Or
          ((Cur*2+1<=NS) And (Agents[Street[Cur].NAg].C>Agents[Street[Cur*2+1].NAg].C)) Do Begin
      If (Cur*2+1>NS) Or (Agents[Street[Cur*2].NAg].C<Agents[Street[Cur*2+1].NAg].C) Then Begin
        Temp:=Street[Cur];
        Street[Cur]:=Street[Cur*2];
        Street[Cur*2]:=Temp;
        Cur:=Cur*2;
      End Else Begin
        Temp:=Street[Cur];
        Street[Cur]:=Street[Cur*2+1];
        Street[Cur*2+1]:=Temp;
        Cur:=Cur*2+1;
      End;
    End;
  End;
End;
Procedure DeleteFirstFromEStreet(RN:Byte);
Var
  Cur:Byte;
  Temp:TStreetItem;
Begin
  With Elevators[RN] Do Begin
    Street[1]:=Street[NS];
    Dec(NS);
    Cur:=1;
    While ((Cur*2<=NS) And (Agents[Street[Cur].NAg].C>Agents[Street[Cur*2].NAg].C)) Or
          ((Cur*2+1<=NS) And (Agents[Street[Cur].NAg].C>Agents[Street[Cur*2+1].NAg].C)) Do Begin
      If (Cur*2+1>NS) Or (Agents[Street[Cur*2].NAg].C<Agents[Street[Cur*2+1].NAg].C) Then Begin
        Temp:=Street[Cur];
        Street[Cur]:=Street[Cur*2];
        Street[Cur*2]:=Temp;
        Cur:=Cur*2;
      End Else Begin
        Temp:=Street[Cur];
        Street[Cur]:=Street[Cur*2+1];
        Street[Cur*2+1]:=Temp;
        Cur:=Cur*2+1;
      End;
    End;
  End;
End;
Procedure Run;
Var
  I:Word;
  Ev:TEvent;
  It:TStreetItem;
Begin
  NE:=0;
  For I:=1 To N Do AddEvent(etEntry,I,1,Agents[I].Start);
  For I:=1 To NRooms Do Begin
    Rooms[I].NS:=0;
    Rooms[I].Inside:=False;
  End;
  For I:=1 To NElevators Do Begin
    Elevators[I].NS:=0;
  End;
  Repeat
    Ev:=Events[1];
    DeleteFirstEvent;
    With Ev,Agents[Ev.NAg] Do
      Case EventType Of
        etEntry:Begin
          AddToPlan(NAg,itEntry,0,0,Time,Time+30);
          If RoomFloor(Visits[NVi].Where)=1 Then AddEvent(etArriveRoom,NAg,NVi,Time+30)
                                            Else AddEvent(etArriveElevator,NAg,NVi,Time+30);
          CurFloor:=1;
        End;
        etExit:;
        etArriveRoom:Begin
          If Rooms[Visits[NVi].Where].Inside Then Begin
            AddToStreet(Visits[NVi].Where,NAg,NVi);
            LastEv:=Time;
          End Else Begin
            Rooms[Visits[NVi].Where].Inside:=True;
            AddEvent(etOutRoom,NAg,NVi+1,Time+Visits[NVi].Time);
            AddToPlan(NAg,itStay,Visits[NVi].Where,0,Time,Time+Visits[NVi].Time);
          End;
        End;
        etOutRoom:Begin
          If NVi>NVis Then Begin
            If RoomFloor(Visits[NVi-1].Where)=1 Then Begin
              AddToPlan(NAg,itExit,0,0,Time,Time+30);
              AddEvent(etExit,NAg,0,Time+30);
            End Else Begin
              AddToPlan(NAg,itTransfer,Visits[NVi-1].Where,0,Time,Time+10);
              AddEvent(etArriveElevator,NAg,0,Time+10);
            End;
          End Else If RoomFloor(Visits[NVi].Where)=RoomFloor(Visits[NVi-1].Where) Then Begin
            AddToPlan(NAg,itTransfer,Visits[NVi-1].Where,Visits[NVi].Where,Time,Time+10);
            AddEvent(etArriveRoom,NAg,NVi,Time+10);
          End Else Begin
            AddToPlan(NAg,itTransfer,Visits[NVi-1].Where,0,Time,Time+10);
            AddEvent(etArriveElevator,NAg,NVi,Time+10);
          End;
          If Rooms[Visits[NVi-1].Where].NS=0 Then
            Rooms[Visits[NVi-1].Where].Inside:=False
          Else Begin
            It:=Rooms[Visits[NVi-1].Where].Street[1];
            DeleteFirstFromStreet(Visits[NVi-1].Where);
            If Agents[It.NAg].LastEv<Time Then AddToPlan(It.NAg,itWaiting,Visits[NVi-1].Where,0,Agents[It.NAg].LastEv,Time);
            AddToPlan(It.NAg,itStay,Visits[NVi-1].Where,0,Time,Time+Agents[It.NAg].Visits[It.NVi].Time);
            AddEvent(etOutRoom,It.NAg,It.NVi+1,Time+Agents[It.NAg].Visits[It.NVi].Time);
          End;
        End;
        etArriveElevator:Begin
          If Elevators[CurFloor].NS=0 Then
            AddEvent(etInElevator,0,CurFloor,(Time+4) Div 5*5);
          AddToEStreet(CurFloor,NAg,NVi);
          LastEv:=Time;
        End;
        etInElevator:Begin
          If Elevators[NVi].NS>0 Then Begin
            It:=Elevators[NVi].Street[1];
            DeleteFirstFromEStreet(NVi);
            If Agents[It.NAg].LastEv<Time Then AddToPlan(It.NAg,itWaiting,0,0,Agents[It.NAg].LastEv,Time);
            AddToPlan(It.NAg,itStay,0,0,Time,
                      Time+30*Abs(RoomFloor(Agents[It.NAg].Visits[It.NVi].Where)-NVi));
            AddEvent(etOutElevator,It.NAg,It.NVi,
                     Time+30*Abs(RoomFloor(Agents[It.NAg].Visits[It.NVi].Where)-NVi));
            If Elevators[NVi].NS>0 Then AddEvent(etInElevator,0,NVi,Time+5);
          End;
        End;
        etOutElevator:Begin
          CurFloor:=RoomFloor(Visits[NVi].Where);
          If NVi>0 Then Begin
            AddToPlan(NAg,itTransfer,0,Visits[NVi].Where,Time,Time+10);
            AddEvent(etArriveRoom,NAg,NVi,Time+10);
          End Else Begin
            AddToPlan(NAg,itExit,0,0,Time,Time+30);
            AddEvent(etExit,NAg,0,Time+30);
          End;
        End;
      End;
  Until NE=0;
End;
Function MakeTime(T:LongInt):String;
Var
  H,M,S:String;
Begin
  Str(T Div 3600,H);
  Str((T Div 60) Mod 60,M);
  Str(T Mod 60,S);
  If Length(H)=1 Then H:='0'+H;
  If Length(M)=1 Then M:='0'+M;
  If Length(S)=1 Then S:='0'+S;
  MakeTime:=H+':'+M+':'+S;
End;
Function NameOf(R:Byte):String;
Var
  S1,S2:String;
Begin
  If R=0 Then NameOf:='elevator' Else Begin
    Str((R-1) Div 10+1,S1);
    Str((R-1) Mod 10+1,S2);
    If Length(S1)=1 Then S1:='0'+S1;
    If Length(S2)=1 Then S2:='0'+S2;
    NameOf:='room '+S1+S2;
  End;
End;
Function WaitingPlace(R:Byte):String;
Var
  S1,S2:String;
Begin
  If R=0 Then WaitingPlace:='elevator queue' Else Begin
    Str((R-1) Div 10+1,S1);
    Str((R-1) Mod 10+1,S2);
    If Length(S1)=1 Then S1:='0'+S1;
    If Length(S2)=1 Then S2:='0'+S2;
    WaitingPlace:='front of room '+S1+S2;
  End;
End;
Procedure OutPlan(Const P:TPlan);
Var
  I:Word;
Begin
  For I:=1 To P.NItems Do Begin
    Write(MakeTime(P.Items[I].Start),' ',MakeTime(P.Items[I].Finish),' ');
    Case P.Items[I].ItemType Of
      itEntry:WriteLn('Entry');
      itExit:WriteLn('Exit');
      itTransfer:WriteLn('Transfer from ',NameOf(P.Items[I].R1),' to ',NameOf(P.Items[I].R2));
      itStay:WriteLn('Stay in ',NameOf(P.Items[I].R1));
      itWaiting:WriteLn('Waiting in ',WaitingPlace(P.Items[I].R1));
    End;
  End;
End;
Procedure Save;
Var
  Ch:Char;
  Num:Byte;
  First:Boolean;
Begin
  Assign(Output,'OUTPUT.TXT');
  ReWrite(Output);
  First:=True;
  For Ch:='A' To 'Z' Do Begin
    For Num:=1 To N Do If Agents[Num].C=Ch Then Begin
      If First Then First:=False Else WriteLn;
      WriteLn(Ch);
      OutPlan(Plans[Num]^);
      Break;
    End;
  End;
  Close(Output);
End;
Begin
  Load;
  Run;
  Save;
End.