
{.$define Debug}

program Solution;
{$M 16384,0,655360}

{$ifndef Debug}
{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'output.txt';
{$else}
{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  msgFailure			= 'failure';
  msgAmb			= 'ambiguous';

type
  TSet				= set of 0..10;

const
  digits			: array[0..9] of TSet =
  ( [1,3,4,5,6,7],
    [5,7],
    [1,5,2,6,3],
    [1,2,3,5,7],
    [4,2,5,7],
    [1,4,2,7,3],
    [1,4,2,6,7,3],
    [1,5,7],
    [1,2,3,4,5,6,7],
    [1,2,3,4,5,7] );

var
  tbl				: array[1..3] of string;
  ch				: array[1..9] of TSet;
  valid				: array[1..9] of integer;
  failure			: boolean;
  amb				: boolean;
  cur				: string;
  answer			: string;
  d				: array[1..9] of integer;
  found				: boolean;

procedure Rec( depth, sum : integer; invalid : boolean );
var
  i				: integer;
  newSum			: integer;

begin
  for i := 0 to 9 do
    if i in ch[depth] then begin
      newSum := sum + (10 - depth) * i;
      if (depth = 9) and (newSum mod 11 <> 0) then continue;
      if invalid and (i <> valid[depth]) then continue;
      cur[depth] := chr( i + ord( '0' ) );
      if depth = 9 then begin
        if found then
	  amb := true
        else begin
          answer := cur;
          found := true;
        end;
      end else
        Rec( depth + 1, newSum, invalid or (i <> valid[depth]) );
    end;
end;

procedure Solve;
var
  i,j,k				: integer;
  s				: TSet;

begin
  for i := 1 to 9 do valid[i] := -1;
  for i := 1 to 9 do begin
    s := [];
    j := i * 3 - 2;
    if tbl[1,j+1] = '_' then include( s, 1 );
    if tbl[2,j+1] = '_' then include( s, 2 );
    if tbl[3,j+1] = '_' then include( s, 3 );
    if tbl[2,j] = '|' then include( s, 4 );
    if tbl[2,j+2] = '|' then include( s, 5 );
    if tbl[3,j] = '|' then include( s, 6 );
    if tbl[3,j+2] = '|' then include( s, 7 );
    ch[i] := [];
    for k := 0 to 9 do
      if s * digits[k] = s then begin
        include( ch[i], k );
        if s = digits[k] then valid[i] := k;
      end;
  end;
  cur := '?????????';
  found := false;
  Rec( 1, 0, false );
  if not amb and not found then failure := true;
end;

procedure ReadData;
var
  i				: integer;

begin
  for i := 1 to 3 do begin
    readln( tbl[i] );
    while length( tbl[i] ) < 27 do tbl[i] := tbl[i] + ' ';
  end;
end;

procedure WriteData;
begin
  if failure then writeln( msgFailure ) else
  if amb then writeln( msgAmb ) else
  writeln( answer );
end;

procedure Initialize;
begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  WriteData;
  Finalize;
end.