program Department;
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 16384,250000,655360}

{ $ifdef TRACE}

const
{$ifdef ILIA}
  InFile='a.in';
  OutFile='a.out';
{$else}
  InFile='input.txt';
  OutFile='output.txt';
{$endif}

type Time = object
              tm:longint; {sec}
              procedure read;
              procedure write;
            end;
     Place=integer;
     { 0 = street,
       1(x-1) = elevator on X floor
       2(x-1) = begin of x floor,
       3(x-1) = waiting for elev. on x floor
       100 = exiting on street
       -room = exiting from room}
     Event = object
              w:boolean;
              src,dest:Place;
              time1,time2:Time;
              procedure write;
             end;
var agent:array['A'..'Z'] of
            record
              yes:boolean;
              entry:Time;
              todon:byte;
              todo:array[1..101] of
                     record
                       p:Place;
                       t:longint;
                     end;
            end;

procedure Time.read;
  var h,m,s:byte;
      c:char;
  begin
  system.read(c);
  while c=' ' do
    system.read(c);
  tm:=3600*10*(ord(c)-ord('0'));
  system.read(c);
  inc(tm,3600*(ord(c)-ord('0')));
  system.read(c);
  system.read(c);
  inc(tm,600*(ord(c)-ord('0')));
  system.read(c);
  inc(tm,60*(ord(c)-ord('0')));
  system.read(c);
  system.read(c);
  inc(tm,10*(ord(c)-ord('0')));
  system.read(c);
  inc(tm,(ord(c)-ord('0')));
  end;

procedure Time.write;
  var h,m:byte;
      t:longint;
  begin
  t:=tm;
  h:=longint(t) div longint(3600);
  t:=t-longint(h)*3600;
  m:=t div 60;
  t:=t-60*longint(m);
  system.write(h div 10,h mod 10,':',
        m div 10,m mod 10,':',
        t div 10,t mod 10);
  end;

procedure Event.write;
  function room(x:Place):string;
    begin
    room:=chr((x div 1000)+ord('0'))+
          chr((x div 100) mod 10+ord('0'))+
          chr((x div 10) mod 10+ord('0'))+
          chr(x mod 10+ord('0'));
    end;
  begin
  time1.write;
  system.write(' ');
  time2.write;
  system.write(' ');
  if w then
    if src=1 then
      writeln('Waiting in elevator queue')
    else
      writeln('Waiting in front of room ', room(src))
  else if src=dest then
    if src=1 then
      writeln('Stay in elevator')
    else
      writeln('Stay in room ',room(src))
  else
    if src=0 then
      writeln('Entry')
    else if dest=0 then
      writeln('Exit')
    else if src<20 then
      writeln('Transfer from elevator to room ',room(dest))
    else if dest<20 then
      writeln('Transfer from room ',room(src),' to elevator')
    else
      writeln('Transfer from room ',room(src),' to room ',room(dest));
  end;


procedure ReadData;
  var ch:char;
      c:char;
  begin
  Assign(input,InFile);
  Reset(Input);
  repeat
    read(ch);
    if ch='.' then break;
    with agent[ch] do begin
      yes:=true;
      entry.read;
      readln;
      todon:=0;
      repeat
        read(todo[todon+1].p);
        if todo[todon+1].p<>0 then
          inc(todon)
        else
          break;
        readln(todo[todon].t);
      until false;
      readln;
      inc(todon);
      todo[todon].p:=100;
    end;
  until false;
  Close(Input);
  end;

type TEvtArray=array['A'..'Z',1..510] of ^Event;
var
  evts:^TEvtArray;
  evtn:array['A'..'Z'] of word;

procedure WriteSol;
  var ch:char;
      i:word;
  begin
  Assign(Output,OutFile);
  Rewrite(Output);
  for ch:='A' to 'Z' do
    if agent[ch].yes then begin
      writeln(ch);
      for i:=1 to evtn[ch] do begin
        evts^[ch,i]^.write;
        dispose(evts^[ch,i]);
      end;
      writeln;
    end;
  Close(Output);
  end;

type TXEvt = record
             who: char;
             when: Time;
             where: Place;
             had:byte;
             end;

     PXENode = ^TXENode;
     TXENode = record
               e:TXEvt;
               next:PXENode;
               end;

     TXEQueue = object
                  private
                    f:PXENode;
                  public
                procedure init;
                function pop(var x:TXEvt):boolean;
                procedure push(const x:TXEvt);
                end;

     procedure TXEQueue.init;
       begin
       f:=nil;
       end;

     function TXEQueue.pop(var x:TXEvt):boolean;
       var f1:PXENode;
       begin
       if (f<>nil) then begin
         pop:=true;
         x:=f^.e;
         f1:=f^.next;
         dispose(f);
         f:=f1;
       end else
         pop:=false;
       end;

     procedure TXEQueue.push(const x:TXEvt);
       var node:PXeNode;
           p:^PXeNode;
       begin
       new(node);
       node^.e:=x;
       p:=@f;
       while (p^<>nil) and
             ((p^^.e.when.tm<x.when.tm) or
              (p^^.e.when.tm=x.when.tm) and
                ((p^^.e.who<x.who)
                 or ((p^^.e.where<0) and (x.where>=0)))
             )
              do
         p:=@p^^.next;
       node^.next:=p^;
       p^:=node;
       end;


var queue:TXEQueue;

procedure addv(who:char; const v:Event);
  begin
  inc(evtn[who]);
  new(evts^[who,evtn[who]]);
  evts^[who,evtn[who]]^:=v;
  end;

var atcab:array[1..10,1..10] of record is:char; endtime:Time; end;
    elock:array[1..10] of Time;
    wait:array['A'..'Z'] of Time;

procedure Run;
  var ch:char;
      e1,e:TXEvt;
      v:Event;
      next:Place;
      i:byte;
      df:byte;
  begin
  fillchar(evtn,sizeof(evtn),0);
  fillchar(atcab,sizeof(atcab),0);
  for i:=1 to 10 do
    elock[i].tm:=-1;
  for ch:='A' to 'Z' do
    wait[ch].tm:=-1;
  queue.init;
  for ch:='A' to 'Z' do
    if agent[ch].yes then
      with agent[ch] do begin
        e1.who:=ch;
        e1.when:=entry;
        e1.where:=0;
        e1.had:=0;
        queue.push(e1);
      end;

  while queue.pop(e) do begin
{$ifdef TRACE}
    e.when.write;
    writeln(' ',e.who,' ',e.where,' ',e.had);
{$endif}
    if e.where = 0 then begin
      e1.who:=e.who;
      e1.when.tm:=longint(e.when.tm)+30;
      v.w:=false;
      v.time1:=e.when;
      v.time2:=e1.when;
      v.src:=0;
      v.dest:=-1;
      addv(e.who,v);
      if (agent[e.who].todo[1].p div 100)=1 then
        e1.where:=agent[e.who].todo[1].p
      else
        e1.where:=10; {1 floor}
      queue.push(e1);
      continue;
    end;
    if e.where=100 then {want to exit}
      {do nothing};
    if (e.where>100) then begin
      if atcab[e.where div 100,e.where mod 100].is<>#0 then begin
        if wait[e.who].tm=-1 then
          wait[e.who]:=e.when;
        e.when:=atcab[e.where div 100,e.where mod 100].endtime;
        queue.push(e);
        continue;
      end else begin
        if wait[e.who].tm<>-1 then begin
          v.time1:=wait[e.who];
          v.time2:=e.when;
          v.w:=true;
          v.src:=e.where;
          v.dest:=e.where;
          addv(e.who,v);
          wait[e.who].tm:=-1;
        end;
        inc(e.had);
        with atcab[e.where div 100,e.where mod 100] do begin
          is:=e.who;
          endtime.tm:=e.when.tm+agent[e.who].todo[e.had].t;
          v.time1:=e.when;
          v.time2:=endtime;
          v.src:=E.where;
          v.dest:=e.where;
          v.w:=false;
          addv(e.who,v);
          e.when:=endtime;
        end;
        e.where:=-e.where;
        queue.push(e);
        continue;
      end;
    end;
    if (e.where<0) then begin
      atcab[(-e.where) div 100,(-e.where) mod 100].is:=#0;
      next:=agent[e.who].todo[e.had+1].p;
      if (next=100) and ((-e.where) div 100 = 1) then begin
          v.time1:=e.when;
          v.time2.tm:=v.time1.tm+30;
          v.src:=-e.where;
          v.dest:=0;
          v.w:=false;
          addv(e.who,v);
      end else if (next div 100)=((-e.where) div 100) then begin
          v.time1:=e.when;
          v.time2.tm:=v.time1.tm+10;
          v.src:=-e.where;
          v.dest:=next;
          v.w:=false;
          addv(e.who,v);
          e.where:=next;
          e.when.tm:=e.when.tm+10;
          queue.push(e);
      end else begin
          v.time1:=e.when;
          v.time2.tm:=v.time1.tm+10;
          v.src:=-e.where;
          v.dest:=1;
          v.w:=false;
          addv(e.who,v);
          e.when.tm:=e.when.tm+10;
          e.where:=(-e.where)div 100+9;
          queue.push(e);
      end;
      continue;
   end;
   if (e.where<=19) and (e.where>=10) then begin
     if ((elock[e.where-9].tm<e.when.tm)) then begin
       if wait[e.who].tm<>-1 then begin
         v.w:=true;
         v.src:=1;
         v.dest:=1;
         v.time1:=wait[e.who];
         v.time2:=e.when;
         addv(e.who,v);
         wait[e.who].tm:=-1;
       end;
       df:=abs((e.where-9)-(agent[e.who].todo[e.had+1].p div 100));
       elock[e.where-9]:=e.when;
       v.w:=false;
       v.src:=1;
       v.dest:=1;
       v.time1:=e.when;
       v.time2.tm:=e.when.tm+30*df;
       addv(e.who,v);
       e.where:=e.where+10;
       e.when.tm:=e.when.tm+df*30;
       queue.push(e);
     end else begin
       if wait[e.who].tm=-1 then
         wait[e.who]:=e.when;
       e.when.tm:=5*((e.when.tm) div 5)+5;
       queue.push(e);
     end;
     continue;
   end;
{   if (e.where<=39) and (e.where>=30) then begin
     if (elock[e.where-29].tm<e.when.tm) then begin
       dec(qsize[e.where-29]);
       df:=abs((e.where-29)-(agent[e.who].todo[e.had+1].p div 100));
       elock[e.where-29]:=e.when;
       v.w:=false;
       v.src:=1;
       v.dest:=1;
       v.time1:=e.when;
       v.time2.tm:=e.when.tm+30*df;
       addv(e.who,v);
       e.where:=e.where-10;
       e.when.tm:=e.when.tm+df*30;
       queue.push(e);
     end else begin
       e.when.tm:=e.when.tm+5;
       e.where:=e.where+20;
       queue.push(e);
     end;
     continue;
   end;}
   if (e.where<=29) and (e.where>=20) then begin
     e.where:=agent[e.who].todo[e.had+1].p;
     v.time1:=e.when;
     if e.where=100 then begin
       e.when.tm:=e.when.tm+30;
       v.dest:=0
     end else begin
       v.dest:=e.where;
       e.when.tm:=e.when.tm+10;
     end;
     v.time2:=e.when;
     v.src:=1;
     addv(e.who,v);
     queue.push(e);
     continue;
   end;
  end;
  end;

begin
new(evts);
ReadData;
Run;
WriteSol;
dispose(evts);
end.