{ ----------------- Compiler directives ------------------- }
{$A+,B-,E-,F-,G-,N+,O-,P-,Q-,T-,V+,X+}
{$M 65520,0,655360}

{ ------------------ Debug mode on/off -------------------- }


{$DEFINE __DEBUG__}

{$IFDEF __DEBUG__}
{$D+,I+,L+,R+,S+,Y+}
{$ELSE}
{$D-,I-,L-,R-,S-,Y-}
{$ENDIF}
{ --------------- End Compiler directives ----------------- }

program AgentsInBuilding;

type
    TTime = record
    			h, m, s : word;
    		end;

    Duration = word;

    TRoom = record
    		floor, number : word;
    		end;

	TAgent = 	record
					code : char;
                    entry_time : TTime;
                    num_rooms : integer;
                    rooms : array [1..100] of TRoom;
                    durations : array [1..100] of Duration;
    			end;

    TAgentsArray = array [1..26] of TAgent;

    TPlan = array [1..1000] of
				record
                    code, floor : integer;
                    room, room2 : TRoom;
                    time1, time2 : TTime;
                end;

	ElLines = array [1..10] of
					record
                    	tstart : TTime;
						num : integer;
						codes : array [1..26] of char;
					end;

    RoomLines = array [1..10, 1..10] of
					record
                    	tstart : TTime;
						num : integer;
						codes : array [1..26] of char;
					end;

const
	Enters = 0;
    Exits = 1;
    WaitsElev = 2;
    WaitsRoom = 3;
    InRoom = 4;
    InElev = 5;
    TransfR2E = 6;
    TransfE2R = 7;
    TransfR2R = 8;

    EntryTime = 30;
    ExitTime = 30;
    R2ETime = 10;
    E2RTime = 10;
    R2RTime = 10;
    ElevTime = 30;
    QueueTime = 5;

var
	a : ^TAgentsArray;
    num_a : word;
    x : TAgent;

    EQ : ElLines;
    LQ : RoomLines;

    plans : array [1..26] of ^TPlan;
    last_p : array [1..26] of integer;
    last_room : array [1..26] of integer;

    i, j : integer;
    num, bad : integer;

    s : string;

procedure AddTime (t : TTime; dur : Duration; var nt : TTime);
	var
    	inch, incm : word;

	begin
    	nt := t;
        inc (nt.h, dur div 3600);
        dur := dur mod 3600;
        inc (nt.m, dur div 60);
        dur := dur mod 60;
        if (nt.s + dur >= 60)
        	then
				begin
            		inc (nt.m);
					if (nt.m = 60)
                        then
							begin
								nt.m := 0;
								inc (nt.h);
                            end;
                    dur := dur - 60;
                end;
        inc (nt.s, dur);
    end;

function SameTime (t1, t2 : TTime) : boolean;
	begin
    	SameTime := (t1.h = t2.h) and (t1.m = t2.m) and (t1.s = t2.s);
    end;

function Compare (t1, t2 : TTime) : integer;
	begin
    	if t1.h > t2.h
			then Compare := 1
        else if t1.h < t2.h
			then Compare := -1
        else if t1.m > t2.m
			then Compare := 1
        else if t1.m < t2.m
        	then Compare := -1
        else if t1.s > t2.s
        	then Compare := 1
        else if t1.s < t2.s
        	then Compare := -1
        	else Compare := 0;
    end;

procedure Initialize;
	var
    	i : integer;

	begin
	    for i := 1 to num_a do
	    	for j := 1 to num_a - i do
	        	if a^[j].code > a^[j + 1].code
	            	then
	                	begin
	                        x := a^[j];
	                        a^[j] := a^[j + 1];
	                        a^[j + 1] := x
						end;

	    for i := 1 to num_a do
        	begin
				new (plans [i]);
                last_p [i] := 1;
                plans [i]^[1].code := Enters;
                plans [i]^[1].time1 := a^[i].entry_time;
                AddTime (a^[i].entry_time, EntryTime, plans [i]^[1].time2);
            end;

        for i := 1 to 10 do
        	EQ [i].num := 0;
        for i := 1 to 10 do
        	for j := 1 to 10 do
				LQ [i, j].num := 0;

        for i := 1 to num_a do
        	last_room [i] := 0;
    end;

procedure Model;
	var
    	all_quit : boolean;
        cur_time : TTime;
        num : integer;
        cur_a : array [1..26] of 1..26;
        exited : array [1..26] of boolean;

	begin
    	fillchar (exited, sizeof (exited), 0);

    	all_quit := false;
        cur_time.h := 23; cur_time.m := 59; cur_time.s := 59;
        repeat
        	num_a := 0;
        	for i := 1 to num_a do if not exited [i] then
            	case Compare (cur_time, plans [i]^[last_p [i]].time2) of
                	0 :
                    	begin
                        	inc (num);
                            cur_a [i] := i;
                        end;
                    1 :
                    	begin
                        	num := 1;
                            cur_a [1] := i;
                        end;
                    end;
            if (num = 1)
            	then
                	begin
                    	i := cur_a [1];
                        if (last_room [i] = a^[i].num_rooms)
                        	then case plans [i]^[last_p [i]].code of
                            		InRoom : begin
                                    			if a^[i].rooms [last_room [i]].floor = 1
                                                	then begin
														inc (last_p [i]);
                                                        plans [i]^[last_p [i]].code := Exits;
                                                        plans [i]^[last_p [i]].time1 := plans [i]^[last_p [i] - 1].time2;
                                                        AddTime (plans [i]^[last_p [i]].time1, ExitTime, plans [i]^[last_p [i]].time2);
                                                        exited [i] := true;
                                                        end
                                                    else begin
														inc (last_p [i]);
                                                        plans [i]^[last_p [i]].code := TransfR2E;
                                                        plans [i]^[last_p [i]].time1 := plans [i]^[last_p [i] - 1].time2;
                                                        AddTime (plans [i]^[last_p [i]].time1, R2ETime, plans [i]^[last_p [i]].time2);
                                                        end;
                                                end;
                                    InElev : begin
												 inc (last_p [i]);
                                                 plans [i]^[last_p [i]].code := Exits;
                                                 plans [i]^[last_p [i]].time1 := plans [i]^[last_p [i] - 1].time2;
                                                 AddTime (plans [i]^[last_p [i]].time1, ExitTime, plans [i]^[last_p [i]].time2);
                                                 exited [i] := true;
                                    		end;

                                    WaitsElev : begin
                                    			if
                                    			inc (last_p [i]);


            for i := 1 to num do

        until all_quit;
    end;

begin
	assign (input, 'input.txt');
    reset (input);
	readln (input, s);

    num_a := 0;

    new (a);

    while (s <> '.') do
    	begin
        	inc (num_a);
            a^[num_a].code := s [1];
            val (copy (s, 3, 2), a^[num_a].entry_time.h, bad);
            val (copy (s, 6, 2), a^[num_a].entry_time.m, bad);
            val (copy (s, 9, 2), a^[num_a].entry_time.s, bad);
            readln (s);
            a^[num_a].num_rooms := 0;
            while (s <> '0') do
            	begin
                	inc (a^[num_a].num_rooms);
                	val (copy (s, 1, 2), a^[num_a].rooms [a^[num_a].num_rooms].floor, bad);
                	val (copy (s, 3, 2), a^[num_a].rooms [a^[num_a].num_rooms].number, bad);
                	val (copy (s, 6, length (s)), a^[num_a].durations [a^[num_a].num_rooms], bad);
                    readln (s);
                end;
            readln (s);
        end;

    close (input);

    Initialize;

    Model;

    assign (output, 'output.txt');
    rewrite (output);
    for i := 1 to num_a do
    	begin
        	Writeln (a^[i].code);
            for j := 1 to last_p [i] do
            	begin
                	if (plans [i]^[j].time1.h div 10) = 0
                    	then Write ('0');
                	Write (plans [i]^[j].time1.h, ':');
                	if (plans [i]^[j].time1.m div 10) = 0
                    	then Write ('0');
                	Write (plans [i]^[j].time1.m, ':');
                	if (plans [i]^[j].time1.s div 10) = 0
                    	then Write ('0');
                	Write (plans [i]^[j].time1.s, ' ');

                	if (plans [i]^[j].time2.h div 10) = 0
                    	then Write ('0');
                	Write (plans [i]^[j].time2.h, ':');
                	if (plans [i]^[j].time2.m div 10) = 0
                    	then Write ('0');
                	Write (plans [i]^[j].time2.m, ':');
                	if (plans [i]^[j].time2.s div 10) = 0
                    	then Write ('0');
                	Write (plans [i]^[j].time2.s, ' ');
                    case plans [i]^[j].code of
                    	Enters : Writeln ('Entry');
                        Exits : Writeln ('Exit');
                        WaitsElev : Writeln ('Waiting in elevator queue');
                        WaitsRoom :
							begin
								Write ('Waiting in front of room ');
                                if (plans [i]^[j].room.floor div 10 = 0)
                                	then Write ('0');
                                Write (plans [i]^[j].room.floor);
                                if (plans [i]^[j].room.number div 10 = 0)
                                	then Write ('0');
                                Write (plans [i]^[j].room.number);
                                Writeln;
                            end;

                        InRoom :
                        	begin
								Write ('Stay in room ');
                                if (plans [i]^[j].room.floor div 10 = 0)
                                	then Write ('0');
                                Write (plans [i]^[j].room.floor);
                                if (plans [i]^[j].room.number div 10 = 0)
                                	then Write ('0');
                                Write (plans [i]^[j].room.number);
                                Writeln;
                            end;

                        InElev : Writeln ('Stay in elevator');

                        TransfR2R :
							begin
								Write ('Transfer from room ');
                                if (plans [i]^[j].room.floor div 10 = 0)
                                	then Write ('0');
                                Write (plans [i]^[j].room.floor);
                                if (plans [i]^[j].room.number div 10 = 0)
                                	then Write ('0');
                                Write (plans [i]^[j].room.number);
                                Write (' to room ');
                                if (plans [i]^[j].room2.floor div 10 = 0)
                                	then Write ('0');
                                Write (plans [i]^[j].room2.floor);
                                if (plans [i]^[j].room2.number div 10 = 0)
                                	then Write ('0');
                                Write (plans [i]^[j].room2.number);
                                Writeln;
                            end;

                        TransfR2E :
                        	begin
								Write ('Transfer from room ');
                                if (plans [i]^[j].room.floor div 10 = 0)
                                	then Write ('0');
                                Write (plans [i]^[j].room.floor);
                                if (plans [i]^[j].room.number div 10 = 0)
                                	then Write ('0');
                                Write (plans [i]^[j].room.number);
                                Writeln (' to elevator');
                            end;

                        TransfE2R :
                        	begin
								Write ('Transfer from elevator to room ');
                                if (plans [i]^[j].room.floor div 10 = 0)
                                	then Write ('0');
                                Write (plans [i]^[j].room.floor);
                                if (plans [i]^[j].room.number div 10 = 0)
                                	then Write ('0');
                                Write (plans [i]^[j].room.number);
                                Writeln;
                            end;
                    end;
                end;
	        Writeln;
	    end;

	close (output);
end.