
{.$define Debug}

program Solution;
{$M 16384,0,0}

{$ifndef Debug}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'a.in';
  outFile			= 'a.out';
{$else}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  maxL				= 40960;
  spaces			= [#32,#9];

var
  buf				: array[1..maxL] of char;
  p				: word;
  sz				: word;

function SkipSpaces( p : word ) : word;
var
  i				: word;

begin
  i := p + 1;
  while i <= sz do begin
    if not (buf[i] in spaces) then begin
      SkipSpaces := i;
      exit;
    end;
    inc( i );
  end;
  SkipSpaces := 0;
end;

function IsHruHru : boolean;
var
  i				: word;

begin
  IsHruHru := false;
  if buf[p] in spaces then
    i := SkipSpaces( p )
  else
    i := p;
  if i = 0 then exit;
  if buf[i] <> '"' then exit;
  i := SkipSpaces( i );
  if i = 0 then exit;
  if (Upcase( buf[i] ) <> 'H') or
     (Upcase( buf[i+1] ) <> 'R') or
     (Upcase( buf[i+2] ) <> 'U') then exit;
  i := SkipSpaces( i + 2 );
  if i = 0 then exit;
  if buf[i] <> '-' then exit;
  i := SkipSpaces( i );
  if i = 0 then exit;
  if (Upcase( buf[i] ) <> 'H') or
     (Upcase( buf[i+1] ) <> 'R') or
     (Upcase( buf[i+2] ) <> 'U') then exit;
  i := SkipSpaces( i + 2 );
  if i = 0 then exit;
  if buf[i] <> '"' then exit;
  IsHruHru := true;
end;

function SkipUpToEOL( p : word ) : word;
var
  i				: word;

begin
  i := p;
  while (i <= sz) do begin
    if (buf[i] = #10) and (buf[i+1] = #13) or
       (buf[i] = #13) and (buf[i+1] = #10) then begin
      SkipUpToEOL := i + 2;
      exit;
    end;
    inc( i );
  end;
  SkipUpToEOL := 0;
end;

procedure Solve;
var
  i,j				: word;

begin
  p := 1;
  while p <= sz do begin
    if IsHruHru then
      p := SkipUpToEOL( p )
    else begin
      j := SkipUpToEOL( p );
      for i := p to j do begin
        if (buf[i] = #10) or (buf[i] = #13) then break;
        write( buf[i] );
      end;
      writeln;
      p := j;
    end;
  end;
end;

procedure ReadData;
var
  f				: file;

begin
  fillchar( buf, sizeof(buf), #0 );
  assign( f, inFile );
  reset( f, 1 );
  sz := FileSize( f );
  blockread( f, buf, sz );
  close( f );
end;

procedure WriteData;
var
  i				: integer;

begin

end;

procedure Initialize;
begin

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  Finalize;
end.