
{.$define Debug}

program Solution;
{$M 16384,204800,204800}

{$ifndef Debug}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'b.in';
  outFile			= 'b.out';
{$else}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  maxN                          = 225;

type
  int                           = longint;
  TArray                        = array[0..maxN] of int;
  PArray                        = ^TArray;

var
  n                             : integer;
  answer                        : int;
  w                             : array[0..maxN] of PArray;

procedure Solve;
var
  i,j,k                         : integer;
  sum				: int;
  hi				: integer;

begin
  for i := 0 to maxN do w[0]^[i] := 1;
  for i := 1 to n do
    for j := 0 to n do begin
      sum := 0;
      if j > i then hi := i else hi := j;
      for k := 1 to hi do inc( sum, w[i-k]^[k-1] );
      w[i]^[j] := sum;
    end;
  answer := w[n]^[n];
end;

procedure ReadData;
begin
  read( n );
end;

procedure WriteData;
begin
  writeln( answer );
end;

procedure Initialize;
var
  i                             : integer;

begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

  for i := 0 to maxN do new( w[i] );

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  WriteData;
  Finalize;
end.