
{.$define Debug}

program Solution;
{$M 64000,0,655360}

{$ifndef Debug}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'c.in';
  outFile			= 'c.out';
{$else}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'c.in';
  outFile			= 'c.out';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  maxN				= 500;

type
  int				= longint;

  TCircle			= record
    x				: int;
    y				: int;
    r				: int;
    max				: integer;
    prev			: integer;
  end;

var
  n				: integer;
  c				: array[1..maxN] of TCircle;
  ansLen			: integer;
  answer			: array[1..maxN] of integer;

function IsInside( a, b : integer ) : boolean;
var
  d				: int;

begin
  d := sqr(c[b].x - c[a].x) + sqr(c[b].y - c[a].y);
  IsInside := (a <> b) and
              (c[a].r <= c[b].r) and
              (d <= sqr(c[b].r - c[a].r));
end;

function Eval( k : integer ) : integer;
var
  i,j				: integer;
  newMax			: integer;
  max				: integer;

begin
  if c[k].max <> -1 then begin
    Eval := c[k].max;
    exit;
  end;
  max := 0;
  j := 0;
  for i := 1 to n do
    if IsInside( k, i ) then begin
      newMax := Eval( i );
      if newMax > max then begin
        j := i;
        max := newMax;
      end;
    end;
  c[k].max := max + 1;
  c[k].prev := j;
  Eval := max + 1;
end;

procedure Solve;
var
  i,j				: integer;
  max				: integer;

begin
  for i := 1 to n do c[i].max := -1;
  for i := 1 to n do Eval( i );
  max := 0;
  for i := 1 to n do
    if c[i].max > max then begin
      j := i;
      max := c[i].max;
    end;
  ansLen := max;
  i := 1;
  while j <> 0 do begin
    answer[i] := j;
    inc( i );
    j := c[j].prev;
  end;
end;

procedure ReadData;
var
  i				: integer;

begin
  read( n );
  for i := 1 to n do read( c[i].x, c[i].y, c[i].r );
end;

procedure WriteData;
var
  i				: integer;

begin
  writeln( ansLen );
  for i := 1 to ansLen do write( answer[i], ' ' );
  writeln;
end;

procedure Initialize;
begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  WriteData;
  Finalize;
end.