
{.$define Debug}

program Solution;
{$M 16384,0,655360}

{$ifndef Debug}
{$A+,B-,D+,E+,F+,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'd.in';
  outFile			= 'd.out';
{$else}
{$A+,B-,D+,E+,F+,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  maxN				= 10000;
  inf				= 65536;

type
  int				= longint;

  TPos				= record
    x,y				: integer;
  end;

var
  n				: integer;
  p				: array[1..maxN] of TPos;
  answer			: int;

procedure HeapSort;
var
  i,j,l,r			: integer;
  pp				: TPos;

  procedure Sift;
  begin
    i := l;
    j := l * 2;
    pp := p[i];
    if (j < r) and (p[j].x < p[j+1].x) then inc( j );
    while (j <= r) and (pp.x < p[j].x) do begin
      p[i] := p[j];
      i := j;
      j := j * 2;
      if (j < r) and (p[j].x < p[j+1].x) then inc( j );
    end;
    p[i] := pp;
  end;

begin
  r := n;
  for l := n div 2 downto 1 do Sift;
  while r > 1 do begin
    pp := p[1];
    p[1] := p[r];
    p[r] := pp;
    dec( r );
    Sift;
  end;
end;

function EvalHor( m : int; delta : integer ) : int;
var
  i				: integer;
  s				: int;

begin
  s := 0;
  for i := 1 to n do begin
    inc( s, abs(int( p[i].x ) - m ) );
    inc( m, delta );
  end;
  EvalHor := s;
end;

function EvalVert( m : int ) : int;
var
  i				: integer;
  s				: int;

begin
  s := 0;
  for i := 1 to n do inc( s, abs(int( p[i].y ) - m ) );
  EvalVert := s;
end;

procedure Transpose;
var
  i				: integer;
  v				: integer;

begin
  for i := 1 to n do begin
    v := p[i].x;
    p[i].x := p[i].y;
    p[i].y := v;
  end;
end;

function Calc : int;
var
  x				: int;
  a,b,c				: int;
  i				: integer;

begin
  a := inf;
  for i := 1 to n do begin
    b := EvalHor( p[i].x, 1 );
    if b < a then a := b;
    b := EvalHor( p[i].x, -1 );
    if b < a then a := b;
  end;
  for x := p[1].x - n to p[1].x do begin
    b := EvalHor( x, 1 );
    if b < a then a := b;
  end;
  for x := p[n].x to p[n].x + n do begin
    b := EvalHor( x, -1 );
    if b < a then a := b;
  end;
  c := inf;
  for i := 1 to n do begin
    b := EvalVert( p[i].y );
    if b < c then c := b;
  end;
  Calc := a + c;
end;

procedure Solve;
var
  tmp				: int;

begin
  HeapSort;
  answer := Calc;
  Transpose;
  HeapSort;
  tmp := Calc;
  if tmp < answer then answer := tmp;
end;

procedure ReadData;
var
  i				: integer;

begin
  read( n );
  for i := 1 to n do read( p[i].x, p[i].y );
end;

procedure WriteData;
var
  i				: integer;

begin
  writeln( answer );
end;

procedure Initialize;
begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  WriteData;
  Finalize;
end.