
{.$define Debug}

program Solution;
{$M 16384,300000,300000}

{$ifndef Debug}
{$A+,B-,D+,E+,F+,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'd.in';
  outFile			= 'd.out';
{$else}
{$A+,B-,D+,E+,F+,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  maxN				= 10000;
  inf				= maxlongint;

type
  int				= longint;

  TPos				= record
    x,y				: integer;
  end;

  TArray                        = array[1..maxN] of TPos;
  PArray                        = ^TArray;

var
  n				: integer;
  p				: PArray;
  xs,ys                         : PArray;
  q                             : PArray;
  answer			: int;

procedure HeapSort( p : PArray );
var
  i,j,l,r			: integer;
  pp				: TPos;

  procedure Sift;
  begin
    i := l;
    j := l * 2;
    pp := p^[i];
    if (j < r) and (p^[j].x < p^[j+1].x) then inc( j );
    while (j <= r) and (pp.x < p^[j].x) do begin
      p^[i] := p^[j];
      i := j;
      j := j * 2;
      if (j < r) and (p^[j].x < p^[j+1].x) then inc( j );
    end;
    p^[i] := pp;
  end;

begin
  r := n;
  for l := n div 2 downto 1 do Sift;
  while r > 1 do begin
    pp := p^[1];
    p^[1] := p^[r];
    p^[r] := pp;
    dec( r );
    Sift;
  end;
end;

procedure Transpose( p : PArray );
var
  i				: integer;
  v				: integer;

begin
  for i := 1 to n do begin
    v := p^[i].x;
    p^[i].x := p^[i].y;
    p^[i].y := v;
  end;
end;

function GetDist( p : PArray ) : int;
var
  sum                           : int;
  i                             : integer;

begin
  sum := 0;
  for i := 1 to n do
    inc( sum, abs( int(p^[i].x) - int(p^[n div 2 + 1].x) ) );
  GetDist := sum;
end;

function Calc : int;
var
  sum                           : int;
  i                             : integer;
  max                           : int;

begin
  Transpose( ys );
  sum := GetDist( ys );
  Transpose( ys );
  move( xs^, q^, sizeof(TArray) );
  max := -inf;
  for i := 1 to n do
    if q^[i].x > max then max := q^[i].x;
  if max < 32000 then
    for i := 1 to n do inc( q^[i].x, 32000 - max );
  for i := 1 to n do dec( q^[i].x, i - 1 );
  HeapSort( q );
  inc( sum, GetDist( q ) );
  Calc := sum;
end;

procedure Solve;
var
  tmp				: int;
  swp                           : PArray;

begin
  move( p^, xs^, sizeof(TArray) );
  HeapSort( xs );
  move( p^, ys^, sizeof(TArray) );
  Transpose( ys );
  HeapSort( ys );
  Transpose( ys );
  answer := Calc;
  Transpose( xs );
  Transpose( ys );
  swp := xs;
  xs := ys;
  ys := swp;
  tmp := Calc;
  if tmp < answer then answer := tmp;
end;

procedure ReadData;
var
  i				: integer;

begin
  read( n );
  for i := 1 to n do read( p^[i].x, p^[i].y );
end;

procedure WriteData;
var
  i				: integer;

begin
  writeln( answer );
end;

procedure Initialize;
var
  i				: integer;

begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

  new( p );
  new( q );
  new( xs );
  new( ys );

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  WriteData;
  Finalize;
end.