{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}

program Labyrinth;

type
	edge = (_L, _R, _U, _D);
	setEdges = set of edge;
    stroke = (_UP, _LEFT, _DOWN, _RIGHT);
    setStrokes = set of stroke;

var
	field : array [1..50, 1..50] of setEdges;
    m, n : integer;

	f, out : text;

    lab : array [1..101, 1..101] of char;
    strokes : array [1..101, 1..101] of setStrokes;

    i, j, k : integer;
    s : string;

begin
	assign (f, 'INPUT.TXT');
    reset (f);
    readln (f, m, n);
    for i := 1 to m do
    	for j := 1 to n do
        	begin
            	readln (f, s);
                field [i, j] := [];
                for k := 1 to length (s) do
                	case s [k] of
                    	'L': include (field [i, j], _L);
                    	'R': include (field [i, j], _R);
                    	'U': include (field [i, j], _U);
                    	'D': include (field [i, j], _D);
                        end;
            end;

    for i := 1 to 2*m + 1 do
    	for j := 1 to 2*n + 1 do
        	strokes [i, j] := [];

    for i := 1 to m do
    	for j := 1 to n do
        	begin
            	if _L in field [i, j]
                	then
                    	begin
                        	include (strokes [i*2, j*2 - 1], _UP);
                            include (strokes [i*2, j*2 - 1], _DOWN);
                            include (strokes [i*2 - 1, j*2 - 1], _DOWN);
                            include (strokes [i*2 + 1, j*2 - 1], _UP);
                        end;
            	if _R in field [i, j]
                	then
                    	begin
                        	include (strokes [i*2, j*2 + 1], _UP);
                            include (strokes [i*2, j*2 + 1], _DOWN);
                            include (strokes [i*2 - 1, j*2 + 1], _DOWN);
                            include (strokes [i*2 + 1, j*2 + 1], _UP);
                        end;
            	if _U in field [i, j]
                	then
                    	begin
                        	include (strokes [i*2 - 1, j*2], _LEFT);
                            include (strokes [i*2 - 1, j*2], _RIGHT);
                            include (strokes [i*2 - 1, j*2 - 1], _RIGHT);
                            include (strokes [i*2 - 1, j*2 + 1], _LEFT);
                        end;
            	if _D in field [i, j]
                	then
                    	begin
                        	include (strokes [i*2 + 1, j*2], _LEFT);
                            include (strokes [i*2 + 1, j*2], _RIGHT);
                            include (strokes [i*2 + 1, j*2 - 1], _RIGHT);
                            include (strokes [i*2 + 1, j*2 + 1], _LEFT);
                        end;
            end;

    if strokes [1, 1] <> []
		then lab [1, 1] := '';
    if strokes [1, 2*n + 1] <> []
    	then lab [1, 2*n + 1] := '';
    if strokes [2*m + 1, 1] <> []
    	then lab [2*m + 1, 1] := '';
    if strokes [2*n + 1, 2*m + 1] <> []
    	then lab [2*m + 1, 2*n + 1] := '';

    for i := 2 to 2*m do
       	begin
            if (strokes [i, 1] = [])
            	then lab [i, 1] := ' '
           	else if (strokes [i, 1] = [_UP])
            	then lab [i, 1] := ''
           	else if (strokes [i, 1] = [_DOWN])
            	then lab [i, 1] := ''
           	else if (strokes [i, 1] = [_UP, _DOWN])
            	then lab [i, 1] := ''
            else if (strokes [i, 1] = [_UP, _RIGHT])
            	then lab [i, 1] := ''
            else if (strokes [i, 1] = [_DOWN, _RIGHT])
            	then lab [i, 1] := ''
            else if (strokes [i, 1] = [_UP, _DOWN, _RIGHT])
            	then lab [i, 1] := ''
            else if (strokes [i, 1] = [_RIGHT])
            	then lab [i, 1] := '';

            if (strokes [i, 2*n + 1] = [])
            	then lab [i, 2*n + 1] := ' '
           	else if (strokes [i, 2*n + 1] = [_UP])
            	then lab [i, 2*n + 1] := ''
           	else if (strokes [i, 2*n + 1] = [_DOWN])
            	then lab [i, 2*n + 1] := ''
           	else if (strokes [i, 2*n + 1] = [_UP, _DOWN])
            	then lab [i, 2*n + 1] := ''
            else if (strokes [i, 2*n + 1] = [_UP, _LEFT])
            	then lab [i, 2*n + 1] := ''
            else if (strokes [i, 2*n + 1] = [_DOWN, _LEFT])
            	then lab [i, 2*n + 1] := ''
            else if (strokes [i, 2*n + 1] = [_UP, _DOWN, _LEFT])
            	then lab [i, 2*n + 1] := ''
            else if (strokes [i, 2*n + 1] = [_LEFT])
            	then lab [i, 2*n + 1] := '';
        end;

    for j := 2 to 2*n do
       	begin
            if (strokes [1, j] = [])
            	then lab [1, j] := ' '
           	else if (strokes [1, j] = [_LEFT])
            	then lab [1, j] := ''
           	else if (strokes [1, j] = [_RIGHT])
            	then lab [1, j] := ''
           	else if (strokes [1, j] = [_LEFT, _RIGHT])
            	then lab [1, j] := ''
            else if (strokes [1, j] = [_LEFT, _DOWN])
            	then lab [1, j] := {''} ''
            else if (strokes [1, j] = [_RIGHT, _DOWN])
            	then lab [1, j] := {''} ''
            else if (strokes [1, j] = [_LEFT, _RIGHT, _DOWN])
            	then lab [1, j] := ''
            else if (strokes [1, j] = [_DOWN])
            	then lab [1, j] := '';

            if (strokes [2*m + 1, j] = [])
            	then lab [2*m + 11, j] := ' '
           	else if (strokes [2*m + 11, j] = [_LEFT])
            	then lab [2*m + 1, j] := ''
           	else if (strokes [2*m + 1, j] = [_RIGHT])
            	then lab [2*m + 1, j] := ''
           	else if (strokes [2*m + 1, j] = [_LEFT, _RIGHT])
            	then lab [2*m + 1, j] := ''
            else if (strokes [2*m + 1, j] = [_LEFT, _UP])
            	then lab [2*m + 1, j] := {''} ''
            else if (strokes [2*m + 1, j] = [_RIGHT, _UP])
            	then lab [2*m + 1, j] := {''} ''
            else if (strokes [2*m + 1, j] = [_LEFT, _RIGHT, _UP])
            	then lab [2*m + 1, j] := ''
            else if (strokes [2*m + 1, j] = [_UP])
            	then lab [2*m + 1, j] := '';
        end;

    for i := 2 to 2*m do
    	for j := 2 to 2*n do
        	begin
            	if strokes [i, j] = []
                	then lab [i, j] := ' '
            	else if strokes [i, j] = [_UP]
                	then lab [i, j] := ''
            	else if strokes [i, j] = [_DOWN]
                	then lab [i, j] := ''
            	else if strokes [i, j] = [_LEFT]
                	then lab [i, j] := ''
            	else if strokes [i, j] = [_RIGHT]
                	then lab [i, j] := ''
            	else if strokes [i, j] = [_UP, _LEFT]
                	then lab [i, j] := ''
            	else if strokes [i, j] = [_UP, _RIGHT]
                	then lab [i, j] := ''
            	else if strokes [i, j] = [_DOWN, _RIGHT]
                	then lab [i, j] := ''
            	else if strokes [i, j] = [_DOWN, _LEFT]
                	then lab [i, j] := ''
            	else if strokes [i, j] = [_LEFT, _RIGHT]
                	then lab [i, j] := ''
            	else if strokes [i, j] = [_DOWN, _UP]
                	then lab [i, j] := ''
            	else if strokes [i, j] = [_UP, _DOWN, _LEFT]
                	then lab [i, j] := ''
            	else if strokes [i, j] = [_UP, _DOWN, _RIGHT]
                	then lab [i, j] := ''
            	else if strokes [i, j] = [_UP, _RIGHT, _LEFT]
                	then lab [i, j] := ''
            	else if strokes [i, j] = [_DOWN, _RIGHT, _LEFT]
                	then lab [i, j] := ''
            	else if strokes [i, j] = [_UP, _DOWN, _RIGHT, _LEFT]
                	then lab [i, j] := '';
            end;

    assign (out, 'output.txt');
    rewrite (out);
    for i := 1 to 2*m + 1 do
    	begin
        	for j := 1 to 2*n + 1 do
            	Write (out, lab [i, j]);
            Writeln (out);
        end;
    close (out);
end.
