program Arhivator;

{$A+,B-,D-,E+,F-,G+,I+,L-,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y-}
{$M 16384,0,655360}

const
{$ifdef ILIA}
  InFile='1.in';
  OutFile='con';
{$else}
  InFile='input.txt';
  OutFile='output.txt';
{$endif}

var R,N:word;
    codes: array[1..64] of char;
    strs: array[1..64] of String;
    best: Array[0..255] of record b:byte; what:word; end;
    ends: array[1..255,1..64] of boolean;

var kmp: array[1..513] of char;
    l: array[0..513] of integer;

procedure FillWithKMP(j:byte; const st:string);
  var ln,sz:word;
      i,k:integer;
  begin
  ln:=length(strs[j]);
  move(strs[j,1],kmp,ln);
  kmp[ln+1]:='#';
  move(st[1],kmp[ln+2],length(st));
  sz:=ln+1+length(st);
  l[0]:=-1;
  l[1]:=0;
  for i:=2 to sz do begin
    k:=l[i-1];
    while (k>=0) and (kmp[k+1]<>kmp[i]) do
      k:=l[k];
    if k<0 then
      l[i]:=0
    else
      l[i]:=k+1;
  end;
  for i:=1 to length(st) do
    ends[i,j]:=(l[ln+1+i]=ln);
  end;

procedure Run;
  var st,st1:string;
      i,j,k:word;
      idx:integer;
      curbest:byte;
  begin
  readln(R,N);
  for i:=1 to R do begin
    readln(strs[i]);
    readln(codes[i]);
  end;
  for k:=1 to N do begin
    readln(st);
    for j:=1 to R do
      FillWithKMP(j,st);
    curbest:=0;
    best[0].b:=0;
    best[0].what:=0;
    for i:=1 to length(st) do begin
      best[i].b:=curbest;
      best[i].what:=0;
      for j:=1 to R do
        if (length(strs[j])<=i) and (ends[i,j]) then
          if best[i-length(strs[j])].b+length(strs[j])-1>best[i].b then begin
            best[i].b:=best[i-length(strs[j])].b+length(strs[j])-1;
            best[i].what:=j;
          end;
      curbest:=best[i].b;
    end;
    idx:=length(st);
    st1:='';
    while idx>0 do begin
      if best[idx].what=0 then begin
        st1:=st[idx]+st1;
        dec(idx);
      end else begin
        st1:=codes[best[idx].what]+st1;
        dec(idx,length(strs[best[idx].what]));
      end;
    end;
    writeln(st1);
  end;
  end;

begin
  Assign(input,InFile);
  Reset(Input);
  Assign(Output,OutFile);
  Rewrite(Output);
Run;
  Close(Input);
  Close(Output);
end.