
{.$define Debug}

program Solution;
{$M 16384,65536,65536}

{$ifndef Debug}
{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'output.txt';
{$else}
{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  maxR				= 26 * 2;
  maxL				= 256;

var
  r				: integer;
  n				: integer;
  sr                            : array[1..maxR] of string;
  tg                            : array[1..maxR] of char;
  str                           : string;
  answer			: string;
  len				: array[0..maxL] of integer;
  rule				: array[0..maxL] of integer;

procedure Compress;
var
  i,j,k				: integer;

begin

  len[0] := 0;
  rule[0] := -1;

  for i := 1 to ord( str[0] ) do begin
    len[i] := len[i-1] + 1;
    rule[i] := 0;
    for j := 1 to r do begin
      k := ord( sr[j][0] );
      if i >= k then
        if len[i] > len[i-k] + 1 then
          if copy( str, i - k + 1, k ) = sr[j] then begin
            len[i] := len[i-k] + 1;
            rule[i] := j;
          end;
    end;
  end;

  answer := '';

  i := ord( str[0] );
  while rule[i] <> -1 do
    if rule[i] = 0 then begin
      answer := str[i] + answer;
      dec( i );
    end else begin
      answer := tg[rule[i]] + answer;
      dec( i, ord( sr[rule[i]][0] ) );
    end;

end;

procedure Solve;
var
  i,j,k				: integer;

begin
  for i := 1 to n do begin
    readln( str );
    Compress;
    writeln( answer );
  end;
end;

procedure ReadData;
var
  i                             : integer;

begin
  readln( r, n );
  for i := 1 to r do begin
    readln( sr[i] );
    readln( tg[i] );
  end;
end;

procedure Initialize;
var
  p,q                           : pointer;

begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

  getmem( p, 16384 );
  settextbuf( input, p^, 16384 );
  getmem( q, 16384 );
  settextbuf( output, q^, 16384 );

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  Finalize;
end.