
{.$define Debug}

program Solution;
{$M 16384,102400,102400}

{$ifndef Debug}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'output.txt';
{$else}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  maxN                          = 1000;
  maxK				= 3000;

type
  TCmd                          = record
    side			: boolean;
    sings			: boolean;
    enters			: boolean;
    id				: integer;
    ref                         : integer;
  end;

  TCmds                         = array[1..maxK*2] of TCmd;
  PCmds                         = ^TCmds;

  TArray                        = array[0..maxK*2] of integer;
var
  n				: integer;
  k				: integer;
  cmd				: PCmds;
  ansLeft,ansRight		: integer;
  answer			: array[1..maxK*2] of boolean;
  left,right                    : TArray;
  _left,_right                  : TArray;

procedure Simulate;
var
  i                             : integer;

begin
  left[0] := 0;
  right[0] := 0;
  for i := 1 to k * 2 do
    if not cmd^[i].sings then begin
      left[i] := left[i-1];
      right[i] := right[i-1];
    end else begin
      if cmd^[i].enters then begin
        if cmd^[i].side then begin
          left[i] := left[i-1];
          right[i] := right[i-1] - 1
        end else begin
          left[i] := left[i-1] - 1;
          right[i] := right[i-1];
        end;
      end else begin
        if cmd^[i].side then begin
          left[i] := left[i-1];
          right[i] := right[i-1] + 1
        end else begin
          left[i] := left[i-1] + 1;
          right[i] := right[i-1];
        end;
      end;
    end;
end;

function Eval : integer;
var
  i                             : integer;
  lmin,rmin                     : integer;

begin
  lmin := 0;
  rmin := 0;
  for i := 1 to k * 2 do begin
    if left[i] < lmin then lmin := left[i];
    if right[i] < rmin then rmin := right[i];
  end;
  Eval := - lmin - rmin;
  ansLeft := -lmin;
  ansRight := -rmin;
end;

procedure InitRefs;
var
  p                             : array[1..maxN] of integer;
  i                             : integer;

begin
  for i := k * 2 downto 1 do begin
    if cmd^[i].enters then
      cmd^[i].ref := p[cmd^[i].id]
    else
      p[cmd^[i].id] := i;
  end;
end;

procedure Apply( j : integer );
var
  i                             : integer;

begin
  for i := j to k * 2 do
    if cmd^[j].side then dec( right[i] ) else dec( left[i] );
  for i := cmd^[j].ref to k * 2 do
    if not cmd^[j].side then inc( right[i] ) else inc( left[i] );
end;

procedure Solve;
var
  i                             : integer;
  v                             : integer;
  newV                          : integer;

begin
  InitRefs;
  Simulate;
  fillchar( answer, sizeof(answer), false );
  v := Eval;
  for i := k * 2 downto 1 do
    if cmd^[i].enters and not cmd^[i].sings and
       (cmd^[i].side <> cmd^[cmd^[i].ref].side) then begin
      _left := left;
      _right := right;
      Apply( i );
      newV := Eval;
      if newV < v then begin
        newV := v;
        answer[i] := true;
      end else begin
        left := _left;
        right := _right;
      end;
    end;
  for i := 1 to k * 2 do
    if cmd^[i].enters and cmd^[i].sings then answer[i] := true;
  Eval;
end;

function strtok( var s : string ) : string;
var
  i				: integer;

begin
  while s[1] = ' ' do delete( s, 1, 1 );
  i := pos( ' ', s );
  if i = 0 then begin
    strtok := s;
    s := '';
    exit;
  end;
  strtok := copy( s, 1, i - 1 );
  delete( s, 1, i );
end;

function str2int( s : string ) : integer;
var
  x                             : integer;
  code                          : integer;

begin
  val( s, x, code );
  str2int := x;
end;


procedure ReadData;
var
  i				: integer;
  s				: string;

begin
  readln( n );
  readln( k );
  for i := 1 to k * 2 do begin
    readln( s );
    cmd^[i].enters := strtok( s ) = '+';
    cmd^[i].id := str2int( strtok( s ) );
    cmd^[i].side := strtok( s ) = '';
    cmd^[i].sings := strtok( s ) = '';
  end;
end;

procedure WriteData;
var
  i				: integer;

begin
  writeln( ansLeft, ' ', ansRight );
  for i := 1 to k * 2 do
    if cmd^[i].enters then begin
      if answer[i] then
        writeln( 1 )
      else
        writeln( 0 );
    end;
end;

procedure Initialize;
begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

  new( cmd );

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  WriteData;
  Finalize;
end.