#include <conio.h>
#include <stdio.h>
#include <math.h>
#include <mem.h>
#include <time.h>
#include <string.h>


#define MAX_K      101
#define MAX_L      101
#define DEPTH      30

typedef char material [MAX_K];

void input ();
int will_react (material param, int num);
void output ();
int get_str (FILE * file, char * str);
void do_react (material param, int num);
void undo_react (material param, int num);
void solve (material param, int depth);


int k, l, pb, gold, max = -1, q_satis = 0, end = 0;

typedef struct
         {
            material fin;
            char start;
         } react;

react reaction [MAX_L];


main ()
 {
   input ();

   material svin;

   memset (svin, 0, MAX_K);

   svin [pb] = 1;

   solve (svin, 0);
   output ();

   return (0);
 }


void input ()
 {
   FILE * file = fopen ("input.txt", "r");
   char strings [MAX_K] [11], string [11];
   int index2, fl;

   fscanf (file, "%d", & k);

   for (int index = 0; index < k; index ++)
    {
      fscanf (file, "%s", strings [index]);

      if (! (strcmp (strings [index], "ᢨ")))
       pb = index;
      if (! (strcmp (strings [index], "")))
       gold = index;
    }

   fscanf (file, "%d", & l);

   fgetc (file);

   for (index = 0; index < l; index ++)
    {
        get_str (file, string);

        for (index2 = 0; index2 < k; index2 ++)
         {
            if (! (strcmp (string, strings [index2])))
             reaction [index]. start = index2;
         }

      do
       {
        fl = get_str (file, string);

        for (index2 = 0; index2 < k; index2 ++)
         {
          if (! (strcmp (string, strings [index2])))

           reaction [index]. fin [index2] = 1;
         }
       }
      while (fl);
    }

   fclose (file);
 }


int get_str (FILE * file, char * str)
 {
   char sym;
   int len = 0;

   while (((sym = fgetc (file)) != ' ') && (sym != '\n') && (sym != -1))
      str [len ++] = sym;

   str [len] = 0;

   return ((sym == ' ') ? 1 : 0);
 }


void do_react (material param, int num)
 {
    param [reaction [num]. start] --;

   for (int index = 0; index < k; index ++)
      param [index] += reaction [num]. fin [index];
 }


void undo_react (material param, int num)
 {
    param [reaction [num]. start] ++;

   for (int index = 0; index < k; index ++)
      param [index] -= reaction [num]. fin [index];
 }



void output ()
 {
   FILE * file = fopen ("output.txt", "w");

   if (q_satis)
     {
      fputs ("QUANTUM SATIS", file);
      fclose (file);  return;
    }

   fprintf (file, "%d", max);

   fclose (file);
 }

/*
int will_react (material param, int num)
 {
   for (int index = 0; index < k; index ++)
    if (reaction [num]. start [index])
     if (! (param [index]))
      return (0);

    return (1);
 }
*/

void solve (material param, int depth)
 {
   if (q_satis) return;
   if (param [gold] > max)  max = param [gold];

   if ((param [gold]) && (param [pb]))
    {
      q_satis = 1;
      return;
    }
/*   if ((int) (clock () / CLK_TCK) > 9)
    {
      end = 1;
      return;
    }*/
   if (depth > DEPTH)  return;

   for (int index = 0; index < l; index ++)
    if (param [reaction [index]. start])
     {
       do_react (param, index);
       solve (param, depth + 1);

       if (end) return;

       undo_react (param, index);
     }
 }
