{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const
  MaxN=20;
  Eps=1E-6;
  MaxMaxGl=10;
Type
  RealType=Extended;
  TPoint=Record
    X,Y:RealType;
  End;
  TLine=Record
    A,B,C:RealType;
  End;
  TOtrezok=Record
    P1,P2:TPoint;
    L,R:Boolean;
  End;
Var
  N,X,Y:LongInt;
  Xs,Ys:Array[1..MaxN]Of LongInt;
  Timer:LongInt Absolute $0040:$006C;
  Finish:LongInt;
  ToGo:Byte;
  MaxGl:Byte;
Procedure Load;
Var
  I:Byte;
Begin
  Assign(Input,'INPUT.TXT');
  ReSet(Input);
  Read(N,X,Y);
  For I:=1 To N Do Read(Xs[I],Ys[I]);
  Close(Input);
End;
Procedure Run;
Var
  MaxPDist,MinADist,ADist,MinMin:RealType;
  I,J,MinMinI:Byte;
  SeqN:Byte;
  Seq:Array[1..MaxMaxGl]Of Byte;
Function LineByPoints(P1,P2:TPoint; Var L1:TLine):Boolean;
Begin
  L1.A:=P2.Y-P1.Y;
  L1.B:=P1.X-P2.X;
  L1.C:=-(L1.A*P1.X+L1.B*P1.Y);
  LineByPoints:=(Abs(L1.A*L1.B)>Eps);
End;
Function SideOfPoint(L1:TLine; P1:TPoint):Integer;
Var
  Z:RealType;
Begin
  Z:=L1.A*P1.X+L1.B*P1.Y+L1.C;
  If Z<-Eps Then
    SideOfPoint:=-1
  Else
    If Z>Eps Then
      SideOfPoint:=1
    Else
      SideOfPoint:=0;
End;
Function CrossLineLine(L1,L2:TLine; Var P1:TPoint):Integer;
Var
  Z:RealType;
Begin
  Z:=L1.A*L2.B-L2.A*L1.B;
  If Z=0 Then
    CrossLineLine:=0
  Else Begin
    P1.X:=(L1.B*L2.C-L2.B*L1.C)/Z;
    P1.Y:=(L1.C*L2.A-L2.C*L1.A)/Z;
    CrossLineLine:=1;
  End;
End;
Function CrossLineOtr(L1:TLine; O1:TOtrezok; Var P1:TPoint):Integer;
Var
  L2:TLine;
  C,S1,S2:Integer;
Begin
  LineByPoints(O1.P1,O1.P2,L2);
  C:=CrossLineLine(L1,L2,P1);
  If C=0 Then Begin
    CrossLineOtr:=0;
    Exit;
  End;
  S1:=SideOfPoint(L1,O1.P1);
  S2:=SideOfPoint(L1,O1.P2);
  If (S1=0) And (O1.L) Then
    If (S2=0) And (O1.R) Then Begin
      S1:=-1;
      S2:=1;
    End Else Begin
      S1:=-S2;
    End
  Else
    If (S2=0) And (O1.R) Then Begin
      S2:=-S1;
    End;
  If S1*S2<=-1 Then C:=1 Else C:=0;
  CrossLineOtr:=C;
End;
Procedure CountADist;
Var
  I:Byte;
  P1,P2:TPoint;
  L1,L2:TLine;
  O:TOtrezok;
Begin
  MinADist:=1E+18;
  For I:=1 To N Do Begin
    ADist:=Sqr(1.0*Xs[I]-X)+Sqr(Ys[I]-Y);
    If ADist<MinADist Then MinADist:=ADist;
    P1.X:=Xs[I];
    P1.Y:=Ys[I];
    P2.X:=Xs[I Mod N+1];
    P2.Y:=Ys[I Mod N+1];
    LineByPoints(P1,P2,L1);
    L2.A:=-L1.B;
    L2.B:=L1.A;
    L2.C:=-(L2.A*X+L2.B*Y);
    O.P1:=P1;
    O.P2:=P2;
    O.L:=False;
    O.R:=False;
    If CrossLineOtr(L2,O,P1)>0 Then Begin
      ADist:=Sqr(1.0*P1.X-X)+Sqr(P1.Y-Y);
      If ADist<MinADist Then MinADist:=ADist;
    End;
  End;
End;
Procedure Mirror(A,B:Byte);
Var
  PX2,PY2:LongInt;
  I:Byte;
Begin
  PX2:=Xs[A]+Xs[B];
  PY2:=Ys[A]+Ys[B];
  For I:=1 To N Do Begin
    Xs[I]:=PX2-Xs[I];
    Ys[I]:=PY2-Ys[I];
  End;
End;
Procedure Impossible;
Begin
  ReWrite(Output);
  WriteLn('IMPOSSIBLE');
  Close(Output);
  Halt(0);
End;
Function Check:Boolean;
Var
  Res:Boolean;
  I,J:Byte;
  AX:RealType;
Function Sign(A:LongInt):ShortInt;
Begin
  If A=0 Then Sign:=0 Else If A<0 Then Sign:=-1 Else Sign:=1;
End;
Function SignR(A:RealType):ShortInt;
Begin
  If Abs(A)<Eps Then SignR:=0 Else If A<0 Then SignR:=-1 Else SignR:=1;
End;
Begin
  Res:=False;
  For I:=1 To N Do Begin
    J:=I Mod N+1;
    Case Sign(Ys[I]-Y) Of
      -1:Case Sign(Ys[J]-Y) Of
        0:Case Sign(Xs[J]-X) Of
          0:Begin Check:=True; Exit; End;
          1:Res:=Not Res;
        End;
        1:Begin
          AX:=Xs[I]+(Xs[J]-Xs[I])*(Y-Ys[I])/(Ys[J]-Ys[I]);
          Case SignR(AX-X) Of
            0:Begin Check:=True; Exit; End;
            1:Res:=Not Res;
          End;
        End;
      End;
      0:Case Sign(Ys[J]-Y) Of
        -1:Case Sign(Xs[I]-X) Of
          0:Begin Check:=True; Exit; End;
          1:Res:=Not Res;
        End;
      End;
      1:Case Sign(Ys[J]-Y) Of
        -1:Begin
          AX:=Xs[I]+(Xs[J]-Xs[I])*(Y-Ys[I])/(Ys[J]-Ys[I]);
          Case SignR(AX-X) Of
            0:Begin Check:=True; Exit; End;
            1:Res:=Not Res;
          End;
        End;
      End;
    End;
  End;
  Check:=Res;
End;
Function FullSearch(Gl:Byte):Boolean;
Var
  I:Byte;
Begin
  If Check Then Begin FullSearch:=True; SeqN:=Gl; Exit; End;
  If Timer>=Finish Then Impossible;
  If Gl>=MaxGl Then Begin FullSearch:=False; Exit; End;
  Inc(Gl);
  For I:=1 To N Do Begin
    Mirror(I,I Mod N+1);
    Seq[Gl]:=I;
    If FullSearch(Gl) Then Begin FullSearch:=True; Exit; End;
    Mirror(I,I Mod N+1);
  End;
  FullSearch:=False;
End;
Begin
  Assign(Output,'OUTPUT.TXT');
  ReWrite(Output);
  MaxPDist:=0;
  For I:=1 To N Do
    For J:=1 To N Do Begin
      ADist:=Sqr(1.0*Xs[I]-Xs[J])+Sqr(Ys[I]-Ys[J]);
      If ADist>MaxPDist Then MaxPDist:=ADist;
    End;
  Repeat
    CountADist;
    If MinADist<MaxPDist+1E-2 Then Break;
    MinMin:=1E+18;
    For I:=1 To N Do Begin
      Mirror(I,I Mod N+1);
      CountADist;
      If MinADist<MinMin Then Begin
        MinMin:=MinADist;
        MinMinI:=I;
      End;
      Mirror(I,I Mod N+1);
    End;
    WriteLn(MinMinI,' ',MinMinI Mod N+1);
    Mirror(MinMinI,MinMinI Mod N+1);
    If Timer>=Finish Then Impossible;
  Until False;
  MaxGl:=0;
  ToGo:=N;
  Repeat
    If FullSearch(0) Then Begin
      For I:=1 To SeqN Do WriteLn(Seq[I],' ',Seq[I] Mod N+1);
      Break;
    End;
    MinMin:=1E+18;
    For I:=1 To N Do Begin
      Mirror(I,I Mod N+1);
      CountADist;
      If MinADist<MinMin Then Begin
        MinMin:=MinADist;
        MinMinI:=I;
      End;
      Mirror(I,I Mod N+1);
    End;
    WriteLn(MinMinI,' ',MinMinI Mod N+1);
    Mirror(MinMinI,MinMinI Mod N+1);
    If Timer>=Finish Then Impossible;
    If ToGo>0 Then Dec(ToGo) Else Begin
      Inc(MaxGl);
      ToGo:=N;
      If MaxGl>MaxMaxGl Then Impossible;
    End;
  Until False;
  Close(Output);
End;
Begin
  Finish:=Timer+Trunc(18.2*90000);
  Load;
  Run;
End.