
{.$define Debug}

program Solution;
{$M 16384,0,655360}

{$ifndef Debug}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'output.txt';
{$else}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  maxN                          = 16000;

type
  int                           = longint;

var
  n                             : int;
  taskA                         : boolean;
  a                             : array[1..maxN] of int;
  l                             : integer;

procedure ReadA( k : integer );
var
  s                             : string[10];
  x                             : int;
  i                             : int;
  code                          : integer;

begin
  close( input );
  reset( input );
  read( n );
  for i := 1 to n do begin
    read( x );
    str( x, s );
    while s[0] <> chr( l ) do s := '0' + s;
    delete( s, l - k + 1, 1 );
    val( s, a[i], code );
  end;
end;

procedure Sort;
var
  i,j,l,r                       : integer;
  aa                            : int;

  procedure Sift;
  begin
    i := l;
    j := l * 2;
    aa := a[i];
    if (j < r) and (a[j+1] > a[j]) then inc( j );
    while (j <= r) and (aa < a[j]) do begin
      a[i] := a[j];
      i := j;
      j := j * 2;
      if (j < r) and (a[j+1] > a[j]) then inc( j );
    end;
    a[i] := aa;
  end;

begin
  r := n;
  for l := n div 2 downto 1 do Sift;
  while r > 1 do begin
    aa := a[1];
    a[1] := a[r];
    a[r] := aa;
    dec( r );
    Sift;
  end;
end;

procedure SolveA;
var
  answer                        : comp;
  i                             : integer;
  j                             : int;
  x                             : int;

begin
  if n > maxN then begin
    writeln( 0 );
    exit;
  end;
  answer := 0;
  for i := 1 to l do begin
    ReadA( i );
    Sort;
    x := 1;
    for j := 2 to n do
      if a[j] = a[j-1] then
        inc( x )
      else begin
        answer := answer + x * (x - 1) div 2;
        x := 1;
      end;
   answer := answer + x * (x - 1) div 2;
  end;
  writeln( answer:0:0 );
end;

procedure SolveB;
var
  i                             : int;
  j                             : integer;
  a : int;
  b : integer;

begin
  i := 0;
  repeat
    a := i;
    b := 0;
    while a <> 0 do begin
      inc( b, a mod 10 );
      a := a div 10;
    end;
    b := b mod 10;
    for j := 0 to 9 do begin
      writeln( i, j, (j + b) mod 10 );
      dec( n );
      if n = 0 then exit;
    end;
    inc( i );
  until false;
end;

procedure Solve;
begin
  if taskA then SolveA else SolveB;
end;

procedure ReadData;
var
  i				: int;
  x                             : int;
  s                             : string[10];

begin
  read( n );
  if SeekEOF( input ) then begin
    taskA := false;
    exit;
  end;
  taskA := true;
  l := 0;
  for i := 1 to n do begin
    read( x );
    str( x, s );
    if length( s ) > l then l := length( s );
  end;
end;

procedure Initialize;
begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  Finalize;
end.