
{.$define Debug}

program Solution;
{$M 16384,0,655360}

{$ifndef Debug}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'output.txt';
{$else}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'con';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

type
  int				= longint;

var
  n				: int;
  answer			: integer;
  z				: int;

function Pow( a : integer; b : longint ) : integer;
var
  v                             : array[0..10] of integer;
  i,j,k                         : integer;

begin
  j := 1;
  for i := 0 to 10 do begin
    v[i] := j;
    if i = b then begin
      Pow := v[i];
      exit;
    end;
    j := (j * a) mod 10;
    for k := 0 to i - 1 do
      if v[k] = v[i] then begin
        Pow := v[(b - k) mod (i - k) + k];
        exit;
      end;
  end;
  halt;
end;

function Eval( lo, hi : int ) : integer;
var
  i,j                           : integer;
  k                             : int;
  _lo,_hi                       : int;

begin
  i := 1;
  for j := 1 to 9 do
    if j <> 5 then begin
      k := 0;
      if lo mod 10 <> 0 then begin
        if lo mod 10 <= j then inc( k );
        _lo := lo + 10 - lo mod 10;
      end else
        _lo := lo;
      if hi mod 10 <> 0 then begin
        if hi mod 10 >= j then inc( k );
        _hi := hi - hi mod 10;
      end else
        _hi := hi;
      inc( k, (_hi - _lo) div 10 );
      i := (i * Pow( j, k )) mod 10;
    end;
  Eval := i;
end;

procedure Solve;
const
  q                             : array[0..3] of integer = ( 2, 6, 8, 4 );

var
  a				: int;
  i				: int;
  j,k                           : integer;

begin

  if n <= 1 then begin
    answer := 1;
    exit;
  end;

  z := 0;
  a := 5;
  while a <= n do begin
    inc( z, n div a );
    if a > maxlongint div 5 then break;
    a := a * 5;
  end;

  i := 1;
  j := 1;
  answer := 1;

  while i <= n do begin
    a := Eval( (n div (i * 5)) + 1, n div i );
    for k := 1 to j do answer := (answer * a) mod 10;
    if i > maxlongint div 25 then break;
    i := i * 5;
    inc( j );
  end;

  for i := 0 to 3 do
    if q[i] = answer then break;

  inc( i, z mod 4 );
  answer := q[i mod 4];

end;

procedure ReadData;
begin
  read( n );
end;

procedure WriteData;
begin
  writeln( answer );
end;

procedure Initialize;
begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  WriteData;
  Finalize;
end.