{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}

program Walking_Polygon;

type
	Polygon = array [1..21] of
				record
                	x, y : longint;
                end;


var
	poly : polygon;
    n : integer;

    x0, y0 : integer;

	i, j : integer;

procedure Reflect (var p : polygon; n : integer; v1, v2 : integer);
	var
    	j : integer;
        _2xc, _2yc : longint;

    begin
    	_2xc := p [v1].x + p [v2].x;
        _2yc := p [v1].y + p [v2].y;
    	for j := 1 to n + 1 do
        	begin
                p [j].x := _2xc - p [j].x;
                p [j].y := _2yc - p [j].y;
            end;
    end;

type
	TLine =
			record
    			vert : boolean;
                k, b : real;
                xpos : real;
    		end;

    TSegment =
				record
    				x1, y1, x2, y2 : real;
    			end;

procedure MakeSegment (x1, y1, x2, y2 : real; var s : TSegment);
	begin
    	s.x1 := x1;
        s.y1 := y1;
        s.x2 := x2;
        s.y2 := y2;
    end;

procedure MakeLine (Segm : TSegment; var l : TLine);
	begin
    	if Segm.x1 = Segm.x2
        	then
				begin
                	l.vert := true;
                    l.xpos := Segm.x1;
                end
            else
            	begin
                	l.vert := false;
                    l.k := (Segm.y2 - Segm.y1) / (Segm.x2 - Segm.x1);
                    l.b := (Segm.y1*Segm.x2 - Segm.y2*Segm.x1) / (Segm.x2 - Segm.x1);
                end;
    end;

function IsIn (Segm : TSegment; x1, y1 : real) : boolean;
	begin
    	if (Segm.x1 = Segm.x2)
        	then if (y1 - Segm.y1)*(y1 - Segm.y2) > 0
            		then IsIn := false
                    else IsIn := true
            else if (x1 - Segm.x1)*(x1 - Segm.x2) > 0
            		then IsIn := false
                    else IsIn := true
    end;

function InterPoint (l1, l2 : TLine; var x1, y1 : real; var eq : boolean) : boolean;
	begin
    	if (l1.vert)
        	then if (l2.vert)
            	then
					if l1.xpos <> l2.xpos
						then InterPoint := false
                        else
							begin
								InterPoint := true;
                                eq := true;
                            end
                else
                	begin
                    	InterPoint := true;
                        x1 := l1.xpos;
                        y1 := x1*l2.k + l2.b;
                        eq := false;
                    end
            else if (l2.vert)
            	then
                	begin
                    	InterPoint := true;
                        x1 := l2.xpos;
                        y1 := x1*l1.k + l1.b;
                        eq := false;
                    end
                else if (l1.k = l2.k)
                	then if (l1.b = l2.b)
						then
							begin
								InterPoint := true;
                                eq := true;
                            end
                        else InterPoint := false
                	else
                    	begin
                        	x1 := (l2.b - l1.b) / (l1.k - l2.k);
                            y1 := (l1.k*l2.b - l2.k*l1.b) / (l1.k - l2.k);
                            InterPoint := true;
                        end;
    end;

procedure Perp (s : TSegment; x1, y1 : integer; var l : TLine);
	var
    	s1 : TSegment;

	begin
    	if s.y1 = s.y2
        	then
            	begin
                	MakeSegment (x1, s.y1, x1, y1, s1);
                    MakeLine (s1, l);
                end
            else
            	begin
			    	MakeSegment (0, x1*(s.x2 - s.x1) / (s.y2 - s.y1) + y1, x1, y1, s1);
                    MakeLine (s1, l);
                end;
    end;

function Distance (x1, y1, x2, y2 : real) : real;
	begin
    	Distance := sqrt (sqr (x1 - x2) + sqr (y1 - y2));
    end;

function Intercepts (Line : TLine; Segm : TSegment; var eq : boolean) : boolean;
	var
    	l2 : TLine;
        x1, y1 : real;
        eq1 : boolean;

	begin
    	eq := false;
    	MakeLine (Segm, l2);
    	if not InterPoint (Line, l2, x1, y1, eq1)
        	then Intercepts := false
            else if eq1
				then
					begin
						Intercepts := true;
                        eq := true;
                    end
				else Intercepts := IsIn (Segm, x1, y1);
    end;

function InPolygon (p : polygon; n : integer; x1, y1 : integer) : boolean;
	var
    	i : integer;

        xin, yin : real;

        inter : boolean;

        Segm, s2 : TSegment;
        l, l2 : TLine;
        eq : boolean;

    begin
    	for i := 1 to n do
        	if (x1 = p [i].x) and (y1 = p [i].y)
            	then
                	begin
                    	InPolygon := true;
                        Exit;
                    end;
    	MakeSegment (p [1].x, p [1].y, x1, y1, Segm);
        MakeLine (Segm, l);

        inter := false;
        i := 0;
        while (i < n) and (not inter) do
	       	begin
            	inc (i);
            	MakeSegment (p [i].x, p [i].y, p [i + 1].x, p [i + 1].y, Segm);
                if Intercepts (l, Segm, eq)
					then
                    	if not eq
                        	then begin
	                            MakeLine (Segm, l2);
	                            InterPoint (l, l2, xin, yin, eq);
                                if ((xin <> p [1].x) or (yin <> p [1].y))
                                    then
		                    			inter := true;
	                        end
                    	else if IsIn (Segm, x1, y1)
                        	then
                            	begin
                                	inter := true;
                                    xin := x1;
                                    yin := y1;
                                end;
           	end;
        if (not inter)
        	then InPolygon := false
            else if IsIn (Segm, xin, yin)
            	then
					begin
                    	MakeSegment (p [1].x, p [1].y, xin, yin, s2);
                        if (IsIn (s2, x1, y1))
                        	then InPolygon := true
			                else InPolygon := false;
                    end;
    end;

function MinDist (p : Polygon; n : integer; x1, y1 : longint) : real;
	var
    	min : real;
        dist : real;
        i : integer;

        x2, y2 : real;

        s, s1 : TSegment;
        l, l2 : TLine;

        eq : boolean;

    begin
    	if InPolygon (p, n, x1, y1)
        	then
            	begin
                	MinDist := 0;
                	Exit;
                end;
    	min := Distance (x1, y1, p [1].x, p [1].y);
        for i := 1 to n do
        	begin
            	dist := Distance (x1, y1, p [i + 1].x, p [i + 1].y);
                if dist < min
                	then min := dist;
                MakeSegment (p [i].x, p [i].y, p [i + 1].x, p [i + 1].y, s);
                Perp (s, x1, y1, l);
                if Intercepts (l, s, eq)
                	then
                    	if not eq
	                    	then begin
                        	MakeLine (s, l2);
                        	InterPoint (l, l2, x2, y2, eq);
                            dist := Distance (x1, y1, x2, y2);
                            if (dist < min)
                            	then min := dist;
                        end;
            end;
        MinDist := min;
    end;

procedure MakePath;
	const
    	MAX_BAD = 21;

	var
    	p2 : Polygon;
        min_dist, dist : real;
        i : integer;
        ibest : integer;
        iprev : integer;
        bad_level : integer;
	    cur_dist : real;

	begin
    	assign (output, 'output.txt');
        rewrite (output);

		cur_dist := MinDist (poly, n, x0, y0);

    	bad_level := 0;
        iprev := 0;

    	while (cur_dist > 0.0) do
        begin
	    	min_dist := cur_dist;
            ibest := 1;
	        for i := 1 to n do
            	if (i <> iprev) then
	        	begin
	            	p2 := poly;
	            	Reflect (p2, n, i, i + 1);
                    dist := MinDist (p2, n, x0, y0);
                    if (dist < min_dist)
                    	then
                        	begin
                            	ibest := i;
                                min_dist := dist;
                            end;
                end;

            if (min_dist >= cur_dist)
            	then
                	begin
                    	inc (bad_level);
                        if (bad_level > MAX_BAD)
                        	then
                            	begin
                                	close (output);
                                	assign (output, 'output.txt');
                                    rewrite (output);
                                    Writeln ('IMPOSSIBLE');
                                    Close (output);
                                    Halt (0);
                                end;
                    end
                else bad_level := 0;

            iprev := ibest;
            Reflect (poly, n, ibest, ibest + 1);
            Writeln (ibest, ' ', ibest mod n + 1);

            cur_dist := min_dist;

        end;

        close (output);
    end;


begin
	assign (input, 'input.txt');
	reset (input);
    read (n, x0, y0);
    for i := 1 to n do
    	read (poly [i].x, poly [i].y);
    close (input);

    poly [n + 1].x := poly [1].x;
    poly [n + 1].y := poly [1].y;

	MakePath;
end.
