#define MAX_N  22

#include <conio.h>
#include <stdio.h>
#include <mem.h>
#include <time.h>


void input ();
void output ();
void convert (int & a, int & b);
long dist (int ver);
int inside ();


struct point
			 {
				long x, y;
			 } polygon [MAX_N];

long x, y;
int n;


main ()
 {
	input ();
	output ();

	return (0);
 }



void input ()
 {
	FILE * file = fopen ("input.txt", "r");
	fscanf (file, "%d %ld %d\n", & n, & x, & y);

	for (int index = 0; index < n; index ++)
	 fscanf (file, "%ld %ld", & polygon [index]. x, & polygon [index]. y);

	fclose (file);
 }


void output ()
 {
	int a, b;

	FILE * file = fopen ("output.txt", "w");

	while (! inside ())
	 {
		if ((int) (clock () / CLK_TCK) > 9)
		 {
			fclose (file);
			file = fopen ("output.txt", "w");

			fprintf (file, "IMPOSSIBLE");
			fclose (file);

			return;
		 }

		convert (a, b);
		fprintf (file, "%d %d\n", a + 1, b + 1);
	 }

	fclose (file);
 }



void convert (int & a, int & b)
 {
	long min = 1000000, xx, yy, temp;

	for (int index = 0; index < n; index ++)
	  if ((temp = (dist (index) + dist ((index + 1) % n))) < min)
		{
			a = index;
			b = (a + 1) % n;

			min = temp;
		}

	xx = polygon [a]. x + polygon [b]. x;
	yy = polygon [a]. y + polygon [b]. y;

	for (index = 0; index < n; index ++)
	 {
		polygon [index]. x = xx - polygon [index]. x;
		polygon [index]. y = yy - polygon [index]. y;
	 }
 }



long dist (int ver)
 {
	long temp = ((polygon [ver]. x - x) * (polygon [ver]. x - x) +
			  (polygon [ver]. y - y) * (polygon [ver]. y - y));

	return (temp);
 }


int inside ()
 {
	char verx [MAX_N], flag = 0;
	memset (verx, 1, n);

	long x1, y1, x2, y2;

	for (int index = 0; index < n; index ++)
	 if ((polygon [index]. y == y) && (polygon [index]. x >= x))
	  {
		 flag ++;
		 verx [((index << 1) - 1) % n] = verx [index] = 0;
	  }

	for (index = 0; index < n; index ++)
	 {
		if (! verx [index]) continue;

		x1 = polygon [index]. x;
		y1 = polygon [index]. y;
		x2 = polygon [(index + 1) % n]. x;
		y2 = polygon [(index + 1) % n]. y;

		flag += (((y > y1) ^ (y > y2)) &&
				(x1 + (((float) (x2 - x1) * (float) (y - y1)) / (float) (y2 - y1))) > x);
	 }

	return (flag % 2);
 }