program WalkingPolygon;
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}

const
{$ifdef ILIA}
  InFile='c.in';
  OutFile='c.out';
{$else}
  InFile='input.txt';
  OutFile='output.txt';
{$endif}

type real=extended;
type TPoint = record x,y:longint end;
type TPolygon = array[-1..2] of TPoint;

var pl:TPolygon;
    N:byte;
    pt:TPoint;

procedure PAdd(const a,b:TPoint; var c:TPoint);
  begin
  c.x:=a.x+b.x;
  c.y:=a.y+b.y;
  end;

procedure PSub(const a,b:TPoint; var c:TPoint);
  begin
  c.x:=a.x-b.x;
  c.y:=a.y-b.y;
  end;

{function gdiv(x,y:longint):longint;
  begin
  if (x>=0) then
    if (y>0) then
      gdiv:= x div y
    else
  end;}

procedure PBasis(const a,b,p:TPoint; var xc,yc:real);
  begin
  xc:=((p.x*b.y-p.y*b.x)/(b.y*a.x-a.y*b.x));
  yc:=((p.x*a.y-p.y*a.x)/(a.y*b.x-a.x*b.y));
  end;

procedure ReadData;
  var i:shortint;
  begin
  Assign(input,InFile);
  Reset(Input);
  readln(N,pt.x,pt.y);
  for i:=-1 to 1 do
    read(pl[i].x,pl[i].y);
  if N=3 then
    pl[2]:=pl[-1]
  else
    read(pl[2].x,pl[2].y);
  Close(Input);
  end;

const eps=1e-10;
function floor(x:real):longint;
  begin
  if x>0 then
    floor:=trunc(x)
  else if abs(int(x)-x)<eps then
    floor:=trunc(x)
  else
    floor:=trunc(x)-1;
  end;

function int2str(x:longint):string;
  var s:string;
  begin
  str(x,s);
  int2str:=s;
  end;

function PEqual(const a,b:TPoint):boolean;
  begin
  PEqual:=(a.x=b.x) and (a.y=b.y);
  end;

function ptinpl(const pl:TPolygon):boolean;
  var i,j:longint;
      count:longint;
      ry:real;
  begin
  for i:=-1 to 2 do
    if PEqual(pl[i],pt) then begin
      ptinpl:=true;
      exit;
      end;
  count:=0;
  for i:=-1 to 2 do begin
    if i<>2 then j:=i+1 else j:=-1;
    if ((pl[i].x<pt.x) and (pl[j].x<pt.x)) or
       ((pl[i].x>pt.x) and (pl[j].x>pt.x)) then
      continue;
    if pl[i].x=pl[j].x then begin
      if ((pl[i].y>pt.y) and (pt.y>pl[j].y)) or
         ((pl[i].y<pt.y) and (pt.y<pl[j].y)) then begin
         ptinpl:=true;
         exit;
      end;
    end else begin
      ry:=(pl[j].y-pl[i].y)/(pl[j].x-pl[i].x)*(pt.x-pl[i].x)+pl[i].y;
      count:=count+ord((ry>=pt.y-eps));
    end;
  end;
  ptinpl:=(count mod 2)=1;
  end;

procedure Run;
  var va,vb,pt_0:TPoint;
      xc,yc:real;
      xcf,ycf:longint;
      s01,s12,s_10:string;
      i:longint;
      pl1:TPolygon;
      tmp:TPoint;
  begin
  PSub(pl[2],pl[0],va);
  PSub(pl[-1],pl[1],vb);
  PSub(pt,pl[0],pt_0);
  PBasis(va,vb,pt_0,xc,yc);
  s01:='2 3'#13#10;
  s12:='3 '+int2str((3 mod N+1))+#13#10;
  s_10:='1 2'+#13#10;
  xcf:=floor(xc);
  ycf:=floor(yc);
  if xcf>0 then
    for i:=1 to xcf do
      write(s12,s01);
  if xcf<0 then
    for i:=1 to -xcf do
      write(s01,s12);
  if ycf>0 then
    for i:=1 to ycf do
      write(s_10,s01);
  if ycf<0 then
    for i:=1 to -ycf do
      write(s01,s_10);
  pt.x:=pt.x-xcf*va.x-ycf*vb.x;
  pt.y:=pt.y-xcf*va.y-ycf*vb.y;

  if ptinpl(pl) then begin
    if (xcf=0) and (ycf=0) then
      write(s01,s01);
    exit;
  end;

  for i:=-1 to 2 do
    PAdd(pl[i],vb,pl1[i]);
  if ptinpl(pl1) then begin
    write(s_10,s01);
    exit;
  end;

  PAdd(pl[-1],pl[0],tmp);
  for i:=-1 to 2 do
    PSub(tmp,pl[i],pl1[i]);
  if ptinpl(pl1) then begin
    write(s_10);
    exit;
  end;

  {if N>3 then -- ࠧ㬥}
(*  PCenter(pl[-1],pl[0],tmp);
  PLSymmetry(pl,tmp,pl1);
  if ptinpl(pl1) then begin
    write(s_10);
    exit;
  end;*)
  write(s_10,s01,s12);
  end;

begin
ReadData;
  Assign(Output,OutFile);
  Rewrite(Output);
Run;
  Close(Output);
end.