
{.$define Debug}

program Solution;
{$M 16384,0,655360}

{$ifndef Debug}
{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'output.txt';
{$else}
{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  digits			= ['0'..'9'];
  size                          = 16384;


var
  inp				: File;
  buf                           : array[1..size] of char;
  p                             : integer;
  eof                           : boolean;
  gp                            : longint;
  len                           : longint;

procedure ReadBuf;
var
  tmp                           : word;

begin
  blockread( inp, buf, size, tmp );
end;

function getch : char;
begin
  getch := buf[p];
  inc( p );
  inc( gp );
  if gp > len then
    eof := true
  else begin
    if p > size then begin
      p := 1;
      ReadBuf;
    end;
  end;
end;

procedure Solve;
label again;
var
  markup			: boolean;
  ch				: char;
  i,j				: integer;

begin
  p := 1;
  gp := 1;
  ReadBuf;
  markup := true;
  while not EOF do begin
    ch := getch;
    again :
    if ch = '\' then begin
      if EOF then begin
        write( '\' );
        exit;
      end;
      ch := getch;
      if not markup then begin
        if ch <> '*' then
          write( '\', ch )
        else
          markup := true
      end else begin
        case ch of
          'b' : ;
          'i' : ;
          's' : begin
            i := 0;
            repeat
              if EOF then exit;
              ch := getch;
              inc( i );
            until not (ch in digits);
            if ch = '.' then begin
              if EOF then begin
                if i = 1 then write( '.' );
	        exit;
              end;
              j := 0;
              repeat
                if EOF then exit;
                ch := getch;
                inc( j );
              until not (ch in digits);
              if (i = 1) and (j = 1) then write( '.' );
              goto again;
            end else
              goto again;
          end;
          '*' : markup := false;
          else write( ch );
        end;
      end;
    end else
      write( ch );
  end;
end;

procedure Initialize;
begin

  assign( inp, inFile );
  reset( inp, 1 );
  len := FileSize( inp );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  Solve;
  Finalize;
end.