{ ----------------- Compiler directives ------------------- }
{$A+,B-,E-,F-,G-,N+,O-,P-,Q-,T-,V+,X+}
{$M 65520,0,655360}

{ ------------------ Debug mode on/off -------------------- }


{$DEFINE __DEBUG__}

{$IFDEF __DEBUG__}
{$D+,I+,L+,R+,S+,Y+}
{$ELSE}
{$D-,I-,L-,R-,S-,Y-}
{$ENDIF}
{ --------------- End Compiler directives ----------------- }

program RemoveMarkup;

const
	Usual = 1;
    Slash = 2;
    Skip = 3;
	SlashSkip = 4;

    Digits : set of byte = [ord ('0'), ord ('1'), ord ('2'),
							ord ('3'), ord ('4'), ord ('5'),
							ord ('6'), ord ('7'), ord ('8'),
							ord ('9'), ord ('.')];

type
	TBlock = array [1..64000] of byte;

var
	f, out : file;
    next, b : byte;
    state : integer;

    cur_pos : longint;
    cur_block_read, cur_block_write : ^TBlock;
    cur_limit : longint;
    left_size : longint;

    cur_wrote : longint;

function min (a, b : longint) : longint;
	begin
    	if (a < b)
        	then min := a
            else min := b;
    end;

procedure NextByte;
	var
        left : integer;

	begin
		inc (cur_pos);
        if (cur_pos > cur_limit)
        	then
                begin
                	cur_limit := min (left_size, 64000);
                    left_size := left_size - cur_limit;
                    BlockRead (f, cur_block_read^, 64000, left);
                    cur_pos := 1;
                end;
        next := cur_block_read^[cur_pos];
    end;

procedure WriteByte;
	var
    	left : integer;

	begin
    	inc (cur_wrote);
        if (cur_wrote > 64000)
        	then
            	begin
                	BlockWrite (out, cur_block_write^, 64000, left);
                    cur_wrote := 1;
                end;
        cur_block_write^[cur_wrote] := next;
    end;

procedure FlushOutput;
	var
    	left : integer;

    begin
    	if (cur_wrote > 0)
        	then
            	begin
                	BlockWrite (out, cur_block_write^, cur_wrote, left);
                end;
    end;

function EndOfFile : boolean;
	begin
    	EndOfFile := (cur_pos = cur_limit) and (left_size = 0);
    end;

begin
	assign (f, 'input.txt');
    reset (f, 1);
    if eof (f)
    	then
        	begin
            	assign (out, 'output.txt');
                rewrite (out);
                close (out);
                Halt (0);
            end;
    assign (out, 'output.txt');
    rewrite (out, 1);
    state := Usual;

    new (cur_block_read);
    new (cur_block_write);

    cur_wrote := 0;
    cur_limit := 0;
    left_size := FileSize (f);
    NextByte;

	repeat
        case state of
            Usual : begin
					    while (not EndOfFile) and (next <> ord ('\')) do
						    begin
                            	WriteByte;
							    NextByte;
						    end;
                        if next <> ord ('\')
							then WriteByte
                            else
								begin
									State := Slash;
                                    if (not EndOfFile)
                                    	then NextByte;
                                end;
                    end;
            Slash : case next of
                	    ord ('b'), ord ('i') :
						    begin
							    state := Usual;
                                if (not EndOfFile)
									then NextByte;
           				    end;
                        ord ('s') :
						    begin
                                if (not EndOfFile)
									then NextByte;
							    while (not EndOfFile) and (next in Digits) do
								    NextByte;
                                if (next <> ord ('\'))
                                    then state := Usual
                                    else
										begin
											state := Slash;
                                            if (not EndOfFile)
                                            	then NextByte;
                                        end;
                            end;
                        ord ('*') :
						    begin
							    state := Skip;
                                if (not EndOfFile) then
	                                NextByte;
                            end
                        else begin
                            state := Usual;
						    WriteByte;
                            if (not EndOfFile)
                            	then NextByte;
                            end;
                    end;
            Skip :
				begin
					while (not EndOfFile) and (next <> ord ('\')) do
						begin
							WriteByte;
							NextByte;
						end;
                	if (next <> ord ('\'))
						then
							WriteByte
                        else
                        	begin
								state := SlashSkip;
                                if (not EndOfFile)
                                	then NextByte;
                            end;
                    end;
            SlashSkip : case next of
                	    ord ('*') :
							begin
								state := Usual;
                                if (not EndOfFile)
                                	then NextByte;
                            end
                        else
							begin
                                state := Skip;
                                b := next;
                                next := ord ('\');
                                WriteByte;
                                next := b;
                                WriteByte;
                                if (not EndOfFile)
                                	then NextByte;
                            end;
                    end;
        end;
    until EndOfFile;

    if ((state = Slash) and (not (next in [ord ('b'), ord ('i'), ord ('*'), ord ('s')])))
					or ((state = SlashSkip) and (next <> ord ('*')))
		then WriteByte;

    FlushOutput;

    close (f);
    close (out);

    dispose (cur_block_read);
    dispose (cur_block_write);
end.