{ ----------------- Compiler directives ------------------- }
{$A+,B-,E-,F-,G-,N+,O-,P-,Q-,T-,V+,X+}
{$M 65520,0,655360}

{ ------------------ Debug mode on/off -------------------- }


{$DEFINE __DEBUG__}

{$IFDEF __DEBUG__}
{$D+,I+,L+,R+,S+,Y+}
{$ELSE}
{$D-,I-,L-,R-,S-,Y-}
{$ENDIF}
{ --------------- End Compiler directives ----------------- }

program Scanner;

type
    ScannedCode = array [1..3, 1..27] of char;
    ScannedInt = array [1..3, 1..3] of char;

    num_set = set of 1..9;

const
    Predefined : array [0..9] of ScannedInt =
	   (((' ','_',' '),     { 0 }
         ('|',' ','|'),
         ('|','_','|')),

		((' ',' ',' '),     { 1 }
         (' ',' ','|'),
         (' ',' ','|')),

		((' ','_',' '),     { 2 }
         (' ','_','|'),
         ('|','_',' ')),

		((' ','_',' '),     { 3 }
         (' ','_','|'),
         (' ','_','|')),

		((' ',' ',' '),     { 4 }
         ('|','_','|'),
         (' ',' ','|')),

		((' ','_',' '),     { 5 }
         ('|','_',' '),
         (' ','_','|')),

		((' ','_',' '),     { 6 }
         ('|','_',' '),
         ('|','_','|')),

		((' ','_',' '),     { 7 }
         (' ',' ','|'),
         (' ',' ','|')),

		((' ','_',' '),     { 8 }
         ('|','_','|'),
         ('|','_','|')),

		((' ','_',' '),     { 9 }
         ('|','_','|'),
         (' ','_','|')));

	toWhich : array [0..9] of set of 0..9 =
		([8],					{ 0 }
		 [0, 3, 4, 7, 8, 9],	{ 1 }
		 [8],					{ 2 }
		 [8, 9],				{ 3 }
		 [8, 9],				{ 4 }
		 [6, 8, 9],				{ 5 }
		 [8],					{ 6 }
		 [0, 3, 8, 9],			{ 7 }
		 [],					{ 8 }
		 [8]);					{ 9 }
var
code:ScannedCode;
numbers:array [1..9] of ScannedInt;
can_recognize:array [1..9] of boolean;
i,j,k:integer;
s:string;
scanned, new_scanned, code_found : array [1..9] of integer;
num,bad:integer;
found:boolean;
all_recognized:boolean;
function Recognize (i : integer; var num : integer) : boolean;
	var
    	m,j,k:integer;
        good:boolean;
	begin
    	for k := 0 to 9 do
        	begin
            	good := true;
	        	for m := 1 to 3 do
                	for j := 1 to 3 do
                    	if Predefined [k] [m, j] <> numbers [i] [m, j]
                        	then good := false;
                if good
                	then
                    	begin
                        	Recognize := true;
                            num := k;
                            Exit;
                        end;
            end;
        Recognize := false;
    end;

function CheckSum : boolean;
	var
    	i : integer;
        sum : integer;

    begin
    	sum := 0;
        for i := 1 to 9 do
        	inc (sum, scanned [10 - i]*i);
        if (sum mod 11) = 0
        	then CheckSum := true
            else CheckSum := false;
    end;

procedure WriteCode;
	var
    	i : integer;

	begin
    	assign (output, 'output.txt');
        rewrite (output);
        for i := 1 to 9 do
        	Write (scanned [i]);
        Writeln;
        close (output);
    end;

procedure WriteAmbiguous;
	begin
    	assign (output, 'output.txt');
        rewrite (output);
        Writeln ('ambiguous');
        close (output);
    end;

procedure WriteFailure;
	begin
    	assign (output, 'output.txt');
        rewrite (output);
        Writeln ('failure');
        close (output);
    end;

procedure CheckSolution (toMake : num_set);
	var
    	i, j : integer;
        old_num : ScannedInt;

    begin
    	old_num := numbers [bad];
    	if (toMake = [7])
        	then
            	begin
                	inc (i);
                end;
    	for i := 1 to 3 do
        	for j := 1 to 3 do
            	if ((i - 1)*3 + j) in toMake
                	then if (j mod 2) = 0
                            	then numbers [bad] [i, j] := '_'
                                else numbers [bad] [i, j] := '|';
        if Recognize (bad, num)
        	then
            	begin
                	new_scanned := scanned;
                    scanned [bad] := num;
                    if (CheckSum)
                    	then
	           	            if (found)
	               	            then
                       	            begin
                        	            WriteAmbiguous;
                                        Halt (0);
                                    end
                                else
                    	            begin
                        	            found := true;
                                        code_found := scanned;
                                        code_found [bad] := num;
                                    end;
                    scanned := new_scanned;
                end;
        numbers [bad] := old_num;
    end;

procedure FindRec (toMake : num_set; next : integer);
	begin
    	if next = 10
        	then CheckSolution (toMake)
        	else
            	begin
			    	FindRec (toMake, next + 1);
			    	if numbers [bad] [(next - 1) div 3 + 1, (next - 1) mod 3 + 1] = ' '
			        	then FindRec (toMake + [next], next + 1);
                end;
    end;

begin
	assign (input, 'input.txt');
    reset (input);
	for i := 1 to 3 do
    	begin
			readln (s);
            for j := 1 to 27 do
            	code [i, j] := s [j];
        end;
    close (input);

    for k := 1 to 9 do
    	for i := 1 to 3 do
        	for j := 1 to 3 do
            	numbers [k] [i, j] := code [i, j + (k - 1)*3];

    for k := 1 to 9 do
    	if Recognize (k, num)
        	then
            	begin
                    can_recognize [k] := true;
                    scanned [k] := num;
                end
            else can_recognize [k] := false;

    all_recognized := true;
    bad := 0;
    for k := 1 to 9 do
    	if not can_recognize [k]
        	then
            	begin
                	bad := k;
                    all_recognized := false;
                end;

    if (all_recognized)
    	then
			if CheckSum
            	then
                	begin
                        WriteCode;
                        Halt (0);
                    end
                else
                	begin
                    	found := false;
                        for k := 1 to 9 do
                        	for j := 0 to 9 do
                            	if j in toWhich [scanned [k]]
                                	then
                                    	begin
                                        	new_scanned := scanned;
                                            scanned [k] := j;
                                            if CheckSum
                                            	then if not (found)
                                                	then begin
                                                        code_found := scanned;
                                                        found := true;
                                                        end
                                                    else begin
                                                    	WriteAmbiguous;
                                                        Halt (0);
                                                        end;
                                            scanned := new_scanned;
                                        end;
                        if (found)
                        	then
                            	begin
                                	scanned := code_found;
                                    WriteCode;
                                    Halt (0);
                                end
                            else
                            	begin
                                	WriteFailure;
                                    Halt (0);
                                end;
                    end
        else
        	begin
            	found := false;
                FindRec ([], 1);
                if found
                   	then
                       	begin
                           	scanned := code_found;
                            WriteCode;
                            Halt (0);
                        end
                    else
	                   	begin
                           	WriteFailure;
                            Halt (0);
                        end;
            end;
end.