{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program  TaskA;
const    MaxEvents=2300;
type     TCab= record R: ShortInt; Time: LongInt; end;
         TEventT = (_Entry, _Exit, _WaitElev,_WaitRoom,_ElevRoom,
                    _RoomElev,_StayElev, _StayRoom, _RoomRoom, _ElevElev,
                    _ExitRoom, _ExitElev, _None,
                    _ExitEntry, _ExitExit, _NeedRoom, _NeedElev
                    );
         TEvent=record
                 Typ: TEventT;
                 T1: LongInt;
                 Dop: Byte;
                end;
         TTT=array [0..MaxEvents-1] of TEvent;
var      V: array [1..27,1..101] of TCab;
         VN: array [1..27] of Integer;
         SA: array [1..27] of LongInt;
         Target: array [1..27] of Integer; {Target room index in V !}
         Cod: array [1..27] of Char;
         Time: LongInt;
         NextRTime, NextETime: LongInt;
         Agents: Integer;
{         E: array [0..MaxEvents-1] of TEvent;}
         E1, E2: integer;
         Floor: array [1..27] of Byte;
         Room: array [1..27] of Integer; {0 - for Elevator}
         E: array [1..27] of ^TTT;
         EN, EP: array [1..27] of Integer;
         QR: array [0..99,0..27] of Byte;
         RBusy: array [0..99] of Byte;
         QE: array [0..9,0..27] of Byte;
         Left: array [1..27] of Byte;
         LeftN: Integer;
         CurLef: Integer;

procedure ReadIn;
var       Ag, C: Char;
          I,CB: Integer;
          T: LongInt;
begin
 Assign (Input,'input.txt'); reset (Input);
 FillChar (SA, SizeOf (SA),0);
 FillChar (V, SizeOf (V),255);
 Agents := 0;
 for I := 1 to 27 do New (E[I]);
 while not SeekEOF do
 begin
  repeat Read (C); until C in ['a'..'z','A'..'Z','.']; Ag := UpCase (C);
  if Ag='.' then begin Close (InpuT); exit; end;
  repeat Read (C); until C in ['0'..'9'];
  T := 0;
  Inc (T, (Ord (C)-48)*36000); Read(C);
  Inc (T, (Ord (C)-48)*3600); Read(C);
  Read (C);
  Inc (T, (Ord (C)-48)*600); Read(C);
  Inc (T, (Ord (C)-48)*60); Read(C);
  Read (C);
  Inc (T, (Ord (C)-48)*10); Read(C);
  Inc (T, (Ord (C)-48)); ReadLn;

  Inc (Agents); Cod[Agents] := Ag;
  SA[Agents] := T;
  Read (CB);
  while CB<>0 do
  begin
   ReadLn (T);
   Inc (VN[Agents]);
   CB := (CB div 100-1)*10+CB mod 100-1;
   with V[Agents,VN[Agents]] do begin R := CB; Time := T; end;
   Read (CB);
  end; ReadLn;
  if VN[Agents]=0 then Dec (Agents);
 end;
 Close (input);
end;

procedure Solve;

function GetNext: Byte;
var      Ag, I, K: Integer;
         T: LongInt;
begin
 T := MaxLongInt; Ag := 255;
 for K := 1 to LeftN do
 begin
  I := Left[K];
  if E[I]^[EP[I]].T1<T then
  begin
   Ag := I;
   T := E[I]^[EP[I]].T1;
   CurLef := K;
  end;
 end;
 GetNext := Ag;
end;

var     A: Integer;

procedure PutEvent (I: Integer;_Typ: TEventT; _T1: LongInt; _Dop: Byte);
begin
 Inc (EN[I]);
 with E[I]^[EN[I]] do
 begin
  Typ := _Typ;
  T1 := _T1;
  Dop := _Dop;
 end;
end;

procedure PutInRoom (I, Room: Integer);
begin
 PutEvent (I, _WaitRoom, Time,Room);
 PutEvent (I, _StayRoom, MaxLongInt, Room);
 Inc (QR[Room,0]);
 QR[Room,QR[Room,0]]:=I;
 NextRTime := Time;
end;

procedure PutInElev (I, DFloor: Integer);
begin
 PutEvent (I, _WaitElev, Time, 0);
 PutEvent (I, _StayElev, MaxLongInt, DFloor);
 Inc (QE[Floor[I],0]);
 QE[Floor[I],QE[Floor[I],0]]:=I;
 if Time mod 5=0 then NextETime := Time else
                      NextETime := Time+5-Time mod 5;
end;

procedure ProcessTarget (I, Target: Integer);
var       C: Byte;
begin
 if Target < 0 then
 begin
  if Floor[I]=0 then PutEvent (I, _Exit, Time, 0) else
  begin
   C := 10;
   if Room[I]>0 then PutEvent (I, _RoomElev, Time, 0) else
   if Room[I]=0 then PutEvent (I, _ElevElev, Time, 0) else C := 0;
   PutEvent (I, _NeedElev, Time+C, 0);
  end;
 end else
 if Floor[I]=Target div 10 then
 begin
  C := 10;
  if Room[I]>0 then PutEvent (I, _RoomRoom, Time, Target) else
  if Room[I]=0 then PutEvent (I, _ElevRoom, Time, Target) else C := 0;
  PutEvent (I, _NeedRoom, Time+C, 0);
 end else
 begin
  C := 10;
  if Room[I]>0 then PutEvent (I, _RoomElev, Time, 0) else
  if Room[I]=0 then PutEvent (I, _ElevElev, Time, 0) else C := 0;
  PutEvent (I, _NeedElev, Time+C, 0);
 end;
end;

procedure ProcessRoom (R: Integer);
var       A, J, I: Integer;
begin
 A := QR[R,1]; J := 1;
 for I := 2 to Qr[R,0] do
  if Cod[QR[R,I]]<Cod[A] then begin A := QR[R,I]; J := I; end;

 RBusy [R] := A;
 E[A]^[EN[A]].T1:=Time;
 PutEvent (A,_ExitRoom,Time+V[A,Target[A]].Time,R);
 QR[R,J]:=QR[R,QR[R,0]]; Dec (QR[R,0]);
end;

procedure ProcessRooms;
var       R: Integer;
begin
 Time := NextRTime;
 for R := 0 to 99 do
  if QR[R,0]>0 then
   if RBusy[R]=0 then ProcessRoom (R);
 NextRTime := MaxLongInt;
end;

procedure ProcessElevs;
var       A, K, J, I:Integer;
          F: Boolean;
begin
 Time := NextETime;
 F := True;
 for I := 0 to 9 do
  if QE[I,0]>0 then
  begin
   K := 1; A := QE[I,1];
   for J := 2 to QE[I,0] do
    if Cod[QE[I,J]]<Cod[A] then begin K := J; A := QE[I,J]; end;
   E[A]^[EN[A]].T1 := Time; J := E[A]^[EN[A]].Dop;
   PutEvent (A, _ExitElev, Time+Abs(J-Floor[A])*30, J);
   QE[I,K]:=QE[I,QE[I,0]]; Dec (QE[I,0]);
   if QE[I,0]>0 then F := False;
  end;
 if F then NextETime := MaxLongInt else
           Inc (NextETime,5);
end;

begin
 FillChar (RBusy, SizeOf (RBusy),0);
 for A := 1 to Agents do
 begin
  EN [A] := 0; EP [A] := 1;
  PutEvent (A, _Entry, SA[A], 0);
  PutEvent (A, _ExitEntry, SA[A]+30, 0);
 end;
 Time := 0; NextRTime := MaxLongInt; NextETime := MaxLongInt;
 for A := 1 to Agents do Left[A]:=A; LeftN := Agents;
 repeat
  A := GetNext;
  if A=255 then
  begin
   if NextRTime<NextETime then ProcessRooms else
                               ProcessElevs;
  end else
  with E[A]^[EP[A]] do
  begin
   if T1>NextRTime then
    if NextRTime<NextETime then ProcessRooms else
                                ProcessElevs else
   if T1>NextETime then ProcessElevs else
   begin
   Time:=T1;
   case Typ of
   _ExitEntry:
    begin
     Floor [A] := 0;
     Target [A] := 1;
     Room[A] := -1;
     ProcessTarget (A, V[A,Target[A]].R);
     end;
   _ExitElev:
    begin
     Room [A] := 0;
     Floor[A] := Dop;
     ProcessTarget (A, V[A,Target[A]].R);
    end;
   _ExitRoom:
    begin
     Room [A] := Dop;
     if QR[Room[A],0]>0 then ProcessRoom (Dop) else RBusy[Dop]:=0;
     Inc (Target[A]);
     ProcessTarget (A, V[A,Target[A]].R);
    end;
   _NeedRoom:
     PutInRoom (A, V[A,Target[A]].R);
   _NeedElev:
     PutInElev (A, V[A,Target[A]].R div 10);
   _WaitElev,_WaitRoom: {Idle};
   _StayRoom,_StayElev: {Idle};
   _Exit: begin
           Left[CurLef]:=Left[LeftN];
           Dec (LeftN);
          end;
   end;
   Inc (EP[A]);
   end;
  end;
 until LeftN=0;
end;

procedure WriteOut;
var       A,I: Integer;
          R: Integer;

procedure PrintTime (A: LongInt);
begin
 A := A mod 86400;
 Write(A div 36000); A := A mod 36000;
 Write(A div 3600); A := A mod 3600;
 Write(':');
 Write(A div 600); A := A mod 600;
 Write(A div 60); A := A mod 60;
 Write(':');
 Write(A div 10); A := A mod 10;
 Write(A,' ');
end;

function RN (I: Word): string;
begin
 I := (I div 10+1)*100+I mod 10+1;
 RN := Char (I div 1000+48)+
       Char (I mod 1000 div 100+48)+
       Char (I mod 100 div 10+48)+
       Char (I mod 10+48);
end;

begin
 Assign (output,'output.txt'); rewrite (output);
 for A := 1 to Agents do
 begin
  WriteLn (Cod[A]); R := -1;
  for I := 1 to EN[A] do
   with E[A]^[I] do
    case Typ of
     _Entry:
     begin
      PrintTime (E[A]^[I].T1); PrintTime (E[A]^[I+1].T1);
      WriteLn ('Entry');
     end;
     _Exit:
     begin
      PrintTime (e[a]^[I].T1); PrintTime (e[a]^[I].T1+30);
      WriteLn ('Exit');
     end;
     _WaitElev:if e[a]^[I].T1<>e[a]^[I+1].T1 then
     begin
      PrintTime (e[a]^[I].T1); PrintTime (e[a]^[I+1].T1);
      WriteLn ('Waiting in elevator queue');
     end;
     _WaitRoom:if e[a]^[I].T1<>e[a]^[I+1].T1 then
     begin
      PrintTime (e[a]^[I].T1); PrintTime (e[a]^[I+1].T1);
      WriteLn ('Waiting in front of room ',RN(e[a]^[I].Dop));
     end;
    _StayRoom:
     begin
      PrintTime (e[a]^[I].T1); PrintTime (e[a]^[I+1].T1);
      WriteLn ('Stay in room ',RN(e[a]^[I].Dop));
      R := e[a]^[I].Dop;
     end;
    _StayElev:
     begin
      PrintTime (e[a]^[I].T1); PrintTime (e[a]^[I+1].T1);
      WriteLn ('Stay in elevator');
      R := 0;
     end;
    _ElevRoom:
     begin
      PrintTime (e[a]^[I].T1); PrintTime (e[a]^[I+1].T1);
      WriteLn ('Transfer from elevator to room ',RN(e[a]^[I].Dop));
      R := e[a]^[I].Dop;
     end;
    _RoomElev:
     begin
      PrintTime (e[a]^[I].T1); PrintTime (e[a]^[I+1].T1);
      WriteLn ('Transfer from room ',RN(R),' to elevator');
      R := 0;
     end;
     _RoomRoom:
     begin
      PrintTime (e[a]^[I].T1); PrintTime (e[a]^[I+1].T1);
      WriteLn ('Transfer from room ',RN(R),' to room ',RN(e[a]^[I].Dop));
      R := e[a]^[i].Dop;
     end;
    end;
  WriteLn;
 end;
 close (output);
end;

begin
 ReadIn;
 Solve;
 WriteOut;
end.
