{$A+,B-,D+,E-,F-,G+,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program macro;

{.$DEFINE DEBUG}
const
  maxN          = 100;
  maxM          = 100;

var
  N, M          : integer;
  L, LL         : array [0..maxN] of longint;
  ps            : array [1..maxM] of longint;
  TL            : longint;        { total length of line }
  TL2           : longint;        { TL * 2 }
  t             : longint;        { time... }
  tm            : longint;        { time modulo period }
  Mark          : array [0..maxN, 1..maxM, 0..1] of boolean;
  total: longint;

procedure sort (a, b : integer);
var i, j, x, y : longint;
begin
  if a >= b then exit;
  x := ps [(a+b) shr 1];
  i := a;
  j := b;
  repeat
    while ps[i] < x do inc (i);
    while ps[j] > x do dec (j);
    if i <= j then begin
      y := ps[i]; ps[i] := ps[j]; ps[j] := y;
      inc (i); dec (j) end
  until i > j;
  sort (a, i-1);
  sort (i, b)
end;

function binsearch (x : longint) : integer;
var a, b, c : integer;
begin
  if x <= ps [1] then begin binsearch := 0; exit end;
  if x > ps [M] then begin binsearch := M; exit end;
  a := 1; b := M;  { ps[a] < x <= ps[b] }
  while b - a > 1 do
    begin
      c := (a + b) shr 1;
      if ps[c] < x then a := c else b := c
    end;
  binsearch := a
end;

function nexttram (sh : longint) : integer;
var i : integer;
begin
  while sh < 0 do inc (sh, TL2);
  while sh >= TL2 do dec (sh, TL2);
  i := binsearch (sh);
  if i = 0 then nexttram := M else nexttram := i
end;

var i, j, j1, j2, k     : integer;
    t1, t2              : longint;
begin
  assign (input, 'input.txt'); reset (input);
  assign (output, 'output.txt'); rewrite (output);
  read (N);   { 0..N -- tram stops }
  read (M);   { M -- # of trams }
  for i := 1 to N do read (LL[i]);  { distance between stops }
  L[0] := 0;
  for i := 1 to N do L[i] := L[i-1] + LL[i];
  TL := L[N];
  TL2 := TL shl 1;
  for i := 1 to M do
    begin read (ps[i]); { initial position of trams }
          if ps[i] < 0 then inc (ps[i], TL2);
            { negative position means inversed direction }
    end;
  sort (1, M); { sorts trams by position }
  t := 0; tm := 0; i := 0;
  total := 0;
  repeat
    j1 := nexttram (L[i] - tm);
    t1 := (L[i] - tm) - ps [j1];
    j2 := nexttram (TL2 - L[i] - tm);
    t2 := (TL2 - L[i] - tm) - ps [j2];
    while t1 <= 0 do inc (t1, TL2);
    while t2 <= 0 do inc (t2, TL2);
    inc(total);
    if t1 <= t2 then begin { forward! }
{$IFDEF DEBUG}
write (t div 10 :5, '.', t mod 10, ': ');
writeln ('Stop #', i, ': waiting ', t1 div 10, '.', t1 mod 10,
        ' for tram ', j1, ' to travel forward');
{$ENDIF}
      j := j1; inc (t1, LL[i+1]); inc (i);
      inc (tm, t1); inc (t, t1); k := 0 end
    else begin { backward! }
{$IFDEF DEBUG}
write (t div 10 :5, '.', t mod 10, ': ');
writeln ('Stop #', i, ': waiting ', t2 div 10, '.', t2 mod 10,
        ' for tram ', j2, ' to travel backward');
{$ENDIF}
      j := j2; inc (t2, LL[i]); dec (i);
      inc (tm, t2); inc (t, t2); k := 1 end;
    if Mark [i, j, k] then begin tm := -1; break end;
    Mark [i, j, k] := true;
    if tm >= TL2 then dec (tm, TL2)
  until i = N;
  if tm < 0 then writeln (0)
            else writeln (t);
{  writeln('  ', total);}
end.
