{$E-,N+}
type Float = Extended;
Point = record
 X,Y: Float;
end;
Line = record
 A,B: Point;
end;
LongLine = record
 A,B,C: Float;
end;
var F: text;
QQ,I,J,Size,N: integer;
A: array [1..100] of Line;
B: array [1..100] of LongLine;
P: array [1..100,1..2] of Point;
Q: array [1..100,1..2] of Float;
L: LongLine;
const TestPoint = 50.01;

procedure MakeLongLine(F: Line; var TT: LongLine);
begin
 TT.A:=F.B.Y-F.A.Y;
 TT.B:=F.A.X-F.B.X;
 TT.C:=TT.A*F.A.X+TT.B*F.A.Y;
end;

procedure MakeTestLine(LL: LongLine; var L: LongLine; N: integer);
var R,Dx,Dy: Float;
begin
 L:=LL;
 R:=TestPoint*Sqrt(L.A*L.A+L.B*L.B);
 L.C:=L.C+R*N;
end;

function GetPeresek(var X,Y: Float; A,B: LongLine): boolean;
begin
 GetPeresek:=True;
 if Abs(A.B*B.A-B.B*A.A)<1E-5 then
 begin
  GetPeresek:=False;
  Exit;
 end;
 Y:=(A.C*B.A-B.C*A.A)/(A.B*B.A-B.B*A.A);
 X:=(A.C*B.B-B.C*A.B)/(A.A*B.B-B.A*A.B);
end;

function Min(A,B: Float): Float;
begin
 if A<B then Min:=A else Min:=B;
end;

function Max(A,B: Float): Float;
begin
 if A>B then Max:=A else Max:=B;
end;

procedure TestFor(K: integer);
var AA,BB: LongLine;
X1,Y1,X2,Y2: Float;
begin
 MakeTestLine(B[K],AA,1);
 MakeTestLine(B[K],BB,-1);
 if not GetPeresek(X1,Y1,L,AA) then Exit;
 if not GetPeresek(X2,Y2,L,BB) then Exit;
 if X1<X2 then
 begin
  P[K,1].X:=X1;
  P[K,1].Y:=Y1;
  P[K,2].X:=X2;
  P[K,2].Y:=Y2;
 end else
 begin
  P[K,1].X:=X2;
  P[K,1].Y:=Y2;
  P[K,2].X:=X1;
  P[K,2].Y:=Y1;
 end;
end;

procedure Delete(F,T: integer);
begin
 if T=0 then Exit;
 Move(Q[F+T,2],Q[F,2],20*(QQ-F+T)-10);
 Dec(QQ,T);
end;

procedure Insert(F: integer; L,R: Float);
begin
 Move(Q[F,2],Q[F+1,2],20*(QQ-F)+10);
 Q[F,2]:=L;
 Q[F+1,1]:=R;
 Inc(QQ);
end;

procedure Correct(L,R: Float);
var I,J: integer;
begin
 if L<0 then L:=0;
 if R>Size then R:=Size;
 if L>R then Exit;
 for I:=1 to QQ do if Q[I,2]>=L then Break;
 for J:=QQ downto 1 do if Q[J,1]<=R then Break;
 Delete(I,J-I);
 Insert(I,L,R);
end;

procedure TestPointsX;
var I: integer;
X1,X2,Y1,Y2: Float;
begin
 for I:=1 to QQ do
 if Abs(Q[I,2]-Q[I,1])>1E-5 then
 begin
  X1:=Q[I,1];
  X2:=Q[I,2];
  Y1:=(L.C-L.A*X1)/L.B;
  Y2:=(L.C-L.A*X2)/L.B;
  X1:=(X1+X2)/2;
  Y1:=(Y1+Y2)/2;
  if (X1<0) or (X1>Size) or (Y1<0) or (Y1>Size) then Continue;
  Assign(F,'fire.out');
  Rewrite(F);
  Writeln(F,X1:1:3,' ',Y1:1:3);
  Close(F);
  Halt(0);
 end;
end;

procedure TestPointsY;
var I: integer;
X1,X2,Y1,Y2: Float;
begin
 for I:=1 to QQ do
 if Abs(Q[I,2]-Q[I,1])>1E-5 then
 begin
  Y1:=Q[I,1];
  Y2:=Q[I,2];
  X1:=(L.C-L.B*Y1)/L.A;
  X2:=(L.C-L.B*Y2)/L.A;
  X1:=(X1+X2)/2;
  Y1:=(Y1+Y2)/2;
  if (X1<0) or (X1>Size) or (Y1<0) or (Y1>Size) then Continue;
  Assign(F,'fire.out');
  Rewrite(F);
  Writeln(F,X1:1:3,' ',Y1:1:3);
  Close(F);
  Halt(0);
 end;
end;

procedure MakeFree;
var X1,Y1,X2,Y2: Float;
const Upper: LongLine = (A:0;B:1;C:100);
Lower: LongLine = (A:0;B:1;C:0);
Lefter: LongLine = (A:1;B:0;C:0);
Righter: LongLine = (A:1;B:0;C:100);
begin
 QQ:=1;
 Q[1,1]:=0;
 Q[1,2]:=Size;
 if GetPeresek(X1,Y1,L,Lefter) and GetPeresek(X2,Y2,L,Righter) then
 begin
  for I:=1 to N do Correct(P[I,1].X,P[I,2].X);
  TestPointsX;
 end else
 begin
  for I:=1 to N do Correct(P[I,1].Y,P[I,2].Y);
  TestPointsY;
 end;
end;

procedure Work;
var I,J: integer;
begin
 FillChar(P,SizeOf(P),0);
 for I:=1 to N do TestFor(I);
 MakeFree;
end;

procedure Test(P: integer);
begin
 MakeTestLine(B[P],L,1);
 Work;
 MakeTestLine(B[P],L,-1);
 Work;
end;

begin
 Assign(F,'fire.in');
 Reset(F);
 Readln(F,Size);
 Readln(F,N);
 for I:=1 to N do Readln(F,A[I].A.X,A[I].A.Y,A[I].B.X,A[I].B.Y);
 Close(F);
 for I:=1 to N do MakeLongLine(A[I],B[I]);
 for I:=1 to N do Test(I);
 Assign(F,'fire.out');
 Rewrite(F);
 Writeln(F,'OK');
 Close(F);
end.