{$A-,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
type
  float = double;
  px = array [0..3500] of float;
const eps: float = 1e-7;
var
  n, i: integer;
  nx: longint;
  l: float;
  xb, yb, xe, ye, aat, bbt, cct, ddt: array [1..150] of float;
  aaa, bbb, ccc, ddd: array [1..150] of float;
  xx: array [0..7] of ^px;
  ok: boolean;
  ax, ay: float;
  tm: longint absolute 0:$46c;
  st: longint;

procedure ReadAll;
var  i: integer;
begin
  Assign(Input, 'fire.in'); Reset(Input);

  Read(l);
  Read(n);
  for i := 1 to n do Read(xb[i], yb[i], xe[i], ye[i]);

  Close(Input);
end;

procedure Out;
begin
  Assign(Output, 'fire.out'); ReWrite(Output);

  if ok then begin
    WriteLn(ax:1:3, ' ', ay:1:3);
  end else WriteLn('OK');

  Close(Output);
end;

procedure AddX(const x: float);
begin
  xx[nx and 7]^[nx shr 3] := x;
  inc(nx);
end;

procedure intr(const a1, b1, c1, a2, b2, c2: float);
var
  dx, dy, d, xx: float;
begin
  d := a1*b2 - b1*a2;

  if (abs(d) < eps) then exit;

  dx := c1*b2 - b1*c2;
  xx := dx/d;
  if (xx>(-eps)) and ((xx-l)<eps) then AddX(xx);
end;

procedure procln(i, j: integer);
var
  aa, bb, cc, dd: array [1..2] of float;
begin
  aa[1] := ye[i] - yb[i];
  bb[1] := xb[i] - xe[i];
  cc[1] := (xe[i]*aa[1]) + (ye[i]*bb[1]);
  dd[1] := 50*sqrt(sqr(aa[1]) + sqr(bb[1]));

  aa[2] := ye[j] - yb[j];
  bb[2] := xb[j] - xe[j];
  cc[2] := (xe[j]*aa[2]) + (ye[j]*bb[2]);
  dd[2] := 50*sqrt(sqr(aa[2]) + sqr(bb[2]));

  intr(aa[1], bb[1], cc[1]+dd[1], aa[2], bb[2], cc[2]+dd[2]);
  intr(aa[1], bb[1], cc[1]+dd[1], aa[2], bb[2], cc[2]-dd[2]);
  intr(aa[1], bb[1], cc[1]-dd[1], aa[2], bb[2], cc[2]+dd[2]);
  intr(aa[1], bb[1], cc[1]-dd[1], aa[2], bb[2], cc[2]-dd[2]);
end;

procedure procpl(i: integer);
var
  aa, bb, cc, dd, xx: float;
begin
  aa := ye[i] - yb[i];
  bb := xb[i] - xe[i];
  cc := (xe[i]*aa) + (ye[i]*bb);
  dd := 50*sqrt(sqr(aa) + sqr(bb));

  if (abs(aa)<eps) then exit;
  xx := (cc+dd-(bb*l))/aa;
  if (xx>(-eps)) and ((xx-l)<eps) then AddX(xx);
  xx := (cc+dd)/aa;
  if (xx>(-eps)) and ((xx-l)<eps) then AddX(xx);
  xx := (cc-dd-(bb*l))/aa;
  if (xx>(-eps)) and ((xx-l)<eps) then AddX(xx);
  xx := (cc-dd)/aa;
  if (xx>(-eps)) and ((xx-l)<eps) then AddX(xx);
end;

procedure SortX(l, r: longint);
var
  i, j, mm: longint;
  m, h: float;
begin
  i := l; j := r;
  mm := (i+j) div 2;
  m := xx[mm and 7]^[mm shr 3];
  repeat
    while ((m-xx[i and 7]^[i shr 3])>eps) do inc(i);
    while ((xx[j and 7]^[j shr 3]-m)>eps) do dec(j);
    if (i<=j) then begin
      h := xx[i and 7]^[i shr 3];
      xx[i and 7]^[i shr 3] := xx[j and 7]^[j shr 3];
      xx[j and 7]^[j shr 3] := h;
      inc(i); dec(j);
    end;
  until (i>j);

  if (i < r) then SortX(i, r);
  if (l < j) then SortX(l, j);
end;

var
  wy: array [1..500] of integer;
  acty: array [0..500] of boolean;
  yy, y1, y2: array [1..500] of float;
  ny, na: integer;
  hf: float;
  hi: integer;

procedure swpf(var a, b: float);
begin
  hf := a; a := b; b := hf;
end;

procedure swpi(var a, b: integer);
begin
  hi := a; a := b; b := hi;
end;

procedure SortY(l, r: longint);
var
  i, j: longint;
  m: float;
begin
  i := l; j := r;
  m := yy[(i+j) div 2];
  repeat
    while ((m-yy[i])>eps) and (i<=r) do inc(i);
    while ((yy[j]-m)>eps) and (j>=l) do dec(j);
    if (i<=j) then begin
      swpf(yy[i], yy[j]);
      swpf(y1[i], y1[j]);
      swpf(y2[i], y2[j]);
      swpi(wy[i], wy[j]);
      inc(i); dec(j);
    end;
  until (i>j);

  if (i < r) then SortY(i, r);
  if (l < j) then SortY(l, j);
end;

procedure procstrp(const x1, x2: float);
var
  i: integer;
  at, bb, ct, dt, a1b, a2b: float;
begin
  if (abs(x1-x2) < eps) then exit;

  ny := 0;
  inc(ny);
  y1[ny] := 0;
  y2[ny] := 0;
  yy[ny] := 0;
  wy[ny] := 0;
  inc(ny);
  y1[ny] := l;
  y2[ny] := l;
  yy[ny] := l;
  wy[ny] := 0;

  for i := 1 to n do begin
{    aa := ye[i] - yb[i];
    bb := xb[i] - xe[i];
    cc := (xe[i]*aa) + (ye[i]*bb);
    dd := 50*sqrt(sqr(aa) + sqr(bb));}
    at := aat[i]; bb := bbb[i]; ct := cct[i]; dt := ddt[i];

    if (abs(bb)<eps) then begin
      if ((xe[i]+50-x2)>-eps) and ((x1-xe[i]+50)>-eps) then exit;
    end else begin
      inc(ny);
      a1b := (at*x1);
      a2b := (at*x2);
      y1[ny] := ((ct+dt))-a1b;
      y2[ny] := ((ct+dt))-a2b;
      yy[ny] := (y1[ny]+y2[ny])/2;
      wy[ny] := i;
      inc(ny);
      y1[ny] := ((ct-dt)) - a1b;
      y2[ny] := ((ct-dt)) - a2b;
      yy[ny] := (y1[ny]+y2[ny])/2;
      wy[ny] := i;

      if (((yy[ny]-l)>eps) and ((yy[ny-1]-l)>eps)) then dec(ny, 2) else
      if (((yy[ny])<-eps) and ((yy[ny-1])<-eps)) then dec(ny, 2);
    end;
  end;

  SortY(1, ny);

  fillchar(acty, sizeof(acty), 0);
  na := 0;
  for i := 1 to ny do begin
    if (acty[0] and (na<1) and (abs(yy[i-1]-yy[i])>eps)) then begin
      ok := true;
      ax := (x1+x2)/2;
      ay := (yy[i-1]+yy[i])/2;
      exit;
    end;
    if (wy[i]>0) then begin
      if acty[wy[i]] then begin
        dec(na);
        acty[wy[i]] := false;
      end else begin
        inc(na);
        acty[wy[i]] := true;
      end;
    end else begin
      if acty[0] then exit else acty[0] := true;
    end;
  end;
end;

procedure Solve;
var
  i, j, kk: longint;
begin
  nx := 0;

  AddX(0);
  AddX(l);
  for i := 1 to n-1 do for j := i+1 to n do procln(i, j);
  for i := 1 to n do procpl(i);
  for i := 1 to n do begin
    aaa[i] := ye[i] - yb[i];
    bbb[i] := xb[i] - xe[i];
    ccc[i] := (xe[i]*aaa[i]) + (ye[i]*bbb[i]);
    ddd[i] := 50*sqrt(sqr(aaa[i]) + sqr(bbb[i]));
    if (abs(bbb[i])>eps) then begin
      aat[i] := aaa[i]/bbb[i];
      cct[i] := ccc[i]/bbb[i];
      ddt[i] := ddd[i]/bbb[i];
    end;
  end;

  SortX(0, nx-1);
  ok := false;

  if (nx>5000) then begin
    for i := nx-13 to nx-2 do begin
      j := i+1;
      procstrp(xx[i and 7]^[i shr 3], xx[j and 7]^[j shr 3]);
      if (ok)  then exit;
    end;
    randseed := $13666;
    for kk := 1 to 666 do begin
      i := random(nx-1);
      j := i+1;
      procstrp(xx[i and 7]^[i shr 3], xx[j and 7]^[j shr 3]);
      if (ok)  then exit;
    end;
  end;

  for i := 0 to nx-2 do begin
    j := i+1;
    procstrp(xx[i and 7]^[i shr 3], xx[j and 7]^[j shr 3]);
    if (ok or (tm>st))  then exit;
  end;
end;

begin
  st := tm + 85;
  for i := 0 to 7 do new(xx[i]);
  ReadAll;
  Solve;
  Out;
  for i := 0 to 7 do dispose(xx[i]);
end.
