{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$M 65000,0,655360}
const
    InFile='fire.in';
    OutFile='fire.out';
    max=100;
    eps=1e-5;

type
    {real=double;}
    Tpoint=record
            x,y:real;
        end;
    Tline=record
            A,B,C:real;
            p1,p2:Tpoint;
        end;

var
    N,L:integer;
    a:array[1..max]of Tline;
    db:array[1..max,1..2]of Tline;
    res:boolean;
    resP:Tpoint;
    x0,y0,xL,yL:Tline;

function eq(r1,r2:real):boolean;
begin
    if abs(r1-r2)<eps then eq:=true
     else eq:=false;
end;

function distPL(p:Tpoint; l:Tline):real;
begin
    distPL:=abs((l.A*p.x+l.B*p.y+l.C)/(sqrt(sqr(l.A)+sqr(l.B))));
end;

procedure Conv(var l:Tline);
begin
    l.A:=l.p1.y-l.p2.y;
    l.B:=l.p2.x-l.p1.x;
    l.C:=l.p1.x*l.p2.y-l.p2.x*l.p1.y;
end;

function Cross(var c:Tpoint; l1,l2:Tline):boolean;
var
    bool:boolean;
    dx,dy,d:real;
begin
    d:=l1.A*l2.B-l2.A*l1.B;
    if eq(d,0) then bool:=false
     else begin
        dx:=l1.A*l2.C-l2.A*l1.C;
        dy:=l1.C*l2.B-l2.C*l1.B;
        c.x:=-dx/d;
        c.y:=-dy/d;
        bool:=true;
    end;
    Cross:=bool;
end;

procedure ReadData;
var
    f:text;
    i:integer;
begin
    assign(f,InFile);
    reset(f);
    readln(f,L);
    readln(f,N);
    for i:=1 to N do begin
        readln(f,a[i].p1.x,a[i].p1.y,a[i].p2.x,a[i].p2.y);
        Conv(a[i]);
    end;
    close(f);
end;

procedure Result;
var
    f:text;
begin
    assign(f,OutFile);
    rewrite(f);
    if res then write(f,'OK')
     else write(f,resP.x:0:4,' ',resP.y:0:4);
    close(f);
end;

function Parall:boolean;
var
    bool:boolean;
    i,j:integer;
    h,v:array[0..max]of integer;
    xx,yy:boolean;
    dx,dy:real;

 procedure SortX(l, r: Integer);
 var
  i, j, y: integer;
  x:real;
 begin
  i := l; j := r; x := a[v[(l+r) DIV 2]].p1.x;
  repeat
    while (a[v[i]].p1.x < x)and(i<r) do inc(i);
    while (x < a[v[j]].p1.x)and(j>1) do dec(j);
    if i <= j then
    begin
      y := v[i];
      v[i] := v[j];
      v[j] := y;
      inc(i);
      inc(j);
    end;
  until i > j;
  if l < j then SortX(l, j);
  if i < r then SortX(i, r);
 end;

 procedure SortY(l, r: Integer);
 var
  i, j, y: integer;
  x:real;
 begin
  i := l; j := r; x := a[h[(l+r) DIV 2]].p1.y;
  repeat
    while (a[h[i]].p1.y < x)and(i<r) do inc(i);
    while (x < a[h[j]].p1.y)and(j>1) do dec(j);
    if i <= j then
    begin
      y := h[i];
      h[i] := h[j];
      h[j] := y;
      inc(i);
      inc(j);
    end;
  until i > j;
  if l < j then SortY(l, j);
  if i < r then SortY(i, r);
 end;

begin
    bool:=true;
    h[0]:=0;
    v[0]:=0;
    for i:=1 to n do begin
        if eq(a[i].p1.x,a[i].p2.x) then begin
            inc(v[0]);
            v[v[0]]:=i;
        end
         else
            if eq(a[i].p1.y,a[i].p2.y) then begin
                inc(h[0]);
                h[h[0]]:=i;
            end
             else bool:=false;
    end;
    if bool then begin
        xx:=false;
        if v[0]<>0 then begin
            if v[0]>1 then SortX(1,v[0]);
            for i:=1 to v[0]-1 do begin
                dx:=abs(a[v[i]].p1.x-a[v[i+1]].p1.x);
                if dx>100 then begin
                    xx:=true;
                    resP.x:=(a[v[i]].p1.x+a[v[i+1]].p1.x)/2
                end;
            end;
            dx:=abs(a[v[1]].p1.x);
            if dx>50 then begin
                xx:=true;
                resP.x:=(dx-50)/2;
            end;
            dx:=abs(L-a[v[v[0]]].p1.x);
            if dx>50 then begin
                xx:=true;
                resP.x:=(L+a[v[v[0]]].p1.x+50)/2;
            end;
        end
         else begin
            xx:=true;
            resP.x:=L/2;
        end;
        yy:=false;
        if h[0]<>0 then begin
            if h[0]>1 then SortY(1,h[0]);
            for i:=1 to h[0]-1 do begin
                dy:=abs(a[h[i]].p1.y-a[h[i+1]].p1.y);
                if dy>100 then begin
                    yy:=true;
                    resP.y:=(a[h[i]].p1.y+a[h[i+1]].p1.y)/2
                end;
            end;
            dy:=abs(a[h[1]].p1.y);
            if dy>50 then begin
                yy:=true;
                resP.y:=(dy-50)/2;
            end;
            dy:=abs(L-a[h[h[0]]].p1.y);
            if dy>50 then begin
                yy:=true;
                resP.y:=(L+a[h[h[0]]].p1.y+50)/2;
            end;
        end
         else begin
            yy:=true;
            resP.y:=L/2;
        end;
        if xx and yy then res:=false
         else res:=true;
    end;
    Parall:=bool;
end;

function Proverka(p:Tpoint; num1,num2:integer):boolean;{true-४뢠}
var
    i,j:integer;
    bool:boolean;
    d:real;
begin
    bool:=false;
    if (p.x<0)or(p.x>L)or(p.y<0)or(p.y>L)then bool:=true
     else
        for i:=1 to n do
            if (i<>num1)and(i<>num2) then begin
                d:=distPL(p,a[i]);
                if (d<50)or(eq(d,50)) then bool:=true;
            end;
    if not(bool) then
        for i:=1 to n do begin
            d:=distPL(p,a[i]);
            if (d<50)and(not eq(d,50)) then bool:=true;
        end;
    Proverka:=bool;
end;

procedure NotP;
var
    i,j:integer;
    p:Tpoint;
    AB:real;
begin
    {㣫 }
    res:=false;
    resP.x:=0.0001;
    resP.y:=0.0001;
    if not Proverka(resP,0,0) then exit;
    resP.x:=L-0.0001;
    resP.y:=0.0001;
    if not Proverka(resP,0,0) then exit;
    resP.x:=0.0001;
    resP.y:=L-0.0001;
    if not Proverka(resP,0,0) then exit;
    resP.x:=L-0.0001;
    resP.y:=L-0.0001;
    if not Proverka(resP,0,0) then exit;
    res:=true;
    for i:=1 to n do begin
        db[i,1]:=a[i];
        db[i,2]:=a[i];
        AB:=50*sqrt(sqr(a[i].A)+sqr(a[i].B));
        db[i,1].C:=a[i].C+AB;
        db[i,2].C:=a[i].C-AB;
    end;
    x0.A:=1; x0.B:=0; x0.C:=0;
    y0.A:=0; y0.B:=1; y0.C:=0;
    xL.A:=1; xL.B:=0; xL.C:=-L;
    yL.A:=0; yL.B:=1; yL.C:=-L;
    for i:=1 to n do begin
        for j:=(i+1) to n do begin
            if Cross(p,db[i,1],db[j,1]) then
                if not Proverka(p,i,j) then begin
                    resP:=p;
                    res:=false;
                    exit;
                end;
            if Cross(p,db[i,1],db[j,2]) then
                if not Proverka(p,i,j) then begin
                    resP:=p;
                    res:=false;
                    exit;
                end;
            if Cross(p,db[i,2],db[j,1]) then
                if not Proverka(p,i,j) then begin
                    resP:=p;
                    res:=false;
                    exit;
                end;
            if Cross(p,db[i,2],db[j,2]) then
                if not Proverka(p,i,j) then begin
                    resP:=p;
                    res:=false;
                    exit;
                end;
        end;
        if Cross(p,db[i,1],x0) then
            if not Proverka(p,i,0) then begin
                resP:=p;
                res:=false;
                exit;
            end;
        if Cross(p,db[i,1],xL) then
            if not Proverka(p,i,0) then begin
                resP:=p;
                res:=false;
                exit;
            end;
        if Cross(p,db[i,1],y0) then
            if not Proverka(p,i,0) then begin
                resP:=p;
                res:=false;
                exit;
            end;
        if Cross(p,db[i,1],yL) then
            if not Proverka(p,i,0) then begin
                resP:=p;
                res:=false;
                exit;
            end;
        if Cross(p,db[i,2],x0) then
            if not Proverka(p,i,0) then begin
                resP:=p;
                res:=false;
                exit;
            end;
        if Cross(p,db[i,2],xL) then
            if not Proverka(p,i,0) then begin
                resP:=p;
                res:=false;
                exit;
            end;
        if Cross(p,db[i,2],y0) then
            if not Proverka(p,i,0) then begin
                resP:=p;
                res:=false;
                exit;
            end;
        if Cross(p,db[i,2],yL) then
            if not Proverka(p,i,0) then begin
                resP:=p;
                res:=false;
                exit;
            end;
    end;
end;

procedure Solve;
begin
    res:=true;
    if Parall then exit;
    NotP;
end;

begin
    ReadData;
    Solve;
    Result;
end.