Type
    TPlane=Record
          Xb,Yb: Real;
          Xe,Ye: Real;
          X1,Y1,X2,Y2: Real;
          X3,Y3,X4,Y4: Real;
    End;
    TPoint=Record
          X,Y: Real;
    End;

Var
   Planes: Array[1..100] Of TPlane;
   L: Real;
   Count: Byte;
   Points: Array[1..2000] Of TPoint;
   PointsCount: Word;

Function ArcSin(X: Real): Real;
Begin
     ArcSin:=ArcTan(x/sqrt(1-sqr(x)));
End;

Procedure CalcRect(N: Byte);
Var
   Alfa: Real;
   A,B,C,E: Real;
Begin
     A:=Sqrt(Sqr(Planes[N].Xe-Planes[N].Xb)+Sqr(Planes[N].Ye-Planes[N].Yb));
     C:=50.0;
     E:=Abs(Planes[N].Ye-Planes[N].Yb)+0.000000001;
     B:=E/A;
     If Abs(B-1)<0.000000001 Then Alfa:=Pi/2 Else Alfa:=ArcSin(B);
     Planes[N].X1:=C*Cos(Alfa+Pi/2)+Planes[N].Xb;
     Planes[N].Y1:=C*Sin(Alfa+Pi/2)+Planes[N].Yb;
     Planes[N].X2:=C*Cos(Alfa+Pi/2)+Planes[N].Xe;
     Planes[N].Y2:=C*Sin(Alfa+Pi/2)+Planes[N].Ye;

     Planes[N].X3:=C*Cos(Alfa-Pi+Pi/2)+Planes[N].Xb;
     Planes[N].Y3:=C*Sin(Alfa-Pi+Pi/2)+Planes[N].Yb;
     Planes[N].X4:=C*Cos(Alfa-Pi+Pi/2)+Planes[N].Xe;
     Planes[N].Y4:=C*Sin(Alfa-Pi+Pi/2)+Planes[N].Ye;

     If Planes[N].X1<0 Then Planes[N].X1:=0;
     If Planes[N].X1>L Then Planes[N].X1:=L;
     If Planes[N].X2<0 Then Planes[N].X2:=0;
     If Planes[N].X2>L Then Planes[N].X2:=L;
     If Planes[N].X3<0 Then Planes[N].X3:=0;
     If Planes[N].X3>L Then Planes[N].X3:=L;
     If Planes[N].X4<0 Then Planes[N].X4:=0;
     If Planes[N].X4>L Then Planes[N].X4:=L;

     If Planes[N].Y1<0 Then Planes[N].Y1:=0;
     If Planes[N].Y1>L Then Planes[N].Y1:=L;
     If Planes[N].Y2<0 Then Planes[N].Y2:=0;
     If Planes[N].Y2>L Then Planes[N].Y2:=L;
     If Planes[N].Y3<0 Then Planes[N].Y3:=0;
     If Planes[N].Y3>L Then Planes[N].Y3:=L;
     If Planes[N].Y4<0 Then Planes[N].Y4:=0;
     If Planes[N].Y4>L Then Planes[N].Y4:=L;
End;

Procedure TriangleTest;
Var
   A,B,C,D: Word;
   Flag: Boolean;
   T: Word;
   PerX1,PerX2,PerX3: Boolean;
   PerY1,PerY2,PerY3: Boolean;
   PerX,PerY: Boolean;
   OutFile: Text;
Begin
     Assign(OutFile,'fire.out'); Rewrite(OutFile);
     Flag:=True;
     If Flag Then
      For A:=1 To PointsCount Do
       If Flag Then
        For B:=1 To PointsCount Do
            If A<>B Then
         If Flag Then
          For C:=1 To PointsCount Do
              If ((C<>A) And (C<>B)) Then
          Begin
               T:=0;
               For D:=1 To Count Do
                 If Flag Then
                 Begin
                   PerX1:=(((Points[A].X<=Planes[D].X1) And (Points[B].X>=Planes[D].X2)) Or
                            (Points[A].X>=Planes[D].X1) And (Points[B].X<=Planes[D].X2));
                   PerX2:=(((Points[B].X<=Planes[D].X3) And (Points[C].X>=Planes[D].X4)) Or
                            (Points[B].X>=Planes[D].X3) And (Points[C].X<=Planes[D].X4));
                   PerX3:=(((Points[C].X<=Planes[D].X1) And (Points[A].X>=Planes[D].X2)) Or
                            (Points[C].X>=Planes[D].X1) And (Points[A].X<=Planes[D].X2));
                   PerY1:=(((Points[A].Y<=Planes[D].Y1) And (Points[B].Y>=Planes[D].Y2)) Or
                            (Points[A].Y>=Planes[D].Y1) And (Points[B].Y<=Planes[D].Y2));
                   PerY2:=(((Points[B].Y<=Planes[D].Y3) And (Points[C].Y>=Planes[D].Y4)) Or
                            (Points[B].Y>=Planes[D].Y3) And (Points[C].Y<=Planes[D].Y4));
                   PerY3:=(((Points[C].Y<=Planes[D].Y3) And (Points[A].Y>=Planes[D].Y4)) Or
                            (Points[C].Y>=Planes[D].Y3) And (Points[A].Y<=Planes[D].Y4));
                   PerX:=PerX1 Or PerX2 Or PerX3;
                   PerY:=PerY1 Or PerY2;
                   If (PerX And PerY) Then Inc(T);
                  End;
               If T=0 Then
               Begin
                    Flag:=False;
                    WriteLn(OutFile,Points[A].X:0:3,' ',Points[A].Y:0:3);
                    Close(OutFile);
                    Halt(0);
               End;
          End;
     If Flag Then WriteLn(OutFile,'OK');
     Close(OutFile);
     Halt(0);
End;

Var
   InFile: Text;
   X: Byte;
   S: Extended;
   Y: Byte;
   XX,YY: Real;
   Step1,Step2: Real;
   Step: Real;
Begin
     Assign(InFile,'fire.in'); Reset(InFile);
     ReadLn(InFile,L);
     ReadLn(InFile,Count);
     For X:=1 To Count Do
     Begin
          Read(InFile,Planes[X].Xb,Planes[X].Yb,Planes[X].Xe,Planes[X].Ye);
     End;
     Close(InFile);
     For X:=1 To Count Do
          CalcRect(X);
     PointsCount:=4;
     Points[1].X:=0; Points[1].Y:=0;
     Points[2].X:=0; Points[2].Y:=L;
     Points[3].X:=L; Points[3].Y:=L;
     Points[4].X:=L; Points[4].Y:=0;
     For X:=1 To Count Do
     Begin
         Inc(PointsCount);
         Points[PointsCount].X:=Planes[X].X1;
         Points[PointsCount].Y:=Planes[X].Y1;
         Inc(PointsCount);
         Points[PointsCount].X:=Planes[X].X2;
         Points[PointsCount].Y:=Planes[X].Y2;
         Inc(PointsCount);
         Points[PointsCount].X:=Planes[X].X3;
         Points[PointsCount].Y:=Planes[X].Y3;
         Inc(PointsCount);
         Points[PointsCount].X:=Planes[X].X4;
         Points[PointsCount].Y:=Planes[X].Y4;
         For Y:=X+1 To Count Do
         Begin
              If (((Planes[X].X1<=Planes[Y].X1) And (Planes[X].X2>=Planes[Y].X2)) Or
                  ((Planes[X].X1>=Planes[Y].X1) And (Planes[X].X2<=Planes[Y].X2)) And
                  ((Planes[X].Y1>=Planes[Y].Y1) And (Planes[X].Y2<=Planes[Y].Y2) Or
                  (Planes[X].Y1<=Planes[Y].Y1) And (Planes[X].Y2>=Planes[Y].Y2))
                  ) Then
                 Begin
                      If Abs(Planes[X].Y2-Planes[X].Y1)>Abs(Planes[Y].Y2-Planes[Y].Y1) Then
                      Begin
                           Step1:=(Planes[Y].X2-Planes[Y].X1)/(Planes[Y].Y2-Planes[Y].Y1+0.00000001);
                           Step2:=(Planes[X].X2-Planes[X].X1)/(Planes[X].Y2-Planes[X].Y1+0.00000001);
                           Step:=4;
                           YY:=0;
                           While Abs((YY*Step1+Planes[Y].X1)-(YY*Step2+Planes[X].X1))>0.00001 Do
                           Begin
                               If Abs((YY*Step1+Planes[Y].X1)-(YY*Step2+Planes[X].X1))
                                  >Abs(((YY+Step)*Step1+Planes[Y].X1)-((YY+Step)*Step2+Planes[X].X1)) Then YY:=YY+Step
                                                                                                      Else YY:=YY-Step;
                                Step:=Step/1.1;
                           End;
                           XX:=(YY*Step2+Planes[X].X1);
                           Inc(PointsCount);
                           Points[PointsCount].X:=XX;
                           Points[PointsCount].Y:=YY+Planes[Y].Y1;
                      End
                      Else
                      Begin
                           Step1:=(Planes[Y].X2-Planes[Y].X1)/(Planes[Y].Y2-Planes[Y].Y1+0.00000001);
                           Step2:=(Planes[X].X2-Planes[X].X1)/(Planes[X].Y2-Planes[X].Y1+0.00000001);
                           Step:=4;
                           YY:=0;
                           While Abs((YY*Step1+Planes[Y].X1)-(YY*Step2+Planes[X].X1))>0.00001 Do
                           Begin
                               If Abs((YY*Step1+Planes[Y].X1)-(YY*Step2+Planes[X].X1))
                                  >Abs(((YY+Step)*Step1+Planes[Y].X1)-((YY+Step)*Step2+Planes[X].X1)) Then YY:=YY+Step
                                                                                                      Else YY:=YY-Step;
                                Step:=Step/1.1;
                           End;
                           XX:=(YY*Step2+Planes[X].X1);
                           Inc(PointsCount);
                           Points[PointsCount].X:=XX;
                           Points[PointsCount].Y:=YY+Planes[Y].Y1;
                      End;
                      Points[PointsCount].X:=XX;
                      Points[PointsCount].Y:=YY;
                 End;
              If (((Planes[X].X1<=Planes[Y].X3) And (Planes[X].X2>=Planes[Y].X3)) Or
                  ((Planes[X].X1>=Planes[Y].X3) And (Planes[X].X2<=Planes[Y].X3)) And
                  ((Planes[X].Y1>=Planes[Y].Y3) And (Planes[X].Y2<=Planes[Y].Y3) Or
                  (Planes[X].Y1<=Planes[Y].Y3) And (Planes[X].Y2>=Planes[Y].Y3))
                  ) Then
                 Begin
                      If Abs(Planes[X].Y2-Planes[X].Y1)>Abs(Planes[Y].Y4-Planes[Y].Y3) Then
                      Begin
                           Step1:=(Planes[Y].X4-Planes[Y].X3)/(Planes[Y].Y4-Planes[Y].Y3+0.00000001);
                           Step2:=(Planes[X].X2-Planes[X].X1)/(Planes[X].Y2-Planes[X].Y1+0.00000001);
                           Step:=4;
                           YY:=0;
                           While Abs((YY*Step1+Planes[Y].X3)-(YY*Step2+Planes[X].X1))>0.00001 Do
                           Begin
                               If Abs((YY*Step1+Planes[Y].X3)-(YY*Step2+Planes[X].X1))
                                  >Abs(((YY+Step)*Step1+Planes[Y].X3)-((YY+Step)*Step2+Planes[X].X1)) Then YY:=YY+Step
                                                                                                      Else YY:=YY-Step;
                                Step:=Step/1.1;
                           End;
                           XX:=(YY*Step2+Planes[X].X1);
                           Inc(PointsCount);
                           Points[PointsCount].X:=XX;
                           Points[PointsCount].Y:=YY+Planes[Y].Y3;
                      End
                      Else
                      Begin
                           Step1:=(Planes[Y].X4-Planes[Y].X3)/(Planes[Y].Y4-Planes[Y].Y3+0.00000001);
                           Step2:=(Planes[X].X2-Planes[X].X1)/(Planes[X].Y2-Planes[X].Y1+0.00000001);
                           Step:=4;
                           YY:=0;
                           While Abs((YY*Step1+Planes[Y].X3)-(YY*Step2+Planes[X].X1))>0.00001 Do
                           Begin
                               If Abs((YY*Step1+Planes[Y].X3)-(YY*Step2+Planes[X].X1))
                                  >Abs(((YY+Step)*Step1+Planes[Y].X3)-((YY+Step)*Step2+Planes[X].X1)) Then YY:=YY+Step
                                                                                                      Else YY:=YY-Step;
                                Step:=Step/1.1;
                           End;
                           XX:=(YY*Step2+Planes[X].X1);
                           Inc(PointsCount);
                           Points[PointsCount].X:=XX;
                           Points[PointsCount].Y:=YY+Planes[Y].Y3;
                      End;
                 End;
              If (((Planes[X].X3<=Planes[Y].X3) And (Planes[X].X4>=Planes[Y].X4)) Or
                  ((Planes[X].X3>=Planes[Y].X3) And (Planes[X].X4<=Planes[Y].X4)) And
                  ((Planes[X].Y3>=Planes[Y].Y3) And (Planes[X].Y4<=Planes[Y].Y4) Or
                  (Planes[X].Y3<=Planes[Y].Y3) And (Planes[X].Y4>=Planes[Y].Y4))
                  ) Then
                 Begin
                      If Abs(Planes[X].Y4-Planes[X].Y3)>Abs(Planes[Y].Y4-Planes[Y].Y3) Then
                      Begin
                           Step1:=(Planes[Y].X4-Planes[Y].X3)/(Planes[Y].Y4-Planes[Y].Y3+0.00000001);
                           Step2:=(Planes[X].X4-Planes[X].X3)/(Planes[X].Y4-Planes[X].Y3+0.00000001);
                           Step:=4;
                           YY:=0;
                           While Abs((YY*Step1+Planes[Y].X3)-(YY*Step2+Planes[X].X3))>0.00001 Do
                           Begin
                               If Abs((YY*Step1+Planes[Y].X3)-(YY*Step2+Planes[X].X3))
                                  >Abs(((YY+Step)*Step1+Planes[Y].X3)-((YY+Step)*Step2+Planes[X].X3)) Then YY:=YY+Step
                                                                                                      Else YY:=YY-Step;
                                Step:=Step/1.1;
                           End;
                           XX:=(YY*Step2+Planes[X].X3);
                           Inc(PointsCount);
                           Points[PointsCount].X:=XX;
                           Points[PointsCount].Y:=YY+Planes[Y].Y3;
                      End
                      Else
                      Begin
                           Step1:=(Planes[Y].X4-Planes[Y].X3)/(Planes[Y].Y4-Planes[Y].Y3+0.00000001);
                           Step2:=(Planes[X].X4-Planes[X].X3)/(Planes[X].Y4-Planes[X].Y3+0.00000001);
                           Step:=4;
                           YY:=0;
                           While Abs((YY*Step1+Planes[Y].X3)-(YY*Step2+Planes[X].X3))>0.00001 Do
                           Begin
                               If Abs((YY*Step1+Planes[Y].X3)-(YY*Step2+Planes[X].X3))
                                  >Abs(((YY+Step)*Step1+Planes[Y].X3)-((YY+Step)*Step2+Planes[X].X3)) Then YY:=YY+Step
                                                                                                      Else YY:=YY-Step;
                                Step:=Step/1.1;
                           End;
                           XX:=(YY*Step2+Planes[X].X3);
                           Inc(PointsCount);
                           Points[PointsCount].X:=XX;
                           Points[PointsCount].Y:=YY+Planes[Y].Y3;
                      End;
                      Points[PointsCount].X:=XX;
                      Points[PointsCount].Y:=YY;
                 End;
              If (((Planes[X].X3<=Planes[Y].X1) And (Planes[X].X4>=Planes[Y].X2)) Or
                  ((Planes[X].X3>=Planes[Y].X1) And (Planes[X].X4<=Planes[Y].X2)) And
                  ((Planes[X].Y3>=Planes[Y].Y1) And (Planes[X].Y4<=Planes[Y].Y2) Or
                  (Planes[X].Y3<=Planes[Y].Y1) And (Planes[X].Y4>=Planes[Y].Y2))
                  ) Then
                 Begin
                      If Abs(Planes[X].Y4-Planes[X].Y3)>Abs(Planes[Y].Y2-Planes[Y].Y1) Then
                      Begin
                           Step1:=(Planes[Y].X2-Planes[Y].X1)/(Planes[Y].Y2-Planes[Y].Y1+0.00000001);
                           Step2:=(Planes[X].X4-Planes[X].X3)/(Planes[X].Y4-Planes[X].Y3+0.00000001);
                           Step:=4;
                           YY:=0;
                           While Abs((YY*Step1+Planes[Y].X1)-(YY*Step2+Planes[X].X3))>0.00001 Do
                           Begin
                               If Abs((YY*Step1+Planes[Y].X1)-(YY*Step2+Planes[X].X3))
                                  >Abs(((YY+Step)*Step1+Planes[Y].X1)-((YY+Step)*Step2+Planes[X].X3)) Then YY:=YY+Step
                                                                                                      Else YY:=YY-Step;
                                Step:=Step/1.1;
                           End;
                           XX:=(YY*Step2+Planes[X].X3);
                           Inc(PointsCount);
                           Points[PointsCount].X:=XX;
                           Points[PointsCount].Y:=YY+Planes[Y].Y1;
                      End
                      Else
                      Begin
                           Step1:=(Planes[Y].X2-Planes[Y].X1)/(Planes[Y].Y2-Planes[Y].Y1+0.00000001);
                           Step2:=(Planes[X].X4-Planes[X].X3)/(Planes[X].Y4-Planes[X].Y3+0.00000001);
                           Step:=4;
                           YY:=0;
                           While Abs((YY*Step1+Planes[Y].X1)-(YY*Step2+Planes[X].X3))>0.00001 Do
                           Begin
                               If Abs((YY*Step1+Planes[Y].X1)-(YY*Step2+Planes[X].X3))
                                  >Abs(((YY+Step)*Step1+Planes[Y].X1)-((YY+Step)*Step2+Planes[X].X3)) Then YY:=YY+Step
                                                                                                      Else YY:=YY-Step;
                                Step:=Step/1.1;
                           End;
                           XX:=(YY*Step2+Planes[X].X3);
                           Inc(PointsCount);
                           Points[PointsCount].X:=XX;
                           Points[PointsCount].Y:=YY+Planes[Y].Y1;
                      End;
                 End;
         End;
     End;
     TriangleTest;
End.