#define MAX					100
#define LEN					32

#include <stdio.h>
#include <mem.h>

void input ();
void solve ();
void output ();
void recurs (int row, int pos);
void init (unsigned char * a);
void add (unsigned char * a, int num);
void shift (unsigned char * a, int num);
int compare (unsigned char * a, unsigned char * b);
void print (unsigned char * a);
void printout (int row, int pos);

int n, matrix [MAX] [3], restore [MAX] [3], inited [MAX] [3], ptr = 0, ans, flag = 0;
unsigned char dyn [MAX] [3] [LEN], last [MAX], zero [MAX], list [MAX + MAX + MAX];
FILE * out;


main ()
 {
	input ();
	solve ();
	output ();

	return (0);
 }


void input ()
 {
	FILE * file = fopen ("class.in", "r");
	fscanf (file, "%d", & n);

	for (int i = 0; i < 3; i ++)
	 for (int j = 0; j < n; j ++)
	  {
		fscanf (file, "%d", & matrix [j] [i]);
		if (matrix [j] [i]) flag = 1;
	  }

	fclose (file);
	init (zero);
 }


void solve ()
 {
	for (int i = 0; i < 3; i ++)
	 for (int j = 0; j < n; j ++)
	  inited [j] [i] = 0;

	dyn [0] [0] [0] = matrix [0] [0];
	dyn [0] [1] [0] = matrix [0] [1];
	dyn [0] [2] [0] = matrix [0] [2];

	recurs (n - 1, 0);
//	recurs (n - 1, 1);
	recurs (n - 1, 2);
 }


void output ()
 {
	out = fopen ("class.out", "w");

	if (flag)
	 {
	  if (compare (dyn [n - 1] [0], dyn [n - 1] [2]) > 0)
		printout (n - 1, 0);
	  else printout (n - 1, 2);

	 fprintf (out, "%d\n", ans + 1);

	 for (int i = 0; i < ptr; i ++)
	  fprintf (out, "%c", list [i]);
	 }
	else
	 {
		fprintf (out, "1\n");

		for (int i = 0; i < n - 1; i ++)
		 fprintf (out, "R");
	 }

	fclose (out);
 }


void recurs (int row, int pos)
 {
	if (row < 0)
	 {
		init (last);
		return;
	 }

	if (inited [row] [pos])
	 {
		memcpy (last, dyn [row] [pos], LEN);
		return;
	 }

	switch (pos)
	 {
		case 0:
		 for (int i = 0; i <= row; i ++)
		  {
			 recurs (i - 1, 2);

			 for (int j = i; j <= row; j ++)
			  shift (last, matrix [j] [2]);

			 for (j = row; j >= i; j --)
			  shift (last, matrix [j] [1]);

			 for (j = i; j <= row; j ++)
			  shift (last, matrix [j] [0]);

			 if ((compare (dyn [row] [pos], last) < 0) || (! inited [row] [pos]))
			  {
				 memcpy (dyn [row] [pos], last, LEN);
				 restore [row] [pos] = i; inited [row] [pos] = 1;
			  }
		  }
		break;
		case 2:
		 for (i = 0; i <= row; i ++)
		  {
			 recurs (i - 1, 0);

			 for (int j = i; j <= row; j ++)
			  shift (last, matrix [j] [0]);

			 for (j = row; j >= i; j --)
			  shift (last, matrix [j] [1]);

			 for (j = i; j <= row; j ++)
			  shift (last, matrix [j] [2]);

			 if ((compare (dyn [row] [pos], last) < 0) || (! inited [row] [pos]))
			  {
				 memcpy (dyn [row] [pos], last, LEN);
				 restore [row] [pos] = i; inited [row] [pos] = 1;
			  }
		  }
	 }

	memcpy (last, dyn [row] [pos], LEN);
 }


void init (unsigned char * a)
 {
	memset (a, 0, LEN);
 }


void add (unsigned char * a, int num)
 {
	for (int i = 0; (i < LEN) && num; i ++)
	 {
		num += a [i];
		a [i] = num % 256;
		num >>= 8;
	 }
 }


void shift (unsigned char * a, int num)
 {
	for (int i = LEN - 1; i >= 0; i --)
	 a [i] = (int) (a [i] << 1) + ((i ? (int) a [i - 1] : 0) >> 7);

	add (a, num);
 }


int compare (unsigned char * a, unsigned char * b)
 {
	for (int i = LEN - 1; i >= 0; i --)
	 {
	  if (a [i] < b [i]) return (-1);
	  if (a [i] > b [i]) return (1);
	 }

	return (0);
 }

void print (unsigned char * a)
 {
	for (int i = LEN - 1; i >= 0; i --)
	 {
		if (a [i] >> 7) printf ("1");
		else printf ("0");

		if ((a [i] >> 6) % 2) printf ("1");
		else printf ("0");

		if ((a [i] >> 5) % 2) printf ("1");
		else printf ("0");

		if ((a [i] >> 4) % 2) printf ("1");
		else printf ("0");

		if ((a [i] >> 3) % 2) printf ("1");
		else printf ("0");

		if ((a [i] >> 2) % 2) printf ("1");
		else printf ("0");

		if ((a [i] >> 1) % 2) printf ("1");
		else printf ("0");

		if (a [i] % 2) printf ("1");
		else printf ("0");
	 }

	printf ("\n\n");
 }


void printout (int row, int pos)
 {
	if (row < 0)
	 {
		ans = pos;
		return;
	 }
//	if (compare (dyn [row] [pos], zero) == 0)
//	 return;

	printout (restore [row] [pos] - 1, (pos ? 0 : 2));

	for (int i = (restore [row] [pos] ? restore [row] [pos] : restore [row] [pos] + 1); i <= row; i ++)
	 list [ptr ++] = 'R';

	if (pos == 2)
	 list [ptr ++] = 'D';
	else list [ptr ++] = 'U';

	for (i = restore [row] [pos]; i <= row - 1; i ++)
	 list [ptr ++] = 'L';

	if (pos == 2)
	 list [ptr ++] = 'D';
	else list [ptr ++] = 'U';

	for (i = restore [row] [pos]; i <= ((row - 1 < n - 1) ? (row - 1): (n - 1)); i ++)
	 list [ptr ++] = 'R';
 }