#define EPS				1e-8
#define MAX				110

#include <stdio.h>
#include <math.h>
#include <mem.h>


void input ();
void solve ();
void output ();
void count (long double x1, long double y1, long double x2, long double y2, long double d);
void add ();
long double square (int poly);


int n, l, m, polys = 1, vertex [MAX], flag = 0, been [MAX];
long double xa [MAX], xb [MAX], ya [MAX], yb [MAX], huge xpoly [MAX] [MAX], huge ypoly [MAX] [MAX], x [MAX], y [MAX];
long double A, B, C, A1, A2, B1, B2, C1, C2, ansx = 0, ansy = 0;


main ()
 {
//	printf ("\n\n\n\n");
	input ();
	solve ();
	output ();

	return (0);
 }


void input ()
 {
	long double temp;
	FILE * file = fopen ("fire.in", "r");
	fscanf (file, "%d %d", & l, & n);

	for (int i = 0; i < n; i ++)
	 {
		fscanf (file, "%Lf %Lf %Lf %Lf", & xa [i], & ya [i], & xb [i], & yb [i]);

		if (ya [i] > yb [i])
		 {
			temp = xa [i]; xa [i] = xb [i]; xb [i] = temp;
			temp = ya [i]; ya [i] = yb [i]; yb [i] = temp;
		 }
	 }

	fclose (file);
 }


void solve ()
 {
	vertex [0] = 4;
	xpoly [0] [0] = xpoly [0] [1] = 0;
	xpoly [0] [2] = xpoly [0] [3] = l;
	ypoly [0] [0] = ypoly [0] [3] = 0;
	ypoly [0] [1] = ypoly [0] [2] = l;

	for (int i = 0; i < n; i ++)
	 {
	 memset (been, 0, MAX << 1);

	 for (int j = 0; j < polys; j ++)
	  if (! been [j])
	  {
		 m = vertex [j];
		 memcpy (x, xpoly [j], m * sizeof (long double));
		 memcpy (y, ypoly [j], m * sizeof (long double));

		 if (m != polys - 1)
		  {
			 memcpy (xpoly [j], xpoly [polys - 1], MAX * sizeof (long double));
			 memcpy (ypoly [j], ypoly [polys - 1], MAX * sizeof (long double));
			 vertex [j] = vertex [polys - 1];
		  }
		 polys --;

		 count (xa [i], ya [i], xb [i], yb [i], -50.);
		 A1 = A; B1 = B; C1 = C; add ();
		 count (xa [i], ya [i], xb [i], yb [i], 50.);
		 A2 = A; B2 = B; C2 = C; add ();

		 vertex [polys] = vertex [polys + 1] = 0;
/*
		 for (int k = 0; k < m; k ++)
		  {
			if ((A1 * x [k] + B1 * y [k] + C1 >= -EPS) && (xa [i] >= xb [i]))
			 {
				xpoly [polys] [vertex [polys]] = x [k];
				ypoly [polys] [vertex [polys] ++] = y [k];
			 }
			if ((A2 * x [k] + B2 * y [k] + C2 >= -EPS) && (xa [i] <= xb [i]))
			 {
				xpoly [polys + 1] [vertex [polys + 1]] = x [k];
				ypoly [polys + 1] [vertex [polys + 1] ++] = y [k];
			 }
			if ((A2 * x [k] + B2 * y [k] + C2 <= EPS) && (xa [i] >= xb [i]))
			 {
				xpoly [polys + 1] [vertex [polys + 1]] = x [k];
				ypoly [polys + 1] [vertex [polys + 1] ++] = y [k];
			 }
			if ((A1 * x [k] + B1 * y [k] + C1 <= EPS) && (xa [i] <= xb [i]))
			 {
				xpoly [polys] [vertex [polys]] = x [k];
				ypoly [polys] [vertex [polys] ++] = y [k];
			 }
		  }
*/
		 for (int k = 0; k < m; k ++)
		  {
			if ((A1 * x [k] + B1 * y [k] + C1 <= EPS) && (A2 * x [k] + B2 * y [k] + C2 <= EPS))// &&
//			 (! ((fabsl (xpoly [polys] [vertex [polys] - 1] - x [k]) < EPS) && (fabsl (ypoly [polys] [vertex [polys] - 1] - y [k]) < EPS)))
			 {
				xpoly [polys] [vertex [polys]] = x [k];
				ypoly [polys] [vertex [polys] ++] = y [k];
			 }
			if ((A1 * x [k] + B1 * y [k] + C1 >= -EPS) && (A2 * x [k] + B2 * y [k] + C2 >= -EPS))//) &&
//			 (! ((fabsl (xpoly [polys + 1] [vertex [polys + 1] - 1] - x [k]) < EPS) && (fabsl (ypoly [polys + 1] [vertex [polys + 1] - 1] - y [k]) < EPS)
			 {
				xpoly [polys + 1] [vertex [polys + 1]] = x [k];
				ypoly [polys + 1] [vertex [polys + 1] ++] = y [k];
			 }
		  }

		 if (! vertex [polys])
		  {
			 memcpy (xpoly [polys], xpoly [polys + 1], MAX * sizeof (long double));
			 memcpy (ypoly [polys], ypoly [polys + 1], MAX * sizeof (long double));
			 vertex [polys] = vertex [polys + 1];

			 if (vertex [polys]) polys ++, been [polys - 1] = 1;
		  }
		 else
		  {
			 polys ++; been [polys - 1] = 1;

			if (vertex [polys]) polys ++, been [polys - 1] = 1, j --;
		  }
	  }
	 }

	for (i = 0; i < polys; i ++)
	 if (square (i) > EPS)
	  {
		 for (int j = 0; j < vertex [i]; j ++)
		  {
			 ansx += xpoly [i] [j];
			 ansy += ypoly [i] [j];
//			 printf ("%Lf %Lf\n", xpoly [i] [j], ypoly [i] [j]);
		  }

//		 printf ("\n");
		 ansx /= (long double) vertex [i];
		 ansy /= (long double) vertex [i];
		 flag = 1; return;
	  }
 }


void output ()
 {
	FILE * file = fopen ("fire.out", "w");

	if (! flag)
	 fprintf (file, "OK");
	else
	 fprintf (file, "%.3Lf %.3Lf", ansx, ansy);

	fclose (file);
 }


long double square (int poly)
 {
	long double ans = 0;

	for (int i = 0; i < vertex [poly]; i ++)
	 ans += (xpoly [poly] [(i + 1) % vertex [poly]] - xpoly [poly] [i]) *
			  (ypoly [poly] [(i + 1) % vertex [poly]] + ypoly [poly] [i]);

	return (fabsl (ans / 2.));
 }


void count (long double x1, long double y1, long double x2, long double y2, long double d)
 {
	if (fabsl (x1 - x2) < EPS)
	 A = 1, B = 0, C = -x1 - d;
	else if (fabsl (y1 - y2) < EPS)
	 A = 0, B = 1, C = -y1 - d;
	else A = (y1 - y2) / (x1 - x2), B = -1, C = y1 - A * (x1 + d);
 }


void add ()
 {
	long double A1 = A, B1 = B, C1 = C, D, xx, yy;

	for (int i = 0; i < m; i ++)
	 {
		count (x [i], y [i], x [(i + 1) % m], y [(i + 1) % m], 0);
		D = A*B1 - A1*B;

		if (fabsl (D) < EPS) continue;

		xx = (B * C1 - B1 * C) / D;
		yy = (A1 * C - A * C1) / D;

		if (fabsl (x [i] - x [(i + 1) % m]) > EPS)
		 {
		if (x [i] < x [(i + 1) % m])
		 {
		  if ((xx < x [i]) || (xx > x [(i + 1) % m]))
			continue;
		 }
		else
		  if ((xx < x [(i + 1) % m]) || (xx > x [i]))
			continue;
		 }
		else
		 {
		if (y [i] < y [(i + 1) % m])
		 {
		  if ((yy < y [i]) || (yy > y [(i + 1) % m]))
			continue;
		 }
		else
		  if ((yy < y [(i + 1) % m]) || (yy > y [i]))
			continue;
		 }

		memmove (x + i + 2, x + i + 1, (m - i) * sizeof (long double));
		memmove (y + i + 2, y + i + 1, (m - i) * sizeof (long double));
		x [i + 1] = xx; y [i + 1] = yy; i ++; m ++;
	 }
 }
