#define MAX					1024

#include <stdio.h>
#include <mem.h>


void input ();
void solve ();
void output ();
void wave (int vertex);
int recurs (int vertex);
void put1 (int a, int b);
void put0 (int a, int b);
int get (int a, int b);

int power [MAX], ans = 0, been [MAX], list [MAX * 10], ptr = 0, n, k;
char huge matrix [MAX] [150];


main ()
 {
	input ();
	solve ();
	output ();

	return (0);
 }


void input ()
 {
	int temp;

	FILE * file = fopen ("castle.in", "r");
	fscanf (file, "%d %d", & n, & k);
	memset (power, 0, n << 1);

	for (int i = 0; i < n; i ++)
	 for (int j = 0; j< 150; j ++)
	  matrix [i] [j] = 0;

	for (i = 0; i < n; i ++)
	 {
		for (int j = 0; 1; j ++)
		 {
			fscanf (file, "%d", & temp);

			if (! temp) break;
			if (temp - 1 == i) continue;
			power [i] ++; power [temp - 1] ++;
			put1 (i, temp - 1); put1 (temp - 1, i);
		 }
	 }

	fclose (file);
 }


void solve ()
 {
	memset (been, 0, n << 1);
	wave (k - 1);

	for (int i = 0; i < n; i ++)
	 if (been [i] && (power [i] % 4)) ans = 1;

	if (! ans) return;

	memset (been, 0, n << 1);
	recurs (k - 1);
 }


void output ()
 {
	FILE * file = fopen ("castle.out", "w");

	if (ans)
	 {
		fprintf (file, "Yes\n%d\n", ptr - 1);

		for (int i = ptr - 1; i >= 0; i --)
		 fprintf (file, "%d ", list [i] + 1);
	 }
	else fprintf (file, "No");

	fclose (file);
 }


void wave (int vertex)
 {
	been [vertex] = 1;

	for (int i = 0; i < n; i ++)
	 if ((! been [i]) && get (vertex, i))
	  wave (i);
 }


int recurs (int vertex)
 {
	int flag = 0;

	for (int i = 0; i < n; i ++)
	 if (get (vertex, i))
	  {
		 flag = 1;
		 put0 (vertex, i); put0 (i, vertex);

		 if (recurs (i))
		  {
			 list [ptr ++] = vertex;
			 return (1);
		  }

		 put1 (vertex, i); put1 (i, vertex);
	  }

	if ((! flag) && (vertex != k - 1))
	 {
		list [ptr ++] = vertex;
		return (1);
	 }
	else return (0);
 }


void put1 (int a, int b)
 {
	switch (b % 8)
	 {
		case 0: matrix [a] [b >> 3] |= 1; break;
		case 1: matrix [a] [b >> 3] |= 2; break;
		case 2: matrix [a] [b >> 3] |= 4; break;
		case 3: matrix [a] [b >> 3] |= 8; break;
		case 4: matrix [a] [b >> 3] |= 16; break;
		case 5: matrix [a] [b >> 3] |= 32; break;
		case 6: matrix [a] [b >> 3] |= 64; break;
		case 7: matrix [a] [b >> 3] |= 128; break;
	 }
 }


void put0 (int a, int b)
 {
	switch (b % 8)
	 {
		case 0: matrix [a] [b >> 3] &= 254; break;
		case 1: matrix [a] [b >> 3] &= 253; break;
		case 2: matrix [a] [b >> 3] &= 251; break;
		case 3: matrix [a] [b >> 3] &= 247; break;
		case 4: matrix [a] [b >> 3] &= 239; break;
		case 5: matrix [a] [b >> 3] &= 223; break;
		case 6: matrix [a] [b >> 3] &= 191; break;
		case 7: matrix [a] [b >> 3] &= 127; break;
	 }
 }


int get (int a, int b)
 {
	switch (b % 8)
	 {
		case 0: return (matrix [a] [b >> 3] & 1);
		case 1: return (matrix [a] [b >> 3] & 2);
		case 2: return (matrix [a] [b >> 3] & 4);
		case 3: return (matrix [a] [b >> 3] & 8);
		case 4: return (matrix [a] [b >> 3] & 16);
		case 5: return (matrix [a] [b >> 3] & 32);
		case 6: return (matrix [a] [b >> 3] & 64);
		case 7: return (matrix [a] [b >> 3] & 128);
	 }
 }
