{$A+,B-,D+,E-,F-,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,358400}
const maxVertex=103;
maxPoly=430;
eps:single=1E-7;
type
tLine=
  record
    a,b,c:single;
  end;
pPoly=^tPoly;
tPoly=
  record
    nVertex:integer; { -1 }
    v:array[1..maxVertex]of record x,y:single; end;
  end;
tPolyQueue=
  object
    startPoly,nPoly:integer;
    polys:array[0..maxPoly-1]of pPoly;
    procedure init;
    procedure done;
    procedure put(var p:tPoly);
    procedure get(var p:tPoly);
    procedure flyAirPlane(var l:tLine);
  end;
function polyArea(var p:tPoly):single;
var s:single;
i:integer;
begin
  for i:=1 to p.nVertex do
    begin
      s:=s+(p.v[i mod p.nVertex+1].x-p.v[i].x)*(p.v[i mod p.nVertex+1].y+p.v[i].y)
    end;
  polyArea:=s*0.5;
end;
procedure tPolyQueue.init;
var i:integer;
begin
  for i:=1 to maxPoly do
    new(polys[i-1]);
  startPoly:=0;
  nPoly:=0;
end;
procedure tPolyQueue.done;
var i:integer;
begin
  for i:=1 to maxPoly do
    dispose(polys[i-1]);
end;
procedure tPolyQueue.put(var p:tPoly);
begin
  startPoly:=(startPoly+maxPoly-1)mod maxPoly;
  inc(nPoly);
  polys[startPoly]^:=p;
end;

procedure tPolyQueue.get(var p:tPoly);
begin
  p:=polys[(startPoly+nPoly+maxPoly-1)mod maxPoly]^;
  dec(nPoly);
end;
procedure buildLine(var x1,y1,x2,y2:single;var l:tLine);{left function value >0}
var r:single;
begin
  l.a:=y1-y2;
  l.b:=x2-x1;
  l.c:=x1*y2-x2*y1;
  r:=1/sqrt(l.a*l.a+l.b*l.b);
  l.a:=l.a*R;
  l.b:=l.b*R;
  l.c:=l.c*R;
end;
procedure moveLineLeftTo50(var l:tLine);
var r:single;
begin
  r:=sqrt(l.a*l.a+l.b*l.b);
  l.c:=l.c-r*50.0001;
end;
var timer:longint absolute 0:$046c;
time:longint;
fin:text;
fout:text;
polyList:array[0..1]of tPoly;
q:tPolyQueue;
airPlanes:array[1..100]of tLine;
x1,y1,x2,y2,x,y:single;
l,i,j,n:integer;
procedure overFlow;
var l1,l2:array[1..100]of tLine;
i:integer;
flag:integer;
x,y:single;
begin
  for i:=1 to n do
    begin
      l1[i]:=airPlanes[i];
      l2[i]:=airPlanes[i];
      moveLineLeftTo50(l1[i]);
      l2[i].a:=-l2[i].a;
      l2[i].b:=-l2[i].b;
      l2[i].c:=-l2[i].c;
      moveLineLeftTo50(l2[i]);
    end;
  repeat
    x:=random*l;
    y:=random*l;
    flag:=0;
    for i:=1 to n do
      begin
        if l1[i].a*x+l1[i].b*y+l1[i].c<=-eps then
          begin
            flag:=1;break;
          end;
        if l2[i].a*x+l2[i].b*y+l2[i].c<=-eps then
          begin
            flag:=1;break;
          end;
      end;
    if flag=0 then
      begin
        writeln(fout,x:4:4,' ',y:4:4);
        close(fout);
        halt;
      end;
  until timer>time+72000;
  writeln(fout,'OK');
  close(fout);
  halt;
end;
function intersectLines(var l1,l2:tLine;var x,y:single):boolean;
var r:single;
begin
  interSectLines:=false;
  r:=l1.a*l2.b-l2.a*l1.b;
  if abs(r)>=eps then
    begin
      intersectLines:=true;
      r:=1/r;
      x:=(l1.b*l2.c-l1.c*l2.b)*r;
      y:=(l1.c*l2.a-l2.c*l1.a)*r;
    end;
end;
function intersectLine(var x1,y1,x2,y2:single;var l:tLine;var x,y:single):boolean;
var l2:tLine;
minx,maxx,miny,maxy:single;
begin
  interSectLine:=false;
  buildLine(x1,y1,x2,y2,l2);
  if interSectLines(l,l2,x,y) then
    begin
      minx:=x1;maxx:=x2;
      if x2<x1 then
        begin
          maxx:=x1;minx:=x2;
        end;
      miny:=y1;maxy:=y2;
      if y2<y1 then
        begin
          maxy:=y1;miny:=y2;
        end;
      if (x+eps>=minx)and(x<=maxx+eps)and(y+eps>=miny)and(y<=maxy+eps) then
        intersectLine:=true;
    end;
end;
procedure clipPoly(var p:tPoly;var l:tLine);
var p2:tPoly;
i:integer;
x,y:single;
begin
  p2.nVertex:=0;
  for i:=1 to p.nVertex do
    begin
      if l.a*p.v[i].x+l.b*p.v[i].y+l.c>0 then
        begin
          inc(p2.nVertex);
          p2.v[p2.nVertex].x:=p.v[i].x;
          p2.v[p2.nVertex].y:=p.v[i].y;
        end;
      if intersectLine(p.v[i].x,p.v[i].y,p.v[i mod p.nVertex+1].x,p.v[i mod p.nVertex+1].y,l,x,y) then
        begin
          inc(p2.nVertex);
          p2.v[p2.nVertex].x:=x;
          p2.v[p2.nVertex].y:=y;
        end;
    end;
  p:=p2;
end;
procedure tPolyQueue.flyAirPlane(var l:tLine);
var i:integer;
starti,endi:integer;
p:tPoly;
l1,l2:tLine;
begin
  starti:=startPoly;
  endi:=startPoly+nPoly-1;
  l1:=l;
  moveLineLeftTo50(l1);
  l2.a:=-l.a;
  l2.b:=-l.b;
  l2.c:=-l.c;
  moveLineLeftTo50(l2);
  for i:=startI to endI do
    begin
      p:=polys[i mod maxPoly]^;
      clipPoly(p,l1);
      if p.nVertex>=3 then
        begin
          startPoly:=(startPoly+maxPoly-1)mod maxPoly;
          inc(nPoly);
          polys[startPoly]^:=p;
        end;

      p:=polys[i mod maxPoly]^;
      clipPoly(p,l2);
      if p.nVertex>=3 then
        begin
          startPoly:=(startPoly+maxPoly-1)mod maxPoly;
          inc(nPoly);
          polys[startPoly]^:=p;
        end;
{       if nPoly>maxPoly then overFlow;}
    end;
  nPoly:=(startI+maxPoly-startPoly)mod maxPoly;
end;
begin
  time:=timer;
  assign(fin,'fire.in');
  reset(fin);
  readln(fin,l);
  readln(fin,n);
  for i:=1 to n do
    begin
      readln(fin,x1,y1,x2,y2);
      buildLine(x1,y1,x2,y2,airPlanes[i]);
    end;
  close(fin);
{---}
  q.init;

  q.nPoly:=1;
  with q.polys[0]^ do
    begin
      nVertex:=4;
      v[1].x:=0;
      v[1].y:=0;
      v[2].x:=l;
      v[2].y:=0;
      v[3].x:=l;
      v[3].y:=l;
      v[4].x:=0;
      v[4].y:=l;
    end;
  assign(fout,'fire.out');
  rewrite(fout);
  for i:=1 to n do
    q.flyAirPlane(airPlanes[i]);
{  writeln(airPlanes[1].a*x2+airPlanes[1].b*y2+airPlanes[1].c:8:8);}

  if q.nPoly=0 then
    begin
      writeln(fout,'OK');
    end
  else
    begin
      x:=0;y:=0;
      i:=0;
{      maxArea:=-1;
      for j:=0 to q.nPoly-1 do
        if polyArea(q.polys[q.startPoly+i]^)>maxArea
          then
            begin
              maxArea:=polyArea(q.polys[q.startPoly+i]^);
              i:=j;
            end;}
      for i:=1 to q.polys[q.startPoly]^.nVertex do
        begin
          x:=x+q.polys[q.startPoly]^.v[i].x;
          y:=y+q.polys[q.startPoly]^.v[i].y;
        end;
      x:=x/q.polys[q.startPoly]^.nVertex;
      y:=y/q.polys[q.startPoly]^.nVertex;
      writeln(fout,x:4:4,' ',y:4:4);
    end;
  close(fout);
  q.done;
end.
