#include <stdio.h>
#include <math.h>

inline double sqr(double x) {return x*x;}

const double E = 1E-7;
const double W = 50.00001;
double L;
int N;

struct prime           //a*x + b*y = c
{
  double a, b, c;
} P[100];

struct point
{
  double x, y;
} R;
int OK;

void input()
{
  int i;
  FILE *f = fopen("fire.in", "rt");
  fscanf(f, "%lf%d", &L, &N);
  for (i = 0; i < N; i++)
  {
    double x1, y1, x2, y2;
    fscanf(f, "%lf%lf%lf%lf", &x1, &y1, &x2, &y2);
    P[i].a = y2 - y1;
    P[i].b = x1 - x2;
    P[i].c = x1 * y2 - y1 * x2;
    double d = sqrt(sqr(P[i].a) + sqr(P[i].b));
    P[i].a /= d; P[i].b /= d; P[i].c /= d;
  }
  fclose(f);
}

void output()
{
  FILE *f = fopen("fire.out", "wt");
  if (OK) fprintf(f, "OK");
  else fprintf(f, "%.6lf %.6lf", R.x, R.y);
  fclose(f);
}

int Vpoint(point T)
{
  if (T.x < -E || T.x > L + E || T.y < -E || T.y > L + E) return 0;
  int i;
  for (i = 0; i < N; i++)
  {
    if (fabs(P[i].a * T.x + P[i].b * T.y - P[i].c) <= 50) return 0;
  }
  return 1;
}

int main()
{
  int h, i, j, M;
  prime G[500];
  input();
  G[0].a = 1; G[0].b = 0; G[0].c = 0;
  G[1].a = 1; G[1].b = 0; G[1].c = L;
  G[2].a = 0; G[2].b = 1; G[2].c = 0;
  G[3].a = 0; G[3].b = 1; G[3].c = L;
  M = 4;
  for (i = 0; i < N; i++)
  {
    G[M].a = P[i].a; G[M].b = P[i].b; G[M].c = P[i].c + W;
    M++;
    G[M].a = P[i].a; G[M].b = P[i].b; G[M].c = P[i].c - W;
    M++;
  }
  OK = 1;
  for (i = 0; i < M && OK; i++) for (j = 0; j < i && OK; j++)
  {
    double D = G[i].a * G[j].b - G[i].b * G[j].a;
    if (fabs(D) > E)
    {
      point T;
      T.x = (G[i].c * G[j].b - G[i].b * G[j].c) / D;
      T.y = (G[i].a * G[j].c - G[i].c * G[j].a) / D;
      if (Vpoint(T)) {R = T; OK = 0;}
    }
  }
  output();
  return 0;
}