#include <stdio.h>

int N, K;

struct list
{
  int k;
  list *next;

  list(int k1 = 0, list *n1 = 0) : k(k1), next(n1) {}
};

void remove(list *L)
{
  if (L)
  {
    remove(L->next);
    delete L;
  }
}

int getsize(list *L)
{
  if (L) return getsize(L->next) + 1;
  else return 0;
}

list *getnext(list *L)
{
  list *next = L->next;
  delete L;
  return next;
}

list *V[1000], *R, *RE;
int NV[1000];

void input()
{
  int i, p;
  FILE *f = fopen("castle.in", "rt");
  fscanf(f, "%d%d", &N, &K);
  K--;
  for (i = 0; i < N; i++)
  {
    for (;;)
    {
      fscanf(f, "%d", &p);
      if (p)
      {
	V[i] = new list(p - 1, V[i]);
	NV[i]++;
      }
      else break;
    }
  }
  fclose(f);
}

void output()
{
  FILE *f = fopen("castle.out", "wt");
  if (R)
  {
    fprintf(f, "Yes\n%d\n", getsize(R) - 1);
    while(R)
    {
      fprintf(f, "%d ", R->k + 1);
      R = getnext(R);
    }
  }
  else fprintf(f, "No");
  fclose(f);
}

int WP[1010], NWP;
int PT[1010];
int pathD(int a, int b)
{
  if (a == b)
  {
    WP[NWP++] = b;
    return 1;
  }
  else if (PT[b])
  {
    PT[b] = 0;
    int t = -1;
    list *p;
    for (p = V[b]; p; p = p->next)
    {
      if (pathD(a, p->k)) {t = p->k; break;}
    }
    if (t >= 0)
    {
      WP[NWP++] = b;
      return 1;
    }
    else return 0;
  }
  else return 0;
}

int path(int a, int b)
{
  int i;
  NWP = 0;
  for (i = 0; i < N; i++) PT[i] = 1;
  return pathD(a, b);
}

int FN;
void fndnD(int a)
{
  PT[a] = 0;
  list *p;
  for (p = V[a]; p; p = p->next) if (PT[p->k])
  {
    if (NV[p->k] % 2 && (FN < 0 || NV[p->k] < NV[FN])) FN = p->k;
    fndnD(p->k);
  }
}

int fndn()
{
  int i;
  FN = -1;
  for (i = 0; i < N; i++) PT[i] = 1;
  fndnD(K);
  return FN;
}

void delpD(int a, int b)
{
  list *x;
  if (V[a])
  {
    if (V[a]->k == b) V[a] = getnext(V[a]);
    for (x = V[a]; x->next; x = x->next) if (x->next->k == b)
    {
      x->next = getnext(x->next);
    }
  }
}

void delp()
{
  int i;
  for (i = 1; i < NWP; i++)
  {
    delpD(WP[i - 1], WP[i]);
    delpD(WP[i], WP[i - 1]);
  }
}

void addr(int k)
{
  if (!R) R = RE = new list(k);
  else
  {
    RE->next = new list(k);
    RE = RE->next;
  }
}

int main()
{
  int i, j, Z = -1;
  for (i = 0; i < 1000; i++) {V[i] = 0; NV[i] = 0;}
  R = 0; RE = 0;
  input();
/*  for (i = 0; i < N; i++)
  {
    if (i != K && NV[i] % 2 && (Z < 0 || V[i] < V[Z])) Z = i;
  }*/
  Z = fndn();
  if (Z >= 0)
  {
    path(K, Z);
    for (i = 0; i < NWP; i++) addr(WP[i]);
    delp();
    while(V[Z] && V[Z]->next)
    {
      int a = V[Z]->k, b = V[Z]->next->k;
      delpD(a, Z); delpD(b, Z);
      V[Z] = getnext(getnext(V[Z]));
      if (!path(a, K)) {addr(a); break;}
      else if (!path(b, K)) {addr(b); break;}
      else
      {
	path(a, b);
	for (i = 0; i < NWP; i++) addr(WP[i]);
	addr(Z);
	delp();
      }
    }
  }
  output();
  for (i = 0; i < 1000; i++) if (V[i]) remove(V[i]);
  remove(R);
  return 0;
}