{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 65520,0,655360}
{Solution by Denis Pak, reg. # 0607}
type
 TLink = array[1..2] of word;
 TShit = array[1..10000] of boolean;

var
 InFile,OutFile: Text;
 MaxId: word;
 NodesNo: word;
 Weights: array[1..10000] of integer;
 Links: array[1..9999] of TLink;
 LinksNo: word;
 Greatest: word;
 I,K: word;
 Timer: longint absolute $0:$046C;
 ComeTime: longint;

function Empty: boolean;
var
 I: word;
begin
 Empty:=True;
 for I:=1 to NodesNo do
  if Weights[I]>0 then Empty:=False;
end;

procedure DeleteLink(N: word);
begin
 Dec(Weights[Links[N][1]]);
 Dec(Weights[Links[N][2]]);
 Links[N][1]:=0;
 Links[N][2]:=0;
end;

procedure CleanLinks;
var
 LastGood: word;
 I: word;
procedure Renumber;
var
 I: word;
begin
 LastGood:=0;
 for I:=1 to LinksNo do
  if Links[I][1]>0 then LastGood:=I;
 LinksNo:=LastGood;
end;
function IsShit: word;
var
 I: word;
 Result: boolean;
begin
 I:=1;
 Result:=False;
 IsShit:=0;
 while (I<=LinksNo) and (not Result) do begin
  if Links[I][1]=0 then begin
   Result:=True;
   IsShit:=I;
   Exit;
  end;
  Inc(I);
 end;
end;
begin
 Renumber;
 while IsShit>0 do begin
  Links[IsShit]:=Links[LinksNo];
  Links[LinksNo][1]:=0;
  Links[LinksNo][2]:=0;
  Renumber;
 end;
end;

function AnySubZero: word;
var
 I: word;
begin
 AnySubZero:=0;
 for I:=1 to NodesNo do
  if Weights[I]<0 then begin
   AnySubZero:=I;
   Exit;
  end;
end;

procedure Scan(N: word);
var
 Nodes: TShit;
 LastNodes: TShit;
 No: word;
 I,K: word;
function Eq(A,B: TShit): boolean;
var
 I: word;
begin
 Eq:=True;
 for I:=1 to NodesNo do
  if A[I]<>B[I] then begin
   Eq:=False;
   Exit;
  end;
end;
begin
 FillChar(Nodes,SizeOf(Nodes),#0);
 FillChar(LastNodes,SizeOf(LastNodes),#0);
 Nodes[N]:=True;
 repeat
  LastNodes:=Nodes;
  for I:=1 to NodesNo do
   if Nodes[I] then
    for K:=1 to LinksNo do begin
     if Links[K][1]=I then Nodes[Links[K][2]]:=True;
     if Links[K][2]=I then Nodes[Links[K][1]]:=True;
    end;
 until Eq(LastNodes,Nodes);
 No:=0;
 for I:=1 to NodesNo do
  if Nodes[I] then Inc(No);
 if No<MaxId then begin
  for I:=1 to NodesNo do
   if Nodes[I] then begin
    Weights[I]:=0;
    for K:=1 to LinksNo do
     if Links[K][1]=I then DeleteLink(K);
    for K:=1 to LinksNo do
     if Links[K][2]=I then DeleteLink(K);
   end;
  CleanLinks;
 end
 else begin
  for I:=1 to NodesNo do
   if Nodes[I] then Weights[I]:=-Weights[I];
 end;
end;

procedure FuckSolve;
var
 I: word;
begin
 Assign(OutFile,'org.out');
 Rewrite(OutFile);
 Writeln(OutFile,NodesNo);
 for I:=1 to NodesNo-1 do
  Write(OutFile,I,' ');
 Writeln(OutFile,NodesNo);
 Close(OutFile);
end;

procedure Solve;
var
 Answer: array[1..10000] of word;
 AnswerNo: word;
begin
 AnswerNo:=0;
 while not Empty do begin
  Greatest:=0;
  for I:=1 to NodesNo do
   if Weights[I]>0 then
    if (Weights[I]>Weights[Greatest]) or (Greatest=0) then Greatest:=I;
  for I:=1 to LinksNo do
   if Links[I][1]=Greatest then DeleteLink(I);
  for I:=1 to LinksNo do
   if Links[I][2]=Greatest then DeleteLink(I);
  CleanLinks;
  for I:=1 to NodesNo do
   Weights[I]:=-Weights[I];
  {室}
  while AnySubZero>0 do
   Scan(AnySubZero);
  Inc(AnswerNo);
  Answer[AnswerNo]:=Greatest;
  if Timer>=ComeTime then begin
   Assign(OutFile,'org.out');
   Rewrite(OutFile);
   Writeln(OutFile,AnswerNo);
   for I:=1 to AnswerNo-1 do
    Write(OutFile,Answer[I],' ');
   Writeln(OutFile,Answer[AnswerNo]);
   Close(OutFile);
   Halt;
  end;
 end;
 Assign(OutFile,'org.out');
 Rewrite(OutFile);
 Writeln(OutFile,AnswerNo);
 for I:=1 to AnswerNo-1 do
  Write(OutFile,Answer[I],' ');
 Writeln(OutFile,Answer[AnswerNo]);
 Close(OutFile);
end;

begin
 ComeTime:=Timer-10+Round(5*1000/55);
 Assign(InFile,'org.in');
 Reset(InFile);
 Readln(InFile,MaxId);
 Readln(InFile,NodesNo);
 LinksNo:=NodesNo-1;
 FillChar(Links,SizeOf(Links),#0);
 for I:=2 to NodesNo do begin
  Links[I-1][1]:=I;
  Read(InFile,Links[I-1][2]);
 end;
 Close(InFile);
 FillChar(Weights,SizeOf(Weights),#0);
 for I:=1 to LinksNo do begin
  Inc(Weights[Links[I][1]]);
  Inc(Weights[Links[I][2]]);
 end;
 if MaxId=1 then FuckSolve else Solve;
end.