{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 65520,0,655360}
{Solution (c) Denis Pak, reg.#0607}
type
 TPoint = array[1..2] of double;
 TPlane = array[1..2] of TPoint;

const
 Eq=0.001;

var
 InFile,OutFile: Text;
 SqSize: integer;
 PlaneNo: byte;
 Plane: array[1..100] of TPlane;
 I: word;
 Timer: longint absolute $0:$046C;
 BreakTime: longint;

procedure Init;
begin
 BreakTime:=Timer+Round((1000/55)*5-10);
 Assign(InFile,'fire.in');
 Reset(InFile);
 Readln(InFile,SqSize);
 Readln(InFile,PlaneNo);
 for I:=1 to PlaneNo do
  Readln(InFile,Plane[I][1][1],Plane[I][1][2],Plane[I][2][1],Plane[I][2][2]);
 Close(InFile);
end;

function Distance(A,B: TPoint): double;
begin
 Distance:=Sqrt(Sqr(A[1]-B[1])+Sqr(A[2]-B[2]));
end;

function doubleMore(A,B: double): boolean;
begin
 doubleMore:=A-B>Eq;
end;

function Surface(A,B,C: double): double;
var
 P: double;
begin
 P:=(A+B+C)/2;
 Surface:=Sqrt(P*(P-A)*(P-B)*(P-C));
end;

procedure ExitOK;
begin
 Assign(OutFile,'fire.out');
 Rewrite(OutFile);
 Writeln(OutFile,'OK');
 Close(OutFile);
 Halt;
end;

function Inside(P: TPlane; Point: TPoint): boolean;
var
 High: double;
 A,B,C: double;
 uK,uB: double;
 pA,pB: TPoint;
begin
 if P[1][1]=P[2][1] then begin
  Inside:=not doubleMore(Abs(Point[1]-P[1][1]),50);
 end
 else begin
  uK:=(P[1][2]-P[2][2])/(P[1][1]-P[2][1]);
  uB:=P[1][2]-uK*P[1][1];
  pA[1]:=0;
  pA[2]:=pA[1]*uK+uB;
  pB[1]:=SqSize;
  pB[2]:=pB[1]*uK+uB;
  A:=Distance(pA,Point);
  B:=Distance(pB,Point);
  C:=Distance(pA,pB);
  High:=(2*Surface(A,B,C))/C;
  Inside:=not doubleMore(High,50);
 end;
end;

function Present(P: TPoint): boolean;
var
 I: byte;
begin
 Present:=False;
 if Timer>=BreakTime then ExitOK;
 for I:=1 to PlaneNo do
  if Inside(Plane[I],P) then begin
   Present:=True;
   Exit;
  end;
end;

procedure ExitCoord(P: TPoint);
begin
 Assign(OutFile,'fire.out');
 Rewrite(OutFile);
 Writeln(OutFile,P[1]:0:3,' ',P[2]:0:3);
 Close(OutFile);
 Halt;
end;

procedure Solve(Seed: double);
var
 TestPoint: TPoint;
 X,Y: double;
begin
 X:=0.001;
 while X<=SqSize do begin
  Y:=0.001;
  while Y<=SqSize do begin
   TestPoint[1]:=X;
   TestPoint[2]:=Y;
   if not Present(TestPoint) then ExitCoord(TestPoint);
   Y:=Y+Seed;
  end;
  X:=X+Seed;
 end;
end;

begin
 if False then
  Writeln('Set the controls for the heart of the sun...');
 Init;
 Solve(1);
 Solve(0.1);
 Solve(0.01);
 ExitOK;
end.