{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 65520,0,655360}
Program ForestFire;
Const
  InFile='FIRE.IN';
  OutFile='FIRE.OUT';
  Eps=1E-10;
  Eps2=1E-100;
  MaxN=102;
  Visibility=50;
  Pi=3.14159265358979;
Type
  Float=Extended;
  TPoint=Record X,Y:Float; End;
  TLine=Record A,B,C:Float; End;
Var
  L:Float;
  N:Byte;
  Plane:Array[1..MaxN,0..1]Of TPoint;
  Lines:Array[1..MaxN]Of TLine;
  Angles:Array[1..MaxN]Of Float;
  IsSol:Boolean;
  ResX,ResY:Float;
Procedure LineByPoints(Var P1,P2:TPoint; Var L:TLine);
Var
  Z:Float;
Begin
  L.A:=P2.Y-P1.Y;
  L.B:=P1.X-P2.X;
  If Abs(L.A)<Eps2 Then L.A:=0;
  If Abs(L.B)<Eps2 Then L.B:=0;
  Z:=Sqrt(Sqr(L.A)+Sqr(L.B));
  L.A:=L.A/Z;
  L.B:=L.B/Z;
  L.C:=-(L.A*P1.X+L.B*P1.Y);
End;
Function SideOfPoint(Var P:TPoint; Var L:TLine):Float;
Begin
  SideOfPoint:=L.A*P.X+L.B*P.Y+L.C;
End;
Procedure ShiftLine(Var L:TLine; Delta:Float);
Begin
  L.C:=L.C+Delta;
End;
Function Sign(A:Float):ShortInt;
Begin
  If Abs(A)<Eps Then Sign:=0 Else If A<0 Then Sign:=-1 Else Sign:=1;
End;
Function GetAngle(Var P1,P2:TPoint):Float;
Var
  DX,DY:Float;
Begin
  DX:=P1.X-P2.X;
  DY:=P1.Y-P2.Y;
  Case Sign(DX) Of
    -1:Case Sign(DY) Of
      -1:GetAngle:=Pi+ArcTan(DY/DX);
      0:GetAngle:=Pi;
      1:GetAngle:=Pi-ArcTan(-DY/DX);
    End;
    0:Case Sign(DY) Of
      -1:GetAngle:=3*Pi/2;
      0:GetAngle:=0;
      1:GetAngle:=Pi/2;
    End;
    1:Case Sign(DY) Of
      -1:GetAngle:=2*Pi-ArcTan(-DY/DX);
      0:GetAngle:=0;
      1:GetAngle:=ArcTan(DY/DX);
    End;
  End;
End;
Function CrossLineLine(Var L1,L2:TLine; Var P:TPoint):Boolean;
Var
  Z:Float;
Begin
  Z:=L1.A*L2.B-L1.B*L2.A;
  If Abs(Z)<Eps Then
    CrossLineLine:=False
  Else Begin
    P.X:=(L1.B*L2.C-L1.C*L2.B)/Z;
    P.Y:=(L1.C*L2.A-L1.A*L2.C)/Z;
    CrossLineLine:=True;
  End;
End;
Procedure Load;
Var
  I:Byte;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(L);
  If Not SeekEOF Then Read(N);
  For I:=1 To N Do
    If Not SeekEOF Then
      Read(Plane[I,0].X,Plane[I,0].Y,Plane[I,1].X,Plane[I,1].Y);
  Close(Input);
End;
Function VerifyPoint(Var P:TPoint):Boolean;
Var
  I:LongInt;
Begin
  VerifyPoint:=False;
  If (P.X<-Eps) Or (P.Y<-Eps) Or (P.X>L+Eps) Or (P.Y>L+Eps) Then Exit;
  For I:=1 To N Do
    If Abs(SideOfPoint(P,Lines[I]))<Visibility+Eps Then Exit;
  VerifyPoint:=True;
  IsSol:=True;
  ResX:=P.X;
  ResY:=P.Y;
End;
Function CheckPoint(Var P:TPoint):Boolean;
Var
  Z:Float;
  I:LongInt;
  Dist,A1,BMin,BMax:Float;
  PP:TPoint;
Procedure Enbound(AMin:Float);
Begin
  If BMin>50 Then Begin
    BMin:=AMin-Pi;
    BMax:=AMin;
  End Else Begin
    While Abs(AMin-BMin)>Pi+Eps Do
      If AMin<BMin Then AMin:=AMin+2*Pi Else AMin:=AMin-2*Pi;
    If AMin<BMax Then
      If AMin+Pi<BMax Then BMin:=AMin+Pi Else If AMin>BMin Then BMax:=AMin Else BMax:=BMin;
  End;
  While BMin>2*Pi-Eps Do Begin BMin:=BMin-2*Pi; BMax:=BMax-2*Pi; End;
  While BMin<-Eps Do Begin BMin:=BMin+2*Pi; BMax:=BMax+2*Pi; End;
End;
Begin
  CheckPoint:=False;
  If (P.X<-Eps) Or (P.Y<-Eps) Or (P.X>L+Eps) Or (P.Y>L+Eps) Then Exit;
  BMin:=100;
  If Abs(P.X)<Eps Then Enbound(Pi/2);
  If Abs(P.Y)<Eps Then Enbound(Pi);
  If Abs(P.X-L)<Eps Then Enbound(3*Pi/2);
  If Abs(P.Y-L)<Eps Then Enbound(0);
  For I:=1 To N Do Begin
    Z:=SideOfPoint(P,Lines[I]);
    If Abs(Z)<Visibility-Eps Then Exit;
    If Abs(Z)>Visibility+Eps Then Continue;
    A1:=Angles[I]+Pi/2;
    PP.X:=P.X+Cos(A1)*Visibility;
    PP.Y:=P.Y+Sin(A1)*Visibility;
    If Abs(SideOfPoint(PP,Lines[I]))<Visibility Then
      Enbound(Angles[I])
    Else
      Enbound(Angles[I]-Pi);
  End;
  If BMax>BMin+Eps Then Begin
    A1:=(BMax+BMin)/2;
    Dist:=Visibility;
    While Dist>Eps Do Begin
      PP.X:=P.X+Cos(A1)*Dist;
      PP.Y:=P.Y+Sin(A1)*Dist;
      If VerifyPoint(PP) Then Begin
        CheckPoint:=True;
        Exit;
      End;
      Dist:=Dist/10;
    End;
  End;
End;
Procedure Solve;
Var
  I,J,II,JJ:LongInt;
  L1,L2:TLine;
  P1:TPoint;
Begin
  IsSol:=False;
  For I:=1 To N Do
    LineByPoints(Plane[I,0],Plane[I,1],Lines[I]);
  For I:=1 To N Do
    Angles[I]:=GetAngle(Plane[I,1],Plane[I,0]);
  For I:=1 To N Do
    For II:=0 To 1 Do Begin
      L1:=Lines[I];
      ShiftLine(L1,Visibility*(II*2-1));
      If Abs(L1.B)>Eps Then Begin
        P1.X:=0;
        P1.Y:=-L1.C/L1.B;
        If CheckPoint(P1) Then Exit;
        P1.X:=L;
        P1.Y:=-(L1.C+L1.A*L)/L1.B;
        If CheckPoint(P1) Then Exit;
      End;
      If Abs(L1.A)>Eps Then Begin
        P1.Y:=0;
        P1.X:=-L1.C/L1.A;
        If CheckPoint(P1) Then Exit;
        P1.Y:=L;
        P1.X:=-(L1.C+L1.B*L)/L1.A;
        If CheckPoint(P1) Then Exit;
      End;
      For J:=1 To N Do If I<>J Then
        For JJ:=0 To 1 Do Begin
          L2:=Lines[J];
          ShiftLine(L2,Visibility*(JJ*2-1));
          If CrossLineLine(L1,L2,P1) Then
            If CheckPoint(P1) Then Exit;
        End;
    End;
End;
Procedure Save;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  If IsSol Then
    WriteLn(ResX:0:10,' ',ResY:0:10)
  Else
    WriteLn('OK');
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.