{$A+,B-,D-,E-,F-,G-,I+,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 56384,0,655360}
{.$R+,S+,Q+}
{.$L+,D+}
PROGRAM Task4; (* Task 4 day 2 by Shulyatnikov D. *)

  Const
    inp = 'fire.in';
    out = 'fire.out';
    MaxN = 100;
    MaxL = 1000;
    eps = 1e-5;
    st  : Array [0..7] Of Integer = (1,2,4,8,16,32,64,128);

  Type
    Mat     = Extended;
    TPoint  = Record
                x,y: Mat;
              End;
    TWas    = Array [0..MaxL div 8+1] Of Byte;

  Var
    inf, ouf : Text;
    L, N     : Integer;
    Beg, Lst : Array [1..MaxN] Of TPoint;

    Was      : Array [0..MaxL] Of ^TWas;

    Ok       : Boolean;
    Res      : TPoint;

  Procedure Init;
    Var i: Integer;
  Begin
    Assign(inf, inp); Reset(inf);
     Read(inf, L, N);
     For i := 1 To N Do
      Read(inf, Beg[i].x, Beg[i].y, Lst[i].x, Lst[i].y);
    Close(inf);
  End;

  Function Rav(a,b: Mat): Boolean;
  Begin
    Rav := Abs(a-b) < eps;
  End;

  Procedure Put(i,j: Integer);
    Var q: Integer;
  Begin
    inc(j);
    q := j div 8;
    Was[i]^[q] := Was[i]^[q] Or St[j mod 8];
  End;

  Function Get(i,j: Integer): Boolean;
    Var q: Integer;
  Begin
    inc(j);
    q := j mod 8;
    Get := Was[i]^[j div 8] And St[q] = St[q];
  End;

  Procedure Swap(Var a,b: Mat);
    Var c: Mat;
  Begin
    c := a; a := b; b := c;
  End;

  Function More(a,b: Mat): Boolean;
  Begin
    More := a-b >= eps;
  End;

  Function Correct(a: Mat): Integer;
  Begin
    Correct := Trunc(a) + Ord(Not Rav(a, Trunc(a)));
  End;

  Function Max(a,b: Integer): Integer;
  Begin
    If a > b Then Max := a Else Max := b;
  End;

  Function Min(a,b: Integer): Integer;
  Begin
    If a < b Then Min := a Else Min := b;
  End;

  Procedure Prepare(Var beg, lst: TPoint);
    Var left, right,down,up,i,q, rhor, rver,x,y,qd,qu: Integer;
        sw: TPoint;
        t: Mat;
  Begin
    If More(Beg.x, Lst.x) Then Swap(Beg.x, Lst.x);
    If More(Beg.y, Lst.y) Then Swap(Beg.y, Lst.y);
    left := Correct(Beg.x);
    right := Trunc(Lst.x);
    down := Correct(Beg.y);
    up := Trunc(Lst.y);
    rhor := right-left;
    rver := up-down;
    If rhor = 0 Then
     Begin
       left := Max(left-50, 0);
       right := Min(left+50,l);
       For i := left To right Do
        For q := 0 To L Do Put(i,q);
     End
    Else If rver = 0 Then
     Begin
       down := Max(up-50,0);
       up := Min(up+50,l);
       For i := 0 To L Do
        For q := down To up Do Put(i,q);
     End
    Else
     For i := left To right Do
      Begin
        t := (i-left) / rhor;
        y := Correct(rver*t+down);
        qd := Max(y-50,0);
        qu := Min(y+50,l);
        For q := qd To qu Do Put(i,q);
      End;
  End;

  Function Inside(p, beg, lst: TPoint): Boolean;
    Var t,y: Mat;
  Begin
    t := (p.x - beg.x) / (lst.x-beg.x);
    y := (lst.y-beg.y)*t+beg.y;
    Inside := More(p.y,y-50) And More(y+50,p.y);
  End;

  Function OutSide(Const p: TPoint): Boolean;
    Var i: Integer;
  Begin
    OutSide := False;
    For i := 1 To N Do
     If Rav(Beg[i].x,Lst[i].x) Then
      Begin
        If More(p.x, beg[i].x-50) And More(beg[i].x+50,p.x) Then Exit;
      End
     Else If Inside(p, beg[i], lst[i]) Then Exit;
    OutSide := True;
  End;

  Function SearchRes(x,y: Integer): Boolean;
    Var i,j: Integer; p: TPoint;
  Begin
    SearchRes := True;
    For i := 0 To 999 Do
     For j := 0 To 999 Do
      Begin
        p.x := x+0.001*i;
        p.y := y+0.001*j;
        If OutSide(p) Then
         Begin
           Res := p; Exit;
         End;
      End;
    SearchRes := False;
  End;

  Procedure Solve;
    Var i,j: Longint;
  Begin
    Ok := False;
    For i := 1 To L Do
     Begin
       New(Was[i]);
       FillChar(Was[i]^, SizeOf(Was[i]^), 0);
     End;
    For i := 1 To N Do Prepare(beg[i],lst[i]);
    For i := 0 To L Do
     For j := L Downto 0 Do
      If Not Get(i,j) Then
       If SearchRes(i,j) Then
        Begin
          Ok := True; Exit;
        End;
    For i := 1 To L Do Dispose(Was[i]);
  End;

  Procedure Done;
  Begin
    Assign(ouf, out); Rewrite(ouf);
     If Ok Then Write(ouf, Res.x:0:3,' ',Res.y:0:3)
     Else Write(ouf, 'OK');
    Close(ouf);
  End;

BEGIN
  Init; Solve; Done;
END.