{$A+,B-,D+,E-,F-,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

program ForestFire;
const
	eps = 1e-9;

type
	real = extended;
	TPoint = record x,y:real end;
	pListOfPts = ^TListOfPts;
	TListOfPts = record
		p:TPoint;
		next:pListOfPts;
	end;
	arr = array[1..3000] of TPoint;
	arr2 = array[1..3000] of real;
	parr = ^arr;
	TPolygon = pListOfPts;
	pPolyList = ^TPolyList;
	TPolyList = record
		v:TPolygon;
		next:pPolyList;
		prev:pPolyList;
	end;
	TLine = record
		a,b,c:real;
	end;
	T2Lines = record
		l1,l2:TLine;
	end;

function eq(x,y:real):boolean;
begin
	eq:=(abs(x-y)<=eps);
end;

function PAngle(x,y:real):real;
begin
	if Eq(x,0) then begin
		if y>0 then PAngle:=pi/2 else PAngle:=-pi/2;
	end else if x>0 then begin
		if y>0 then PAngle:=ArcTan(y/x) else PAngle:=2*pi+ArcTan(y/x);
	end else begin
		PAngle:=pi+ArcTan(y/x);
	end;
end;

function PolarAngle(p,o:TPoint):real;
begin
	PolarAngle := PAngle(p.x-o.x,p.y-o.y);
end;

var
	ang:arr2;

procedure QSort(z:parr; zn:word);

	var
		exc:TPoint;

	procedure Sort(l, r: Integer);
	var
		i, j: integer; x,y:real;


	begin
		i := l; j := r; x := ang[(l+r) DIV 2];
		repeat
			while ang[i] < x do i := i + 1;
			while x < ang[j] do j := j - 1;
			if i <= j then
			begin
				y := ang[i]; ang[i] := ang[j]; ang[j] := y;
				exc:=z^[i]; z^[i]:=z^[j]; z^[j]:=exc;
				i := i + 1; j := j - 1;
			end;
		until i > j;
		if l < j then Sort(l, j);
		if i < r then Sort(i, r);
	end;

var
	p:TPoint;
	i:word;

begin
	if zn<2 then exit;
	p.x:=0; p.y:=0;
	For i:=1 to zn do begin p.x:=p.x+z^[i].x; p.y:=p.y+z^[i].y end;
	p.x:=p.x/zn;
	p.y:=p.y/zn;
	for i:=1 to zn do ang[i]:=PolarAngle(z^[i],p);
	sort(1,zn);
end;

procedure MakeLine(a,b:TPoint; var l:TLine);
begin
	l.a:=a.y-b.y;
	l.b:=b.x-a.x;
	l.c:=a.x*b.y-b.x*a.y;
end;

function det(a,b,c,d:real):real;
begin
	det:=a*d-b*c;
end;

function crosslines(var l1,l2:TLine; var p:TPoint):byte;
var
	d,dx,dy:real;
begin
	d:=det(l1.a,l2.a,l1.b,l2.b);
	if eq(d,0) then crosslines:=0
	else begin
		dx:=-det(l1.c,l2.c,l1.b,l2.b);
		dy:=-det(l1.a,l2.a,l1.c,l2.c);
		crosslines:=1;
		p.x:=dx/d;
		p.y:=dy/d;
	end;
end;

function Ge(x,y:real):boolean;
begin
	Ge := Eq(x,y) or (x>=y);
end;
function Le(x,y:real):boolean;
begin
	Le := Eq(x,y) or (x<=y);
end;

function Btw(x,a,b:real):boolean;
begin
	Btw := ( Ge(x,a) and Ge(b,x) ) or ( Le(x,a) and Le(b,x) );
end;

function PBtw(p,p1,p2:TPoint):boolean;
begin
	PBtw := Btw(p.x,p1.x,p2.x) and Btw(p.y,p1.y,p2.y);
end;

function Coef(p:TPOint; l:TLine):real;
begin
	with p,l do Coef:=a*x+b*y+c;
end;

function Sgn(a:real):shortint;
begin
	If Eq(a,0) then Sgn:=0 else
	if a<0 then Sgn:=-1 else sgn:=1;
end;

Function PBetwL(p:TPoint; l1,l2:TLine):boolean;
var
	s1,s2:shortint;
begin
	s1:=Sgn(Coef(p,l1));
	s2:=Sgn(Coef(p,l2));
	PBetwL := (s1=0)or(s2=0)or(s1<>s2);
end;

function CrossPoly_Line(var p:TPolygon; l:TLine; var p1,p2:TPoint):byte;
	function CrossLine_Vec(p1,p2:TPoint; var p:TPoint):byte;
	var
		l1:TLine;
		b:byte;
	begin
		MakeLine(p1,p2,l1);
		if CrossLines(l1,l,p)=1 then begin
			If PBtw(p,p1,p2) then CrossLine_Vec:=1 else CrossLine_Vec:=0;
		end;
	end;
var
	x,y:TPolygon;
	c:TPoint;
	h:byte;
	i:byte;
begin
	x:=p; i:=0;
	while x<>nil do begin
		y:=x^.next;
		if y=nil then y:=p;
		h:=CrossLine_Vec(x^.p,y^.p,c);
		if h=1 then begin
			if i=0 then begin p1:=c; i:=1 end else begin  p2:=c;i:=2 end;
		end;
		x:=x^.next;
		if i=2 then break;
	end;
	CrossPoly_Line := i;
end;

procedure FillPoly(var z:TPolygon; c:parr; cn:word);
var
	x,y,f:TPolygon;
	i:word;
begin
	x:=z;
	f:=x;
	for i:=1 to cn do begin
		if x<>nil then begin
			x^.p:=c^[i];
		end else begin
			new(y);
			f^.next:=y;
			y^.next:=nil;
			y^.p:=c^[i];
			x:=y;
		end;
		y:=x;
		f:=x;
		x:=x^.next;
	end;
	y^.next:=nil;
	while x<>nil do begin
		y:=x^.next;
		dispose(x);
		x:=y;
	end;
end;

var
	r,o:parr;
	p:pPolyList;

procedure NewPolygon(a:TPolygon);
var
	x:pPolyList;
begin
	new(x);
	x^.v := a;
	x^.next := p;
	x^.prev:=nil;
	if p<>nil then p^.prev := x;
	p := x;
end;

procedure AddPoint(var q:pListOfPts; p:TPoint);
var
	x:pListOfPts;
begin
	new(x);
	x^.p:=p;
	x^.next:=q;
	q:=x;
end;

function CrossPoly(var p:TPolygon; s:T2Lines):boolean;
var
	n1,n2:byte;
	pp:TPoint;
	x,y:TPolygon;
	rj,oj,i:byte;
begin
	rj:=CrossPoly_Line(p,s.l1,r^[1],r^[2]);
	oj:=CrossPoly_Line(p,s.l2,o^[1],o^[2]);
	x:=p;
	while x<>nil do begin
		pp:=x^.p;
		if sgn(coef(pp,s.l1))=-1 then begin
			inc(rj); r^[rj]:=pp;
		end;
		if sgn(coef(pp,s.l2))=-1 then begin
			inc(oj); o^[oj]:=pp;
		end;
		x:=x^.next;
	end;
	qsort(r,rj);
	qsort(o,oj);
	if rj<3 then begin rj:=oj; r^:=o^; oj:=0 end;
	CrossPoly:=false;
	if rj>2 then fillPoly(p,r,rj) else CrossPoly:=true;
	if oj>2 then begin
		y:=nil;
		For i:=1 to oj do
			AddPoint(y,o^[i]);
		NewPolygon(y);
	end;
end;

var
	L:real;

procedure init_pol;
var
	p:TPoint;
	x:pListOfPts;
begin
	x:=nil;
	p.x:=0; p.y:=0; AddPoint(x,p);
	p.x:=0; p.y:=L; AddPoint(x,p);
	p.x:=L; p.y:=L; AddPoint(x,p);
	p.x:=L; p.y:=0; AddPoint(x,p);
	NewPolygon(x);
end;

procedure Normalize(var s:T2Lines);
var
	p1,p2:TPoint;
begin
	if eq(s.l1.b,0) then begin
		with p1,s.l1 do begin y:=0; x:=-c/a; end;
		with p2,s.l2 do begin y:=0; x:=-c/a; end;
	end else begin
		with p1,s.l1 do begin x:=0; y:=-c/b; end;
		with p2,s.l2 do begin x:=0; y:=-c/b; end;
	end;
	if sgn(coef(p2,s.l1))=-1 then
		with s.l1 do begin a:=-a; b:=-b; c:=-c end;
	if sgn(coef(p1,s.l2))=-1 then
		with s.l2 do begin a:=-a; b:=-b; c:=-c end;
end;

procedure DisposePoly(z:TPolygon);
var
	y:TPolygon;
begin
	while z<>nil do begin
		y:=z^.next;
		dispose(z);
		z:=y;
	end;
end;

Procedure DisposeAll(z:pPolyList);
begin
	DisposePoly(z^.v);
	Dispose(z);
end;

var
	z,w:pPolyList;
	zw:TPolygon;
	n,i:byte;
	b,e:TPoint;
	v:TLine;
	s:T2Lines;
	ok,del:boolean;

begin
	new(r);
	new(o);
	fillchar(p,sizeof(p),0);
	assign(input,'fire.in');
	reset(input);
	read(L);
	init_pol;
	Read(n);
	ok:=false;
	for i:=1 to n do begin
		read(b.x,b.y,e.x,e.y);
		MakeLine(b,e,v);
		if eq(b.x,e.x) and eq(e.y,b.y) then begin
			if (eq(b.x,0) and eq(b.y,l)) or (eq(b.x,l) and eq(b.y,0)) then begin
				v.a:=-1; v.b:=1;
			end else begin
				v.a:=1; v.b:=1;
			end;
			with b,v do c:=-a*x-b*y;
		end;
		s.l1:=v; s.l2:=v;
		s.l1.c:=v.c-50*sqrt(v.a*v.a+v.b*v.b);
		s.l2.c:=v.c+50*sqrt(v.a*v.a+v.b*v.b);
		Normalize(s);
		z:=p;
		if z=nil then begin ok:=true; break; end;
		repeat
			w:=z^.next;
			del:=CrossPoly(z^.v,s);
			if del then begin
				if z^.next<>nil then z^.next^.prev:=z^.prev;
				if z^.prev<>nil then z^.prev^.next:=z^.next;
				if z=p then p:=p^.next;
				disposeAll(z);
			end;
			z:=w;
		until z=nil;
	end;
	close(input);
	assign(output,'fire.out');
	rewrite(output);
	if (ok)or(p=nil) then begin
		writeln('OK');
	end else begin
		b.x:=0; b.y:=0;
		n:=0;
		zw:=p^.v;
		while zw<>nil do begin
			b.x:=b.x+zw^.p.x;
			b.y:=b.y+zw^.p.y;
			inc(n);
			zw:=zw^.next;
		end;
		b.x:=b.x/n; b.y:=b.y/n;
		writeln(b.x:0:3,' ',b.y:0:3);
	end;
	close(output);
	dispose(r);
	dispose(o);
end.