{$A+,B-,D+,E-,F-,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

program StoneHendge;
type
	pEdgeList = ^TEdgeList;
	TEdgeList = record
		v:word;
		prev,next:pEdgeList;
	end;
	TVertex = record
		deg:word;
		e:pEdgeList;
	end;
	TGraph = array[1..1000] of TVertex;

procedure AddItem(var p:pEdgeList; value:word);
var
	x:pEdgeList;
begin
	new(x);
	x^.prev:=nil;
	x^.next:=p;
	x^.v:=value;
	if p<>nil then p^.prev:=x;
	p:=x;
end;

var
	g:TGraph;

procedure AddEdge(i,j:word);
begin
	AddItem(g[i].e,j);
end;

procedure DisposeList(l:pEdgeList);
begin
	if l=nil then exit;
	DisposeList(l^.next);
	Dispose(l);
end;

var
	v:array[1..1000] of boolean;

procedure find(i:word);
var
	x:pEdgeList;
begin
	v[i]:=true;
	x:=g[i].e;
	while x<>nil do begin
		if not v[x^.v] then find(x^.v);
		x:=x^.next;
	end;
end;

var
	p:array[1..1000] of word;
	q:array[1..1000] of word;
	w:array[1..1000] of word;
	ql,lp:word;

procedure DeleteEdge(i,j:word);
	procedure Del(var p:pEdgeList);
	begin
		if p^.prev<>nil then p^.prev^.next:=p^.next;
		if p^.next<>nil then p^.next^.prev:=p^.prev;
		if p^.prev=nil then g[i].e:=p^.next;
		Dispose(p);
	end;
var
	x,y:pEdgeList;
begin
	x:=g[i].e;
	while x<>nil do begin
		y:=x^.next;
		if x^.v=j then begin
			Del(x);
			dec(g[i].deg);
			if g[i].deg=0 then g[i].e:=nil;
			break;
		end;
		x:=y;
	end;
end;

procedure BuildPath(t:word);
var
	z:word;
	x,y:pEdgeList;
	qc:word;
	slp:word;
begin
	slp:=lp+1;
	z:=t;
	repeat
		inc(lp);
		p[lp]:=z;
		z:=w[z];
	until z=0;
	for qc:=slp to lp-1 do begin
		DeleteEdge(p[qc],p[qc+1]);
		DeleteEdge(p[qc+1],p[qc]);
	end;
	for qc:=1 to lp div 2 do begin
		z:=p[lp-qc+1];
		p[lp-qc+1]:=p[qc];
		p[qc]:=z;
	end;
end;

procedure cycle(t:word);
var
	vs:array[1..1000] of boolean;
	done:boolean;
	x:pEdgeList;
	e:word;
	qc:word;

begin
	fillchar(vs,sizeof(vs),0);
	fillchar(w,sizeof(w),0);
	qc:=1; ql:=1;
	q[1]:=t;
	e:=0;
	done:=false;
	vs[t]:=true;
	repeat
		x:=g[q[qc]].e;
		while x<>nil do begin
			if not vs[x^.v] then begin
				inc(ql);
				q[ql]:=x^.v;
				w[x^.v]:=q[qc];
				vs[x^.v]:=true;
			end else begin
				if x^.v<>w[q[qc]] then begin
					done:=true;
					e:=x^.v;
					break;
				end;
			end;
			x:=x^.next;
		end;
		if done then break;
		inc(qc);
	until (qc>ql) or done;
	lp:=0;
	BuildPath(e);
	BuildPath(q[qc]);
	DeleteEdge(e,q[qc]);
	DeleteEdge(q[qc],e);
end;

procedure wave(s,t:word);
var
	vs:array[1..1000] of boolean;
	x:pEdgeList;
	done:boolean;
	qc:word;

begin
	fillchar(vs,sizeof(vs),0);
	fillchar(w,sizeof(w),0);
	qc:=1; ql:=1;
	q[1]:=s;
	done:=false;
	vs[s]:=true;
	repeat
		x:=g[q[qc]].e;
		while x<>nil do begin
			if not vs[x^.v] then begin
				inc(ql);
				q[ql]:=x^.v;
				w[x^.v]:=q[qc];
				vs[x^.v]:=true;
				if x^.v = t then begin
					done:=true; break;
				end;
			end;
			x:=x^.next;
		end;
		inc(qc);
	until (qc>ql) or done;
	lp:=0;
	BuildPath(t);
end;

var
	n,sv,ev,i,a:word;
	min:word;
	ok:boolean;
	mp:array[1..20000] of word;
	mpn:word;

begin
	fillchar(g,sizeof(g),0);
	assign(input,'castle.in');
	reset(input);
	read(n);
	read(sv);
	ok:=false;
	min:=5000;
	for i:=1 to n do begin
		read(a);
		while a>0 do begin
			inc(g[i].deg);
			AddEdge(i,a);
			read(a);
		end;
	end;
	close(input);
	fillchar(v,sizeof(v),0);
	find(sv);
	for i:=1 to n do
		if (v[i])and(i<>sv) then begin
			if g[i].deg mod 2=1 then begin
				ok:=true;
				if g[i].deg<min then begin min:=g[i].deg; ev:=i end;
			end;
		end;
	assign(output,'castle.out');
	rewrite(output);
	if ok then begin
		wave(sv,ev);
		mpn:=0;
		for i:=1 to lp do begin inc(mpn); mp[mpn]:=p[i]; end;
		while g[ev].deg>0 do begin
			cycle(ev);
			if lp<4 then ok:=false else begin
				for i:=2 to lp do begin inc(mpn); mp[mpn]:=p[i] end;
			end;
		end;
		if not ok then begin
			fillchar(v,sizeof(v),0);
			find(sv);
			if not v[ev] then ok:=true;
		end;
		if ok then begin
			writeln('Yes');
			writeln(mpn-1);
			for i:=1 to mpn do write(mp[i],' ');
			writeln;
		end;
	end;
	if ok=false then writeln('No');
	close(output);
	for i:=1 to n do
		DisposeList(g[i].e);
end.