#include <stdio.h>
#include <math.h>

#define sqr(x) ((x) * (x))
typedef double arr[300];
arr xb, yb, xe, ye, A, B, C, xA, xB, xC, xp, yp;
int pno, N, L;

int stin( double x, double y )
{
  int i;

  for (i = 0; i < N; i++)
    if (fabs(A[i] * x + B[i] * y + C[i]) + .0000000001
	< 50 * sqrt(A[i] * A[i] + B[i] * B[i]))
      return 1;
  return 0;
}

int stout( double x, double y )
{
  int i;

  for (i = 0; i < N; i++)
    if (fabs(A[i] * x + B[i] * y + C[i])
	<= 50 * sqrt(A[i] * A[i] + B[i] * B[i]) + .0000000001)
      return 0;
  return 1;
}

void add( double x, double y )
{
  if ((x < 0) || (x > L) || (y < 0) || (y > L) || stin(x, y))
    return;
  xp[pno] = x;
  yp[pno] = y;
  pno++;
}

void set( int i, int A, int B, int C )
{
  xA[i] = A;
  xB[i] = B;
  xC[i] = C;
}

int main( void )
{
  int i, j, k, lno;
  double tryx, tryy;

  freopen("fire.in", "r", stdin);
  freopen("fire.out", "w", stdout);
  scanf("%i %i", &L, &N);
  for (i = 0; i < N; i++)
  {
    double Xb, Yb, Xe, Ye;
    double xC1, xC2;

    scanf("%lf %lf %lf %lf", &xb[i], &yb[i], &xe[i], &ye[i]);
    Xb = xb[i];
    Yb = yb[i];
    Xe = xe[i];
    Ye = ye[i];
    xC1 = Xb * Ye - Xe * Yb;
    xC2 = 50 * sqrt(sqr(Xb - Xe) + sqr(Yb - Ye));
    A[i] = xA[2 * i] = xA[2 * i + 1] = Yb - Ye;
    B[i] = xB[2 * i] = xB[2 * i + 1] = Xe - Xb;
    C[i] = xC1;
    xC[2 * i] = xC1 - xC2;
    xC[2 * i + 1] = xC1 + xC2;
  }
  set(2 * N, 1, 0, 0);
  set(2 * N + 1, 1, 0, -L);
  set(2 * N + 2, 0, 1, 0);
  set(2 * N + 3, 0, 1, -L);
  lno = 2 * N + 4;
  for (i = 0; i < lno; i++)
    for (j = i + 1; j < lno; j++)
    {
      double A1 = xA[i], B1 = xB[i], C1 = xC[i],
	     A2 = xA[j], B2 = xB[j], C2 = xC[j];
      double d = A1 * B2 - A2 * B1,
	     dx = C2 * B1 - C1 * B2,
	     dy = C1 * A2 - A1 * C2;

      if (d != 0)
	add(dx / d, dy / d);
    }
  for (i = 0; i < pno; i++)
    if (stout(xp[i], yp[i]))
    {
      printf("%f %f\n", xp[i], yp[i]);
      return 0;
    }
  for (i = 0; i < pno; i++)
    for (j = i + 1; j < pno; j++)
      if (stout(tryx = (xp[i] + xp[j]) / 2,
                tryy = (yp[i] + yp[j]) / 2))
      {
        printf("%f %f\n", tryx, tryy);
        return 0;
      }
  for (i = 0; i < pno; i++)
    for (j = i + 1; j < pno; j++)
      for (k = j + 1; k < pno; k++)
	if (stout(tryx = (xp[i] + xp[j] + xp[k]) / 3,
		  tryy = (yp[i] + yp[j] + yp[k]) / 3))
	{
	  printf("%f %f\n", tryx, tryy);
	  return 0;
	}
  printf("OK\n");
  return 0;
}
