{ த᪠  誮쭨 -࣠ 2001   }
{ ࠪ᪨                                            }
{ : "㣮쭨"                                    }
{ : ३ ⠭                                    }
{ 襭: ३ ⠭                                  }
{ :                                         }

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P+,Q-,R-,S+,T-,V-,X+,Y+}
{$M 65520,0,655360}

program Polygon;

const
  eps = 1e-3;

var
  x, y: array [0..101] of double;
  a, b, c: array [0..201] of double;
  xp, yp, xb, yb: double;
  d: double;
  i, j, k, m, n, best: longint;

function inside(xp, yp: double): boolean;
var
  a, b, c: double;
  i: longint;
begin
  inside := false;
  for i := 1 to n do
  begin
    a := y[i] - y[i + 1];
    b := x[i + 1] - x[i];
    c := - (a * x[i] + b * y[i]);
    d := sqrt(a * a + b * b);
    a := a / d;
    b := b / d;
    c := c / d;
    if a * xp + b * yp + c < -eps then
      exit;
  end;
  inside := true;
end;

function solve(a1, b1, c1, a2, b2, c2: double; var x, y: double): boolean;
var
  d: double;
begin
  d := a1 * b2 - a2 * b1;
  if abs(d) < eps then
  begin
    solve := false;
    exit;
  end;

  x := (c1 * b2 - c2 * b1) / d;
  y := (a1 * c2 - a2 * c1) / d;

  solve := inside(x, y);
end;

function calc(x, y: double): longint;
var
  i, j, r: longint;
  d: double;
  f: boolean;
begin
  r := 0;
  for i := 1 to n do
  begin
    f := true;
    j := 2 * i - 1;
    d := a[j] * x + b[j] * y - c[j];
    if d < -eps then
      f := false;
    j := 2 * i;
    d := a[j] * x + b[j] * y - c[j];
    if d > eps then
      f := false;
    if f then inc(r);
  end;
  calc := r;
end;

begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);

  read(n);
  for i := 1 to n do
    read(x[i], y[i]);
  x[0] := x[n];
  y[0] := y[n];
  x[n + 1] := x[1];
  y[n + 1] := y[1];

  best := 0;
  j := 0;
  for i := 1 to n do
  begin
    inc(j);
    a[j] := x[i + 1] - x[i];
    b[j] := y[i + 1] - y[i];
    c[j] := (x[i] * a[j] + y[i] * b[j]);
    d := sqrt(a[j] * a[j] + b[j] * b[j]);
    a[j] := a[j] / d;
    b[j] := b[j] / d;
    c[j] := c[j] / d;
    inc(j);
    a[j] := x[i + 1] - x[i];
    b[j] := y[i + 1] - y[i];
    c[j] := (x[i + 1] * a[j] + y[i + 1] * b[j]);
    d := sqrt(a[j] * a[j] + b[j] * b[j]);
    a[j] := a[j] / d;
    b[j] := b[j] / d;
    c[j] := c[j] / d;
  end;
  m := j;

  for i := 1 to m do
  begin
    for j := 1 to m do
    begin
      if solve(a[i], b[i], c[i], a[j], b[j], c[j], xp, yp) then
      begin
        k := calc(xp, yp);
        if best < k then
        begin
          best := k;
          xb := xp;
          yb := yp;
        end;
      end;
    end;
  end;

  writeln(best, ' ', xb :0 :4, ' ', yb :0 :4);

  close(input);
  close(output);
end.