/**************************************************************
 * (C) Copyright 2001
 *   Computer Graphics Support Group of 30 Phys-Math Gymnasium
 **************************************************************/

/* FILE NAME   : 13_A.C
 * PROGRAMMER  : Sergey Ivanov (11-2).
 * LAST UPDATE : 04.02.2001
 *
 * No part of this file may be changed without agreement of
 * Computer Graphics Support Group of 30 Phys-Math Gymnasium.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Common types definition */
typedef void VOID;
typedef int BOOL;
typedef char CHAR;
typedef int INT;
typedef short SHORT;
typedef unsigned short USHORT;
typedef long LONG;
typedef unsigned long ULONG;
typedef float FLOAT;

#define TRUE  1
#define FALSE 0

/* Input-output files */
FILE *In, *Out;

/* String line type */
typedef struct tagSLINE
{
  CHAR *Line;
  INT P1, P2;
} SLINE;

#define SL 100

/* Source strings */
CHAR S1[SL + 1], S2[SL + 1];
/* Strings length */
INT M, N;

/* Result strings */
CHAR R1[SL + 1], R2[SL + 1];
/* Result count */
INT ResC = 0;

/* String lines */
SLINE S[SL];
INT C = 0;

/* Process function */
VOID Process( VOID )
{
  CHAR *d = NULL, *e;
  INT pos;

  if (strcmp(S1, S2) == 0)
  {
    ResC = 0;
    strcpy(R1, S1);
    strcpy(R2, S2);
    return;
  }
  if ((d = strstr(S2, S1)) != NULL)
  {
    ResC = strlen(S2) - strlen(S1);
    strcpy(R2, S2);
    e = S2;
    pos = 0;
    while (e != d)
    {
      R1[pos++] = '*';
      e++;
    }
    d = S1;
    while (d != 0)
    {
      R1[pos++] = *e++;
      d++;
    }
    while (*e != 0)
    {
      R1[pos++] = '*';
      e++;
    }
    R1[pos] = 0;
  }
  else if ((d = strstr(S1, S2)) != NULL)
  {
    ResC = strlen(S1) - strlen(S2);
    strcpy(R1, S1);
    e = S1;
    pos = 0;
    while (e != d)
    {
      R2[pos++] = '*';
      e++;
    }
    d = S2;
    while (*d != 0)
    {
      R2[pos++] = *e++;
      d++;
    }
    while (*e != 0)
    {
      R2[pos++] = '*';
      e++;
    }
    R2[pos] = 0;
  }
  else
    ;
} /* End of 'Process' function */

/* The main function */
INT main( VOID )
{
  In = fopen("input.txt", "rt");
  Out = fopen("output.txt", "wt");

  fscanf(In, "%d%d\n", &M, &N);
  fscanf(In, "%s\n", S1);
  fscanf(In, "%s", S2);

  Process();

  fprintf(Out, "%d\n", ResC);
  fprintf(Out, "%s\n", R1);
  fprintf(Out, "%s", R2);

  fclose(In);
  fclose(Out);
  return 0;
} /* End of 'main' function */

/* END OF '13_A.C' FILE */
