{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+}
{$M 65000,0,655360}
const
    InFile='input.txt';
    OutFile='output.txt';
    max=100;
    eps=1e-5;

type
    Tpoint=record
            x,y:real;
        end;

var
    N,maximum:integer;
    v:array[1..(max+1)] of Tpoint;
    minX,minY,maxX,maxY:real;
    Timer:longint absolute $40:$6c;
    BreakTimer:longint;

function eq(r1,r2:real):boolean;
begin
    if abs(r1-r2)<eps then eq:=true
     else eq:=false;
end;

procedure ReadData;
var
    f:text;
    i:integer;
begin
    assign(f,InFile);
    reset(f);
    read(f,N);
    read(f,v[1].x,v[1].y);
    maxX:=v[1].x;
    maxY:=v[1].y;
    minX:=v[1].x;
    minY:=v[1].y;
    for i:=2 to N do begin
        read(f,v[i].x,v[i].y);
        if v[i].x>maxX then maxX:=v[i].x;
        if v[i].x<minX then minX:=v[i].x;
        if v[i].y>maxY then maxY:=v[i].y;
        if v[i].y<minY then minY:=v[i].y;
    end;
    v[N+1]:=v[1];
    close(f);
end;

function ugl(p,p1,p2:Tpoint):integer;
var
    v1,v2:Tpoint;
    c1,c2:real;
begin
    v1.x:=p.x-p1.x;
    v1.y:=p.y-p1.y;
    v2.x:=p2.x-p1.x;
    v2.y:=p2.y-p1.y;
    c1:=v1.x*v2.x+v1.y*v2.y;
    v1.x:=p.x-p2.x;
    v1.y:=p.y-p2.y;
    v2.x:=p1.x-p2.x;
    v2.y:=p1.y-p2.y;
    c2:=v1.x*v2.x+v1.y*v2.y;
    if (eq(c1,0))or(c1>0)and((eq(c2,0))or(c2>0)) then ugl:=1
     else ugl:=0;
end;

function proverka(p:Tpoint):integer;
var
    i,k:integer;
begin
    k:=0;
    for i:=1 to N do k:=k+ugl(p,v[i],v[i+1]);
    proverka:=k;
end;

function InM(p:Tpoint):boolean;
var
    i:integer;
    v1,v2:Tpoint;
    pr,pr1:real;
    bool:boolean;
begin
    bool:=true;
    v1.x:=p.x-v[1].x;
    v1.y:=p.y-v[1].y;
    v2.x:=v[2].x-v[1].x;
    v2.y:=v[2].y-v[1].y;
    pr:=v1.x*v2.y-v2.x*v1.y;
    if not eq(pr,0) then
        for i:=2 to N do begin
            v1.x:=p.x-v[i].x;
            v1.y:=p.y-v[i].y;
            v2.x:=v[i+1].x-v[i].x;
            v2.y:=v[i+1].y-v[i].y;
            pr1:=v1.x*v2.y-v2.x*v1.y;
            if not ((eq(pr*pr1,0))or((pr*pr1)>0)) then bool:=false;
        end;
    InM:=bool;
end;

procedure Result(p:Tpoint);
var
    f:text;
begin
    assign(f,OutFile);
    rewrite(f);
    writeln(f,maximum);
    writeln(f,p.x:0:4,' ',p.y:0:4);
    close(f);
end;

procedure Solve;
var
    i,k:integer;
    p:Tpoint;
begin
    BreakTimer:=round(timer+18.2*8);
    maximum:=0;
    Randomize;
    while (BreakTimer>Timer)and(maximum<N) do begin
        p.x:=random*(maxX-minX)+minX;
        p.y:=random*(maxY-minY)+minY;
        k:=proverka(p);
        if k>maximum then
            if InM(p) then begin
                maximum:=k;
                Result(p);
            end;
    end;
end;

begin
    ReadData;
    Solve;
end.