{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+}
{$M 65000,0,655360}
const
    InFile='input.txt';
    OutFile='output.txt';
    max=10;

type
    Tpole=array[0..(max+1),0..(max+1)]of integer;
    Tcoord=record
            x,y:integer;
        end;
    Tsh=record
            x,y,l:integer;
            vh:boolean; {true-vert,false-hor}
        end;

var
    pole,best:Tpole;
    a:array[1..max]of integer;
    sh:array[1..max]of Tsh;
    step:array[1..(max*max)]of Tcoord;
    P,N,M,pos:integer;

procedure Sort(l, r: Integer);
var
  i, j, x, y: integer;
begin
  i := l; j := r; x := a[(l+r) DIV 2];
  repeat
    while a[i] < x do i := i + 1;
    while x < a[j] do j := j - 1;
    if i <= j then
    begin
      y := a[i]; a[i] := a[j]; a[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;


procedure ReadData;
var
    f:text;
    i,w,h,c:integer;
    ch:char;
    s:string;
begin
    assign(f,InFile);
    reset(f);
    read(f,M,N);
    read(f,P);
    for i:=1 to P do read(f,a[i]);
    readln(f);
    for i:=1 to M*N do begin
        readln(f,s);
        ch:=s[1];
        delete(s,1,1);
        val(s,h,c);
        w:=ord(ch)-ord('a')+1;
        step[i].x:=w;
        step[i].y:=h;
    end;
    close(f);
end;

procedure Result(res:boolean);
var
    f:text;
    i,j:integer;
begin
    assign(f,OutFile);
    rewrite(f);
    if res then begin
        writeln(f,pos);
        for i:=1 to N do begin
            for j:=1 to M do
                if pole[j,i]>0 then write(f,pole[j,i],' ')
                 else write(f,'0 ');
            writeln(f);
        end;
    end
     else begin
        writeln(f,'0');
    end;
    close(f);
    halt;
end;

function Put(num:integer):boolean;
var
    i,j:integer;
    bool:boolean;
begin
    bool:=true;
    if sh[num].vh then begin
        for j:=(sh[num].x-1) to (sh[num].x+1) do
            for i:=(sh[num].y-1) to (sh[num].y+sh[num].l) do begin
                if (j=sh[num].x)and(i>=(sh[num].y))and(i<=(sh[num].y+sh[num].l-1)) then begin
                    if (i>N) then bool:=false
                     else
                        if pole[j,i]<>0 then bool:=false;
                end
                 else begin
                    if (i<=N)and(j<=M) then
                        if pole[j,i]>0 then bool:=false;
                end;
            end;
        if bool then
            for i:=sh[num].y to (sh[num].y+sh[num].l-1) do pole[sh[num].x,i]:=sh[num].l;
    end
     else begin
        for j:=(sh[num].y-1) to (sh[num].y+1) do
            for i:=(sh[num].x-1) to (sh[num].x+sh[num].l) do begin
                if (j=sh[num].y)and(i>=(sh[num].x))and(i<=(sh[num].x+sh[num].l-1)) then begin
                    if (i>M) then bool:=false
                     else
                        if pole[i,j]<>0 then bool:=false;
                end
                 else begin
                    if (i<=M)and(j<=N) then
                        if pole[i,j]>0 then bool:=false;
                end;
            end;
        if bool then
            for i:=sh[num].x to (sh[num].x+sh[num].l-1) do pole[i,sh[num].y]:=sh[num].l;
    end;
    Put:=bool;
end;

procedure Get(num:integer);
var
    i:integer;
begin
    if sh[num].vh then begin
        for i:=sh[num].y to (sh[num].y+sh[num].l-1) do pole[sh[num].x,i]:=0;
    end
     else begin
        for i:=sh[num].x to (sh[num].x+sh[num].l-1) do pole[i,sh[num].y]:=0;
    end;
end;

procedure Gen(num:integer);
var
    i,j:integer;
begin
    if num>P then begin
        best:=pole;
        inc(pos);
        while (pole[step[pos].x,step[pos].y]<=0)and(pos<(M*N)) do begin
            pole[step[pos].x,step[pos].y]:=-1;
            inc(pos);
        end;
        exit;
    end;
    if pos<>0 then begin
        if pole[step[pos].x,step[pos].y]>0 then exit
         else pole[step[pos].x,step[pos].y]:=-1;
    end;
    for i:=1 to N do
        for j:=1 to M do begin
            sh[num].x:=i;
            sh[num].y:=j;
            sh[num].vh:=true;
            if put(num) then begin
                gen(num+1);
                get(num);
            end;
            if pos<>0 then begin
                if pole[step[pos].x,step[pos].y]>0 then exit
                 else pole[step[pos].x,step[pos].y]:=-1;
            end;
            sh[num].vh:=false;
            if put(num) then begin
                gen(num+1);
                get(num);
            end;
            if pos<>0 then begin
                if pole[step[pos].x,step[pos].y]>0 then exit
                 else pole[step[pos].x,step[pos].y]:=-1;
            end;
        end;
end;

procedure Solve;
var
    i,j:integer;
begin
    for i:=1 to N do
        for j:=1 to M do pole[i,j]:=0;
    sort(1,P);
    if (a[p]>m)and(a[p]>n) then Result(false);
    for i:=1 to P do begin
        sh[i].x:=0;
        sh[i].y:=0;
        sh[i].l:=a[P-i+1];
        sh[i].vh:=true;
    end;
    gen(1);
    pole:=best;
    if pos=0 then Result(false)
     else Result(true);
end;

begin
    ReadData;
    Solve;
end.