/*****************************************************************\
* Computer Graphics Support Group of 30 Phys-Math Gymnasium       *
*          PROGRAMMER: Peter Azmanov                              *
*          DATE:       04.03.01                                   *
*          TASK NUMBER:Task A                                     *
*          NOTE:       Memory model for Borland C - LARGE         *
\*****************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAX_LENGTH 2000
#define MIN_LENGTH 1

#define TRUE 0
#define FALSE 1


typedef void VOID;
typedef int  INT;
typedef char CHAR;
typedef int  BOOL;


INT i = 0, L1 = 0, L2 = 0, M = 0;
CHAR *S1, *S2, *MS, *MS1, *WS2;
FILE *F;
BOOL Flag = FALSE;

INT MIN( INT x, INT y )
{
  if (x < y)
    return x;
  return y;
}

INT MAX( INT x, INT y )
{
  if (x > y)
    return x;
  return y;
}

VOID SWAP( INT x, INT y )
{
  INT tmp;

  tmp = x;
  x = y;
  y = tmp;
}

CHAR *AddElement( CHAR *Str, INT Pos, CHAR c, INT length )
{
  INT l;

  if (Pos > strlen(Str))
    return Str;

  WS2 = malloc(length + 1);
  strcpy(WS2, Str);
  if (WS2 == NULL)
    return Str;

  for (l = 0; l < strlen(WS2) + 1; l++)
  {
    if (l == Pos)
      WS2[l] = c;
    if (l < Pos)
      WS2[l] = Str[l];
    if (l > Pos)
      WS2[l] = Str[l - 1];
  }
  Str = malloc(length + 1);
  strcpy(Str, WS2);
  return Str;
}

CHAR *DelElement( CHAR *Str, INT Pos, INT length )
{
  INT l;

  if (Pos > strlen(Str))
    return Str;

  WS2 = malloc(length);
  strcpy(WS2, Str);
  if (WS2 == NULL)
    return Str;

  for (l = 0; l < strlen(WS2); l++)
  {
    if (l == Pos)
      WS2[l] = Str[l + 1];
    if (l < Pos)
      WS2[l] = Str[l];
    if (l > Pos)
      WS2[l] = Str[l + 1];
  }
  Str = malloc(length + 1);
  strcpy(Str, WS2);
  return Str;
}


BOOL OpenInputFile( VOID )
{
  if ((F = fopen("input.txt", "rt")) == NULL)
  {
    printf("Error loading input file!");
    return FALSE;
  }
  fscanf(F, "%d %d", &L1, &L2);
  if (L1 < MIN_LENGTH || L2 < MIN_LENGTH ||
      L1 > MAX_LENGTH || L2 > MAX_LENGTH)
  {
    printf("Not valid size of string!");
    return FALSE;
  }

  if ((S1 = malloc(sizeof(CHAR) * L1)) == NULL)
  {
    printf("Not enough memory to load first string!");
    return FALSE;
  }
  if ((S2 = malloc(sizeof(CHAR) * L2)) == NULL)
  {
    printf("Not enough memory to load second string!");
    return FALSE;
  }
  if ((MS = malloc(sizeof(CHAR) * MAX(L1, L2))) == NULL)
  {
    printf("Not enough memory to create work string!");
    return FALSE;
  }
  if ((MS1 = malloc(sizeof(CHAR) * MAX(L1, L2))) == NULL)
  {
    printf("Not enough memory to create work string!");
    return FALSE;
  }
  fscanf(F, "%s", S1);
  fscanf(F, "%s", S2);
fclose(F);
  return TRUE;
}

BOOL WriteOutputFile( VOID )
{
  if ((F = fopen("output.txt", "wt")) == NULL)
  {
    printf("Error loading output file!");
    return FALSE;
  }
  fprintf(F, "%d\n", M);
  fprintf(F, "%s\n", S1);
  fprintf(F, "%s", S2);
  fclose(F);
  return TRUE;
}
VOID FreeMemory( VOID )
{
  free(S1);
  free(S2);
  free(MS);
  free(MS1);
  free(WS2);
}

INT FindDifferense( CHAR *Str1, CHAR *Str2 )
{
  INT j, sum = 0, len1 = strlen(Str1), len2 = strlen(Str2);

  for (j = 0; j < MAX(len1, len2); j++)
  {
    if (Str1[j] != Str2[j])
      sum++;
  }
  if (len1 != len2)
  {
    sum += abs(len2 - len1);
  }
  return sum;
}

INT FindIfEqual( INT M )
{
  INT l, m, p = 0, count = 0, pf;

  if (M == 0)
    M = FindDifferense(S1, S2);
  for (l = 0; l < strlen(S1); l++)
    for (m = 0; m < strlen(S2); m++)
    {
      if (S2[m] == S1[l] && Flag == FALSE)
      {
        p = m;
        pf = l;
        count++;
        Flag = TRUE;
      }
      if (Flag == TRUE && m >= count)
        if (S1[l] == S2[m] && (m == l - pf || m == l))
        {
          count++;
        }
    }
    for (i = 0; i < MIN(p, pf) + 1; i++)
    {
      if (p < pf)
      {
        MS1 = AddElement(S2, 0, '*', strlen(S2));
        MS = AddElement(S1, strlen(S1), '*', strlen(S1));
      }
      else
      {
        MS = AddElement(S1, 0, '*', strlen(S1));
        MS1 = AddElement(S2, strlen(S2), '*', strlen(S2));
      }
    }
    if (FindDifferense(MS, MS1) < M)
    {
      M = FindDifferense(MS, MS1);
      strcpy(S1, MS);
      strcpy(S2, MS1);
    }
    return M;
}

INT FindMinDifferense( VOID )
{
  INT Dif = 0, Leng = 0, Leng1;
  INT Minimum = 0;

  if (L1 < L2)
    strcpy(MS, S1);
  else
    strcpy(MS, S2);
  Leng = MAX(L1, L2);
  Leng1 = Leng;
  while (strlen(MS) != Leng1)
  {
    Leng++;
    strcpy(MS1, MS);
    if (L1 < L2)
      Dif = FindDifferense(MS1, S2);
    else
      Dif = FindDifferense(MS1, S1);
    Minimum = Dif;
    for (i = 0; i < MAX(L1, L2); i++)
    {
      MS1  = AddElement(MS1, i, '*', Leng);
      if (L1 < L2)
        Dif = FindDifferense(MS1, S2);
      else
        Dif = FindDifferense(MS1, S1);
      if (Dif < Minimum)
        strcpy(MS, MS1);
      Minimum = MIN(Dif, Minimum);
      MS1 = DelElement(MS1, i, Leng);
    }
  }
  if (L1 < L2)
    strcpy(S1, MS);
  else
    strcpy(S2, MS);
  return Minimum;
}


BOOL main( VOID )
{
  INT x;
  BOOL Res;

  Res = OpenInputFile();
  if (Res == FALSE)
    return FALSE;
  M = FindMinDifferense();
  if ((x = FindIfEqual(M)) >= 0)
    M = x;
  Res = WriteOutputFile();
  if (Res == FALSE)
    return FALSE;
  FreeMemory();
  return TRUE;
}