#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define get(n) malloc((n) * sizeof(double))

int fi( double A, double B, double C, double x1, double y1,
        double x2, double y2, double *x, double *y )
{
  double v1 = A * x1 + B * y1 + C, v2;

  if (v1 == 0)
  {
    *x = x1;
    *y = y1;
    return 2;
  }
  v2 = A * x2 + B * y2 + C;
  if (v1 * v2 < 0)
  {
    double Ax = y1 - y2,
           Bx = x2 - x1,
           Cx = x1 * (y2 - y1) + y1 * (x1 - x2);
    double d = A * Bx - Ax * B;
    double dx = -C * Bx + Cx * B, dy = -A * Cx + Ax * C;

    *x = dx /= d;
    *y = dy /= d;
    return 1;
  }
  return 0;
}

int main( void )
{
  int N;
  int i, j;
  double x[101], y[101];
  double *xps[101], *yps[101];
  int size[101];
  int arr[101];

  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  scanf("%i", &N);
  xps[0] = get(N + 1);
  yps[0] = get(N + 1);
  arr[0] = 0;
  for (i = 0; i < N; i++)
    scanf("%lf %lf", &x[i], &y[i]), xps[0][i] = x[i], yps[0][i] = y[i];
  size[0] = N;
  xps[0][N] = xps[0][0];
  yps[0][N] = yps[0][0];
  for (i = 1; i <= N; i++)
  {
    int max = -1, max_no;
    double mx_1, mx_2, mx_3, mx_4, my_1, my_2, my_3, my_4;
    int mn_1, mn_2, mn_3, mn_4;
    int mh1, mh2;

    max = -1;
    for (j = 0; j < i; j++)
    {
      double xp[101], yp[101];
      double A = x[i - 1] - x[i], B = y[i - 1] - y[i],
             C1 = x[i - 1] * (x[i] - x[i - 1]) + y[i - 1] * (y[i] - y[i - 1]),
             C2 = x[i] * (x[i] - x[i - 1]) + y[i] * (y[i] - y[i - 1]);
      double x_1, x_2, x_3, x_4, y_1, y_2, y_3, y_4;
      int n_1, n_2, n_3, n_4;
      int k;
      double v1, v2;
      int has_1, has_2;
      int off = 1;

      for (k = 0; k < size[j]; k++)
        switch (fi(A, B, C1, xps[j][k], yps[j][k],
                   xps[j][k + 1], yps[j][k + 1], &x_1, &y_1))
        {
        case 1:
          n_1 = k + 1;
          k++;
          goto next;
        case 2:
          n_1 = k + 1;
          k++;
          goto next;
        }
      has_1 = 0;
      goto xnext;
    next:
      has_1 = 1;
      for (; k < size[j]; k++)
        switch (fi(A, B, C1, xps[j][k], yps[j][k],
                   xps[j][k + 1], yps[j][k + 1], &x_2, &y_2))
        {
        case 1:
          n_2 = k;
          k++;
          goto xnext;
        case 2:
          n_2 = k - 1;
          k++;
          goto xnext;
        }
    xnext:
      for (k = 0; k < size[j]; k++)
        switch (fi(A, B, C2, xps[j][k], yps[j][k],
                   xps[j][k + 1], yps[j][k + 1], &x_3, &y_3))
        {
        case 1:
          n_3 = k;
          k++;
          goto xxnext;
        case 2:
          n_3 = k - 1;
          k++;
          goto xxnext;
        }
      has_2 = 0;
      goto xxxnext;
    xxnext:
      has_2 = 1;
      for (; k < size[j]; k++)
        switch (fi(A, B, C2, xps[j][k], yps[j][k],
                   xps[j][k + 1], yps[j][k + 1], &x_4, &y_4))
        {
        case 1:
          n_4 = k + 1;
          k++;
          goto xxxnext;
        case 2:
          n_4 = k + 1;
          k++;
          goto xxxnext;
        }
    xxxnext:
      if (!has_1 && !has_2)
      {
         double a1 = A * xps[j][0] + B * yps[j][0] + C1,
                a2 = A * xps[j][0] + B * yps[j][0] + C2;

         off = (a1 * a2 < 0);
      }
      if (max < arr[j] + off)
      {
        max = arr[j] + 1, max_no = j;
        mx_1 = x_1;
        mx_2 = x_2;
        mx_3 = x_3;
        mx_4 = x_4;
        my_1 = y_1;
        my_2 = y_2;
        my_3 = y_3;
        my_4 = y_4;
        mn_1 = n_1;
        mn_2 = n_2;
        mn_3 = n_3;
        mn_4 = n_4;
        mh1 = has_1;
        mh2 = has_2;
      }
    }
    if (mh1 && mh2)
    {
      int si = 6 + mn_2 + mn_3 - mn_1 - mn_4;
      double *xs, *ys;
      int l;

      arr[i] = max;
      size[i] = si;
      xs = xps[i] = get(si + 1);
      ys = yps[i] = get(si + 1);
      xs[0] = mx_1;
      ys[0] = my_1;
      for (l = mn_1; l <= mn_3; l++)
        xs[l - mn_1 + 1] = xps[max_no][l],
        ys[l - mn_1 + 1] = yps[max_no][l];
      xs[mn_3 - mn_1 + 2] = mx_3;
      ys[mn_3 - mn_1 + 2] = my_3;
      xs[mn_3 - mn_1 + 3] = mx_4;
      ys[mn_3 - mn_1 + 3] = my_4;
      for (l = mn_4; l <= mn_2; l++)
        xs[l - mn_4 + mn_3 - mn_1 + 4] = xps[max_no][l],
        ys[l - mn_4 + mn_3 - mn_1 + 4] = yps[max_no][l];
      xs[si - 1] = mx_2;
      ys[si - 1] = my_2;
      xs[si] = xs[0];
      ys[si] = ys[0];
    }
    else if (mh1 && !mh2)
    {
      int si = 3 + mn_2 - mn_1;
      double *xs, *ys;
      int l;

      arr[i] = max;
      size[i] = si;
      xs = xps[i] = get(si + 1);
      ys = yps[i] = get(si + 1);
      xs[0] = mx_1;
      ys[0] = my_1;
      for (l = mn_1; l <= mn_2; l++)
        xs[l - mn_1 + 1] = xps[max_no][l],
        ys[l - mn_1 + 1] = yps[max_no][l];
      xs[si - 1] = mx_2;
      ys[si - 1] = my_2;
      xs[si] = xs[0];
      ys[si] = ys[0];
    }
    else if (!mh1 && mh2)
    {
      int siz = size[max_no];
      int si = 3 + ((mn_4 < mn_3) ? mn_3 - mn_4 : siz - mn_4 + mn_3) + 5;
      double *xs, *ys;
      int l;

      arr[i] = max;
      size[i] = si;
      xs = xps[i] = get(si + 1);
      ys = yps[i] = get(si + 1);
      xs[0] = mx_4;
      ys[0] = my_4;
      if (mn_4 <= mn_3)
        for (l = mn_4; l <= mn_3; l++)
          xs[l - mn_4 + 1] = xps[max_no][l],
          ys[l - mn_4 + 1] = yps[max_no][l];
      else
      {
        for (l = mn_4; l < siz; l++)
          xs[l - mn_4 + 1] = xps[max_no][l],
          ys[l - mn_4 + 1] = yps[max_no][l];
        for (l = 0; l <= mn_3; l++)
          xs[l + siz - mn_4 + 1] = xps[max_no][l],
          ys[l + siz - mn_4 + 1] = yps[max_no][l];
      }
      xs[si - 1] = mx_3;
      ys[si - 1] = my_3;
      xs[si] = xs[0];
      ys[si] = ys[0];
    }
    else
    {
      size[i] = size[max_no];
      xps[i] = get(size[i] + 1);
      yps[i] = get(size[i] + 1);
      memcpy(xps[i], xps[max_no], sizeof(double) * (size[i] + 1));
      memcpy(yps[i], yps[max_no], sizeof(double) * (size[i] + 1));
    }
  }
  printf("%i\n%g %g\n", arr[N], xps[N][0], yps[N][0]);
  return 0;
}
