#include <stdio.h>

#define MAXN 100
#define e 0.0005

int N;
float v[MAXN+1][2];
int P;
float p[2];

int eq(float a, float b)
{
  return ((a-b)<e);
}

void dot(float x11, float y11, float x12, float y12,
         float x21, float y21, float x22, float y22,
         float *x, float *y)
{
  float k, b;
  float k1, b1, k2, b2;
  *x = 0;
  *y = 0;
  if ((y11 == y12) && (y21 == y22)) return;
  if (y11 == y12) {
    k = -(x22-x21)/(y22-y21);
    b = y21 - k*x21;
    *x = x11;
    *y = k*x11+b;
    return;
  }
  if (y21 == y22) {
    k = -(x12-x11)/(y12-y11);
    b = y11 - k*x11;
    *x = x21;
    *y = k*x21+b;
    return;
  }
  k2 = -(x22-x21)/(y22-y21);
  b2 = y21 - k2*x21;
  k1 = -(x12-x11)/(y12-y11);
  b1 = y11 - k1*x11;
  *x = -(b1-b2)/(k1-k2);
  *y = 0.5*((k1+k2)*(*x) + b1+b2);
}

void count(float x, float y)
{
  int i;
  int L;
  float x1, y1, x2, y2;
  float k, b1, b2;
  L = 0;
  for (i=0; i<N; i++)
  {
    x1 = v[i][0];
    y1 = v[i][1];
    x2 = v[i+1][0];
    y2 = v[i+1][1];
    if (y1 == y2) {
      if (((x+e > x1) && (x-e < x2)) ||
          ((x+e > x2) && (x-e < x1)))
      L++;
    } else {
      k = -(x2-x1)/(y2-y1);
      b1 = y1 - k*x1;
      b2 = y2 - k*x2;
      y1 = k*x + b1;
      y2 = k*x + b2;
      if (((y+e > y1) && (y-e < y2)) ||
          ((y+e > y2) && (y-e < y1)))
        L++;
    }
  }
  if (L > P) {
    P = L;
    p[0] = x;
    p[1] = y;
  }
}

void test(int n1, int n2)
{
  float x, y;
  if ((v[n1][1]==v[n1+1][1]) && (v[n2][1]==v[n2+1][1]))
    return;
  if ((v[n1][1]!=v[n1+1][1]) && (v[n2][1]!=v[n2+1][1]) &&
       eq((v[n1][0]-v[n1+1][0])/(v[n1][1]-v[n1+1][1]),
          (v[n2][0]-v[n2+1][0])/(v[n2][1]-v[n2+1][1])))
    return;
  dot(v[n1][0], v[n1][1], v[n1+1][0], v[n1+1][1],
      v[n2][0], v[n2][1], v[n2+1][0], v[n2+1][1], &x, &y);
  count(x, y);
  dot(v[n1+1][0], v[n1+1][1], v[n1][0], v[n1][1],
      v[n2][0], v[n2][1], v[n2+1][0], v[n2+1][1], &x, &y);
  count(x, y);
  dot(v[n1][0], v[n1][1], v[n1+1][0], v[n1+1][1],
      v[n2+1][0], v[n2+1][1], v[n2][0], v[n2][1], &x, &y);
  count(x, y);
  dot(v[n1+1][0], v[n1+1][1], v[n1][0], v[n1][1],
      v[n2+1][0], v[n2+1][1], v[n2][0], v[n2][1], &x, &y);
  count(x, y);
}

int main(void)
{
  FILE *fi, *fo;
  int i;
  int n1, n2;
  P = -1;
  fi = fopen("input.txt", "rt");
  fo = fopen("output.txt", "wt");
  fscanf(fi, "%d", &N);
  for (i=0; i<N; i++)
    fscanf(fi, "%f %f", &v[i][0], &v[i][1]);
  v[N][0] = v[0][0];
  v[N][1] = v[0][1];
  for (n1=0; n1<N-1; n1++)
  for (n2=n1+1; n2<N; n2++)
    test(n1, n2);
  fprintf(fo, "%d\n", P);
  fprintf(fo, "%.4f %.4f", p[0], p[1]);
  fclose(fi);
  fclose(fo);
  return 0;
}