#include <stdio.h>

#define MAXL (8+2)
#define MAXN 10
#define BASE 10000

int M, N, P;
int A[MAXL];

FILE *fi, *fo;

int board[MAXN][MAXN];

int valid(int ll, int x, int y, int w);

int testh(int x, int y, int l, int w)
{
  int i, j;
  int v;
  int x1, y1, x2, y2;
  if (x+l > M) return 0;
  for (i=0; i<l; i++)
    if (board[x+i][y] != 0)
      return 0;
  x1 = x-1;
  x2 = x+l;
  y1 = y-1;
  y2 = y+1;
  if (x1 < 0) x1 = 0;
  if (y1 < 0) y1 = 0;
  if (x2 >= M) x2 = M-1;
  if (y2 >= N) y2 = N-1;

  for (i=x1; i<=x2; i++)
  for (j=y1; j<=y2; j++)
    if (board[i][j] >= BASE) return 0;

  for (i=x1; i<=x2; i++)
  for (j=y1; j<=y2; j++)
    board[i][j]++;
  for (i=0; i<l; i++)
    board[x+i][y] = BASE+l;

  v = valid(l, x, y, w);

  for (i=x1; i<=x2; i++)
  for (j=y1; j<=y2; j++)
    board[i][j]--;

  for (i=0; i<l; i++)
    board[x+i][y] = 0;

  return v;
}

int testv(int x, int y, int l, int w)
{
  int i, j;
  int v;
  int x1, y1, x2, y2;
  if (y+l > N) return 0;
  for (j=0; j<l; j++)
    if (board[x][y+j] != 0)
      return 0;
  x1 = x-1;
  x2 = x+1;
  y1 = y-1;
  y2 = y+l;
  if (x1 < 0) x1 = 0;
  if (y1 < 0) y1 = 0;
  if (x2 >= M) x2 = M-1;
  if (y2 >= N) y2 = N-1;

  for (i=x1; i<=x2; i++)
  for (j=y1; j<=y2; j++)
    if (board[i][j] > 1) return 0;

  for (i=x1; i<=x2; i++)
  for (j=y1; j<=y2; j++)
    board[i][j]++;

  for (j=0; j<l; j++)
    board[x][y+j] = BASE+l;

  v = valid(l, x, y, w);

  for (i=x1; i<=x2; i++)
  for (j=y1; j<=y2; j++)
    board[i][j]--;

  for (j=0; j<l; j++)
    board[x][y+j] = 0;

  return v;
}

int valid(int ll, int x, int y, int w)
{
  int v;
  int l;
  int i, j;
  l = ll;
  while ((l > 0) && (A[l] == 0))
    l--;
  if (l == 0) {
    if (w) {
      for (j=0; j<N; j++) {
        for (i=0; i<M; i++)
          if (board[i][j] >= BASE)
            fprintf(fo, "%d ", board[i][j]-BASE); else
            fprintf(fo, "%d ", 0);
        fprintf(fo, "\n");
      }
    }
    return 1;
  }
  if (l != ll) {
    x = 0;
    y = 0;
  }
  while (y < N) {
    A[l]--;
    v = testh(x, y, l, w);
    if (!v)
      v = testv(x, y, l, w);
    A[l]++;
    if (v) return 1;
    x++;
    if (x >= M) {
      x = 0;
      y++;
    }
  }
  return 0;
}

int main(void)
{
  int i, j, k, d;
  char c;
  int v;
  fi = fopen("input.txt", "rt");
  fo = fopen("output.txt", "wt");

  fscanf(fi, "%d %d", &M, &N);
  fscanf(fi, "%d", &P);
  for (k=0; k<MAXL; k++)
    A[k] = 0;
  for (k=0; k<P; k++) {
    fscanf(fi, "%d", &d);
    A[d]++;
  }

  for (i=0; i<M; i++)
  for (j=0; j<N; j++)
    board[i][j] = 0;

  if (!valid(MAXL-1, 0, 0, 0)) {
    fprintf(fo, "0");
  } else
  for (k=0; k<M*N; k++) {
    fscanf(fi, "\n%c%d", &c, &d);
    board[c-'a'][d-1] = 1;
    if (!valid(MAXL-1, 0, 0, 0)) {
      board[c-'a'][d-1] = 0;
      fprintf(fo, "%d\n", k+1);
      valid(MAXL-1, 0, 0, 1);
      break;
    }
  }

  fclose(fi);
  fclose(fo);
  return 0;
}