#define MAX          4096
#define INF          30000
#define N            1001
#define M            256

#include <stdio.h>
#include <string.h>


void input ();
void solve ();
void output ();
int min (int a, int b) { return ((a > b) ? b : a); }
void get_word (int n, int m);
void put (int i, int j, int num);
int get (int i, int j);

int m, n, cur [MAX], last [MAX], ans, ptr = 0;
char a [MAX], b [MAX], new_a [MAX], new_b [MAX], huge restore [N] [M];


main ()
 {
   input ();
   solve ();
   new_a [0] = new_b [0] = 0;

   if ((m <= 1000) && (n <= 1000))
    get_word (n, m);

   output ();

   return (0);
 }



void input ()
 {
   FILE * file = fopen ("input.txt", "r");

   fscanf (file, "%d %d\n%s\n%s", & n, & m, a, b);

   fclose (file);
 }


void solve ()
 {
   for (int j = 1; j <= m; j ++)
    cur [j] = INF;

   cur [0] = 0;

   for (int i = 1; i <= n; i ++)
    {
      memcpy (last, cur, (m + 1) << 1);

      for (int j = 0; j <= m; j ++)
       {
         if (cur [j] != INF)
          cur [j] ++;

         put (i, j, 0);

        if (j >= 1)
         {
          if (a [i - 1] == b [j - 1])
           {
             if (cur [j] > last [j - 1])
              cur [j] = last [j - 1], put (i, j, 1);
           }
          else if (cur [j] > last [j - 1] + 1)
           cur [j] = last [j - 1] + 1, put (i, j, 1);

          if (cur [j] > cur [j - 1] + 1)
           cur [j] = cur [j - 1] + 1, put (i, j, 2);
         }
       }
    }

   ans = cur [m];
 }


void get_word (int n, int m)
 {
   if ((n == 0) && (m == 0)) return;

   switch (get (n, m))
    {
      case 0:
       new_b [ptr] = '*'; new_a [ptr ++] = a [n - 1];
       get_word (n - 1, m);
       break;
      case 1:
       new_a [ptr] = a [n - 1]; new_b [ptr ++] = b [m - 1];
       get_word (n - 1, m - 1);
       break;
      case 2:
       new_a [ptr] = '*'; new_b [ptr ++] = b [m - 1];
       get_word (n, m - 1);
       break;
    }
 }

void output ()
 {
   FILE * file = fopen ("output.txt", "w");
   fprintf (file, "%d\n", ans);

   if ((m <= 1000) && (n <= 1000))
    {
     for (int i = 0; i < ptr; i ++)
      fprintf (file, "%c", new_a [ptr - i - 1]);

     fprintf (file, "\n");

     for (i = 0; i < ptr; i ++)
      fprintf (file, "%c", new_b [ptr - i - 1]);
    }

   fclose (file);
 }


void put (int i, int j, int num)
 {
   if ((i > 1000) || (j > 1000)) return;

   switch (j % 4)
    {
      case 0:
       restore [i] [j / 4] &= 252;
       restore [i] [j / 4] |= num;
       break;
      case 1:
       restore [i] [j / 4] &= 243;
       restore [i] [j / 4] |= (num << 2);
       break;
      case 2:
       restore [i] [j / 4] &= 207;
       restore [i] [j / 4] |= (num << 4);
       break;
      case 3:
       restore [i] [j / 4] &= 63;
       restore [i] [j / 4] |= (num << 6);
       break;
    }
 }


int get (int i, int j)
 {
   switch (j % 4)
    {
      case 0:
       return (restore [i] [j / 4] & 3);
      case 1:
       return ((restore [i] [j / 4] & 12) >> 2);
      case 2:
       return ((restore [i] [j / 4] & 48) >> 4);
      case 3:
       return ((restore [i] [j / 4] & 192) >> 6);
    }
 }
