#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <values.h>


FILE *in, *out;

struct line
{
  float a, b, c;
} res;

struct point
{
  float x, y;
} result;

int peresek(struct line *x1, struct line *x2)
{
  float delta, dx, dy;
  delta = x1->a*x2->b - x1->b*x2->a;
  if (delta < 0.00001 && delta > -0.00001)
    return 0;
  dx = -x1->c *x2->b + x1->b *x2->c;
  dy = -x1->a *x2->c + x1->c *x2->a;
  result.x = dx/delta;
  result.y = dy/delta;
  return 1;
}


float x[100];
float y[100];
float storon[100];
float dist[100];
struct line lines[200];
int i, j, k;
int N;

void solve_storon(void)
{
  float x0, y0, x1, y1;
  for (i = 0; i < N; i++)
  {
    x0 = x[i];
    y0 = y[i];
    x1 = x[(i+1) % N];
    y1 = y[(i+1) % N];
    storon[i] = (x0 - x1) * (x0 - x1) + (y0 - y1) * (y0 - y1);
  }
}

void solve_dist(float x0, float y0)
{
  float x1, y1;
  int i;
  for (i = 0; i < N; i++)
  {
    x1 = x[i];
    y1 = y[i];
    dist[i] = (x0 - x1) * (x0 - x1) + (y0 - y1) * (y0 - y1);
  }
}

int check(int i, int j)
{
   struct line a1, a2;
   int x = 0;
   a1 = lines[i];
   a2 = lines[j];
   if (!peresek(&a1, &a2))
     return -1;
   solve_dist(result.x, result.y);
   for (k = 0; k < N; k++)
   {
      if (dist[k] + storon[k] >= dist[(k+1) % N] &&
          dist[(k+1) % N] + storon[k] >= dist[k] )
        x++;
   }
   return x;
}






void made_line(int i)
{
  float x0 = x[i], y0 = y[i];
  float x1 = x[(i+1) % N], y1 = y[(i+1) % N];
  res.a = x1 - x0;
  res.b = y1 - y0;
  res.c = x0*x0 - x0*x1 + y0*y0 - y0*y1;
  lines[i * 2] = res;
  res.c = -x1*x1 + x0*x1 - y1*y1 + y0*y1;
  lines[i * 2 + 1] = res;
}


float res_x, res_y;
int res_int=-1;

int main(void)
{
  int i, j;
  int z;
  in = fopen("input.txt", "rt");
  out = fopen("output.txt", "wt");

  fscanf(in, "%d", &N);

  for (i = 0; i < N; i++)
    fscanf(in, "%f %f", x + i, y + i);
  for (i = 0; i < N; i++)
    made_line(i);
  solve_storon();
  for (i = 0; i < N*2; i++)
    for (j = i + 1; j < N*2; j++)
    {
      z = check(i, j);
      if (z > res_int)
      {
        res_int = z;
        res_x = result.x;
        res_y = result.y;
      }
      if (z == res_int && (res_x + res_y) > (result.x + result.y))
      {
        res_int = z;
        res_x = result.x;
        res_y = result.y;
      }
    }

  fprintf(out, "%i\n%f %f", res_int, res_x, res_y);
  fclose(in);
  fclose(out);
  return 0;
}
