#include <stdio.h>
#include <string.h>

#define CLOSE -10

#define STACK_SIZE 1000

int pole[11][11];
int closed[11][11];
int result[11][11];
int N, M, P;
int p;
int move_number;
int ship[9];

FILE *in, *out;

int stack[STACK_SIZE];
int stack_size = 0;

void set_close(int x, int y)
{
  if (x < 0)
    return;
  if (y < 0)
    return;
  if (pole[x][y] >= 0)
    pole[x][y] = CLOSE;
}

void set_pole(void)
{
   int i, j;

   for (i = 0; i < N; i++)
     for (j = 0; j < M; j++)
       if (pole[j][i] == CLOSE)
         pole[j][i] = 0;
   for (i = 0; i < N; i++)
     for (j = 0; j < M; j++)
     {
       if (pole[j][i] < 0 && pole[j][i] != CLOSE)
       {
           set_close(j - 1, i - 1);
           set_close(j - 1, i);
           set_close(j - 1, i + 1);

           set_close(j, i - 1);
           set_close(j, i);
           set_close(j, i + 1);

           set_close(j + 1, i - 1);
           set_close(j + 1, i);
           set_close(j + 1, i + 1);
       }
     }
   for (i = 0; i < N; i++)
     for (j = 0; j < M; j++)
       if (closed[j][i] == CLOSE)
         pole[j][i] = CLOSE;
}

void push(int x)
{
  stack[stack_size++] = x;
}

int pop(void)
{
  return stack[--stack_size];
}

struct move
{
  int x;
  int y;
} current;




void read_move(void)
{
  char c;
  c = fgetc(in);
  current.x = c - 'a';
  c = fgetc(in);
  fscanf(in, "\n");
  current.y = c - '1';
  move_number++;
}

int temp;

void situatedonline(int x, int y, int size)
{
  int i;
  p--;
  ship[size]--;
  push(size);
  push(x);
  push(y);
  push(1);
  set_close(x-1, y-1);
  set_close(x-1, y+1);
  set_close(x-1, y);
  for(i = 0; i < size; i++)
  {
    pole[x+i][y] = -size;
    set_close(x+i, y - 1);
    set_close(x+i, y + 1);
  }
  set_close(x+size, y-1);
  set_close(x+size, y+1);
  set_close(x+size, y);
}



void situatedoncol(int x, int y, int size)
{
  int i;
  p--;
  ship[size]--;
  push(size);
  push(x);
  push(y);
  push(-1);
  set_close(x-1, y-1);
  set_close(x, y-1);
  set_close(x+1, y-1);
  for(i = 0; i < size; i++)
  {
    pole[x][y+i] = -size;
    set_close(x - 1, y + i);
    set_close(x + 1, y + i);
  }
  set_close(x, y+size);
  set_close(x-1, y+size);
  set_close(x+1, y+size);
}

void release(void)
{
  int i;
  int x, y, size, direction;
  p++;
  direction = pop();
  y = pop();
  x = pop();
  size = pop();
  ship[size]++;
  if (direction == -1)
    for(i = 0; i < size; i++)
      pole[x][y+i] = 0;
  else
    for(i = 0; i < size; i++)
      pole[x+i][y] = 0;
  set_pole();
}


int check(void)
{
  int x = 8;
  int i, j, k;

  if (p > 0)
  {
    while (ship[x] == 0)
     x--;
    for (i = 0; i <= M - x; i++)
      for (j = 0; j <= N - 1; j++)
      {
        temp = 1;
        for (k = 0; k < x; k++)
          temp = temp + pole[i+k][j];
        if (temp > 0)
        {
          situatedonline(i, j, x);
          temp = check();
          if (temp == 1 && p == 0)
            goto end;
          if (temp == 1)
            p = 0;
          else
            release();
        }
      }
    for (i = 0; i <= M - 1; i++)
      for (j = 0; j <= N - x; j++)
      {
        temp = 1;
        for (k = 0; k < x; k++)
          temp = temp + pole[i][j+k];
        if (temp > 0)
        {
          situatedoncol(i, j, x);
          temp = check();
          if (temp == 1 && p == 0)
            goto end;
          if (temp == 1)
            p = 0;
          else
            release();
        }
      }
  }
  if (p == 0)
  {
    end:
    if (stack_size != 0)
      memcpy(result, pole, 121*2);
     while(stack_size != 0)
      release();
    p = 0;
    return 1;
  }
  return 0;
}

int main(void)
{
  int i, j;

  in = fopen("input.txt", "rt");
  out = fopen("output.txt", "wt");

  fscanf(in, "%i %i %i", &M, &N, &P);

  for (i = 0; i < P; i++)
  {
    fscanf(in, "%i", &j);
    ship[j]++;
  }

  p = P;
  fscanf(in, "\n");

  while(check())
  {
     p = P;
     read_move();
     pole[current.x][current.y] = closed[current.x][current.y] = CLOSE;

/*     for (i = 0; i < M; i++)
       for (j = 0; j < N; j++)
         if (closed[i][j])
           set_close(i, j);*/
  }
  for (i = 0; i < M; i++)
    for (j = 0; j < N; j++)
      if (result[i][j] == CLOSE)
        result[i][j] = 0;

  fprintf(out, "%i\n", move_number);
  if (move_number == 0)
    goto end;
  for (i = 0; i < N; i++)
  {
    for (j = 0; j < M; j++)
      fprintf(out, "%i", -result[j][i]);
    fprintf(out, "\n");
  }
end:
  fclose(in);
  fclose(out);
  return 0;
}