Uses Crt;
Const
  FIn='INPUT.TXT';
  FOut='OUTPUT.';
Var
  Output:Text;
  Input:Text;
{----------------------------------------------------------------------------}
Const
  MaxS=203+20;
  MaxV=200+20;
Type
  TToken=(_Name,_Const,_Assign,_Nil,_Rem,_If,_Then,_Function,_BeginParam
         ,_EndParam,_Return,_Print,_End,_Operation,_BeginFunction,_EndFunction
         ,_Delimiter);
  TState=(_Run,_Compile,_Debug);
  TVars=array['A'..'Z']of LongInt;
  TVarStack=array[1..MaxV]of TVars;
  TFuncs=array['A'..'Z']of Byte;
  TSInput=Array[1..MaxS,1..255]of Char;
Var
  State:TState;
  IsCompile:Boolean;
  {}
  Ch:TSInput;
  Len,X,Y:Byte;
  {}
  Token:TToken;
  St:String;
  C:LongInt;
  {}
  Funcs:TFuncs;
  Vars:TVars;
  Pr:TVars;
  {}
  Stack:TVarStack;
  Level:Byte;

Procedure Error(Err:Byte);
begin
  TextColor(6);
  Write('Error in line ',X,'!   ');
  TextColor(9);
  Case Err of
    1:Writeln('Unknown symbol: ',Ch[X,Y],' - #',Ord(Ch[X,Y]));
    2:Writeln('Unknown token!');
    3:Writeln('= expected');
    4:Writeln('Variable or function name expected!');
    5:Writeln('End of command expected but "',St,'" found!');
    6:Writeln('Variable name expected!');
    7:Writeln('Then expected but "',St,'" found!');
    8:Writeln('Variable name or conts expected!');
    9:Writeln('Const expected!');
    10:Writeln('Unexpected end of file!');
    11:Writeln('Function name expected!');
    12:Writeln('( expected!');
    13:Writeln('Invalid parametr!');
    14:Writeln('{ expected!');
    15:Writeln('Return not Found!');
    16:Writeln('Function not Found');
    Else Writeln('Unknown error!!!');
  end;
  Halt;
end;

Procedure GetToken;
begin
  While Ch[X,Y] in [#32] do Inc(Y);
{???  C:=0;}
  St:='';
  If X>Len then Token:=_End else
  If Ch[X,Y]='#' then
  begin
    Inc(X); Y:=1;
    Token:=_Rem;
  end else
  If Ch[X,Y]=#0 then begin
    Inc(X); Y:=1;
    Token:=_Nil;
  end else
  If Ch[X,Y] in ['A'..'Z'] then
  begin
    while Ch[X,Y] in ['A'..'Z'] do
    begin
      St:=St+Ch[X,Y];
      Inc(Y);
    end;
    St:=UpCase(St);
    If St='FUNCTION' then Token:=_Function else
    If St='PRINT'    then Token:=_Print    else
    If St='IF'       then Token:=_If       else
    If St='THEN'     then Token:=_Then     else
    If St='RETURN'   then Token:=_Return   else
                          Token:=_Name;
  end else
  If Ch[X,Y] in ['0'..'9'] then
  begin
    C:=0;
    while Ch[X,Y] in ['0'..'9'] do
    begin
      St:=St+Ch[X,Y];
      C:=C*10+Ord(Ch[X,Y])-Ord('0');
      Inc(Y);
    end;
    Token:=_Const;
  end else
  If Ch[X,Y] in [',','(',')','{','}'] then
  begin
    St:=Ch[X,Y];
    If Ch[X,Y]=',' then Token:=_Delimiter else
    If Ch[X,Y]='(' then Token:=_BeginParam else
    If Ch[X,Y]=')' then Token:=_EndParam else
    If Ch[X,Y]='{' then Token:=_BeginFunction else
    If Ch[X,Y]='}' then Token:=_EndFunction;
    Inc(Y);
  end else
  If Ch[X,Y] in ['=','+','-','*','<','>'] then
  begin
    St:=Ch[X,Y];
    If Ch[X,Y]='=' then Token:=_Assign else Token:=_Operation;
    Inc(Y);
  end else
  begin
    Error(1);
    If (State=_Run)or(State=_Compile) then Close(Output);
  end;
end;

Procedure GetVariable;
begin
  C:=Vars[St[1]];
end;
{Operators}
Procedure ExecuteCommand; Forward; {+}

Function RunFunction(Name:Char):LongInt; {+-}
Var
  Result:LongInt;
  Col,Col2:Byte;
  {Save}
  PrX,PrY:Byte;
  PrToken:TToken;
begin
  If Funcs[Name]=0 then Error(16);
  Col2:=Ord('A')-1;
  Col:=Ord('A')-1;
  Result:=0;
  {Put Stack}
  Inc(Level);
  Stack[Level]:=Vars;
  FillChar(Vars,SizeOf(Vars),0);
  {Params}
  GetToken;
  While (Token<>_EndParam)and(Token<>_End) do
  begin
    Inc(Col);
    If Token=_Name then Pr[Chr(Col)]:=Stack[Level][St[1]] else
    If Token=_Const then Pr[Chr(Col)]:=C else
    If Token=_Operation then
    begin
      If St[1]='-' then Pr[Chr(Col)]:=-1;
      GetToken;
      If Token=_Const then Pr[Chr(Col)]:=Pr[Chr(Col)]*C else Error(9);
    end else Error(8);
    GetToken;
    If Token=_Delimiter then GetToken;
  end;
  If Token=_End then Error(10);
  GetToken;
  PrToken:=Token;
  PrX:=X;
  PrY:=Y;
  X:=Funcs[Name];
  Y:=1;
  GetToken;
  GetToken;
  GetToken;
  If Token<>_BeginParam then Error(12) else GetToken;
  While (Token<>_EndParam)and(Token<>_End) do
  begin
    Inc(Col2);
    If Token=_Name then Vars[St[1]]:=Pr[Chr(Col2)] else Error(6);
    GetToken;
    If Token=_Delimiter then GetToken;
  end;
  If Col2<>Col then Error(13);
  If Token=_End then Error(10);
  GetToken;
  If Token<>_BeginFunction then Error(14);
  {Run}
  While (Token<>_EndFunction)and(Token<>_Return) do ExecuteCommand;
  If Token=_EndFunction then Error(15);
  GetToken;
  If Token=_Name then Result:=Vars[St[1]] else
  If Token=_Const then Result:=C else
  If Token=_Operation then
  begin
    if St[1]='-' then Result:=-1;
    GetToken;
    If Token=_Const then Result:=Result*C else Error(9);
  end else Error(8);
  {Get Stack}
  X:=PrX;
  Y:=PrY;
  Token:=PrToken;
  Vars:=Stack[Level];
  Dec(Level);
  RunFunction:=Result;
end;

Procedure GetName; {+-}
Var
  Result,R:LongInt;
  Op,Name:Char;
  Flag:Boolean;
begin
  Name:=St[1];
  Result:=0;
  GetToken;
  If Token<>_Assign then Error(3) else GetToken;
  If (Token=_Const)or(Token=_Name)or(Token=_Operation) then
  begin
    If Token=_Operation then
    begin
      If St[1]='-' then Result:=-1;
      GetToken;
      If Token<>_Const then Error(9) else
      begin
        C:=Result*C;
        Result:=0;
      end;
    end;
    If Token=_Name then
    begin
      Op:=St[1];
      GetVariable;
    end;
    GetToken;
    If Token=_BeginParam then C:=RunFunction(Op);
    Result:=Result+C;
    If (Token=_Operation)or(Token=_Assign) then
    begin
      Op:=St[1];
      GetToken;
      If Token=_Name then GetVariable else
      If Token=_Const then else
      If Token=_Operation then
      begin
        if St[1]='-' then R:=-1 else R:=1;
        GetToken;
        If Token=_Const then R:=R*C else Error(9);
        C:=R;
      end else Error(4);
      If Op='+' then Result:=Result+C else
      If Op='-' then Result:=Result-C else
      If Op='*' then Result:=Result*C else
      If Op='>' then Flag:=Result>C else
      If Op='<' then Flag:=Result<C else
      If Op='=' then Flag:=Result=C;
      If (Op='=')or(Op='<')or(Op='>')then
        If Flag then Result:=1 else Result:=0;
      GetToken;
    end;
    If (Token<>_Nil)and(Token<>_End) then Error(5);
    Vars[Name]:=Result;
  end else Error(4);
end;

Procedure GetIf; {+}
begin
  GetToken;
  If Token=_Name then
  begin
    GetVariable;
    GetToken;
    If Token<>_Then then Error(7);
    If C<>0 then ExecuteCommand else
    begin
      Inc(X); Y:=1;
  {    GetToken;}
    end;
  {  If (Token<>_Nil)and(Token<>_End) then Error(5);}
  end else Error(6);
end;

Procedure GetPrint; {+}
Var
  R:LongInt;
begin
  GetToken;
  If (Token=_Const)or(Token=_Name)or(Token=_Operation) then
  begin
    If Token=_Operation then
    begin
      If St[1]='-' then R:=-1 else R:=1;
      GetToken;
      C:=C*R;
    end;
    If Token=_Name then GetVariable;
    {}
    If State=_Run then Writeln(Output,C) else
    If State=_Compile then Writeln(Output,'  WRITELN(',C,');');
    {}
    GetToken;
    If (Token<>_Nil)and(Token<>_End) then Error(5);
  end else Error(8);
end;

procedure GetFunction;
begin
   GetToken;
   If Token=_Name then Funcs[St[1]]:=X else Error(11);
   While (Token<>_EndFunction)and(Token<>_End) do GetToken;
   If Token=_End then Error(10) else GetToken;
end;
{}
Procedure Gen;
begin
  Writeln(Output,'BEGIN                            ');
  Writeln(Output,'  ASSIGN(OUTPUT,''OUTPUT.TXT''); ');
  Writeln(Output,'  REWRITE(OUTPUT);               ');
  IsCompile:=True;
end;

Procedure ExecuteCommand;
begin
  GetToken;
  {If (State=_Debug) then
  begin
    ClrScr;
    GotoXY(1,1);
    Writeln(X);
    If X-1>0 then Writeln(Ch[X-1]);
    TextColor(Yellow);
    Writeln(Ch[X]);
    TextColor(7);
    If X+1<=Len then Writeln(Ch[X+1]);
    ReadKey;
  end;}
  Case Token of
    _Function: begin
                 GetFunction;
               end;
    _If:       begin
                 If (State=_Compile)and(Not IsCompile) then Gen;
                 GetIf;
               end;
    _Name:     begin
                 If (State=_Compile)and(Not IsCompile) then Gen;
                 GetName;
               end;
    _Print:    begin
                 If (State=_Compile)and(Not IsCompile) then Gen;
                 GetPrint;
               end;
    _Rem:      {Remark};
    _Nil:      {end of Command};
    _End:      {end of Program};
    _Return:   {???};
    Else Error(2);
  end;
end;

Procedure Go;
begin
  While Token<>_End do ExecuteCommand;
end;
{----------------------------------------------------------------------------}
begin
  Assign(Input,FIn);
  Reset(Input);
  IsCompile:=False;
  Level:=0;
  FillChar(Stack,SizeOf(Stack),0);
  FillChar(Vars,SizeOf(Vars),0);
  FillChar(Funcs,SizeOf(Vars),0);
  {}
  Readln(Input,St);
  St:=UpCase(St);
  If St='RUN' then
  begin
    State:=_Run;
    Assign(Output,FOut+'TXT');
    Rewrite(OutPut);
  end else
  If St='COMPILE' then
  begin
    State:=_Compile;
    Assign(Output,FOut+'PAS');
    Rewrite(OutPut);
  end else
  If St='DEBUG' then
  begin
    State:=_Debug;
  end;
  {Load Input File}
  Len:=0;
  X:=1;
  Y:=1;
  While not EOF(Input) do
  begin
    Inc(Len);
    Readln(Input,Ch[Len]);
    Ch[Len]:=UpCase(Ch[Len]);
  end;
  Close(Input);
  {}
  Go;
  {}
  If State=_Compile then
  begin
    Writeln(Output,'  CLOSE(OUTPUT);                 ');
    Writeln(Output,'END.                             ');
  end;
  {}
  If (State=_Run)or(State=_Compile) then Close(Output);
end.
