{$I-,Q-,R-,S-,V-,X-}
uses crt;
const
  F7 = #65; F8 = #66; CF2 = #95;
type
  txx = array ['A'..'Z'] of longint;
  tpar = record
    n: integer;
    x: array [1..26] of char;
  end;
  tparv = record
    n: integer;
    x: array [1..26] of longint;
  end;
  tfunc = record
    sl, sp: integer;
    p: tpar;
  end;
  tacc = set of char;
const
  nums: tacc = ['0'..'9'];
  abc: tacc  = ['A'..'z'];
  oper: tacc = ['+','-','*','<','>','='];
var
  k, tl, cl, cp, ol, op, ql, qp: integer;
  t: array [1..300] of string;
  fn: array ['A'..'Z'] of tfunc;
  main: tfunc;
  txt: text;
  dmb: tparv;
  lx, md: string;
  acc: tacc;
  lvar: char;
  pr: boolean;
  xxx, vv: longint;
  uv: array ['A'..'Z'] of integer;
  o: array [1..4] of string;
  co: integer;

procedure Err(const msg: string);
begin
  Assign(Output, ''); ReWrite(Output);
  TextColor(Red);
  WriteLn('Error at ', ol, ': ', msg);
  Halt(0);
end;

procedure skipbl;
begin
  ol := cl; op := cp;
  if (cp>length(t[cl])) then begin cp := 1; inc(cl); end;
  while ((cl<=tl) and ((t[cl][cp] in ['#',' ', #13, #10]))) do begin
    if (cp>length(t[cl])) then begin
      inc(cl); cp := 1;
    end else
    if (t[cl][cp] = '#') then begin
     if (cp>1) then WriteLn('//Warning at ', cl, ': wrong comment');
     inc(cl); cp := 1;
    end else begin
      inc(cp);
      if (cp>length(t[cl])) then begin cp := 1; inc(cl); end;
    end;
  end;
end;

procedure print(x: longint);
begin
  if (md = 'RUN') then WriteLn(x) else begin
    if (pr) then begin
      Str(x, o[co]);
      WriteLn(txt, x);
      co := (co mod 4) + 1;
    end;
  end;
end;

procedure getlex;
begin
  lx := '';
  ol := cl; op := cp;
  while ((cl<=tl) and (not (t[cl][cp] in acc))) do begin
    if (cp>length(t[cl])) then begin
      inc(cl); cp := 1;
    end else
    if (t[cl][cp] = '#') then begin
     if (cp>1) then WriteLn('//Warning at ', cl, ': wrong comment');
     inc(cl); cp := 1;
    end else
    if not (t[cl][cp] in [' ', #13, #10]) then begin
      Assign(Output, ''); ReWrite(Output);
      WriteLn('Error at line ', cl, ': unexpected char ''', t[cl][cp],'''');
      Halt(0);
    end else begin
      inc(cp);
      if (cp>length(t[cl])) then begin
        cp := 1; inc(cl);
      end;
    end;
  end;

  if (cl>tl) then exit;
  while ((cp<=length(t[cl])) and (t[cl][cp] in acc)) do begin
    lx := lx + UpCase(t[cl][cp]);
    inc(cp);
  end;
  if (cp>length(t[cl])) then begin
    cp := 1; inc(cl);
  end;
end;

procedure skipto(c: char);
begin
  ol := cl; op := cp;
  while ((cl<=tl) and (not (t[cl][cp]=c))) do begin
    if (cp>length(t[cl])) then begin
      inc(cl); cp := 1;
    end else
    if (t[cl][cp] = '#') then begin
     if (cp>1) then WriteLn('Warning at ', cl, ': wrong comment');
     inc(cl); cp := 1;
    end else begin
      inc(cp);
      if (cp>length(t[cl])) then begin
        cp := 1; inc(cl);
      end;
    end;
  end;
end;

procedure getpar(var p: tpar);
var  ff: boolean;
begin
  p.n := 0;
  acc := ['(']; getlex; if (lx <> '(') then Err('''('' not found');

  ff := false;
  repeat
    acc := abc + [')']; getlex;
    if (lx[length(lx)] = ')') then begin dec(lx[0]); ff := true; end;
    if ((length(lx) <> 1) and (not ff)) then Err('wrong function params');
    if (length(lx)=1) then begin
      inc(p.n); p.x[p.n] := lx[1];
      if (not ff) then begin acc := [',',')']; getlex; end;
    end;
  until ((ff) or (lx=')'));
end;

function getf: boolean;
var
  nm: char;
  al, fl: integer;
begin
  getf := false;
  acc := abc; getlex;
  if (lx <> 'FUNCTION') then begin cl := ol; cp := op; exit; end;
  al :=  cl; if (cp<2) then dec(al);
  getlex;
  if (length(lx) <> 1) then begin
    WriteLn('Wrong function name at ', ol);
    Halt(0);
  end;
  nm := lx[1];
  if (fn[nm].sl>0) then Err('dublicate function');

  getpar(fn[nm].p);
  acc := ['{']; getlex; if (lx <> '{') then Err('''{'' not found');

  fl := cl; if (cp<2) then dec(fl);
  if (al<>fl) then WriteLn('Warn: wrong func def at ', al);

  fn[nm].sl := cl; fn[nm].sp := cp;

  skipto('}');
  if (cl>tl) then Err('''}'' not found (func ' + nm +' )');
  inc(cp); skipbl;
  getf := true;
end;

procedure ParseF;
begin
  fillchar(fn, sizeof(fn), 0);

  cl := 1; cp := 1;
  while (getf) do ;

  fillchar(main, sizeof(main), 0);
  main.sl := cl;
  main.sp := cp;
  inc(tl); t[tl] := '}';
end;

function stoi: longint;
var
  x: longint;
  cd: integer;
begin
  if (length(lx)<1) then Err('Wrong constant - ''' + lx + '''');
  Val(lx, x, cd);
  if (cd>0) then Err('Wrong constant - ''' + lx + '''');
  stoi := x;
end;

procedure getsmth(const vars: txx);
var
  inv: boolean;
begin
  skipbl;
  inv := false;
  if (cl>tl) then Err('unepected eof');

  if (t[cl][cp] in abc) then begin
    acc := abc;  getlex;
    if (length(lx)<>1) then Err('wrong variable');
    vv := vars[lx[1]];
  end else begin
    while (cl<tl)and (((t[cl][cp]) in ['-','+'])) do begin
      if (t[cl][cp] = '-') then inv := not inv;
      inc(cp); skipbl;
    end;
    acc := nums; getlex;
    vv := stoi;
    if (inv) then vv := -vv;
  end;
end;

procedure getvar(const vars: txx);
begin
  skipbl;
  if (cl>tl) then Err('unepected eof');

  acc := abc;  getlex;
  if (length(lx)<>1) then Err('wrong variable');
  vv := vars[lx[1]];
  lvar := lx[1];
end;

procedure getparv(var p: tparv; const x: txx);
var  ff: boolean;
begin
  p.n := 0;

  acc := ['(']; getlex; if (lx<>'(') then Err('''('' not found');

  repeat
    skipbl;
    if (cl>tl) then Err(''')'' not found');
    if (t[cl][cp] = ')') then begin
      inc(cp); skipbl; exit;
    end;
    if (t[cl][cp] = ',') then begin
      inc(cp); skipbl;
    end else begin
      inc(p.n);
      getsmth(x);
      p.x[p.n] := vv;
    end;
  until false;
end;

var scmd_x: txx; scmd_pv: tparv;
procedure skipcmd;
begin
    skipbl;
    if ((cl>tl) or (t[cl][cp]='}')) then Err('commmand expected');

    acc := abc; getlex;
    if (length(lx)=1) then begin
       acc := ['=']; getlex;
       if (lx<>'=') then Err('wrong operator');
       skipbl; if (cl>tl) then Err('wrong operator');
       if (t[cl][cp] in abc) then begin
         acc := abc; getlex; if (length(lx)<>1) then Err('wrong operator');
         skipbl;
         if ((cl<=tl) and (t[cl][cp] in oper)) then begin
           inc(cp); skipbl;
           getsmth(scmd_x);
         end else begin
           if ((cl<=tl) and (t[cl][cp]='(')) then begin
             getparv(scmd_pv, scmd_x);
           end;
         end;
       end else begin
         getsmth(scmd_x); skipbl;
         if ((cl<=tl) and (t[cl][cp] in oper)) then begin
           inc(cp); skipbl; getsmth(scmd_x);
         end;
       end;
    end else if (lx='PRINT') then begin
       getsmth(scmd_x);
    end else if (lx='IF') then begin
       getvar(scmd_x);
       acc := abc; getlex; if (lx<>'THEN') then Err('IF w/o THEN');
       skipcmd;
    end else if (lx='RETURN') then begin
       getsmth(scmd_x);
    end else Err('Unknown operator: '''+lx+'''');
end;

function runfn(dp: integer; const f: tfunc; const p: tparv): longint;
var
  x: txx;
  pv: tparv;
  i: integer;
  a, b, oo: char;
  v1: longint;
  ssl, ssp: integer;
begin
  if (dp>201) then Err('Recursion depth >200');
  fillchar(x, sizeof(x), 0);
  for i := 1 to f.p.n do x[f.p.x[i]] := p.x[i];

  if (f.p.n <> p.n) then WriteLn('Wrong param count');

  cl := f.sl; cp := f.sp;
  repeat
    skipbl;
    if ((cl>tl) or (t[cl][cp]='}')) then begin
      if (dp>0) then WriteLn('Warning: func not ended with return at ', cl);
      runfn := 0;
      exit;
    end;

    acc := abc; getlex;
    if (length(lx)=1) then begin
       a := lx[1]; acc := ['=']; getlex;
       if (lx<>'=') then Err('wrong operator');
       skipbl; if (cl>tl) then Err('wrong operator');
       if (t[cl][cp] in abc) then begin
         acc := abc; getlex; if (length(lx)<>1) then Err('wrong operator');
         b := lx[1]; skipbl;
         if ((cl<=tl) and (t[cl][cp] in oper)) then begin
           oo := t[cl][cp]; inc(cp); skipbl;
           getsmth(x); v1 := x[b];
           if (oo='+') then x[a] := v1+vv;
           if (oo='-') then x[a] := v1-vv;
           if (oo='*') then x[a] := v1*vv;
           if (oo='<') then x[a] := ord(v1<vv);
           if (oo='>') then x[a] := ord(v1>vv);
           if (oo='=') then x[a] := ord(v1=vv);
         end else begin
           if ((cl<=tl) and (t[cl][cp]='(')) then begin
             getparv(pv, x);
             ssl := cl; ssp := cp;
             vv := runfn(dp+1, fn[b], pv);
             cl := ssl; cp := ssp;
             x[a] := vv;
           end else begin x[a] := x[b] end;
         end;
       end else begin
         getsmth(x); v1 := vv; skipbl;
         if ((cl<=tl) and (t[cl][cp] in oper)) then begin
           oo := t[cl][cp]; inc(cp); skipbl;
           getsmth(x);
           if (oo='+') then x[a] := v1+vv;
           if (oo='-') then x[a] := v1-vv;
           if (oo='*') then x[a] := v1*vv;
           if (oo='<') then x[a] := ord(v1<vv);
           if (oo='>') then x[a] := ord(v1>vv);
           if (oo='=') then x[a] := ord(v1=vv);
         end else x[a] := v1;
       end;
    end else if (lx='PRINT') then begin
       getsmth(x);
       print(vv);
    end else if (lx='IF') then begin
       getvar(x);
       acc := abc; getlex; if (lx<>'THEN') then Err('IF w/o THEN');
       if (vv=0) then skipcmd;
    end else if (lx='RETURN') then begin
       getsmth(x);
       if (dp<1) then WriteLn('Warning: return in main');
       runfn := vv; exit;
    end else Err('Unknown operator: '''+lx+'''');
  until false;
end;

procedure skipandwr(const s: tacc);
begin
  skipbl;
  repeat
    if ((cl>tl) or (not(t[cl][cp] in s))) then exit;
    Write(t[cl][cp]); inc(cp);  skipbl;
  until false;
end;

procedure compilef(const f: tfunc; nm: char);
var
  a, b: char;
  v1: longint;
begin
  cl := f.sl; cp := f.sp;

  repeat
    skipbl;
    if ((cl>tl) or (t[cl][cp]='}')) then exit;

    acc := abc; getlex;
    if (length(lx)=1) then begin
       a := lx[1]; acc := ['=']; getlex;
       if (lx<>'=') then Err('wrong operator');
       skipbl; if (cl>tl) then Err('wrong operator');

       Write(a, ':=ord(');
       skipandwr(['+', '-']); acc := nums+abc; getlex;
       Write(lx);
       skipbl;
       if (t[cl][cp] in oper) then begin
         Write(t[cl][cp]); inc(cp); skipbl;
         skipandwr(['+', '-']); acc := nums+abc; getlex;
         Write(lx);
       end else if (t[cl][cp] = '(') then begin
         Write('F('); inc(cp); skipbl;
         skipandwr([',','+', '-']+abc+nums);
         if (t[cl][cp] <> ')') then Err('''('' needed');
         Write(')'); inc(cp); skipbl;
       end;
       WriteLn(');')
    end else if (lx='PRINT') then begin
       Write('Writeln(');
       skipandwr(['+', '-']); acc := nums+abc; getlex;
       Write(lx);
       WriteLn(');');
    end else if (lx='IF') then begin
       acc := abc; getlex;
       if (length(lx)<>1) then Err('wrong IF');
       Write('If (', lx, '<>0) then ');
       getlex; if (lx<>'THEN') then Err('IF w/o THEN');
    end else if (lx='RETURN') then begin
       Write('begin ', nm, 'F:=');
       skipandwr(['+', '-']); acc := nums+abc; getlex;
       Write(lx);
       WriteLn('; exit; end;');
    end else Err('Unknown operator: '''+lx+'''');

  until false;
end;

procedure makefuncforw(const f: tfunc; nm: char);
var
  w: boolean;
  i: integer;
begin
  Write('function ', nm, 'F');
  w := false;
  for i := 1 to f.p.n do begin
    if w then Write(',') else begin
      w := true; Write('(');
    end;
    Write(f.p.x[i]);
  end;
  if w then Write(':longint)');
  WriteLn(':longint; forward;');
end;

procedure makefunc(const f: tfunc; nm: char);
var
  w: boolean;
  i: integer; c: char;
  d: array ['A'..'Z'] of boolean;
begin
  Write('function ', nm, 'F');
  w := false;
  for c := 'A' to 'Z' do d[c] := true;
  for i := 1 to f.p.n do begin
    if (w) then Write(',') else begin
      w := true; Write('(');
    end;
    Write(f.p.x[i]);
    d[f.p.x[i]] := false;
  end;
  if (w) then Write(':longint)');
  WriteLn(':longint;');
  w := false;
  for c := 'A' to 'Z' do begin
    if (d[c]) then begin
      if (w) then Write (',') else begin
         w := true;
         Write('var ');
      end;
      Write(c);
    end;
  end;
  if (w) then WriteLn(':longint;');

  WriteLn('begin');
  for c := 'A' to 'Z' do begin
    if (c='N') then WriteLn;
    if (d[c]) then Write(c,':=0;');
  end;
  WriteLn;
  compilef(f, nm);
  WriteLn('end;');
end;

procedure compile;
var  c: char;
begin
  for c := 'A' to 'Z' do if (fn[c].sl > 0) then makefuncforw(fn[c], c);
  WriteLn;
  for c := 'A' to 'Z' do if (fn[c].sl > 0) then makefunc(fn[c], c);
  WriteLn;
  Write('var ');
  for c := 'A' to 'Z' do begin
    if (c>'A') then Write(',');
    Write(c);
  end;
  WriteLn(':longint;');
  WriteLn('begin');
  for c := 'A' to 'Z' do begin
    if (c='N') then WriteLn;
    Write(c,':=0;');
  end;
  WriteLn;
  WriteLn('Assign(Output, ''OUTPUT.TXT''); ReWrite(Output);');
  compilef(main, '_');
  WriteLn('Close(Output);');
  WriteLn('end.')
end;

procedure show(const x: txx; const a1, a2, a3: string; sh: tacc);
var
  i, k: integer;
  c: char;
  s: string;
begin
  s := t[cl];
  for i := 1 to length(s) do s[i] := UpCase(s[i]);
  while (pos(' (', s) <> 0) do delete(s, pos(' (', s), 1);

  for i := 1 to length(s) do begin
    if ( (s[i] in abc) and
         ((i<2) or (not(s[i-1] in abc))) and
         ((i>=length(s)) or (not(s[i+1] in (abc+['('])))) ) then Include(sh, s[i]);
  end;

  TextBackGround(Black);
  ClrScr;
  for i := -3 to 3 do begin
    s := t[cl+i];
    if (length(s)>80) then begin
      s[0] := #79;
      GotoXY(80, i+4);
      TextColor(Cyan);
      Write('>');
    end;
    GotoXY(1, i+4);
    if (i=0) then TextColor(White) else TextColor(LightGray);
    if ((cl+i)>0) and ((cl+i)<tl) then WriteLn(s);
  end;

  GotoXY(1, 9);
  for i := 1 to 80 do Write(#196);
  GotoXY(1, 11);
  for i := 1 to 80 do Write(#196);
  GotoXY(35, 11); Write(' Variables ');
  GotoXY(1, 10);
  TextColor(LightGray); Write('Current command: ');
  TextColor(White); Write(a1);
  TextColor(LightGray); Write(a2);
  TextColor(White); Write(a3);

  GotoXY(1, 12);
  for c := 'A' to 'Z' do if (c in sh) then begin
    TextColor(LightGray); Write(' ', c);
    TextColor(LightGray); Write(' = ');
    TextColor(White); Write(x[c]:11);
  end;
  TextColor(LightGray);
  GotoXY(1, 19);
  for i := 1 to 80 do Write(#196);
  GotoXY(35, 19); Write(' Output ');

  k := co;
  for i := 1 to 4 do begin
    GotoXY(1, 19+i); Write(o[k]);
    k := (k mod 4) + 1;
  end;
end;

function debugfn(dp: integer; const f: tfunc; const p: tparv): longint;
label lp;
var
  x, xx: txx;
  pv: tparv;
  i: integer;
  a, b, oo, cc: char;
  v1: longint;
  ssl, ssp: integer;
  a1, a2, a3: string;
  sh: tacc;
begin
  if (dp>201) then Err('Recursion depth >200');
  fillchar(x, sizeof(x), 0);
  for i := 1 to f.p.n do x[f.p.x[i]] := p.x[i];

  if (f.p.n <> p.n) then WriteLn('Wrong param count');

  cl := f.sl; cp := f.sp;
  repeat
    xx := x; a1 := ''; a2 := ''; a3 := ''; sh := [];
lp:    skipbl;
    ql := cl; qp := cp;
    if ((cl>tl) or (t[cl][cp]='}')) then begin
      if (dp>0) then WriteLn('Warning: func not ended with return at ', cl);
      debugfn := 0;
      a1 := 'END';
    end else begin
    acc := abc; getlex;
    if (length(lx)=1) then begin
       a := lx[1]; acc := ['=']; getlex;
       if (lx<>'=') then Err('wrong operator');
       skipbl; if (cl>tl) then Err('wrong operator');
       if (t[cl][cp] in abc) then begin
         acc := abc; getlex; if (length(lx)<>1) then Err('wrong operator');
         b := lx[1]; skipbl;
         if ((cl<=tl) and (t[cl][cp] in oper)) then begin
           oo := t[cl][cp]; inc(cp); skipbl;
           getsmth(x); v1 := x[b];
           if (oo='+') then x[a] := v1+vv;
           if (oo='-') then x[a] := v1-vv;
           if (oo='*') then x[a] := v1*vv;
           if (oo='<') then x[a] := ord(v1<vv);
           if (oo='>') then x[a] := ord(v1>vv);
           if (oo='=') then x[a] := ord(v1=vv);
         end else begin
           if ((cl<=tl) and (t[cl][cp]='(')) then begin
             getparv(pv, x);
             ssl := cl; ssp := cp;
             pr := false;
             vv := runfn(dp+1, fn[b], pv);
             pr := true;
             cl := ssl; cp := ssp;
             x[a] := vv;
           end else begin x[a] := x[b] end;
         end;
       end else begin
         getsmth(x); v1 := vv; skipbl;
         if ((cl<=tl) and (t[cl][cp] in oper)) then begin
           oo := t[cl][cp]; inc(cp); skipbl;
           getsmth(x);
           if (oo='+') then x[a] := v1+vv;
           if (oo='-') then x[a] := v1-vv;
           if (oo='*') then x[a] := v1*vv;
           if (oo='<') then x[a] := ord(v1<vv);
           if (oo='>') then x[a] := ord(v1>vv);
           if (oo='=') then x[a] := ord(v1=vv);
         end else x[a] := v1;
       end;
       a1 := a; a2 := ' := '; str(x[a], a3);
       Include(sh, a);
    end else if (lx='PRINT') then begin
       getsmth(x);
       a2 := 'PRINT '; str(vv, a3);
    end else if (lx='IF') then begin
       getvar(x);
       include(sh, lvar);
       acc := abc; getlex; if (lx<>'THEN') then Err('IF w/o THEN');
       if (vv=0) then skipcmd else goto lp;
    end else if (lx='RETURN') then begin
       getsmth(x);
       if (dp<1) then a1 := '(Warning: return in main) ';
       a2 := 'RETURN '; str(vv, a3);
    end else Err('Unknown operator: '''+lx+'''');
    end;
    cl := ql; cp := qp; x := xx;
    show(x, a1, a2, a3, sh);
    repeat
      cc := ReadKey;
      if (cc = CF2) then begin
        ClrScr; Close(txt); Halt(0);
      end;
    until (cc in [F7, F8]);

    if ((cl>tl) or (t[cl][cp]='}')) then begin
      if (dp>0) then WriteLn('Warning: func not ended with return at ', cl);
      debugfn := 0;
      exit;
    end;

    acc := abc; getlex;
    if (length(lx)=1) then begin
       a := lx[1]; acc := ['=']; getlex;
       if (lx<>'=') then Err('wrong operator');
       skipbl; if (cl>tl) then Err('wrong operator');
       if (t[cl][cp] in abc) then begin
         acc := abc; getlex; if (length(lx)<>1) then Err('wrong operator');
         b := lx[1]; skipbl;
         if ((cl<=tl) and (t[cl][cp] in oper)) then begin
           oo := t[cl][cp]; inc(cp); skipbl;
           getsmth(x); v1 := x[b];
           if (oo='+') then x[a] := v1+vv;
           if (oo='-') then x[a] := v1-vv;
           if (oo='*') then x[a] := v1*vv;
           if (oo='<') then x[a] := ord(v1<vv);
           if (oo='>') then x[a] := ord(v1>vv);
           if (oo='=') then x[a] := ord(v1=vv);
         end else begin
           if ((cl<=tl) and (t[cl][cp]='(')) then begin
             getparv(pv, x);
             ssl := cl; ssp := cp;
             if (cc=F8) then vv := runfn(dp+1, fn[b], pv)
             else            vv := debugfn(dp+1, fn[b], pv);
             cl := ssl; cp := ssp;
             x[a] := vv;
           end else begin x[a] := x[b] end;
         end;
       end else begin
         getsmth(x); v1 := vv; skipbl;
         if ((cl<=tl) and (t[cl][cp] in oper)) then begin
           oo := t[cl][cp]; inc(cp); skipbl;
           getsmth(x);
           if (oo='+') then x[a] := v1+vv;
           if (oo='-') then x[a] := v1-vv;
           if (oo='*') then x[a] := v1*vv;
           if (oo='<') then x[a] := ord(v1<vv);
           if (oo='>') then x[a] := ord(v1>vv);
           if (oo='=') then x[a] := ord(v1=vv);
         end else x[a] := v1;
       end;
    end else if (lx='PRINT') then begin
       getsmth(x);
       print(vv);
    end else if (lx='IF') then begin
       getvar(x);
       acc := abc; getlex; if (lx<>'THEN') then Err('IF w/o THEN');
       if (vv=0) then skipcmd;
    end else if (lx='RETURN') then begin
       getsmth(x);
       if (dp<1) then WriteLn('Warning: return in main');
       debugfn := vv; exit;
    end else Err('Unknown operator: '''+lx+'''');
  until false;
end;

procedure debug;
begin
  Assign(txt, 'OUTPUT.TXT'); ReWrite(txt);
  xxx:=debugfn(0, main, dmb);
  Close(txt);
end;

begin
  Assign(Input, 'INPUT.TXT'); Reset(Input);
  ReadLn(md); tl := 0;
  while not Eof do begin
    inc(tl);
    ReadLn(t[tl]);
    if (tl>203) then begin
      WriteLn('>203 lines'); Close(Input); exit;
    end;
  end;

  Close(Input);
  for k := 1 to length(md) do md[k] := UpCase(md[k]);

  ParseF;

  pr := true;
  co := 1; fillchar(o, sizeof(o), 0);
  if (md = 'RUN') then begin
    Assign(Output, 'OUTPUT.TXT'); ReWrite(Output);
    xxx:=runfn(0, main, dmb);
    Close(Output);
  end else if (md = 'COMPILE') then begin
    Assign(Output, 'OUTPUT.PAS'); ReWrite(Output);
    compile;
    Close(Output);
  end else if (md = 'DEBUG') then debug else WriteLn('Unknown task');
end.
