uses crt;
const
  stringLength=255;
  programLength=204;


type tString=string[stringLength];
const
errorMsg:array[1..15]of tString=
(
' ᠭ 㭪樨 ய饭 ᨬ (',
' ᠭ 㭪樨 ய饭 ᨬ )',
'४⮭ ᠭ ࠬ஢ 㭪樨',
' ᠭ 㭪樨 ய饭 ᨬ {',
'ᮢ  㭪権',
' ଠ  if',
'᫨誮  ணࠬ',
' ',
' ଠ  ᢠ',
' return  ⥫  ணࠬ',
' ଠ  print',
'୮  ६',
'ࠢ쭠 ⠭',
'ࠬ 㭪樨   㭪樨',
'訡  맮 㭪樨'
);
procedure error(stringNo:integer;errorNo:integer);
begin
  writeln;
  textColor(4);
  write('訡');
  if stringNo<>0 then writeln('  ப ',stringNo+1,':') else writeln(' :');
  writeln(errorMsg[errorNo]);
  readkey;
  while true do halt;
end;
var
prog:array[1..programLength]of tString;
progL:integer;
mainText:array[1..programLength]of tString;
mainL:integer;
linesNo:array[1..programLength]of integer;
functionTable:array[1..26]of
  record
    name:char;
    parameters:tString;
    bodyL:integer;
    linesNo:array[1..programLength]of integer;
    body:array[1..programLength]of tString;
  end;
functionCount:integer;
command:string;
fin,fout:text;
i,j:integer;
st:string;
function killSpaceFromStringStart(st:string):string;
var i:integer;
begin
  i:=1;
  while (st[i]=' ')and(i<length(st)) do inc(i);
  killSpaceFromStringStart:=copy(st,i,255);
end;
function killSpaceFromStringEnd(st:string):string;
begin
  while (st[length(st)]=' ')and(length(st)>0) do dec(st[0]);
  killSpaceFromStringEnd:=st;
end;
function killSpaceFromString(st:string):string;
var i:integer;s:string;inSpace:boolean;
begin
  s:='';
  inSpace:=false;
  for i:=1 to length(st) do
    begin
      if st[i]<>' ' then
        begin
          s:=s+st[i];inSpace:=false;
        end
      else
        if not inSpace then
          begin
            s:=s+' ';inSpace:=true;
          end;
    end;
  killSpaceFromString:=s;
end;
function stringUpCase(st:tstring):string;
var s:string;i:integer;
begin
  s:='';for i:=1 to length(st) do s:=s+upcase(st[i]);stringUpCase:=s;
end;
function findFunction(name:char):integer;
var i:integer;
begin
  findFunction:=0;
  for i:=1 to functionCount do
    if functionTable[i].name=upCase(name) then
      begin
        findFunction:=i;
        exit;
      end;
end;
procedure buildFunctionTable;
var
  i:integer;
  st:string;
  lastI:integer;
begin
  functionCount:=0;
  for i:=1 to progL do
    begin
      st:=killSpaceFromStringStart(prog[i]);
      if stringUpCase(copy(st,1,8))='FUNCTION' then
        begin
          st:=killSpaceFromStringStart(copy(st,9,255));
          if findFunction(st[1])<>0 then error(i,5);
          inc(functionCount);
          functionTable[functionCount].name:=upCase(st[1]);
          st:=killSpaceFromStringStart(copy(st,2,255));
          if st[1]<>'(' then
            begin
              error(i,1);
            end;
          st:=killSpaceFromStringStart(copy(st,2,255));
          functionTable[functionCount].parameters:='';
          while (st[1]<>')')and(st<>'') do
            begin
              if upCase(st[1])in['A'..'Z'] then
                begin
                  if findFunction(upCase(st[1]))<>0 then error (0,14);
                  functionTable[functionCount].parameters:=
                  functionTable[functionCount].parameters+upcase(st[1]);
                end;
              st:=killSpaceFromStringStart(copy(st,2,255));
              if not(st[1]in[',',')']) then error(i,3);
              if st[1]=')' then break;
              st:=killSpaceFromStringStart(copy(st,2,255));
            end;
          if st='' then error(i,2);
          st:=killSpaceFromStringStart(copy(st,2,255));
          if st[1]<>'{' then error(i,4);
          inc(i);
          functionTable[functionCount].bodyL:=0;
          while copy(killSpaceFromStringStart(prog[i]),1,1)<>'}' do
            begin
              inc(functionTable[functionCount].bodyL);
              functionTable[functionCount].linesNo[functionTable[functionCount].bodyL]:=linesNo[i];
              functionTable[functionCount].body[functionTable[functionCount].bodyL]:=prog[i];
              inc(i);
            end;
          lastI:=i+1;
        end;
    end;
  mainL:=0;
  i:=lastI;
  while i<=progL do
    begin
      inc(mainL);
      mainText[mainL]:=prog[i];
      inc(i);
    end;
end;
function isLongint(st:string):boolean;{-2147483648..2147483647}
var i:integer;
begin
  isLongint:=false;
  if st[1]='-' then
    begin
      delete(st,1,1);
      while (st[1]='0')and(length(st)>1) do delete(st,1,1);
      if (st<='2147483648')and(length(st)<=10)then
        begin
          for i:=1 to length(st) do if not (st[i] in ['0'..'9']) then exit;
          isLongint:=true;
        end;
      exit;
    end;
  if st[1]='+' then
    begin
      delete(st,1,1);
      while (st[1]='0')and(length(st)>1) do delete(st,1,1);
      while length(st)<10 do insert('0',st,2);
      if (st<'2147483648')and(length(st)<=10) then
        begin
          for i:=1 to length(st) do if not (st[i] in ['0'..'9']) then exit;
          isLongint:=true;
        end;
      exit;
    end;
  if st[1]in ['0'..'9'] then
    begin
      while (st[1]='0')and(length(st)>1) do delete(st,1,1);
      while length(st)<10 do st:='0'+st;
      if (st<'2147483648')and(length(st)<=10) then
        begin
          for i:=1 to length(st) do if not (st[i] in ['0'..'9']) then exit;
          isLongint:=true;
        end;
      exit;
    end;
end;
procedure compile(outFile:string);
var fout:text;
i,j:integer;
ch:char;
st:string;
currentMainSymbol:string;
lineNumber:integer;
function compileSimpleOperator(op:tstring):string;
var i,j:integer;st,myst,st2:string;
cond:string;
begin
  if stringUpCase(copy(killSpaceFromStringStart(op),1,5))='PRINT' then
    begin
      st:=killSpaceFromStringStart(stringUpCase(copy(killSpaceFromStringStart(op),6,255)));
      if (st[1] in ['A'..'Z'])then
        begin
          if length(killSpacefromStringEnd(st))<>1 then error(lineNumber,12);
        end
      else
        begin
          st:=killSpaceFromStringEnd(st);
          if isLongint(st) then
            begin
              while (st[1]='0')and(length(st)>1) do delete(st,2,1);
              if st[1] in ['-','+'] then while (st[2]='0')and(length(st)>1) do delete(st,2,1);
              if st='-2147483648'then st:='((-2147483647)-1)';
            end
          else error(lineNumber,13);
        end;
      st:='writeLn('+st+');';
      compileSimpleOperator:=st;
      exit;
    end;
  if stringUpCase(copy(killSpaceFromStringStart(op),1,6))='RETURN' then
    begin
      if currentmainSymbol='' then error(lineNumber,10);
      st:=killSpaceFromStringStart(stringUpCase(copy(killSpaceFromStringStart(op),7,255)));
      if (st[1] in ['A'..'Z'])then
        begin
          if length(killSpacefromStringEnd(st))<>1 then error(lineNumber,12);
        end
      else
        begin
          st:=killSpaceFromStringEnd(st);
          if isLongint(st) then
            begin
              if st='-2147483648'then st:='((-2147483647)-1)';
            end
          else error(lineNumber,13);
        end;
      st:=currentMainSymbol+':='+st+';exit;';
      compileSimpleOperator:=st;
      exit;
    end;

  if stringUpCase(copy(killSpaceFromStringStart(op),1,2))='IF' then
    begin
      st:=killSpaceFromStringStart(stringUpCase(copy(killSpaceFromStringStart(op),3,255)));
      if not (upCase(st[1]) in['A'..'Z']) then error (0,6);
      myst:='if ('+st[1]+'<>0) then begin ';
      st:=killSpaceFromStringStart(copy(st,2,255));
      if stringUpCase(copy(killSpaceFromStringStart(st),1,4))<>'THEN'then error(lineNumber,6);
      st:=killSpaceFromStringStart(stringUpCase(copy(killSpaceFromStringStart(st),5,255)));
      st:=myst+compileSimpleOperator(st)+'end;';
      compileSimpleOperator:=st;
      exit;
    end;
  if pos(stringUpCase(copy(killSpaceFromStringStart(op),1,1)),'ABCDEFGHIJKLMNOPQRSTUVWXYZ')<>0 then
    begin
      st:=stringUpCase(copy(killSpaceFromStringStart(op),1,255));
      mySt:=st[1]+':=ord(';

      st:=killSpaceFromStringStart(copy(st,2,255));
      if st[1]<>'=' then error(lineNumber,9);
      st:=killSpaceFromStringStart(copy(st,2,255));
      st2:=st[1];delete(st,1,1);
      while (st[1]in ['0'..'9'])and(length(st)<>0) do
        begin
          st2:=st2+st[1];
          delete(st,1,1);
        end;
      if (st2[1] in ['A'..'Z'])then
        begin
          if length(killSpacefromStringEnd(st2))<>1 then error(lineNumber,12);
        end
      else
        begin
          st2:=killSpaceFromStringEnd(st2);
          if isLongint(st2) then
            begin
              while (st2[1]='0')and(length(st2)>1) do delete(st2,2,1);
              if st2[1] in ['-','+'] then while (st2[2]='0')and(length(st2)>1) do delete(st2,2,1);
              if st2='-2147483648'then st2:='((-2147483647)-1)';
            end
          else error(lineNumber,13);
        end;
      mySt:=mySt+st2+'(';
      j:=findFunction(UpCase(st2[1]));
      if j<>0 then
        begin
          st:=killSpaceFromStringStart(st);
          if st[1]<>'(' then
            begin
              error(lineNumber,1);
            end;
          st:=killSpaceFromStringStart(copy(st,2,255));
          i:=0;
          while (st[1]<>')')and(st<>'') do
            begin
              if upCase(st[1])in['A'..'Z'] then
                begin
                  myst:=myst+st[1]+',';inc(i);
                end;
              st:=killSpaceFromStringStart(copy(st,2,255));
              if not(st[1]in[',',')']) then error(lineNumber,3);
              if st[1]=')' then break;
              st:=killSpaceFromStringStart(copy(st,2,255));
            end;
          if st[1]<>')' then error(i,2);
          if i<>length(functionTable[j].parameters)then error(lineNumber,15);
          dec(myst[0],1);
          myst:=myst+')';
          if i=0 then dec(myst[0],1);
          myst:=myst+');';
          compileSimpleOperator:=myst;
          exit;
        end
      else
        dec(myst[0],1);
      st:=killSpaceFromStringStart(st);
      if st<>'' then
        begin
          if not (st[1] in['-','+','*','>','<','='])then error(lineNumber,9);
          myst:=myst+st[1];delete(st,1,1);
          st:=killSpaceFromStringStart(st);
          st2:=st[1];delete(st,1,1);
          while (st[1]in ['0'..'9'])and(length(st)<>0) do
            begin
              st2:=st2+st[1];
              delete(st,1,1);
            end;
          if (st2[1] in ['A'..'Z'])then
            begin
              if length(killSpacefromStringEnd(st2))<>1 then error(lineNumber,12);
            end
          else
            begin
              st2:=killSpaceFromStringEnd(st2);
              if isLongint(st2) then
                begin
                  while (st2[1]='0')and(length(st2)>1) do delete(st2,2,1);
                  if st2[1] in ['-','+'] then while (st2[2]='0')and(length(st2)>1) do delete(st2,2,1);
                  if st2='-2147483648'then st2:='((-2147483647)-1)';
                end
              else
                error(lineNumber,13);
            end;
          myst:=myst+st2;
        end;
      myst:=myst+');';
      compileSimpleOperator:=myst;
      exit;
    end;
  if killSpaceFromStringStart(op)='' then
    begin
      compileSimpleOperator:='';
      exit;
    end;
  error(lineNumber,8);
end;
begin
  assign(fout,outFile);
  rewrite(fout);
  for i:=1 to functionCount do
    with functiontable[i] do
      begin
        write(fout,'function ');
        write(fout,name);
        if parameters<>'' then
          begin
            write(fout,'(');
            for j:=1 to length(parameters)-1 do
              write(fout,parameters[j],',');
            write(fout,parameters[length(parameters)],':longint)');
          end;
        writeln(fout,':longint;forward;');
      end;
  for i:=1 to functionCount do
    with functionTable[i] do
      begin
        write(fout,'function ');
        write(fout,name);
        if parameters<>'' then
          begin
            write(fout,'(');
            for j:=1 to length(parameters)-1 do
              write(fout,parameters[j],',');
            write(fout,parameters[length(parameters)],':longint)');
          end;
        writeln(fout,':longint;');
        writeln(fout,'var');
        write(fout,'  ');
        st:='';
        for ch:='a' to 'z' do if (name<>upCase(ch))and(pos(upCase(ch),parameters)=0) then
          st:=st+ch+',';
        dec(st[0]);
        writeln(fout,st,' :longint;');
        writeln(fout,'begin');
        write(fout,'  ');
        for ch:='a' to 'm' do if (name<>upCase(ch))and(pos(upCase(ch),parameters)=0) then
          begin
            write(fout,ch,':=0;');
          end;
        writeln(fout);
        write(fout,'  ');
        for ch:='n' to 'z' do if (name<>upCase(ch))and(pos(upCase(ch),parameters)=0) then
          begin
            write(fout,ch,':=0;');
          end;
        writeln(fout);
        currentMainSymbol:=name;
        for j:=1 to bodyL do
          begin
            lineNumber:=linesNo[j];
            writeln(fout,'  ',compileSimpleOperator(killSpaceFromString(body[j])));
          end;
        writeln(fout,'end;');
      end;
  currentMainSymbol:='';
  writeln(fout,'var');
  write(fout,'  ');
  st:='';
  for ch:='a' to 'z' do
    if findFunction(upCase(ch))=0 then
      write(fout,ch,',');
  writeln(fout,'bugVariable:longint;');
  writeln(fout,'begin');
  writeln(fout,'  assign(output,''output.txt'');');
  writeln(fout,'  rewrite(output);');
  for j:=1 to mainL-1 do
    begin
      lineNumber:=linesNo[j];
      writeln(fout,'  ',compileSimpleOperator(killSpaceFromString(mainText[j])));
    end;
  writeln(fout,'  close(output);');
  writeln(fout,'end.');
  close(fout);
end;
begin
{  clrscr;}
  assign(fin,'INPUT.TXT');
  reset(fin);
  readln(fin,command);
  command:=stringUpCase(command);
  progL:=0;
  i:=0;
  while not eof(fin) do
    begin
      inc(progL);
      readln(fin,prog[progL]);inc(i);
      linesNo[progL]:=i;
      if (prog[progL][1]='#')and(prog[progL]<>'') then dec(progL);
      if progL =programLength then error(progL,7);
    end;
  inc(progL);
  prog[progL]:='end';
  close(fin);
  buildFunctionTable;
  if command='COMPILE' then
    begin
      compile('outPut.pas');
      halt;
    end;
  if (command='RUN')or(command='DEBUG') then
    begin
      compile('nul');
      assign(fout,'output.txt');
      rewrite(fout);
      writeln(fout,'-2147483648');
      writeln(fout,2147483647);
      writeln(fout,2147483647);
      writeln(fout,-1);
      writeln(fout,0);
      close(fout);
    end;
end.