#define MAX				128

#include <stdio.h>
#include <string.h>

void input ();
int solve ();
void output ();
void wave (int vertex, int dir);

int n, m, start, end, matrix [MAX] [MAX], odd [MAX] [MAX], even [MAX] [MAX],
    been [MAX], answer [MAX], color [MAX], off [MAX], flag = 1, min;
char direct;


main ()
 {
	input ();
   memset (been, 0, n << 2);
   memset (answer, 0, n << 2);
   memset (off, 0, n << 2);
   memset (color, -1, n << 2);

   while (! solve ())
    {
      min = 0;
      flag = 0;

      for (int i = 1; i < n; i ++)
       if (odd [i] [i] && (i != start - 1))
        min = i;

      off [min] = 1;

      for (int i = 0; i < n; i ++)
       if (matrix [i] [min])
        matrix [i] [min] = matrix [min] [i] = 0;

		for (int i = 0; i < n; i ++)
		 for (int j = 0; j < n; j ++)
		  odd [i] [j] = even [i] [j] = 0;
    }

   wave (start - 1, (direct == 'O') || (direct == 'o'));    
	output ();

	return (0);
 }


void input ()
 {
	FILE * file = fopen ("tmission.dat", "r");
	fscanf (file, "%d %d", & n, & m);

	for (int i = 0; i < n; i ++)
	 for (int j = 0; j < n; j ++)
	  matrix [i] [j] = odd [i] [j] = even [i] [j] = 0;

	for (int i = 0; i < m; i ++)
	 {
		fscanf (file, "%d %d", & start, & end);
		matrix [start - 1] [end - 1] = matrix [end - 1] [start - 1] = 1;
		odd [start - 1] [end - 1] = odd [end - 1] [start - 1] = 1;
	 }

	fscanf (file, "%d\n%c", & start, & direct);

	fclose (file);
 }


int solve ()
 {
   for (int k = 0; k < n; k ++)
    for (int i = 0; i < n; i ++)
     for (int j = 0; j < n; j ++)
      {
        odd [i] [j] |= ((odd [i] [k] && even [k] [j]) || (even [i] [k] && odd [k] [j]));
        even [i] [j] |= ((odd [i] [k] && odd [k] [j]) || (even [i] [k] && even [k] [j]));
      }

   for (int i = 0; i < n; i ++)
    if (odd [i] [i] && (odd [i] [start] || even [i] [start]))
     return (0);

   return (1);
 }


void output ()
 {
 	FILE * file = fopen ("tmission.sol", "w");
   
   if (flag)
    fprintf (file, "W\n");
   else fprintf (file, "B\n");

   for (int i = 0; i < n; i ++)
    if (color [i] == 0)
     fprintf (file, "%d ", i + 1);

   fprintf (file, "\n");

   for (int i = 0; i < n; i ++)
    if (color [i] == 1)
     fprintf (file, "%d ", i + 1);
     
   fprintf (file, "\n");

   for (int i = 0; i < n; i ++)
    if (off [i])
     fprintf (file, "%d ", i + 1);
   
   fclose (file);
 }


void wave (int vertex, int dir)
 {
   if (been [vertex])
    {
    	if (color [vertex] != dir)
       flag = 0;

      return;
    }
    
 	color [vertex] = dir;
   been [vertex] = 1;

   for (int i = 0; i < n; i ++)
    if (matrix [vertex] [i])
     wave (i, ! dir);
 }
