#define EPS					1e-6
#define MAX					2000

#include <stdio.h>
#include <time.h>

void input ();
void solve ();
void output ();
inline long double triangle (long double x1, long double y1, long double x2,
                             long double y2, long double x3, long double y3);

int n, k, x [MAX], y [MAX], start [MAX], end [MAX],
    xmin = 20000, xmax = -20000, ymin = 20000, ymax = -20000, max = 0;
long double angle [MAX];


main ()
 {
 	input ();
   solve ();
   output ();
   
   return (0);
 }


void input ()
 {
   FILE * file = fopen ("input.txt", "r");
   fscanf (file, "%d", & n);

   for (int i = 0; i < n; i ++)
    {
      fscanf (file, "%d %d", & x [i], & y [i]);
      
      if (x [i] < xmin) xmin = x [i];
      if (x [i] > xmax) xmax = x [i];
      if (y [i] < ymin) ymin = y [i];
      if (y [i] > ymax) ymax = y [i];
    }

   fscanf (file, "%d", & k);

   for (int i = 0; i < k; i ++)
    {
      fscanf (file, "%d %d", & start [i], & end [i]);
      start [i] --; end [i] --;
    }

   fclose (file);
   ymax = ymax - ymin + 100;
   xmax = xmax - xmin + 100;
 }

 
void solve ()
 {
   int cur1, flag1, cur2, flag2, cur3, flag3;
   long double koeff1, xs1, ys1, xe1, ye1, koeff2, xs2, ys2, xe2, ye2, koeff3, xs3, ys3, xe3, ye3;

   for (int i = 0; i < k; i ++)
    if (x [start [i]] != x [end [i]])
     angle [i] = (y [start [i]] - y [end [i]]) / (x [start [i]] - x [end [i]]);
   
   for (int i = 0; i < n; i ++)
    for (int j = i + 1; j < n; j ++)
     if (fabs (x [i] - x [j]) + fabs (y [i] - y [j]) > EPS)
      {
        cur1 = flag1 = cur2 = flag2 = cur3 = flag3 = 0;

        if (fabs (x [i] - x [j]) < EPS)
         {
           xs1 = xe1 = x [i]; flag1 = 1;
           ys1 = ys2 = ys3 = ((long double) y [i] + y [j]) / 2 - ymax;
           ye1 = ye2 = ye3 = ((long double) y [i] + y [j]) / 2 + ymax;
           xs2 = x [i] - .5; xe2 = x [i] + .5; flag2 = 0;
           xs3 = x [i] + .5; xe3 = x [i] - .5; flag3 = 0;
         }
        else
         {
           xs1 = (x [i] + x [j]) / 2 - ymax;
           xe1 = (x [i] + x [j]) / 2 + ymax;
           koeff1 = ((long double) (y [i] - y [j])) / ((long double) (x [i] - x [j]));
           ys1 = (xs1 - x [i]) * koeff1 + y [i];
           ye1 = (xe1 - x [i]) * koeff1 + y [i];
           ys2 = ys1 - .5; ys3 = ys1 + .5;
           ye2 = ys1 + .5; ye3 = ys1 - .5;
           xs2 = xs3 = xs1; xe2 = xe3 = xe1;
           koeff2 = (ys2 - ye2) / (xs2 - xe2);
           koeff3 = (ys3 - ye3) / (xs3 - xe3);
         }

//        printf ("%Lf %Lf\n%Lf %Lf\n%Lf %Lf\n%Lf %Lf\n\n", xs1, ys1, xe1, ye1,
//             xs2, ys2, xe2, ye2);
        
        for (int l = 0; l < k; l ++)
         {
           if (fabs ((xs1 - x [i]) * (ys1 - ye1) - (xs1 - xe1) * (ys1 - y [i])) < EPS)
            continue;

           if (fabs ((xs1 - x [j]) * (ys1 - ye1) - (xs1 - xe1) * (ys1 - y [j])) < EPS)
            continue;
            
           if (fabsl (triangle (xs1, ys1, xe1, ye1, x [start [l]], y [start [l]]) +
               		 triangle (xs1, ys1, xe1, ye1, x [end [l]], y [end [l]]) -
              			 triangle (x [start [l]], y [start [l]], x [end [l]], y [end [l]], xs1, ys1) -
             			 triangle (x [start [l]], y [start [l]], x [end [l]], y [end [l]], xe1, ye1)) < EPS)
            cur1 ++;
         }

        if (cur1 > max)
         max = cur1;

        for (int l = 0; l < k; l ++)
         {
           if (fabs ((xs2 - x [i]) * (ys2 - ye2) - (xs2 - xe2) * (ys2 - y [i])) < EPS)
            continue;

           if (fabs ((xs2 - x [j]) * (ys2 - ye2) - (xs2 - xe2) * (ys2 - y [j])) < EPS)
            continue;
            
           if (fabsl (triangle (xs2, ys2, xe2, ye2, x [start [l]], y [start [l]]) +
               		 triangle (xs2, ys2, xe2, ye2, x [end [l]], y [end [l]]) -
              			 triangle (x [start [l]], y [start [l]], x [end [l]], y [end [l]], xs2, ys2) -
             			 triangle (x [start [l]], y [start [l]], x [end [l]], y [end [l]], xe2, ye2)) < EPS)
            cur2 ++;
         }

        if (cur2 > max)
         max = cur2;

        for (int l = 0; l < k; l ++)
         {
           if (fabs ((xs3 - x [i]) * (ys3 - ye3) - (xs3 - xe3) * (ys3 - y [i])) < EPS)
            continue;

           if (fabs ((xs3 - x [j]) * (ys3 - ye3) - (xs3 - xe3) * (ys3 - y [j])) < EPS)
            continue;

           if (fabsl (triangle (xs3, ys3, xe3, ye3, x [start [l]], y [start [l]]) +
               		 triangle (xs3, ys3, xe3, ye3, x [end [l]], y [end [l]]) -
              			 triangle (x [start [l]], y [start [l]], x [end [l]], y [end [l]], xs3, ys3) -
             			 triangle (x [start [l]], y [start [l]], x [end [l]], y [end [l]], xe3, ye3)) < EPS)
            cur3 ++;
         }

        if (cur3 > max)
         max = cur3;
         
        if (clock () > 14 * CLK_TCK)
         return;
      }
 }

 
void output ()
 {
 	FILE * file = fopen ("output.txt", "w");

   fprintf (file, "%d", max);

   fclose (file);
 }


inline long double triangle (long double x1, long double y1, long double x2,
                             long double y2, long double x3, long double y3)
 {
   return (.5 * fabs (x1 * (y3 - y2) + x2 * (y1 - y3) + x3 * (y2 - y1)));
 }
 
