#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

#define eps 0
#define xeps 1e-20

int N, K;
int x[2000], y[2000], f[1000], l[1000];
int max = 0;
double angles[2000];

int cmp( const void *x, const void *y )
{
  if (*(const double *)x < *(const double *)y)
    return -1;
  if (*(const double *)x > *(const double *)y)
    return 1;
  return 0;
}

void try2( double A, double B, double C )
{
  int cnt = 0, j;

  cnt += (eps == 0);
  for (j = 0; j < K; j++)
  {
    double z = A * x[f[j]] + B * y[f[j]] + C,
           t = A * x[l[j]] + B * y[l[j]] + C;
    if (((z < -xeps) && (t > xeps)) || ((z > xeps) && (t < -xeps)))
      cnt++;
  }
  if (cnt > max)
    max = cnt;
}

void try( double x_c, double y_c )
{
  int ang = 0, i;
  
  for (i = 0; i < N; i++)
    if ((x[i] != x_c) || (y[i] != y_c))
      angles[ang++] = atan2(y[i] - y_c, x[i] - x_c);
  qsort(angles, ang, sizeof(double), cmp);
  angles[ang] = angles[0] + 2 * M_PI;
  for (i = 0; i < ang; i++)
  {
    double an = (angles[i] + angles[i + 1]) / 2;
    double sine = sin(an), cosine = cos(an);

    try2(sine, -cosine, -x_c * sine + y_c * cosine);
  }
}


int main( void )
{
  int i;
  clock_t term_time = clock() + CLOCKS_PER_SEC * 10,
          exit_time = clock() + CLOCKS_PER_SEC * 13;

  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  scanf("%i", &N);
  for (i = 0; i < N; i++)
    scanf("%i %i", &x[i], &y[i]);
  scanf("%i", &K);
  for (i = 0; i < K; i++)
    scanf("%i %i", &f[i], &l[i]), f[i]--, l[i]--;
  for (i = 0; i < K; i++)
  {
    double x1 = x[f[i]], y1 = y[f[i]], x2 = x[l[i]], y2 = y[l[i]];

    if (clock() >= term_time)
      break;
    try((1 - eps) * x1 + eps * x2, (1 - eps) * y1 + eps * y2);
    try((1 - eps) * x2 + eps * x1, (1 - eps) * y2 + eps * y1);
  }
  while (1)
  {
    if (clock() >= exit_time)
      break;
    try2(rand() / (double)RAND_MAX - 0.5,
         rand() / (double)RAND_MAX - 0.5,
         (rand() / (double)RAND_MAX - 0.5) * 100);
  }
  printf("%i\n", max);
  return 0;
}

