{$I-,Q-,R-,S-,V-,X-}
Program TelmetryIsNotBack;
Const
  InFile='TELE.IN';
  OutFile='TELE.OUT';
  MaxN=1002;
  ByCh:Array[-1..1]Of Char='- +';
Type
  PList=^TList;
  TList=Record
    What:Word;
    By:ShortInt;
    Next,Prev:PList;
  End;
Var
  N:Word;
  P:Array[1..MaxN]Of Word;
  C:Array[1..MaxN]Of Word;
  CC:Array[1..MaxN]Of Word;
  IsSol:Boolean;
  Sol:PList;
  EvenID:Word;
Procedure Load;
Var
  I:Word;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  For I:=1 To N Do If Not SeekEOF Then Read(P[I]);
  For I:=1 To N Do If Not SeekEOF Then Read(C[I]);
  Close(Input);
End;
Function FindEvenP:Word;
Var
  I:Word;
Begin
  For I:=1 To N Do If Not Odd(P[I]) Then Begin
    FindEvenP:=I;
    Exit;
  End;
  FindEvenP:=0;
End;
Function CountNonOne:Word;
Var
  I,J:Word;
Begin
  J:=0;
  For I:=1 To N Do If P[I]>1 Then Inc(J);
  CountNonOne:=J;
End;
Procedure Insert(Var L:PList; What:Word; By:ShortInt);
Var
  P:PList;
Begin
  New(P);
  P^.What:=What;
  P^.By:=By;
  If L=Nil Then Begin
    P^.Next:=P;
    P^.Prev:=P;
    L:=P;
  End Else Begin
    P^.Next:=L;
    P^.Prev:=L^.Prev;
    L^.Prev^.Next:=P;
    L^.Prev:=P;
  End;
End;
Procedure FreeList(P:PList);
Begin
  If (P^.Prev<>Nil) Then
    P^.Prev^.Next:=Nil;
  While P^.Next<>Nil Do Begin
    P:=P^.Next;
    Dispose(P^.Prev);
  End;
  Dispose(P);
End;
Procedure EvenSolution;
Var
  Cycle,OCycle,CPos:PList;
  I,J,K:Integer;
  NEq:Word;
Begin
  Cycle:=Nil;
  For I:=1 To N Do If (I<>EvenID) And (P[I]>1) Then Begin
    If Cycle=Nil Then Begin
      Insert(Cycle,I,+1);
      For J:=1 To P[EvenID] Do Begin
        If J>1 Then Insert(Cycle,EvenID,+1);
        For K:=2 To P[I]-1 Do
          Insert(Cycle,I,Ord(Odd(J))*2-1);
      End;
      Insert(Cycle,I,-1);
      For J:=1 To P[EvenID]-1 Do
        Insert(Cycle,EvenID,-1);
    End Else Begin
      OCycle:=Cycle;
      Cycle:=Nil;
      CPos:=OCycle;
      For J:=1 To P[I] Do Begin
        If J>1 Then Insert(Cycle,I,+1);
        Repeat
          Case Odd(J) Of
            True:Begin
              If CPos^.Next=OCycle Then Break;
              Insert(Cycle,CPos^.What,CPos^.By);
              CPos:=CPos^.Next;
            End;
            False:Begin
              If CPos^.Prev=OCycle Then Break;
              CPos:=CPos^.Prev;
              Insert(Cycle,CPos^.What,-CPos^.By);
            End;
          End;
        Until False;
      End;
      Case Odd(P[I]) Of
        True:Begin
          Insert(Cycle,CPos^.What,CPos^.By);
          CPos:=CPos^.Next;
        End;
        False:Begin
          CPos:=CPos^.Prev;
          Insert(Cycle,CPos^.What,-CPos^.By);
        End;
      End;
      For J:=1 To P[I]-1 Do Insert(Cycle,I,-1);
      FreeList(OCycle);
    End;
  End;
  Sol:=Cycle;
  For I:=1 To N Do CC[I]:=1;
  NEq:=0;
  For I:=1 To N Do If C[I]=CC[I] Then Inc(NEq);
  While NEq<N Do Begin
    If C[Sol^.What]=CC[Sol^.What] Then Dec(NEq);
    Inc(CC[Sol^.What],Sol^.By);
    If C[Sol^.What]=CC[Sol^.What] Then Inc(NEq);
    Sol:=Sol^.Next;
  End;
  IsSol:=True;
End;
Procedure OddSolution;
Var
  I:Integer;
  Ok:Boolean;
  Dir:Array[1..MaxN]Of ShortInt;
Begin
  IsSol:=False;
  For I:=1 To N Do If (C[I]<>1) And (C[I]<>P[I]) Then Exit;
  IsSol:=True;
  For I:=1 To N Do If (P[I]>1) Then
    If C[I]=1 Then Dir[I]:=+1 Else Dir[I]:=-1;
  Sol:=Nil;
  Repeat
    Ok:=True;
    For I:=1 To N Do If (P[I]>1) And (C[I]+Dir[I]>=1) And (C[I]+Dir[I]<=P[I]) Then Begin
      Inc(C[I],Dir[I]);
      Insert(Sol,I,Dir[I]);
      Ok:=False;
      Break;
    End Else Dir[I]:=-Dir[I];
  Until Ok;
  If Sol<>Nil Then Begin
    Sol^.Prev^.Next:=Nil;
    Sol^.Prev:=Nil;
  End;
End;
Procedure Solve;
Begin
  EvenID:=FindEvenP;
  If (CountNonOne>1) And (EvenID>0) Then
    EvenSolution
  Else
    OddSolution;
End;
Procedure Save;
Var
  P:PList;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  If IsSol Then Begin
    WriteLn('Yes');
    If Sol<>Nil Then Begin
      P:=Sol;
      Repeat
        If (P^.Next=Nil) Or (P^.Next<>Sol) Then Begin
          WriteLn(P^.What,' ',ByCh[P^.By]);
        End;
        P:=P^.Next;
      Until (P=Sol) Or (P=Nil);
    End;
  End Else WriteLn('No');
  Close(Output);
  If Sol<>Nil Then FreeList(Sol);
End;
Begin
  Load;
  Solve;
  Save;
End.
