{$I-,Q-,R-,S-,V-,X-}
Program TheYoungPhysician;
Const
  InFile='INPUT.TXT';
  OutFile='OUTPUT.TXT';
  MaxN=1002;
  MaxK=502;
  Eps=1E-7;
Type
  Real=Extended;
  TPoint=Record
    X,Y:Real;
  End;
  TLine=Record
    A,B,C:Real;
  End;
Var
  N:Word;
  S:Array[1..MaxN]Of TPoint;
  K:Word;
  V:Array[1..MaxK,0..1]Of TPoint;
  Result:LongInt;
Procedure Load;
Var
  I,A,B:Word;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  For I:=1 To N Do If Not SeekEOF Then Read(S[I].X,S[I].Y);
  If Not SeekEOF Then Read(K);
  For I:=1 To K Do If Not SeekEOF Then Begin
    Read(A,B);
    V[I,0]:=S[A];
    V[I,1]:=S[B];
  End;
  Close(Input);
End;
Procedure LineByPoints(Var A,B:TPoint; Var L:TLine);
Var
  Z:Real;
Begin
  L.A:=B.Y-A.Y;
  L.B:=A.X-B.X;
  L.C:=-(L.A*A.X+L.B*A.Y);
  Z:=Sqrt(Sqr(L.A)+Sqr(L.B));
  L.A:=L.A/Z;
  L.B:=L.B/Z;
  L.C:=L.C/Z;
End;
Function Sign(A:Real):ShortInt;
Begin
  If A<-Eps Then Sign:=-1 Else If A>Eps Then Sign:=1 Else Sign:=0;
End;
Procedure Solve;
Var
  I,J,II:Word;
  L:TLine;
  S1,S2:ShortInt;
  CRes:Word;
Begin
  Result:=0;
  For I:=1 To N Do Begin
    For J:=1 To N Do If I<>J Then Begin
      LineByPoints(S[I],S[J],L);
      L.C:=L.C+3*Eps;
      CRes:=0;
      For II:=1 To K Do Begin
        S1:=Sign(L.A*V[II,0].X+L.B*V[II,0].Y+L.C);
        S2:=Sign(L.A*V[II,1].X+L.B*V[II,1].Y+L.C);
        If (S1<>S2) Then Inc(CRes);
      End;
      If CRes>Result Then Begin
        Result:=CRes;
      End;
    End;
  End;
End;
Procedure Save;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(Result);
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
