{$I-,Q-,R-,S-,V-,X-}
uses crt;
const eps=0.000001;
var
  fin,fout:text;
  n,k,i:integer;
  stolb:array[1..1000]of record x,y:double; end;
  pstolb:array[1..1000]of double;
  wire:array[1..500]of record a,b:integer; end;
  projection:array[1..1000]of record delta:integer;x:double; end;
  max:integer;
  t:double;
  tStep:double;
function cmp(d1:integer;x1:double;d2:integer;x2:double):integer;
begin
  if abs(x1-x2)<eps then
    begin
      if d1>d2 then cmp:=1;
      if d1=d2 then cmp:=0;
      if d1<d2 then cmp:=-1;
      exit;
    end;
  if x1>x2 then cmp:=1;
  if x1<x2 then cmp:=-1;
end;
procedure qSort(l,r:integer);
var td,i,j,md:integer;
mx,tx:double;
begin
  md:=projection[(l+r)div 2].delta;
  mx:=projection[(l+r)div 2].x;
  i:=l;j:=r;
  repeat
    while cmp(md,mx,projection[i].delta,projection[i].x)=1 do inc(i);
    while cmp(md,mx,projection[j].delta,projection[j].x)=-1 do dec(j);
    if i<=j then
      begin
        td:=projection[i].delta;projection[i].delta:=projection[j].delta;projection[j].delta:=td;
        tx:=projection[i].x;projection[i].x:=projection[j].x;projection[j].x:=tx;
        inc(i);dec(j);
      end;
  until i>j;
  if l<j then qSort(l,j);
  if i<r then qSort(i,r);
end;
procedure project(vx,vy:double);
var i:integer;
curMax:integer;
begin
  for i:=1 to n do
    pStolb[i]:=stolb[i].y*vx-stolb[i].x*vy;
  for i:=1 to k do
    begin
      if pStolb[wire[i].a]<pStolb[wire[i].b] then
        begin
          projection[i*2-1].delta:=1;
          projection[i*2-1].x:=pStolb[wire[i].a];
          projection[i*2].delta:=-1;
          projection[i*2].x:=pStolb[wire[i].b];
        end
      else
        begin
          projection[i*2-1].delta:=1;
          projection[i*2-1].x:=pStolb[wire[i].b];
          projection[i*2].delta:=-1;
          projection[i*2].x:=pStolb[wire[i].a];
        end
    end;
  qSort(1,2*k);
  curMax:=0;
  for i:=1 to 2*k do
    begin
      curMax:=curMax+projection[i].delta;
      if max<curMax then max:=curMax;
    end;
end;
begin
  assign(fin,'input.txt');
  reset(fin);
  readln(fin,n);
  for i:=1 to n do read(fin,stolb[i].x,stolb[i].y);
  readln(fin);
  readln(fin,k);
  for i:=1 to k do read(fin,wire[i].a,wire[i].b);
  close(fin);

  max:=0;
  tStep:=0.15;
  for i:=1 to 5 do
    begin
      t:=0;
      repeat
        project(cos(t),sin(t));
        t:=t+tStep;
      until t>Pi;
      tStep:=tStep*0.5;
    end;
  for i:=1 to 100 do
    begin
      t:=random*pi;
      project(cos(t),sin(t));
    end;
  assign(fout,'output.txt');
  rewrite(fout);
  writeln(fout,Max);
  close(fout);
end.
