#define INF					2000000000
#define MAX					128
#define RES					MAX - 1

#include <stdio.h>
#include <string.h>

void input ();
void solve ();
void output ();
int single (int cur);
void process (int row, int cur);
int count (int row, int first, int second, int div);
void get_pi (int cur, int len);
int put_pi (int * pi, int len);
void wave (int k, int l);

int matrix [MAX] [4] [MAX] [4], n, m, first, second, min = 0, pi [MAX], ptr = 1, answer [MAX] [4];
int dynamics [MAX] [30], last [MAX] [30], fact [MAX], been [MAX], wbeen [MAX] [4];


main ()
 {
 	input ();
//   solve ();
   output ();

   return (0);
 }


void input ()
 {
   int x1, y1, x2, y2;
   
   FILE * file = fopen ("nalog.in", "r");
   fscanf (file, "%d %d", & n, & m);

   for (int i = 0; i < n; i ++)
    for (int j = 0; j < 4; j ++)
     for (int k = 0; k < n; k ++)
      for (int l = 0; l < 4; l ++)
       matrix [i] [j] [k] [l] = 0;

   for (int i = 0; i < m; i ++)
    {
      fscanf (file, "%d %d %d %d", & x1, & y1, & x2, & y2);
      matrix [y1 - 1] [x1 - 1] [y2 - 1] [x2 - 1] = 1;
    }
   
   fclose (file);
 }
 

void solve ()
 {
   fact [0] = 1;

   for (int i = 1; i < 10; i ++)
    fact [i] = i * fact [i - 1];
    
   for (int i = 0; i < n; i ++)
    for (int j = 0; j < 24; j ++)
     dynamics [i] [j] = INF;

   for (int i = 0; i < 24; i ++)
    dynamics [0] [i] = single (i);

   for (int i = 0; i < n - 1; i ++)
    for (int j = 0; j < 24; j ++)
     for (int k = 0; k < 24; k ++)
      for (int l = 0; l < 70; l ++)
       {
	      if (dynamics [i + 1] [k] > dynamics [i] [j] + count (i, j, k, l))
   	    {
      	   dynamics [i + 1] [k] = dynamics [i] [j] + count (i, j, k, l);
         	last [i + 1] [k] = (l * 24 + k) * 24 + j;
	       }
	     }

   for (int i = 0; i < n; i ++)
    for (int j = 0; j < 4; j ++)
     for (int k = 0; k < n; k ++)
      for (int l = 0; l < 4; l ++)
       matrix [i] [j] [k] [l] = wbeen [i] [j] = 0;

   for (int i = 1; i < 24; i ++)
    if (dynamics [n - 1] [i] < dynamics [n - 1] [min])
     min = i;

   for (int i = n - 1; i >= 0; i --)
    {
      process (i - 1, last [i] [min]);
      min = last [i] [min] % 24;
    }

   for (int i = 0; i < n; i ++)
    for (int j = 0; j < 4; i ++)
     if (! wbeen [i] [j])
      wave (i, j);
 }
 

void output ()
 {
 	FILE * file = fopen ("nalog.out", "w");

   for (int i = 0; i < 4; i ++)
    {
	  for (int j = 0; j < n; j ++)
      fprintf (file, "%d ", /*answer [j] [i]*/ i * n + j + 1);

     fprintf (file, "\n");
    }
   
   fclose (file);
 }


int single (int cur)
 {
   int flag = 0;
   get_pi (cur, 4);

   for (int i = 0; i < 4; i ++)
    for (int j = 0; j < 4; j ++)
     flag += (matrix [i] [0] [j] [0] && (pi [i] < pi [j]));

   return (flag);
 }


void process (int row, int cur)
 {
   get_pi (cur, 8);

   for (int i = 0; i < 8; i ++)
    for (int j = 0; j < 8; j ++)
     matrix [row + i / 4] [i % 4] [row + j / 4] [j % 4] = (pi [i] < pi [j]);
 }


int count (int row, int first, int second, int div)
 {
   int flag = 0, old [10];
   get_pi (first, 4);
   memcpy (old, pi, 16);
   get_pi (second, 4);

   for (int i = 0; i < 8; i ++)
    for (int j = 0; j < 8; j ++)
     flag += (matrix [row + i / 4] [i % 4] [row + j / 4] [j % 4] &&
             (pi [i] < pi [j]));

   return (flag);
 }


void get_pi (int cur, int len)
 {
   int count, num, been [10];
   memset (been, 0, len << 2);

   for (int i = 0; i < len; i ++)
    {
      count = 0;
      num = cur / fact [len - i - 1];
      cur %= fact [len - i - 1];

      while (been [count]) count ++;
      
      for (int j = 0; j < num; j ++)
       {
         count ++;
         while (been [count]) count ++;
       }

      pi [i] = count;
      been [count] = 1;
    }
 }

 
int put_pi (int * pi, int len)
 {
   int answer = 0, num, been [10];
   memset (been, 0, len << 2);

   for (int i = 0; i < len; i ++)
    {
      num = 0;
      
      for (int j = 0; j != pi [i]; j ++)
       if (! been [j])
        num ++;
       
      answer += fact [len - i - 1] * num;
      been [pi [i]] = 1;
    }

   return (answer);
 }


void wave (int k, int l)
 {
   wbeen [k] [l] = 1;

   for (int i = 0; i < n; i ++)
    for (int j = 0; j < 4; j ++)
     if ((! wbeen [i] [j]) && matrix [k] [l] [i] [j])
      wave (i, j);

   answer [k] [l] = ptr ++;
 }
