#define LEN							10
#define MAX							64

#include <stdio.h>
#include <string.h>
#include <math.h>

void input ();
void solve ();
void output ();
void init (int * l, int n);
void add (int * a, int * b);
void sub (int * a, int * b);
int less (int * a, int * b);
void shift (int * a, int n);
int find_price ();

int n, m, a, b, ptr = 0;
int matrix [MAX] [MAX], list [MAX];
int deixtra [MAX] [800] [LEN], k [LEN];


main ()
 {
 	input ();
   solve ();
   output ();

   return (0);
 }


void input ()
 {
   int start, end, price;
   
 	FILE * file = fopen ("input.doc", "r");
   fscanf (file, "%d %d %d %d ", & n, & m, & a, & b);
   a --; b --;

   char chr = fgetc (file);
   init (k, 0);
   
   while ((chr >= '0') && (chr <= '9'))
    {
      shift (k, chr - '0');
      chr = fgetc (file);
    }

   for (int i = 0; i < n; i ++)
    for (int j = 0; j < n; j ++)
     for (int k = 0; k < 12; k ++)
      {
        matrix [i] [j] = 0;
        init (deixtra [i] [k], 0);
      }

   for (int i = 0; i < m; i ++)
    {
    	fscanf (file, "%d %d %d", & start, & end, & price);
      matrix [start - 1] [end - 1] = price;
    }
    
   fclose (file);
 }

 
void solve ()
 {
   int price = find_price (), vertex = a;

   while (vertex != b)
    {
    	for (int i = 0; i < n; i ++)
       if (matrix [vertex] [i])
        if (less (k, deixtra [i] [price - matrix [vertex] [i]]))
         {
           list [ptr ++] = vertex;
           price -= matrix [vertex] [i];           
           vertex = i;
           break;
         }
        else sub (k, deixtra [i] [price - matrix [vertex] [i]]);
    }
 }

 
void output ()
 {
 	FILE * file = fopen ("output.doc", "w");

   for (int i = 0; i < ptr; i ++)
    fprintf (file, "%d ", list [i] + 1);

   fprintf (file, "%d\n", b + 1);
   
   fclose (file);
 }


int find_price ()
 {
   init (deixtra [b] [0], 1);

   for (int i = 0; i < 800; i ++)
    for (int j = 0; j < n; j ++)
     for (int k = 0; k < n; k ++)
      if (matrix [k] [j])
       add (deixtra [k] [i + matrix [k] [j]], deixtra [j] [i]);

   for (int i = 0; i < 800; i ++)
    if (less (k, deixtra [a] [i]))
     return (i);
    else sub (k, deixtra [a] [i]);
 }


void init (int * l, int n)
 {
 	memset (l, 0, LEN << 2);
   l [0] = n;
 }

 
void add (int * a, int * b)
 {
   int c = 0;

   for (int i = 0; i < LEN; i ++)
    {
    	c += a [i] + b [i];
      a [i] = c % 1000000;
      c /= 1000000;
    }
 }

 
void sub (int * a, int * b)
 {
   int c = 0;

   for (int i = 0; i < LEN; i ++)
    {
    	c += a [i] - b [i];
      a [i] = (1000000 + c) % 1000000;
      
      if (c < 0)
       {
         c /= 1000000;
         c --;
       }
      else c /= 1000000;
    }
 }

 
int less (int * a, int * b)
 {
 	for (int i = LEN - 1; i >= 0; i --)
    {
     if (a [i] < b [i]) return (1);
     if (a [i] > b [i]) return (0);
    }

   return (1);
 }


void shift (int * a, int n)
 {
   int c = 0;
   
   for (int i = 0; i < LEN; i ++)
    {
    	c += a [i] * 10;
      a [i] = c % 1000000;
      c /= 1000000;
    }

   a [0] += n;
 }

