#include <stdio.h>

int N;
int A[105][13];
int B[105][24], C[105][24][8];
int W[105][4];

const int SA[13] = {0, 1, 2, 3, 0, 1, 2, 1, 2, 3, 4, 5, 6};
const int SB[13] = {4, 5, 6, 7, 5, 6, 7, 4, 5, 6, 5, 6, 7};

void input()
{
  int i, j, M;
  FILE *f = fopen("NALOG.IN", "rt");
  fscanf(f, "%d%d", &N, &M);
  for (i = 0; i < 100; i++) for (j = 0; j < 13; j++) A[i][j] = 0;
  for (i = 0; i < M; i++)
  {
    int a, b, c, d, L, K;
    fscanf(f, "%d%d%d%d", &a, &b, &c, &d);
    b--; d--;
    if (d > b) L = d; else L = b;
    if (d == b)
    {
      if (a < c) A[L][9 + a] = 1;
      else A[L][9 + c] = -1;
    }
    else if (a == c)
    {
      A[L][a - 1] = d - b;
    }
    else if (b < d)
    {
      if (a < c) A[L][3 + a] = 1;
      else A[L][6 + c] = 1;
    }
    else
    {
      if (a > c) A[L][3 + c] = -1;
      else A[L][6 + a] = -1;
    }
  }
  fclose(f);
}

void output()
{
  int i, j;
  FILE *f = fopen("NALOG.out", "wt");
  for (i = 0; i < 4; i++)
  {
    for (j = 1; j <= N; j++) fprintf(f, "%d ", W[j][i]+1);
    fprintf(f, "\n");
  }
  fclose(f);
}

int Getk(int *p)
{
  int i;
  int R = 0;
  for (i = 1; i < 4; i++) if (p[i] < p[0]) R += 6;
  for (i = 2; i < 4; i++) if (p[i] < p[1]) R += 2;
  if (p[3] < p[2]) R++;
  return R;
}

int main()
{
  int i, j, k, t, u;
  int P[8];
  input();
  for (i = 0; i < 24; i++)
  {
    B[0][i] = 0;
    for (j = 0; j < 8; j++) C[0][i][j] = 0;
  }
  for (k = 0; k < N; k++)
  {
    for (i = 0; i < 24; i++)
    {
      B[k+1][i] = 10000;
      for (j = 0; j < 8; j++) C[k+1][i][j] = 0;
    }
    for (i = 0; i < 8; i++) P[i] = i;
    for (;;)
    {
      int R1 = Getk(P), R2 = Getk(P + 4), S = 0;
      for (i = 0; i < 13; i++)
      {
        if (P[SA[i]] < P[SB[i]]) {if (A[k][i] > 0) S++;}
        else if (A[k][i] < 0) S++;
      }
      if (B[k][R1] + S <= B[k+1][R2])
      {
        B[k+1][R2] = B[k][R1] + S;
        for (j = 0; j < 8; j++) C[k+1][R2][j] = P[j];
      }
      i = 6;
      while(i >= 0 && P[i] > P[i+1]) i--;
      if (i < 0) break;
      j = 7;
      while(P[j] < P[i]) j--;
      t = P[i]; P[i] = P[j]; P[j] = t;
      for (j = i + 1, u = 7; u > j; j++, u--)
      {
        t = P[j]; P[j] = P[u]; P[u] = t;
      }
    }
  }
  j = 0;
  for (i = 1; i < 24; i++) if (B[N][i] < B[N][j]) j = i;
  int M = 8;
  if (N > 1)
  {
    for (i = 0; i < 4; i++) W[N-1][i] = C[N][j][i];
    for (i = 0; i < 4; i++) W[N][i] = C[N][j][i+4];
  }
  else
  {
    for (i = 0; i < 4; i++) W[N][i] = C[N][j][i+4];
    for (i = 0; i < 4; i++)
    {
      int i1, j1 = -1;
      for (i1 = 0; i1 < 4; i1++) if (W[N][i1] >= i)
      {
        if (j1 < 0 || W[N][i1] < W[N][j1]) j1 = i1;
      }
      if (j1 >= 0) W[N][j1] = i;
    }
  }
  for (k = N-1; k > 1; k--)
  {
    j = Getk(C[k+1][j]);
    for (i = 0; i < 4; i++)
    {
      int i1, j1 = -1;
      for (i1 = 0; i1 < 8; i1++) if (i1 >= 4 || i1 < i)
      {
        if (C[k][j][i1] > C[k][j][i] &&
           (j1 < 0 || C[k][j][j1] > C[k][j][i1])) j1 = i1;
      }
      if (j1 < 0) W[k-1][i] = M;
      else
      {
        int M0;
        if (j1 >= 4) M0 = W[k][j1-4];
        else M0 = W[k-1][j1];
        int i2;
        for (i1 = k-1; i1 <= N; i1++) for (i2 = 0; i2 < 4; i2++)
        {
          if (W[i1][i2] >= M0) W[i1][i2]++;
        }
        W[k-1][i] = M0;
      }
      M++;
    }
  }
  output();
  return 0;
}
