{$I-,Q-,R-,S-,V-,X-}
Program CellularPhonesInTheVillage;
Const
  InFile='PHONE.IN';
  OutFile='PHONE.OUT';
  MaxN=10002;
  Eps=1E-8;
  Precision=1E-6;
Var
  N,K:LongInt;
  Dist:Array[1..MaxN]Of LongInt;
  Peop:Array[1..MaxN]Of LongInt;
  Res:LongInt;
  ResPos:Array[1..MaxN]Of Extended;
  Total:LongInt;
Procedure Load;
Var
  I:LongInt;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N,K);
  For I:=1 To N Do If Not SeekEOF Then Read(Dist[I]);
  Total:=0;
  For I:=1 To N Do If Not SeekEOF Then Begin
    Read(Peop[I]);
    Inc(Total,Peop[I]);
  End;
  Close(Input);
End;
Procedure SortPs;
Var
  I,T:LongInt;
  ON:LongInt;
Procedure FlowUp(From:LongInt);
Var
  T:LongInt;
Begin
  While (From>1) And (Dist[From Div 2]<Dist[From]) Do Begin
    T:=Dist[From Div 2];
    Dist[From Div 2]:=Dist[From];
    Dist[From]:=T;
    T:=Peop[From Div 2];
    Peop[From Div 2]:=Peop[From];
    Peop[From]:=T;
    From:=From Div 2;
  End;
End;
Procedure FlowDown(From:LongInt);
Begin
  While ((2*From<=N) And (Dist[2*From]>Dist[From])) Or ((2*From+1<=N) And (Dist[2*From+1]>Dist[From])) Do Begin
    If (2*From=N) Or (Dist[2*From]>Dist[2*From+1]) Then Begin
      T:=Dist[2*From];
      Dist[2*From]:=Dist[From];
      Dist[From]:=T;
      T:=Peop[2*From];
      Peop[2*From]:=Peop[From];
      Peop[From]:=T;
      From:=2*From;
    End Else Begin
      T:=Dist[2*From+1];
      Dist[2*From+1]:=Dist[From];
      Dist[From]:=T;
      T:=Peop[2*From+1];
      Peop[2*From+1]:=Peop[From];
      Peop[From]:=T;
      From:=2*From+1;
    End;
  End;
End;
Begin
  For I:=1 To N Do Begin
    FlowUp(I);
  End;
  ON:=N;
  For N:=ON-1 DownTo 1 Do Begin
    T:=Dist[1];
    Dist[1]:=Dist[N+1];
    Dist[N+1]:=T;
    T:=Peop[1];
    Peop[1]:=Peop[N+1];
    Peop[N+1]:=T;
    FlowDown(1);
  End;
  N:=ON;
End;
Function Enough(Chk:Extended):Boolean;
Var
  CMax:Extended;
  CUsed:LongInt;
  PrevPut:Extended;
  I:LongInt;
Begin
  CUsed:=0;
  CMax:=1E100;
  PrevPut:=-1E100;
  For I:=1 To N Do Begin
    If (Peop[I]*(Dist[I]-PrevPut)<Chk+Eps) Then Continue;
    If Dist[I]+Chk/Peop[I]<CMax Then CMax:=Dist[I]+Chk/Peop[I];
    If (Dist[I]=Dist[N]) Or (Dist[I+1]>CMax+Eps) Then Begin
      If (Dist[I]=Dist[N]) Then CMax:=Dist[I];
      Inc(CUsed);
      If CUsed>K Then Break;
      PrevPut:=CMax;
      ResPos[CUsed]:=CMax;
      CMax:=1E100;
    End;
  End;
  Enough:=(CUsed<=K);
  While CUsed<K Do Begin
    Inc(CUsed);
    ResPos[CUsed]:=Dist[N]+100000;
  End;
End;
Procedure Solve;
Var
  CUB,CLB,Chk:Extended;
  I:LongInt;
Begin
  SortPs;
  CLB:=0;
  CUB:=Dist[N]-Dist[1];
  CUB:=CUB*Total;
  While (CUB-CLB>Precision) Do Begin
    Chk:=(CLB+CUB)/2;
    If Enough(Chk) Then Begin
      CUB:=Chk;
    End Else Begin
      CLB:=Chk;
    End;
  End;
  If Enough(CUB) Then;
End;
Procedure Save;
Var
  I:LongInt;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  For I:=1 To K Do Begin
    If I>1 Then Write(' ');
    Write(ResPos[I]:0:8);
  End;
  WriteLn;
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
