#define LEN									100

#include <stdio.h>
#include <string.h>


void input ();
void solve1 ();
int solve2 ();
void output ();
void read (FILE * file, int * a);
void write (FILE * file, int * a);
int solve (int * m, int * n);
void init (int * l, int n);
void sub (int * a, int * b);
int less (int * a, int * b);
void add (int * a, int * b);
void shift (int * a, int n);

int n [LEN], p1 [LEN], q1 [LEN], p2 [LEN], q2 [LEN];


main ()
 {
 	input ();
   solve1 ();

   if (less (q1, n))
    output ();
   else
    {
	   solve2 ();
      memcpy (p1, p2, LEN << 2);
      memcpy (q1, q2, LEN << 2);
	   output ();      
    }

   return (0);
 }


void input ()
 {
 	FILE * file = fopen ("Input.txT.", "r");

   read (file, n);
   read (file, p1);
   read (file, q1);

   memcpy (p2, p1, LEN << 2);
   memcpy (q2, q1, LEN << 2);
   
   fclose (file);
 }

 
void solve1 ()
 {
   if (! memcmp (p1, q1, LEN << 2))
    {
    
      init (p1, 2);
      init (q1, 1);
    }
   else if (less (p1, q1))
    {
      sub (q1, p1);
      solve1 ();
      add (q1, p1);
    }
   else
    {
      sub (p1, q1);
      solve1 ();
      add (p1, q1);
    }
 }


int solve2 ()
 {
   if (! memcmp (p2, q2, LEN << 2))
    return (1);
   else if (less (p2, q2))
    {
      sub (q2, p2);

      if (solve2 ())
       return (0);

      add (q2, p2);
    }
   else
    {
      sub (p2, q2);

      if (solve2 ())
       return (1);

      add (p2, q2);
    }

   return (0);
 }
 

void output ()
 {
 	FILE * file = fopen ("Output.txT", "w");

   write (file, p1);
   fprintf (file, "\n");
   write (file, q1);

   fclose (file);
 }


void read (FILE * file, int * a)
 {
   char chr;
   
   do
    chr = fgetc (file);
   while ((chr < '0') || (chr > '9'));

   init (a, 0);
   
   while ((chr >= '0') && (chr <= '9'))
    {
      shift (a, chr - '0');
      chr = fgetc (file);
    }
 }


void write (FILE * file, int * a)
 {
   int flag = 0;
   
   for (int i = LEN - 1; i >= 0; i --)
    if (flag)
     fprintf (file, "%06d", a [i]);
    else if (a [i] || (i == 0))
     {
       fprintf (file, "%d", a [i]);
       flag = 1;
     }
 }


void init (int * l, int n)
 {
 	memset (l, 0, LEN << 2);
   l [0] = n;
 }

 
void sub (int * a, int * b)
 {
   int c = 0;

   for (int i = 0; i < LEN; i ++)
    {
    	c += a [i] - b [i];
      a [i] = (10000 + c) % 10000;
      
      if (c < 0)
       {
         c /= 10000;
         c --;
       }
      else c /= 10000;
    }
 }

 
int less (int * a, int * b)
 {
 	for (int i = LEN - 1; i >= 0; i --)
    {
     if (a [i] < b [i]) return (1);
     if (a [i] > b [i]) return (0);
    }

   return (1);
 }


void add (int * a, int * b)
 {
   int c = 0;

   for (int i = 0; i < LEN; i ++)
    {
    	c += a [i] + b [i];
      a [i] = c % 1000000;
      c /= 1000000;
    }
 }


void shift (int * a, int n)
 {
   int c = 0;
   
   for (int i = 0; i < LEN; i ++)
    {
    	c += a [i] * 10;
      a [i] = c % 10000;
      c /= 10000;
    }

   a [0] += n;
 }

