#include <stdio.h>

struct Number
{
  int L;
  int N[60];
};

void Copy(Number &a, Number &b)
{
  for (int i = 0; i < 60; i++) a.N[i] = b.N[i];
  a.L = b.L;
}
void SetNull(Number &a)
{
  for (int i = 0; i < 60; i++) a.N[i] = 0;
  a.L = 0;
}
int IsNull(Number &a)
{
  while(a.L > 0 && a.N[a.L-1] == 0) a.L--;
  return a.L == 0;
}

int Compare(Number &a, Number &b)
{
  IsNull(a); IsNull(b);
  if (a.L > b.L) return 1;
  else if (a.L < b.L) return -1;
  else
  {
    int i;
    for (i = a.L - 1; i >= 0 && a.N[i] == b.N[i]; i--);
    if (i < 0) return 0;
    else if (a.N[i] > b.N[i]) return 1;
    else return -1;
  }
}

void Sub(Number &a, Number &b)
{
  int i, t = 0;
  for (i = 0; i < a.L; i++)
  {
    a.N[i] -= b.N[i] + t;
    if (a.N[i] < 0) {a.N[i] += 10; t = 1;}
    else t = 0;
  }
}

void Summ(Number &a, Number &b)
{
  int i, t = 0;
  for (i = 0; i < b.L; i++)
  {
    a.N[i] += b.N[i] + t;
    if (a.N[i] >= 10) {a.N[i] -= 10; t = 1;}
    else t = 0;
  }
  while(t)
  {
    a.N[i]++;
    if (a.N[i] >= 10) {a.N[i] -= 10; t = 1;}
    else t = 0;
    i++;
  }
  if (i > a.L) a.L = i;
}

void AddMult(Number &a, Number &b, Number &c)
{
  int i, j;
  IsNull(b); IsNull(c);
  if (a.L < b.L + c.L - 1) a.L = b.L + c.L - 1;
  for (i = 0; i < b.L; i++)
  {
    for (j = 0; j < c.L; j++)
    {
      a.N[i+j] += b.N[i] * c.N[j];
      a.N[i+j+1] += a.N[i+j] / 10;
      a.N[i+j] %= 10;
    }
    while(a.N[i+j] >= 10)
    {
      a.N[i+j+1] += a.N[i+j] / 10;
      a.N[i+j] %= 10;
      j++;
    }
    if (a.N[i+j] && i+j >= a.L) a.L = i + j + 1;
  }
}

void Devide(Number &R, Number &P, Number &Q)
{
  int i, j;
  Number QR;
  SetNull(R);
  IsNull(P); IsNull(Q);
  R.L = P.L - Q.L + 1;
  for (i = P.L - Q.L; i >= 0; i--)
  {
    QR.L = Q.L + i;
    for (j = 0; j < i; j++) QR.N[j] = 0;
    for (j = i; j < 60; j++) QR.N[j] = Q.N[j - i];
    while(Compare(QR, P) <= 0) {Sub(P, QR); R.N[i]++;}
  }
}


Number N, P, Q, P1, Q1;

void ReadNumber(FILE *f, Number &nmb)
{
  int ch, i;
  nmb.L = 0;
  for (i = 0; i < 60; i++) nmb.N[i] = 0;
  do ch = fgetc(f); while(ch == ' ' || ch == '\n' || ch == '\t');
  while(ch >= '0' && ch <= '9')
  {
    nmb.N[nmb.L++] = ch - '0';
    ch = fgetc(f);
  }
  for (i = 0; i < nmb.L / 2; i++)
  {
    ch = nmb.N[i];
    nmb.N[i] = nmb.N[nmb.L - 1 - i];
    nmb.N[nmb.L - 1 - i] = ch;
  }
}

void WriteNumber(FILE *f, Number &nmb)
{
  int i;
  if (IsNull(nmb)) fprintf(f, "0");
  else
  {
    for (i = nmb.L - 1; i >= 0; i--) fprintf(f, "%d", nmb.N[i]);
  }
}

void input()
{
  FILE *f = fopen("Input.txT", "rt");
  ReadNumber(f, N);
  ReadNumber(f, P);
  ReadNumber(f, Q);
  fclose(f);
}

void output()
{
  FILE *f = fopen("Output.txT", "wt");
  WriteNumber(f, P1); fprintf(f, "\n");
  WriteNumber(f, Q1); fprintf(f, "\n");
  fclose(f);
}

int main()
{
  Number R, A1, A2, B1, B2;
  SetNull(A1); SetNull(A2); SetNull(B1); SetNull(B2);
  A2.L = 1; A2.N[0] = 1;
  B1.L = 1; B1.N[0] = 1;
  input();
  for(;;)
  {
    if (IsNull(Q))
    {
      Number W, K;
      Copy(W, N);
      Summ(W, B1);
      Devide(K, W, B2);
      SetNull(P1);
      AddMult(P1, K, A2);
      Sub(P1, A1);
      SetNull(Q1);
      AddMult(Q1, K, B2);
      Sub(Q1, B1);
      break;
    }
    Devide(R, P, Q);
    AddMult(A1, A2, R);
    AddMult(B1, B2, R);
    if (IsNull(P))
    {
      Number W, K;
      Copy(W, N);
      Sub(W, B2);
      Devide(K, W, B1);
      Copy(P1, A2);
      AddMult(P1, K, A1);
      Copy(Q1, B2);
      AddMult(Q1, K, B1);
      break;
    }
    Devide(R, Q, P);
    AddMult(A2, A1, R);
    AddMult(B2, B1, R);
  }
  output();
  return 0;
}
