{$I-,Q-,R-,S-,V-,X-}
Program SemiSort;
Const
  InFile='Input.TXT';
  OutFile='Output.TXT';
  MaxN=10002;
  MaxK=22;
  BufSize=32768;
Var
  N,K:LongInt;
  Out:Array[1..MaxN,1..MaxK]Of LongInt;
  NIn:Array[1..MaxN]Of LongInt;
  Heap:Array[1..MaxN]Of LongInt;
  Where:Array[1..MaxN]Of LongInt;
  Res:Array[1..MaxN]Of LongInt;
Procedure Load;
Var
  I,J:LongInt;
  Buf:Pointer;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  GetMem(Buf,BufSize);
  SetTextBuf(Input,Buf^,BufSize);
  Read(K);
  If Not SeekEOF Then Read(N);
  FillChar(NIn,SizeOf(NIn),0);
  For I:=1 To N Do
    For J:=1 To K Do If Not SeekEOF Then Begin
      Read(Out[I,J]);
      If Out[I,J]>0 Then Begin
        Inc(NIn[Out[I,J]]);
      End;
    End;
  Close(Input);
  FreeMem(Buf,BufSize);
End;
Procedure Solve;
Var
  I,J,Num:LongInt;
Procedure Swap(A,B:LongInt);
Var
  T:LongInt;
Begin
  Where[Heap[A]]:=B;
  Where[Heap[B]]:=A;
  T:=Heap[A];
  Heap[A]:=Heap[B];
  Heap[B]:=T;
End;
Procedure FlowUp(From:LongInt);
Begin
  If From>Num Then Exit;
  While (From>1) And (NIn[Heap[From Div 2]]>NIn[Heap[From]]) Do Begin
    Swap(From,From Div 2);
    From:=From Div 2;
  End;
End;
Procedure FlowDown(From:LongInt);
Begin
  If From>Num Then Exit;
  While ((2*From<=Num) And (NIn[Heap[2*From]]<NIn[Heap[From]])) Or ((2*From+1<=Num) And (NIn[Heap[2*From+1]]<NIn[Heap[From]])) Do Begin
    If (2*From=Num) Or (NIn[Heap[2*From]]<NIn[Heap[2*From+1]]) Then Begin
      Swap(From,2*From);
      From:=2*From;
    End Else Begin
      Swap(From,2*From+1);
      From:=2*From+1;
    End;
  End;
End;
Begin
  For Num:=1 To N Do Begin
    Heap[Num]:=Num;
    Where[Num]:=Num;
    FlowUp(Num);
  End;
  For Num:=N-1 DownTo 1 Do Begin
    J:=Heap[1];
    Res[Num+1]:=J;
    Where[Heap[1]]:=Num+1;
    Heap[1]:=Heap[Num+1];
    Where[Heap[1]]:=1;
    FlowDown(1);
    For I:=1 To K Do If Out[J,I]>0 Then Begin
      Dec(NIn[Out[J,I]]);
      FlowUp(Where[Out[J,I]]);
    End;
  End;
  Res[1]:=Heap[1];
End;
Procedure Save;
Var
  I:LongInt;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  For I:=1 To N Do Begin
    If I>1 Then Write(' ');
    Write(Res[I]);
  End;
  WriteLn;
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
