#include <math.h>

#define   MaxN     100

struct Town *t;
struct Way *w;
int V[MaxN][MaxN];
double B[MaxN][MaxN];

inline double fsqr(double x) {return x*x;}

int im, jm;
int ii;
int jj;
int C[MaxN][MaxN];
int R[MaxN];
int VV[MaxN];

int NQ;
int Q[2*MaxN];

void Find(int i)
{
  int j;
  VV[i] = 1;
  Q[NQ++] = i;
  for (j = 0; j < t->N; j++) if (!VV[j] && R[j] == i) Find(j);
}

void WritePath(int i, int j)
{
  if (V[i][j] < 0) w->W[w->M++] = j;
  else
  {
    WritePath(i, V[i][j]);
    WritePath(V[i][j], j);
  }
}

double MyWay(struct Town *t1, struct Way *w1)
{
  int i, j, k, bb;
  t = t1; w = w1;
  for (i = 0; i < t->N; i++) for (j = 0; j < t->N; j++)
  {
    V[i][j] = -1;
    if (i == j) B[i][j] = 0;
    else if (t->A[i][j]) B[i][j] = sqrt(fsqr(t->X[i][0] - t->X[j][0]) +
                                        fsqr(t->X[i][1] - t->X[j][1]));
    else B[i][j] = 1E+25;
  }
    printf("<B[0][4]=%lf (%lf)>", B[0][4], B[4][0]);
  for (k = 0; k < t->N; k++)
  {
    for (i = 0; i < t->N; i++) for (j = 0; j < t->N; j++)
    {
      if (B[i][j] > B[i][k] + B[k][j])
      {
    printf("<%d %d %d %lf=%lf+%lf)>", i, j, k, B[i][j], B[i][k], B[k][j]);

        B[i][j] = B[i][k] + B[k][j];
        V[i][j] = k;
        B[j][i] = B[i][j];
        V[j][i] = k;
      }
    }
  }
    printf("<B[0][4]=%lf (%lf)>", B[0][4], B[4][0]);
  im = 0; jm = 1;
  for (i = 0; i < t->N; i++) for (j = 0; j < t->N; j++)
  {
    if (i != j && B[i][j] < B[im][jm]) {im = i; jm = j;}
  }
  for (i = 0; i < t->N; i++) for (j = 0; j < t->N; j++) C[i][j] = 0;
  C[im][jm] = 1;
  for (i = 0; i < t->N; i++)
  {
    if (i == im || i == jm) VV[i] = 1;
    else
    {
      VV[i] = 0;
      R[i] = (B[i][im] < B[i][jm]) ? im : jm;
    }
  }
  R[jm] = im;
  R[im] = -1;
  for (;;)
  {
    i = -1;
    for (j = 0; j < t->N; j++)
    {
      if (!VV[j] && (i < 0 || B[j][R[j]] < B[i][R[i]])) i = j;
    }
    if (i < 0) break;
    VV[i] = 1;
    for (j = 0; j < t->N; j++)
    {
      if (!VV[j] && B[j][R[j]] > B[j][i]) R[j] = i;
    }
  }
  for (i = 0; i < t->N; i++) VV[i] = 0;
  NQ = 0;
  Find(im);
  do
  {
    bb = 0;
    for (i = 0; i < t->N - 1; i++)
    {
      for (j = i + 2; j < t->N - 1; j++)
      {
      if (B[Q[i]][Q[i+1]]+B[Q[j]][Q[j+1]] > B[Q[i]][Q[j]]+B[Q[i+1]][Q[j+1]])
      {
        for (ii = i + 1, jj = j; ii < jj; ii++, jj--)
        {
          int p = Q[ii];
          Q[ii] = Q[jj];
          Q[jj] = p;
        }
        bb = 1;
      }
      }
      if (i > 0 && i < t->N - 1 && B[Q[i]][Q[i+1]]+B[Q[t->N-1]][Q[0]] >
                                   B[Q[i]][Q[t->N-1]]+B[Q[i+1]][Q[0]])
      {
           printf(" w ");
        for (ii = i + 1, jj = t->N-1; ii < jj; ii++, jj--)
        {
          int p = Q[ii];
          Q[ii] = Q[jj];
          Q[jj] = p;
        }
        bb = 1;
      }
    }
  }
  while(bb);
  w->M = 1;
  w->W[0] = 0;
  for (i = 0; i < t->N; i++) if (Q[i] == 0) break;
  ii = i;
  double S = 0;
  do
  {
    j = i + 1;
    if (j >= t->N) j -= t->N;
    WritePath(Q[i], Q[j]);
    S += B[Q[i]][Q[j]];
    i = j;
  }
  while(i != ii);
  return S;
}
