#include <stdio.h>

int M, N;
double A[12][12], B[12][12];
double A1[12][12], B1[12][12];
double S;
int KZ;

inline double sqr(double x) {return x*x;}

void input()
{
  int i, j;
  FILE *f = fopen("input.txt", "rt");
  fscanf(f, "%d%d", &N, &M);
  for (i = 0; i < N; i++) for (j = 0; j < M; j++)
  {
    fscanf(f, "%lf", &A[i][j]);
  }
  for (i = 0; i < N; i++) for (j = 0; j < M; j++)
  {
    fscanf(f, "%lf", &B[i][j]);
  }
  fclose(f);
}

void circle(double w, int k, int x[], int y[], FILE *f)
{
  int i;
  if (fabs(w) < 1E-10) return;
  x[k] = x[0]; y[k] = y[0];
  for (i = 0; i < k; i++) if (x[i] == x[i+1])
  {
    int yy = (y[i] < y[i+1]) ? y[i] : y[i+1];
    A1[x[i]][yy] += w;
  }
  else
  {
    int xx = (x[i] < x[i+1]) ? x[i] : x[i+1];
    B1[xx][y[i]] += w;
  }
  if (f)
  {
    fprintf(f, "%lf %d", w, k);
    for (i = 0; i < k; i++) fprintf(f, " %d", 1 + M*x[i] + y[i]);
    fprintf(f, "\n");
  }
  KZ++;
}

void prnt(FILE *f)
{
  int x[10], y[10];
  double w;
  int i, j;
  for (i = 0; i < N; i++) for (j = 0; j < M-1; j++) A1[i][j] = A[i][j];
  for (i = 0; i < N-1; i++) for (j = 0; j < M; j++) B1[i][j] = B[i][j];
  if (N == 1 || M == 1) return;
  else if (N == 2 && M == 2)
  {
    w = -(A1[0][0] + A1[1][0] + B1[0][0] + B1[0][1]) / 4;
    x[0] = 0; y[0] = 0;
    x[1] = 1; y[1] = 0;
    x[2] = 1; y[2] = 1;
    x[3] = 0; y[3] = 1;
    circle(w, 4, x, y, f);
  }
  else if (N == 2)
  {
    w = -(A1[0][0] + A1[1][0] + B1[0][0]) / 3;
    x[0] = 0; y[0] = 0;
    x[1] = 1; y[1] = 0;
    x[2] = 1; y[2] = 1;
    x[3] = 0; y[3] = 1;
    circle(w, 4, x, y, f);
    w = -(A1[0][M-2] + A1[1][M-2] + B1[0][M-1]) / 3;
    x[0] = 0; y[0] = M-2;
    x[1] = 1; y[1] = M-2;
    x[2] = 1; y[2] = M-1;
    x[3] = 0; y[3] = M-1;
    circle(w, 4, x, y, f);
    for (j = 1; j < M-2; j++)
    {
      w = -(A1[0][j] + A1[1][j]) / 2;
      x[0] = 0; y[0] = j;
      x[1] = 1; y[1] = j;
      x[2] = 1; y[2] = j+1;
      x[3] = 0; y[3] = j+1;
      circle(w, 4, x, y, f);
    }
  }
  else if (M == 2)
  {
    w = -(B1[0][0] + B1[0][1] + A1[0][0]) / 3;
    x[0] = 0; y[0] = 0;
    x[1] = 0; y[1] = 1;
    x[2] = 1; y[2] = 1;
    x[3] = 1; y[3] = 0;
    circle(w, 4, x, y, f);
    w = -(B1[N-2][0] + B1[N-2][1] + A1[N-1][0]) / 3;
    x[0] = N-2; y[0] = 0;
    x[1] = N-2; y[1] = 1;
    x[2] = N-1; y[2] = 1;
    x[3] = N-1; y[3] = 0;
    circle(w, 4, x, y, f);
    for (i = 1; i < N-2; i++)
    {
      w = -(B1[i][0] + B1[i][1]) / 2;
      x[0] = i; y[0] = 0;
      x[1] = i; y[1] = 1;
      x[2] = i+1; y[2] = 1;
      x[3] = i+1; y[3] = 0;
      circle(w, 4, x, y, f);
    }
  }
  else
  {
    w = -(B1[0][0] + A1[0][0]) / 2;
    x[0] = 0; y[0] = 0;
    x[1] = 0; y[1] = 1;
    x[2] = 1; y[2] = 1;
    x[3] = 1; y[3] = 0;
    circle(w, 4, x, y, f);
    w = -(B1[N-2][0] + A1[N-1][0]) / 2;
    x[0] = N-2; y[0] = 0;
    x[1] = N-2; y[1] = 1;
    x[2] = N-1; y[2] = 1;
    x[3] = N-1; y[3] = 0;
    circle(w, 4, x, y, f);
    w = -(B1[0][M-1] + A1[0][M-2]) / 2;
    x[0] = 0; y[0] = M-2;
    x[1] = 0; y[1] = M-1;
    x[2] = 1; y[2] = M-1;
    x[3] = 1; y[3] = M-2;
    circle(w, 4, x, y, f);
    w = -(B1[N-2][M-1] + A1[N-1][M-2]) / 2;
    x[0] = N-2; y[0] = M-2;
    x[1] = N-2; y[1] = M-1;
    x[2] = N-1; y[2] = M-1;
    x[3] = N-1; y[3] = M-2;
    circle(w, 4, x, y, f);
    for (i = 1; i < N-2; i++)
    {
      w = -B1[i][0];
      x[0] = i; y[0] = 0;
      x[1] = i; y[1] = 1;
      x[2] = i+1; y[2] = 1;
      x[3] = i+1; y[3] = 0;
      circle(w, 4, x, y, f);
      w = -B1[i][M-1];
      x[0] = i; y[0] = 0;
      x[1] = i; y[1] = 1;
      x[2] = i+1; y[2] = 1;
      x[3] = i+1; y[3] = 0;
      circle(w, 4, x, y, f);
    }
    for (j = 1; j < M-2; j++)
    {
      w = -A1[0][j];
      x[0] = 0; y[0] = j;
      x[1] = 1; y[1] = j;
      x[2] = 1; y[2] = j+1;
      x[3] = 0; y[3] = j+1;
      circle(w, 4, x, y, f);
      w = -A1[N-1][j];
      x[0] = 0; y[0] = j;
      x[1] = 1; y[1] = j;
      x[2] = 1; y[2] = j+1;
      x[3] = 0; y[3] = j+1;
      circle(w, 4, x, y, f);
    }
  }
  for (i = 1; i < N-1; i++) for (j = 0; j < M-1; j++)
  {
    w = -A1[i][j];
    x[0] = i; y[0] = j;
    x[1] = i+1; y[1] = j;
    x[2] = i+1; y[2] = j+1;
    x[3] = i; y[3] = j+1;
    circle(w/2, 4, x, y, f);
    x[0] = i-1; y[0] = j;
    x[1] = i; y[1] = j;
    x[2] = i; y[2] = j+1;
    x[3] = i-1; y[3] = j+1;
    circle(w/2, 4, x, y, f);
    x[0] = i-1; y[0] = j;
    x[1] = i; y[1] = j;
    x[2] = i+1; y[2] = j;
    x[3] = i+1; y[3] = j+1;
    x[4] = i; y[4] = j+1;
    x[5] = i-1; y[5] = j+1;
    circle(-w/2, 6, x, y, f);
  }
  for (i = 0; i < N-1; i++) for (j = 1; j < M-1; j++)
  {
    w = -B1[i][j];
    x[0] = i; y[0] = j;
    x[1] = i; y[1] = j+1;
    x[2] = i+1; y[2] = j+1;
    x[3] = i+1; y[3] = j;
    circle(w/2, 4, x, y, f);
    x[0] = i; y[0] = j-1;
    x[1] = i; y[1] = j;
    x[2] = i+1; y[2] = j;
    x[3] = i+1; y[3] = j-1;
    circle(w/2, 4, x, y, f);
    x[0] = i; y[0] = j-1;
    x[1] = i; y[1] = j;
    x[2] = i; y[2] = j+1;
    x[3] = i+1; y[3] = j+1;
    x[4] = i+1; y[4] = j;
    x[5] = i+1; y[5] = j-1;
    circle(-w/2, 6, x, y, f);
  }
}

void output()
{
  FILE *f = fopen("output.txt", "wt");
  fprintf(f, "%lf\n%d\n", S, KZ);
  prnt(f);
  fclose(f);
}

int main()
{
  int i, j;
  input();
  S = 0; KZ = 0;
  prnt(0);
  for (i = 0; i < N; i++) for (j = 0; j < M-1; j++) S += sqr(A1[i][j]);
  for (i = 0; i < N-1; i++) for (j = 0; j < M; j++) S += sqr(B1[i][j]);
  output();
  return 0;
}
