{$I-,Q-,R-,S-,V-,X-}
uses sysutils;
const
  MaxP = 7;
  tm:double = (8/(24*60*60));
type
  float = extended;
  pt = array [0..122] of integer;
const  eps: float = 1e-10;
var
  cc, n, m, na: integer;
  e, r: array [1..200] of float;
  a: array [1..(MaxP*121)] of pt;
  ad: array [1..(MaxP*121)] of float;
  p, bp: pt;
  ff, s, bv: float;
  st: double;

procedure modedg(a, b: integer; w: float);
begin
  if (a=b) then exit;
  if (a>b) then modedg(b, a, w) else begin
    if (b=(a+m)) then r[a] := r[a] + w else
    if (b=(a+1)) then e[a] := e[a] + w;
  end;
end;

function getedg(a, b: integer): float;
var  x: float;
begin
  getedg := 0;
  if (a=b) then exit;
  if (a>b) then getedg := getedg(b, a) else begin
    x := 0;
    if (b=(a+m)) then x := r[a] else
    if (b=(a+1)) then x := e[a];
    getedg := x;
  end;
end;

procedure addl(aa, b, c, d: integer; w: float);
var  i: integer;
begin
  inc(na);
  p[0] := 5; p[1] := aa; p[2] := b; p[3] := c; p[4] := d; p[5] := aa;
  a[na] := p;
  ad[na] := w;
  for i := 1 to 4 do modedg(p[i], p[i+1], w);
end;

procedure addl6(aa, b, c, d, e, f: integer; w: float);
var  i: integer;
begin
  inc(na);
  p[0] := 7;
  p[1] := aa; p[2] := b; p[3] := c; p[4] := d;
  p[5] := e; p[6] := f; p[7] := aa;
  a[na] := p;
  ad[na] := w;
  for i := 1 to 6 do modedg(p[i], p[i+1], w);
end;

procedure reme(i: integer);
var  w: float;
begin
  if (((i mod m) < 1) or ((i+m)>=cc) or ((i-m)<1)) then exit;

  w := e[i]/2;
  addl(i, i+1, i+m+1, i+m, -(w));
  addl(i, i+1, i-m+1, i-m, -(w));
  addl6(i+m, i+m+1, i+1, i-m+1, i-m, i, w);
end;

procedure remr(i: integer);
var  w: float;
begin
  if (i>=(cc-m)) then exit;
  if ((i mod m) = 0) then exit;
  if (((i-1) mod m) = 0) then exit;

  w := r[i]/2;
  addl(i, i+1, i+m+1, i+m, -(w));
  addl(i, i-1, i+m-1, i+m, -(w));
  addl6(i-1, i+m-1, i+m, i+m+1, i+1, i, w);
end;

procedure Opt1;
var
  i: integer;
begin
  na := 0;
  if ((n=1) or (m=1)) then exit;

  for i:=1 to m-1 do if(abs(e[i])>eps)then addl(i,i+1,i+1+m,i+m,-e[i]);
  for i:=cc-m+1 to cc-1 do if(abs(e[i])>eps)then addl(i,i+1,i+1-m,i-m,-e[i]);
  i := 1;
  while (i<(cc-m)) do begin
    if (abs(r[i])>eps) then addl(i, i+1, i+1+m, i+m, -r[i]);
    i := i+m;
  end;
  i := m;
  while (i<=(cc-m)) do begin
    if (abs(r[i])>eps) then addl(i, i-1, i-1+m, i+m, -r[i]);
    i := i+m;
  end;

  for i := 1 to cc do if (abs(e[i]) > eps) then reme(i);
  for i := 1 to cc do if (abs(r[i]) > eps) then remr(i);
end;

procedure makeloop(i1, j1, i2, j2: integer);
var
  k: integer;
begin
  p[0] := 0;
  for k := i1 to i2 do begin
    inc(p[0]); p[p[0]] := k + ((j1-1)*m);
  end;
  for k := j1+1 to j2 do begin
    inc(p[0]); p[p[0]] := i2 + ((k-1)*m);
  end;
  for k := i2-1 downto i1 do begin
    inc(p[0]); p[p[0]] := k + ((j2-1)*m);
  end;
  for k := j2-1 downto j1 do begin
    inc(p[0]); p[p[0]] := i1 + ((k-1)*m);
  end;
end;

procedure Opt2;
var
  k, i, j, ii, jj: integer;
  bi, bj, bii, bjj: integer;
  av: float;
begin
  while (na<(MaxP*cc)) do begin
    if (Now>st) then exit;
    bv := 0;

    for i := 1 to m-1 do for j := 1 to n-1 do
    for ii := i+1 to m do for jj := j+1 to n do begin
      makeloop(i, j, ii, jj);
      if (p[0]>1) then begin
        s := 0;
        for k := 1 to p[0]-1 do s := s + getedg(p[k], p[k+1]);
        av := sqr(s)/(p[0]-1);
        if (av>bv) then begin
          bv := av;
          bi := i; bj := j; bii := ii; bjj := jj;
        end;
      end;
    end;

    if (abs(3*bv)<eps) then exit;

    inc(na);
    makeloop(bi, bj, bii, bjj);
    s := 0;
    for k := 1 to p[0]-1 do s := s + getedg(p[k], p[k+1]);
    a[na] := p;
    s := s/(p[0]-1); s := -s;
    ad[na] := s;
    for k := 1 to p[0]-1 do modedg(p[k], p[k+1], s);
  end;
end;

procedure Solve;
var i: integer;
begin
  Opt1;
  Opt2;

  ff := 0;
  for i := 1 to cc do begin
    if (i<=(cc-m)) then ff := ff + sqr(r[i]);
    if ((i mod m)>0) then ff := ff + sqr(e[i]);
  end;
end;

procedure ReadAll;
var  i: integer;
begin
  Assign(Input, 'input.txt'); Reset(Input);

  Read(n, m);
  cc := n*m;
  for i := 1 to cc do Read(e[i]);
  for i := 1 to cc do Read(r[i]);

  Close(Input);
end;

procedure Out;
var  i, j: integer;
begin
  Assign(Output, 'output.txt'); ReWrite(Output);

  WriteLn(ff:1:10);
  WriteLn(na);
  for i := 1 to na do begin
    Write(ad[i]:1:10, ' ', (a[i][0]-1):1);
    for j := 1 to a[i][0]-1 do Write(' ', a[i][j]:1);
    WriteLn;
  end;

  Close(Output);
end;

begin
  st := now + tm;
  ReadAll;
  Solve;
  Out;
end.
