#define MaxN					100
#define MaxWay					(MaxN * MaxN)

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <time.h>


struct Town
 {
  int N;
  int A [MaxN] [MaxN];
  int X [MaxN] [2];
 };


struct Way
 {
 	int M;
   unsigned char W [MaxWay];
 };

 
struct Town t, * town;
struct Way w, * way;

 
//void input ();
//void solve ();
//void output ();
double MyWay (struct Town * t, struct Way * w);
int recurs (double sum, int vertex);

double min, dist [MaxN] [MaxN], minlen [MaxN + MaxN];
int n, rest, ptr, been [MaxN];
int list [MaxWay];


/*
main ()
 {
 	input ();
   MyWay (& t, & w);
   output ();

   return (0);
 }



void input ()
 {
   int num, a, b;
   
 	FILE * file = fopen ("input.txt", "r");
   fscanf (file, "%d %d", & t. N, & num);

   for (int i = 0; i < t. N; i ++)
    fscanf (file, "%d %d", & t. X [i] [0], & t. X [i] [1]);

   for (int i = 0; i < t. N; i ++)
    for (int j = 0; j < t. N; j ++)
     t. A [i] [j] = 0;

   for (int i = 0; i < num; i ++)
    {
    	fscanf (file, "%d %d", & a, & b);
      t. A [a - 1] [b - 1] = t. A [b - 1] [a - 1] = 1;
    }

   fclose (file);
 }

 
void output ()
 {
 	FILE * file = fopen ("output.txt", "w");
   fprintf (file, "%d %g\n", w. M, min);

   for (int i = 0; i < w. M; i ++)
    fprintf (file, "%d ", w. W [i] + 1);
    
   fclose (file);
 }
*/

 
double MyWay (struct Town * t, struct Way * w)
 {
   town = t; way = w; n = t -> N;
   min = 1e-2; rest = n; ptr = 0;
   minlen [1] = 1e20;
   memset (been, 0, n << 2);

   for (int i = 0; i < n; i ++)
    for (int j = 0; j < n; j ++)
     {
       dist [i] [j] = sqrt (((double) town -> X [i] [0] - town -> X [j] [0]) * ((double) town -> X [i] [0] - town -> X [j] [0]) +
                          ((double) town -> X [i] [1] - town -> X [j] [1]) * ((double) town -> X [i] [1] - town -> X [j] [1]));
       min += dist [i] [j];

       if ((dist [i] [j] > 1e-8) && (minlen [1] > dist [i] [j]))
         minlen [1] = dist [i] [j];
     }

   for (int i = 2; i <= n; i ++)
    minlen [i] = minlen [1] * (double) i;
     
   recurs (0, 0);
 }


int recurs (double sum, int vertex)
 {
   char flag = 0;

   if (clock () > 9 * CLK_TCK)
    return (1);
   
   if (! been [vertex])
    {
      rest --; flag = 1;
      been [vertex] = 1;
    }

   list [ptr ++] = vertex;

   if ((rest == 0) && (vertex == 0))
    {
      if (sum < min)
       {
         min = sum;

         for (int i = 0; i < ptr; i ++)
          way -> W [i] = list [i];
          
		   way -> M = ptr;
       }

      ptr --;
      return (0);
    }
   else if (minlen [rest + 1] + sum > min)
    {
      ptr --;
      return (0);
    }
    
   for (int i = 0; i < n; i ++)
    if (town -> A [vertex] [i] && (! been [i]))
     if (recurs (sum + dist [vertex] [i], i))
      return (1);

   for (int i = 0; i < n; i ++)
    if (town -> A [vertex] [i] && been [i])
     if (recurs (sum + dist [vertex] [i], i))
      return (1);

   if (flag)
    been [vertex] = 0, rest ++;

   ptr --;
   return (0);
 }
