{$I-,Q-,R-,S-,V-,X-}
Program ChessQueens;
Const
  InFile='INPUT.TXT';
  OutFile='OUTPUT.TXT';
  MaxN=12;
Type
  TArr=Array[1..MaxN,1..MaxN]Of LongInt;
Var
  N,M:LongInt;
  Res,Cur:TArr;
  NF:LongInt;
  Amount:LongInt;
Procedure Load;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N,M);
  Close(Input);
End;
Procedure PutQueen(Y,X:LongInt);
Var
  I:LongInt;
Begin
  If Cur[Y,X] And 31=0 Then Dec(NF);
  Inc(Cur[Y,X],33);
  For I:=1 To M Do Begin
    If Cur[Y,I] And 31=0 Then Dec(NF);
    Inc(Cur[Y,I]);
  End;
  For I:=1 To N Do Begin
    If Cur[I,X] And 31=0 Then Dec(NF);
    Inc(Cur[I,X]);
  End;
  For I:=-N To N Do If (Y+I>=1) And (Y+I<=N) And (X+I>=1) And (X+I<=M) Then Begin
    If Cur[Y+I,X+I] And 31=0 Then Dec(NF);
    Inc(Cur[Y+I,X+I]);
  End;
  For I:=-N To N Do If (Y+I>=1) And (Y+I<=N) And (X-I>=1) And (X-I<=M) Then Begin
    If Cur[Y+I,X-I] And 31=0 Then Dec(NF);
    Inc(Cur[Y+I,X-I]);
  End;
End;
Procedure GetQueen(Y,X:LongInt);
Var
  I:LongInt;
Begin
  Dec(Cur[Y,X],33);
  If Cur[Y,X] And 31=0 Then Inc(NF);
  For I:=1 To M Do Begin
    Dec(Cur[Y,I]);
    If Cur[Y,I] And 31=0 Then Inc(NF);
  End;
  For I:=1 To N Do Begin
    Dec(Cur[I,X]);
    If Cur[I,X] And 31=0 Then Inc(NF);
  End;
  For I:=-N To N Do If (Y+I>=1) And (Y+I<=N) And (X+I>=1) And (X+I<=M) Then Begin
    Dec(Cur[Y+I,X+I]);
    If Cur[Y+I,X+I] And 31=0 Then Inc(NF);
  End;
  For I:=-N To N Do If (Y+I>=1) And (Y+I<=N) And (X-I>=1) And (X-I<=M) Then Begin
    Dec(Cur[Y+I,X-I]);
    If Cur[Y+I,X-I] And 31=0 Then Inc(NF);
  End;
End;
Procedure Solve;
Var
  I,J,Gt:LongInt;
Procedure Heuristic;
Var
  WasMax:LongInt;
  WMY,WMX:LongInt;
  Y,X:LongInt;
  Alr:LongInt;
Begin
  Alr:=0;
  Repeat
    WasMax:=-1;
    For Y:=1 To N Do
      For X:=1 To M Do If Cur[Y,X]<32 Then Begin
        PutQueen(Y,X);
        If NF>WasMax Then Begin
          WasMax:=NF;
          WMY:=Y;
          WMX:=X;
        End;
        GetQueen(Y,X);
      End;
    If WasMax<=Alr Then Break;
    Inc(Alr);
    PutQueen(WMY,WMX);
  Until False;
End;
Begin
  FillChar(Cur,SizeOf(Cur),0);
  NF:=N*M;
  Heuristic;
  FillChar(Res,SizeOf(Res),0);
  Gt:=0;
  For I:=1 To N Do
    For J:=1 To M Do If Cur[I,J]>=32 Then Begin
      Inc(Gt);
      Res[I,J]:=1;
    End;
  Amount:=Gt*2;
  If Gt=0 Then Exit;
  For I:=1 To N Do
    For J:=1 To M Do If Cur[I,J]=0 Then Begin
      Dec(Gt);
      Res[I,J]:=2;
      If Gt=0 Then Exit;
    End;
End;
Procedure Save;
Var
  I,J:LongInt;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(Amount);
  For I:=1 To N Do Begin
    For J:=1 To M Do Begin
      If J>1 Then Write(' ');
      Write(Res[I,J]);
    End;
    WriteLn;
  End;
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
