{$I-,Q-,R-,S-,V-,X-}
Program SomeLittleBusinessCells;
Const
  InFile='input.txt';
  OutFile='output.txt';
Type
  Real=Extended;
Const
  MaxN=12;
  MaxM=12;
Var
  Src,Cur:Array[1..MaxN,1..MaxM,0..1]Of Real;
  N,M:Byte;
  Res:Real;
  NRot:LongInt;
Procedure Load;
Var
  I,J:Byte;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N,M);
  For I:=1 To N Do
    For J:=1 To M Do
      If Not SeekEOF Then Read(Src[I][J][0]);
  For I:=1 To N Do
    For J:=1 To M Do
      If Not SeekEOF Then Read(Src[I][J][1]);
  Close(Input);
End;
Function TN(Y,X:Byte):Byte;
Begin
  TN:=(Y-1)*M+X;
End;
Procedure Write4Cycle(Y1,X1:Byte; Delta:Real);
Begin
  WriteLn(Delta:0:18,' 4 ',TN(Y1,X1),' ',TN(Y1,X1+1),' ',TN(Y1+1,X1+1),' ',TN(Y1+1,X1));
End;
Procedure Apply4Cycle(Log:Boolean; Y1,X1:Byte; Delta:Real);
Begin
  If Log Then Begin
    Write4Cycle(Y1,X1,Delta);
  End;
  Inc(NRot);
  Src[Y1,X1,0]:=Src[Y1,X1,0]+Delta;
  Src[Y1,X1+1,1]:=Src[Y1,X1+1,1]+Delta;
  Src[Y1+1,X1,0]:=Src[Y1+1,X1,0]+Delta;
  Src[Y1,X1,1]:=Src[Y1,X1,1]+Delta;
End;
Procedure Write6CycleH(Y1,X1:Byte; Delta:Real);
Begin
  WriteLn(Delta:0:18,' 6 ',TN(Y1,X1),' ',TN(Y1,X1+1),' ',TN(Y1,X1+2),' ',TN(Y1+1,X1+2),' ',TN(Y1+1,X1+1),' ',TN(Y1+1,X1));
End;
Procedure Write6CycleV(Y1,X1:Byte; Delta:Real);
Begin
  WriteLn(Delta:0:18,' 6 ',TN(Y1,X1),' ',TN(Y1+1,X1),' ',TN(Y1+2,X1),' ',TN(Y1+2,X1+1),' ',TN(Y1+1,X1+1),' ',TN(Y1,X1+1));
End;
Procedure DoIt(Log:Boolean);
Var
  I,J:LongInt;
Begin
  If (N>2) And (M>2) Then Begin
    Apply4Cycle(Log,1,1,-(Src[1,1,0]+Src[1,1,1])/2);
    Apply4Cycle(Log,1,M-1,-(Src[1,M-1,0]+Src[1,M,1])/2);
    Apply4Cycle(Log,N-1,1,-(Src[N-1,1,1]+Src[N,1,0])/2);
    Apply4Cycle(Log,N-1,M-1,-(Src[N,M-1,0]+Src[N-1,M,1])/2);
    For I:=2 To N-2 Do
      Apply4Cycle(Log,I,1,-(Src[I,1,1])/1);
    For I:=2 To N-2 Do
      Apply4Cycle(Log,I,M-1,-(Src[I,M,1])/1);
    For I:=2 To M-2 Do
      Apply4Cycle(Log,1,I,-(Src[1,I,0])/1);
    For I:=2 To M-2 Do
      Apply4Cycle(Log,N-1,I,-(Src[N,I,0])/1);
  End Else If (N=2) And (M>2) Then Begin
    Apply4Cycle(Log,1,1,-(Src[1,1,0]+Src[1,1,1]+Src[2,1,0])/3);
    Apply4Cycle(Log,1,M-1,-(Src[1,M-1,0]+Src[1,M,1]+Src[2,M-1,0])/3);
    For I:=2 To M-2 Do
      Apply4Cycle(Log,1,I,-(Src[1,I,0]+Src[2,I,0])/2);
  End Else If (M=2) And (N>2) Then Begin
    Apply4Cycle(Log,1,1,-(Src[1,1,1]+Src[1,1,0]+Src[1,2,1])/3);
    Apply4Cycle(Log,N-1,1,-(Src[N-1,1,1]+Src[N,1,0]+Src[N-1,2,1])/3);
    For I:=2 To N-2 Do
      Apply4Cycle(Log,I,1,-(Src[I,1,1]+Src[I,2,1])/2);
  End Else If (M=2) And (N=2) Then Begin
    Apply4Cycle(Log,1,1,-(Src[1,1,0]+Src[1,1,1]+Src[1,2,1]+Src[2,1,0])/4);
  End;
  For I:=2 To M-1 Do
    For J:=1 To N-1 Do Begin
      If Log Then Write4Cycle(J,I-1,-(Src[J,I,1])/2);
      If Log Then Write4Cycle(J,I,-(Src[J,I,1])/2);
      If Log Then Write6CycleH(J,I-1,Src[J,I,1]/2);
      Inc(NRot,3);
      Src[J,I,1]:=0;
    End;
  For I:=2 To N-1 Do
    For J:=1 To M-1 Do Begin
      If Log Then Write4Cycle(I-1,J,-(Src[I,J,0])/2);
      If Log Then Write4Cycle(I,J,-(Src[I,J,0])/2);
      If Log Then Write6CycleV(I-1,J,Src[I,J,0]/2);
      Inc(NRot,3);
      Src[I,J,0]:=0;
    End;
End;
Procedure Solve;
Var
  I,J,K:LongInt;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  If N=1 Then Begin
    Res:=0;
    For I:=1 To M-1 Do Res:=Res+Sqr(Src[1,I,0]);
    WriteLn(Res:0:18);
    WriteLn(0);
  End Else If M=1 Then Begin
    Res:=0;
    For I:=1 To N-1 Do Res:=Res+Sqr(Src[I,1,1]);
    WriteLn(Res:0:18);
    WriteLn(0);
  End Else Begin
    For I:=1 To N Do
      For J:=1 To M Do
        For K:=0 To 1 Do
          Cur[I,J,K]:=Src[I,J,K];
    NRot:=0;
    DoIt(False);
    Res:=0.0;
    For I:=1 To N Do
      For J:=1 To M Do
        Res:=Res+Sqr(Src[I,J,0])+Sqr(Src[I,J,1]);
    For I:=1 To N Do
      For J:=1 To M Do
        For K:=0 To 1 Do
          Src[I,J,K]:=Cur[I,J,K];
    WriteLn(Res:0:18);
    WriteLn(NRot);
    NRot:=0;
    DoIt(True);
  End;
  Close(Output);
End;
Begin
  Load;
  Solve;
End.
