uses sysutils;
var 
  fin,fout:text;
  endTime:double;
  underWhiteAttack:array[-11..21,-11..21]of integer;
  underBlackAttack:array[-11..21,-11..21]of integer;
  whiteFreeSpace,blackFreeSpace:integer;
  position,bestPosition:array[1..100]of record x,y:integer; end;
  positioned,bestPositioned:integer;
  deck:array[1..10,1..10]of integer;
  n,m,maxSize:integer;
  i,j:integer;
procedure incWhiteAttack(x,y:integer);
begin
  inc(underWhiteAttack[x,y]);
  if (underWhiteAttack[x,y]=1)and(x>0)and(y>0)and(x<=n)and(y<=m) then dec(blackFreeSpace);
end;
procedure decWhiteAttack(x,y:integer);
begin
  dec(underWhiteAttack[x,y]);
  if (underWhiteAttack[x,y]=0)and(x>0)and(y>0)and(x<=n)and(y<=m) then inc(blackFreeSpace);
end;
procedure incBlackAttack(x,y:integer);
begin
  inc(underBlackAttack[x,y]);
  if (underBlackAttack[x,y]=1)and(x>0)and(y>0)and(x<=n)and(y<=m) then dec(whiteFreeSpace);
end;
procedure decBlackAttack(x,y:integer);
begin
  dec(underBlackAttack[x,y]);
  if (underBlackAttack[x,y]=0)and(x>0)and(y>0)and(x<=n)and(y<=m) then inc(whiteFreeSpace);
end;
procedure updateBest;
var i:integer;
begin
  if bestPositioned<positioned then
    begin
      for i:=1 to positioned do
        bestPosition[i]:=position[i];
      bestPositioned:=positioned;
    end;
end;
procedure finish;
var i,j:integer;
begin
  for i:=1 to n do
    for j:=1 to m do
      deck[i,j]:=0;

  for i:=1 to bestPositioned do
    begin
      deck[bestPosition[i].x,bestPosition[i].y]:=2-i mod 2;
    end;
  writeln(fout,bestPositioned);
  for i:=1 to n do
    begin
      for j:=1 to m do write(fout,deck[i,j],' ');
      writeln(fout);
    end;
  close(fout);
  while true do halt;
end;
procedure podBor;
var i,j,k:integer;
begin
  if now>endTime then finish;
  if positioned mod 2=0 then
    begin
      updateBest;
      if
        ((positioned div 2+whiteFreeSpace)<bestPositioned div 2)or
        ((positioned div 2+blackFreeSpace)<bestPositioned div 2) then
          exit;
      for i:=1 to n do
        for j:=1 to m do
          begin
            if underBlackAttack[i,j]=0 then
              begin
                inc(positioned);
                for k:=0 to maxSize do
                  begin
                    incWhiteAttack(i+k,j  );
                    incWhiteAttack(i-k,j  );
                    incWhiteAttack(i  ,j+k);
                    incWhiteAttack(i  ,j-k);
                    incWhiteAttack(i+k,j+k);
                    incWhiteAttack(i-k,j+k);
                    incWhiteAttack(i+k,j-k);
                    incWhiteAttack(i-k,j-k);
                  end;

                incBlackAttack(i,j);
                position[positioned].x:=i;
                position[positioned].y:=j;

                podBor;
                dec(positioned);
                for k:=0 to maxSize do
                  begin
                    decWhiteAttack(i+k,j  );
                    decWhiteAttack(i-k,j  );
                    decWhiteAttack(i  ,j+k);
                    decWhiteAttack(i  ,j-k);
                    decWhiteAttack(i+k,j+k);
                    decWhiteAttack(i-k,j+k);
                    decWhiteAttack(i+k,j-k);
                    decWhiteAttack(i-k,j-k);
                  end;
                decBlackAttack(i,j);
              end;
          end;
    end
  else
    begin
      if
        ((positioned div 2+1+whiteFreeSpace)<bestPositioned div 2)or
        ((positioned div 2+blackFreeSpace)<bestPositioned div 2) then
          exit;
      for i:=n downto 1 do
        for j:=m downto 1 do
          begin
            if underWhiteAttack[i,j]=0 then
              begin
                inc(positioned);
                for k:=0 to maxSize do
                  begin
                    incBlackAttack(i+k,j  );
                    incBlackAttack(i-k,j  );
                    incBlackAttack(i  ,j+k);
                    incBlackAttack(i  ,j-k);
                    incBlackAttack(i+k,j+k);
                    incBlackAttack(i-k,j+k);
                    incBlackAttack(i+k,j-k);
                    incBlackAttack(i-k,j-k);
                  end;
                incWhiteAttack(i,j);
                position[positioned].x:=i;
                position[positioned].y:=j;

                podBor;
                dec(positioned);
                for k:=0 to maxSize do
                  begin
                    decBlackAttack(i+k,j  );
                    decBlackAttack(i-k,j  );
                    decBlackAttack(i  ,j+k);
                    decBlackAttack(i  ,j-k);
                    decBlackAttack(i+k,j+k);
                    decBlackAttack(i-k,j+k);
                    decBlackAttack(i+k,j-k);
                    decBlackAttack(i-k,j-k);
                  end;
                decWhiteAttack(i,j);
              end;
          end;
    end;
end;
begin
  endTime:=now+1/(30*360);
  assign(fin,'INPUT.TXT');
  reset(fin);
  read(fin,n,m);
  close(fin);

  for i:=1 to n do for j:=1 to m do
    begin
      underWhiteAttack[i,j]:=0;
      underBlackAttack[i,j]:=0;
    end;
  maxSize:=n;if m>n then maxSize:=m;
  positioned:=0;
  bestPositioned:=0;
  whiteFreeSpace:=n*m;
  blackFreeSpace:=n*m;
  assign(fout,'OUTPUT.TXT');
  rewrite(fout);
  podBor;

  finish;
end.
