#include <stdio.h>

int N;
double X[102][3], Y[102][3];
double E = 1E-8;

double M = -1;
double XK, YK;

void input()
{
  int i, j;
  FILE *f = fopen("INPUT.TXT", "rt");
  fscanf(f, "%d", &N);
  for (i = 0; i < N; i++) for (j = 0; j < 3; j++)
  {
    fscanf(f, "%lf%lf", &X[i][j], &Y[i][j]);
  }
  fclose(f);
}

void output()
{
  FILE *f = fopen("OUTPUT.TXT", "wt");
  fprintf(f, "%lf %lf", XK, YK);
  fclose(f);
}

double GetS(double x1, double y1, double x2, double y2, double x3, double y3)
{
  return 0.5*(x3*(y1-y2) + x1*(y2-y3) + x2*(y3-y1));
}

void TestP(double xp, double yp)
{
  int i, j, k = 0;
  for (i = 0; i < N; i++)
  {
    double xmin = X[i][0], xmax = X[i][0];
    if (xmin > X[i][1]) xmin = X[i][1];
    if (xmax < X[i][1]) xmax = X[i][1];
    if (xmin > X[i][2]) xmin = X[i][2];
    if (xmax < X[i][2]) xmax = X[i][2];
    double ymin = Y[i][0], ymax = Y[i][0];
    if (ymin > Y[i][1]) ymin = Y[i][1];
    if (ymax < Y[i][1]) ymax = Y[i][1];
    if (ymin > Y[i][2]) ymin = Y[i][2];
    if (ymax < Y[i][2]) ymax = Y[i][2];
    if (xp > xmin - E && xp < xmax + E && yp > ymin - E && yp < ymax + E)
    {
      double S = fabs(GetS(X[i][0], Y[i][0], X[i][1], Y[i][1], X[i][2], Y[i][2]));
      S -= fabs(GetS(xp, yp, X[i][1], Y[i][1], X[i][2], Y[i][2]));
      S -= fabs(GetS(X[i][0], Y[i][0], xp, yp, X[i][2], Y[i][2]));
      S -= fabs(GetS(X[i][0], Y[i][0], X[i][1], Y[i][1], xp, yp));
      if (fabs(S) < E) k++;
    }
  }
  if (M < k)
  {
    M = k;
    XK = xp; YK = yp;
  }
}

void GetPrime(double x1, double y1, double x2, double y2,
              double &a, double &b, double &c)
{                                    //a*x + b*y = c;
  a = y2 - y1; b = x1 - x2;
  c = a*x1 + b*y1;
}

void TestTr(double xa1, double ya1, double xa2, double ya2,
            double xb1, double yb1, double xb2, double yb2)
{
  double xp, yp;
  if (fabs(xa1 - xa2) < E && fabs(ya1 - ya2) < E) return;
  if (fabs(xb1 - xb2) < E && fabs(yb1 - yb2) < E) return;
  double a1, b1, c1, a2, b2, c2;
  GetPrime(xa1, ya1, xa2, ya2, a1, b1, c1);
  GetPrime(xb1, yb1, xb2, yb2, a2, b2, c2);
  double D = a1*b2 - b1*a2;
  if (fabs(D) < E) return;
  xp = (c1*b2 - b1*c2) / D;
  yp = (a1*c2 - c1*a2) / D;
  TestP(xp, yp);
}

int main()
{
  int i, j;
  input();
  for (i = 0; i < N; i++) for (j = 0; j < 3; j++) TestP(X[i][j], Y[i][j]);
  for (i = 0; i < N; i++) for (j = 0; j < N; j++)
  {
    TestTr(X[i][0], Y[i][0], X[i][1], Y[i][1], X[j][0], Y[j][0], X[j][1], Y[j][1]);
    TestTr(X[i][0], Y[i][0], X[i][1], Y[i][1], X[j][0], Y[j][0], X[j][2], Y[j][2]);
    TestTr(X[i][0], Y[i][0], X[i][1], Y[i][1], X[j][1], Y[j][1], X[j][2], Y[j][2]);
    TestTr(X[i][0], Y[i][0], X[i][2], Y[i][2], X[j][0], Y[j][0], X[j][1], Y[j][1]);
    TestTr(X[i][0], Y[i][0], X[i][2], Y[i][2], X[j][0], Y[j][0], X[j][2], Y[j][2]);
    TestTr(X[i][0], Y[i][0], X[i][2], Y[i][2], X[j][1], Y[j][1], X[j][2], Y[j][2]);
    TestTr(X[i][1], Y[i][1], X[i][2], Y[i][2], X[j][0], Y[j][0], X[j][1], Y[j][1]);
    TestTr(X[i][1], Y[i][1], X[i][2], Y[i][2], X[j][0], Y[j][0], X[j][2], Y[j][2]);
    TestTr(X[i][1], Y[i][1], X[i][2], Y[i][2], X[j][1], Y[j][1], X[j][2], Y[j][2]);
  }
  output();
  return 0;
}
