#include <stdio.h>
#include <math.h>

double X[4][3];

double t[3];
double a[3][5];
double c[2][4];
double XA[3] = {0, 0, 0};

double E =1E-7;

inline double fsqr(double s) {return s*s;}

void input()
{
  int i, j;
  FILE *f = fopen("INPUT.TXT", "rt");
  for (i = 0; i < 4; i++) for (j = 0; j < 3; j++) fscanf(f, "%lf", &X[i][j]);
  for (i = 0; i < 3; i++) fscanf(f, "%lf", &t[i]);
  fclose(f);
}

void output()
{
  FILE *f = fopen("OUTPUT.TXT", "wt");
  fprintf(f, "%lf %lf %lf", XA[0], XA[1], XA[2]);
  fclose(f);
}

double Descr(int i, int j, int k)
{
  return a[0][i]*a[1][j]*a[2][k] + a[1][i]*a[2][j]*a[0][k] +
         a[2][i]*a[0][j]*a[1][k] - a[1][i]*a[0][j]*a[2][k] -
         a[2][i]*a[1][j]*a[0][k] - a[0][i]*a[2][j]*a[1][k];
}

int main()
{
  int i, j, k;
  int kw = 0, w[4];
  double D, V = 0;
  input();
  for (i = 0; i < 3; i++) for (j = 0; j < 5; j++) a[i][j] = 0;
  for (i = 0; i < 3; i++)
  {
    for (j = 0; j < 3; j++)
    {
      D = X[0][j] - X[i+1][j];
      a[i][j] += D;
      a[i][4] -= D * (X[0][j] + X[i+1][j]) / 2;
    }
    a[i][3] -= t[i];
    a[i][4] -= t[i]*t[i]/2;
  }
  for (k = 0; k < 4; k++)
  {
    kw = 0;
    for (j = 0; j < 4; j++) if (j != k) w[kw++] = j;
    D = Descr(w[0], w[1], w[2]);
    if (fabs(D) > E) break;
  }
  if (k != 4) {
  c[0][w[0]] = -Descr(k, w[1], w[2]) / D;
  c[1][w[0]] = -Descr(4, w[1], w[2]) / D;
  c[0][w[1]] = -Descr(w[0], k, w[2]) / D;
  c[1][w[1]] = -Descr(w[0], 4, w[2]) / D;
  c[0][w[2]] = -Descr(w[0], w[1], k) / D;
  c[1][w[2]] = -Descr(w[0], w[1], 4) / D;
  c[0][k] = 1; c[1][k] = 0;
  double aa, bb, cc;                          //aa*v*v - 2*bb*v + cc = 0
  aa = fsqr(c[0][0]) + fsqr(c[0][1]) + fsqr(c[0][2]) - fsqr(c[0][3]);
  cc = fsqr(c[1][0] - X[0][0]) + fsqr(c[1][1] - X[0][1]) +
       fsqr(c[1][2] - X[0][2]) - fsqr(c[1][3]);
  bb = c[0][0] * (X[0][0] - c[1][0]) + c[0][1] * (X[0][1] - c[1][1]) +
       c[0][2] * (X[0][2] - c[1][2]) + c[0][3] * c[1][3];
  if (fabs(aa) < E)
  {
    if (fabs(bb) < E) V = 0;
    else V = cc / (2 * bb);
  }
  else
  {
    D = fsqr(bb) - aa*cc;
    if (fabs(D) < E) V = bb / aa;
    else if (D > 0)
    {
      D  = sqrt(D);
      V = (bb + D) / aa;
      if (c[0][3]*V + c[1][3] < -E) V = (bb - D) / aa;
    }
  }}
  for (i = 0; i < 3; i++) XA[i] = c[0][i]*V + c[1][i];
  output();
  return 0;
}
