{$UNDEF DEBUG}
{$DEFINE TIMELIMIT}

{$IFDEF TIMELIMIT}
Uses Sysutils;
{$ENDIF}



Const
  InpF='INPUT.TXT';
  OutpF='OUTPUT.TXT';
  DebugPath='c:\work\day28\1\';
 {$IFDEF DEBUG}
  Inp=DebugPath+InpF;
  Outp=DebugPath+OutpF;
 {$ELSE}
  Inp=InpF;
  Outp=OutpF;
 {$ENDIF}
 {$IFDEF TIMELIMIT}
  TimeLimit=9;
 {$ENDIF}


 {$IFDEF TIMELIMIT}
  var
   Break: TDatetime;
 {$ENDIF}

Const
 Eps=1e-12;
 MaxN=100;

Type
 Real=Extended;
 TPoint = Record
           X, Y: Real;
          End;

 TTriug=Array [0..2] of TPoint;


var
 N: Word;
 A: Array [1..MaxN] of TTriug;
 S: Array [1..MaxN] of Real;
 AnsP: TPoint;
 AnsN: Word;

Function Ss(Const T:TTriug): Real;
 Begin
  Ss:=T[0].X*(T[1].Y-T[2].Y)+T[1].X*(T[2].Y-T[0].Y)+T[2].X*(T[0].Y-T[1].Y);
 End;

Procedure init;
 Var i: Integer;
 Begin
  {$IFDEF TIMELIMIT}
  Break:=Time+TimeLimit/24/3600;
  {$ENDIF}
  Assign(Input, Inp);
  reset(input);
  Read(N);
  For i:=1 to N do Begin
   Read(a[i][0].X, A[i][0].Y);
   Read(a[i][1].X, A[i][1].Y);
   Read(a[i][2].X, A[i][2].Y);
   S[i]:=Abs(Ss(A[i]));
  End;
  close(Input);
 End;

Function Min(A, B: Real): Real;
 Begin
  if (A-B)>Eps Then
   Min:=B
  Else
   Min:=A;
 End;

Function Max(A, B: Real): Real;
 Begin
  if (A-B)>Eps Then
   Max:=A
  Else
   Max:=B;
 End;

Function Between(A, B, C: Real): Boolean;
 Begin
  Between:=((B-Min(A, C))>-eps) and ((B-Max(A, C))<eps);
 End;

Function InRect (A, B, C: TPoint): Boolean;
 Begin
  InRect:=Between(A.X, B.X, C.X) and Between(A.Y, B.Y, C.Y);
 End;

Function Cross(Const A1, B1, A2, B2: TPoint; var P: TPoint): Boolean;
 Var aa1, bb1, cc1, aa2, bb2, cc2: Real;
     D: Real;
 Begin
  aa1:=A1.Y-B1.Y;
  bb1:=-A1.X+B1.X;
  cc1:=-aa1*A1.X-bb1*A1.Y;

  aa2:=A2.Y-B2.Y;
  bb2:=-A2.X+B2.X;
  cc2:=-aa2*A2.X-bb2*A2.Y;

  D:=aa2*bb1-bb2*aa1;
  if Abs(d)<=Eps Then
   Cross:=False
  Else Begin
   P.X:=(cc1*bb2-bb1*cc2)/d;
   P.Y:=(aa1*cc2-cc1*aa2)/d;
   Cross:=InRect(A1, P, B1) and InRect(A2, P, B2);
  End;
 End;

Function Check(Const P: TPoint): Word;
 var i, j: Integer;
     Count: Word;
     S1: Real;
     T: TTriug;
 Begin
  Count:=0;
  For i:=1 to N do begin
   S1:=0;
   for j:=0 to 2 do begin
    T:=A[i];
    T[j]:=P;
    S1:=S1+Abs(Ss(T));
   end;
   if Abs(S1-S[i])<=Eps Then
    Inc(Count);
  End;
  {$IFDEF DEBUG}
   WriteLn(P.X:0:5, ' ', P.Y:0:5, ' ', Count);
  {$ENDIF}
  if Count>AnsN Then Begin
   AnsN:=Count;
   AnsP:=P;
  End;
 End;

procedure done;
 Begin
  Assign(Output, Outp);
  rewrite(Output);
  {$IFDEF DEBUG}
   WriteLn(AnsN);
  {$ENDIF}
  WriteLn(AnsP.X:0:10, ' ', AnsP.Y:0:10);
  Close(Output);
  Halt(0);
 End;


Procedure solve;
 Var i, j, k, l: Integer;
     P: TPoint;
     A1, B1, A2, B2: TPoint;
 Begin
  {$IFDEF DEBUG}
   WriteLn('----------------------------');
  {$ENDIF}
  AnsN:=0;
  AnsP.X:=0;
  AnsP.Y:=0;
  For i:=1 to N do
   for j:=0 to 2 do
    Check(A[i][j]);

  For i:=1 to N do
   For j:=0 to 2 do begin
    A1:=A[i, j];
    B1:=A[i, (j+1) mod 3];
    if Time>=Break Then Exit;
    For k:=i+1 to N do
     For l:=0 to 2 do begin
      A2:=A[k, l];
      B2:=A[k, (l+1) mod 3];
      if Cross(A1, B1, A2, B2, P) Then
       Check(P);
     End;
   End;
 End;

begin
 Init;
 Solve;
 Done;
End.

