#define MAX						1024
#define EPS						1e-8

#include <stdio.h>
#include <math.h>

void input ();
void solve ();
void output ();
int intersect (double x1s, double y1s, double x1e, double y1e,
               double x2s, double y2s, double x2e, double y2e);
int inside (double x1, double y1, double x2, double y2, double x3, double y3, double x, double y);
int inside_line (double x, double y, double xs, double ys, double xe, double ye);
double triangle (double x1, double y1, double x2, double y2, double x3, double y3);
double fmin (double a, double b) { return ((a > b) ? b : a); }
double fmax (double a, double b) { return ((a > b) ? a : b); }

double x [MAX] [3], y [MAX] [3], x_int, y_int, ans_x, ans_y;
int n, max = -1, cur;


main ()
 {
	input ();
	solve ();
	output ();

   return (0);
 }


void input ()
 {
 	FILE * file = fopen ("INPUT.TXT", "r");
   fscanf (file, "%d", & n);

   for (int i = 0; i < n; i ++)
	 for (int j = 0; j < 3; j ++)
     fscanf (file, "%lF %lF", & x [i] [j], & y [i] [j]);
   
   fclose (file);
 }

 
void solve ()
 {
   for (int i = 0; i < n; i ++)
    for (int j = i; j < n; j ++)
	  for (int k = 0; k < 3; k ++)
   	for (int l = 0; l < 3; l ++)
       if (intersect (x [i] [k], y [i] [k], x [i] [(k + 1) % 3], y [i] [(k + 1) % 3],
                      x [j] [l], y [j] [l], x [j] [(l + 1) % 3], y [j] [(l + 1) % 3]))
        {
          cur = 0;
          
          for (int m = 0; m < n; m ++)
           if (inside (x [m] [0], y [m] [0], x [m] [1], y [m] [1], x [m] [2], y [m] [2], x_int, y_int))
            cur ++;

          if (cur > max)
           {
           	 max = cur;
             ans_x = x_int;
             ans_y = y_int;
           }
        }

    for (int i = 0; i < n; i ++)
	  for (int j = 0; j < 3; j ++)
      {
        cur = 0;
          
        for (int m = 0; m < n; m ++)
         if (inside (x [m] [0], y [m] [0], x [m] [1], y [m] [1], x [m] [2], y [m] [2], x [i] [j], y [i] [j]))
          cur ++;

        if (cur > max)
         {
        	  max = cur;
           ans_x = x [i] [j];
           ans_y = y [i] [j];
         }
      }
 }

 
void output ()
 {
 	FILE * file = fopen ("OUTPUT.TXT", "w");

   fprintf (file, "%lf %lf", ans_x, ans_y);
   
   fclose (file);
 }


int intersect (double x1s, double y1s, double x1e, double y1e,
               double x2s, double y2s, double x2e, double y2e)
 {
   double A1, A2, B1, B2, C1, C2, D;
   A1 = y1s - y1e; B1 = x1e - x1s; C1 = -A1 * x1s - B1 * y1s;
   A2 = y2s - y2e; B2 = x2e - x2s; C2 = -A2 * x2s - B2 * y2s;

   D = A1 * B2 - A2 * B1;

   if (fabsl (D) < EPS)
    return (0);

   x_int = (C2 * B1 - C1 * B2) / D;
   y_int = (C1 * A2 - C2 * A1) / D;

   return (inside_line (x_int, y_int, x1s, y1s, x1e, y1e) &&
           inside_line (x_int, y_int, x2s, y2s, x2e, y2e));
 }

 
int inside (double x1, double y1, double x2, double y2, double x3, double y3, double x, double y)
 {
 	if (! (fabs (triangle (x1, y1, x2, y2, x3, y3) - triangle (x1, y1, x2, y2, x, y) -
                 triangle (x1, y1, x3, y3, x, y) - triangle (x2, y2, x3, y3, x, y)) < EPS))
    return (0);

   if (fabs (triangle (x1, y1, x2, y2, x3, y3)) < EPS)
    return (inside_line (x, y, x1, y1, x2, y2) || inside_line (x, y, x1, y1, x3, y3) ||
            inside_line (x, y, x3, y3, x2, y2));

   return (1);
 }

 
double triangle (double x1, double y1, double x2, double y2, double x3, double y3)
 {
 	return (fabs ((x2 - x1) * (y1 + y2) + (x3 - x2) * (y2 + y3) + (x1 - x3) * (y3 + y1)));
 }


int inside_line (double x, double y, double xs, double ys, double xe, double ye)
 {
   if (fabs (xs - xe) < EPS)
    return ((y > fmin (ys, ye) - EPS) && (y < fmax (ys, ye) + EPS));
   else return ((x > fmin (xs, xe) - EPS) && (x < fmax (xs, xe) + EPS));
 }
