#define EPS							1e-1

#include <stdio.h>

void input ();
void solve ();
void output ();
int spare (double x1, double y1, double z1, double x2, double y2, double z2);
int lies (double x1, double y1, double z1, int sphere);
int inside (double x1, double y1, double z1);
double tetr (int a, int b, int c, int d);

double r [10], xc [10], yc [10], zc [10], ans_x, ans_y, ans_z;
double xmin = 1e20, ymin = 1e20, zmin = 1e20, xmax = -1e20, ymax = -1e20, zmax = -1e20;


main ()
 {
 	input ();
   solve ();
   output ();

   return (0);
 }


void input ()
 {
 	FILE * file = fopen ("INPUT.TXT", "r");

   for (int i = 0; i < 4; i ++)
    fscanf (file, "%lf %lf %lf", & xc [i], & yc [i], & zc [i]);

   fscanf (file, "%lf %lf %lf", & r [1], & r [2], & r [3]);
    
   fclose (file);
 }


void solve ()
 {
   double start = 0, end = 1e10, middle;

   for (int i = 0; i < 4; i ++)
    {
    	if (xc [i] < xmin) xmin = xc [i];
    	if (yc [i] < ymin) ymin = yc [i];
    	if (zc [i] < zmin) zmin = zc [i];
    	if (xc [i] > xmax) xmax = xc [i];
    	if (yc [i] > ymax) ymax = yc [i];
    	if (zc [i] > zmax) zmax = zc [i];
    }

   while (end - start > EPS)
    {
      middle = (start + end) / 2.;
      r [0] = middle;
      r [1] += middle;
      r [2] += middle;
      r [3] += middle;

      if (spare (xmin, ymin, zmin, xmax, ymax, zmax))
       start = middle;
      else end = middle;

      r [1] -= middle;
      r [2] -= middle;
      r [3] -= middle;
    }
 }

 
void output ()
 {
 	FILE * file = fopen ("OUTPUT.TXT", "w");
   
   fprintf (file, "%.4lf %.4lf %.4lf", ans_x, ans_y, ans_z);
   
   fclose (file);
 }


int spare (double x1, double y1, double z1, double x2, double y2, double z2)
 {
   if (x2 - x1 < EPS)
    return (0);

   int flag000 = 0, flag001 = 0, flag010 = 0, flag011 = 0, flag100 = 0, flag101 = 0, flag110 = 0, flag111 = 0;

 	flag000 = ! inside (z1, y1, z1);
 	flag001 = ! inside (z1, y1, z2);
 	flag010 = ! inside (z1, y2, z1);
 	flag011 = ! inside (z1, y2, z2);
 	flag100 = ! inside (z2, y1, z1);
 	flag101 = ! inside (z2, y1, z2);
 	flag110 = ! inside (z2, y2, z1);
 	flag111 = ! inside (z2, y2, z2);

   for (int i = 0; i < 4; i ++)
    {
    	flag000 = (flag000 << 1) + lies (z1, y1, z1, i);
    	flag001 = (flag001 << 1) + lies (z1, y1, z2, i);
    	flag010 = (flag010 << 1) + lies (z1, y2, z1, i);
    	flag011 = (flag011 << 1) + lies (z1, y2, z2, i);
    	flag100 = (flag100 << 1) + lies (z2, y1, z1, i);
    	flag101 = (flag101 << 1) + lies (z2, y1, z2, i);
    	flag110 = (flag110 << 1) + lies (z2, y2, z1, i);
    	flag111 = (flag111 << 1) + lies (z2, y2, z2, i);
    }

   if (! flag000) {	ans_x = z1; ans_y = y1; ans_z = z1; return (1); }
   if (! flag001) {	ans_x = z1; ans_y = y1; ans_z = z2; return (1); }
   if (! flag010) {	ans_x = z1; ans_y = y2; ans_z = z1; return (1); }
   if (! flag011) {	ans_x = z1; ans_y = y2; ans_z = z2; return (1); }
   if (! flag100) {	ans_x = z2; ans_y = y1; ans_z = z1; return (1); }
   if (! flag101) {	ans_x = z2; ans_y = y1; ans_z = z2; return (1); }
   if (! flag110) {	ans_x = z2; ans_y = y2; ans_z = z1; return (1); }
   if (! flag111) {	ans_x = z2; ans_y = y2; ans_z = z2; return (1); }

   if ((flag000 == flag001) && (flag000 == flag010) && (flag000 == flag011) &&
       (flag000 == flag100) && (flag000 == flag101) &&
		 (flag000 == flag110) && (flag000 == flag111))
    return (0);

   if (spare (x1, y1, z1, (x1 + x2) / 2, (y1 + y2) / 2, (z1 + z2) / 2)) return (1);
   if (spare ((x1 + x2) / 2, y1, z1, x2, (y1 + y2) / 2, (z1 + z2) / 2)) return (1);
   if (spare (x1, (y1 + y2) / 2, z1, (x1 + x2) / 2, y2, (z1 + z2) / 2)) return (1);
   if (spare ((x1 + x2) / 2, (y1 + y2) / 2, z1, x2, y2, (z1 + z2) / 2)) return (1);
   if (spare (x1, y1, (z1 + z2) / 2, (x1 + x2) / 2, (y1 + y2) / 2, z1)) return (1);
   if (spare ((x1 + x2) / 2, y1, (z1 + z2) / 2, x2, (y1 + y2) / 2, z1)) return (1);
   if (spare (x1, (y1 + y2) / 2, (z1 + z2) / 2, (x1 + x2) / 2, y2, z1)) return (1);
   if (spare ((x1 + x2) / 2, (y1 + y2) / 2, (z1 + z2) / 2, x2, y2, z1)) return (1);

   return (0);
 }


int lies (double x1, double y1, double z1, int sphere)
 {
   return ((x1 - xc [sphere]) * (x1 - xc [sphere]) + (y1 - yc [sphere]) * (y1 - yc [sphere]) +
           (z1 - zc [sphere]) * (z1 - zc [sphere]) < r [sphere] * r [sphere]);
 }


int inside (double x1, double y1, double z1)
 {
   xc [4] = x1, yc [4] = y1, zc [4] = z1;
   double t1, t2, t3, t4, t5;
   
	t1 = tetr (0, 1, 2, 3);
   t2 = tetr (0, 1, 2, 4);
   t3 = tetr (0, 1, 3, 4);
   t4 = tetr (0, 2, 3, 4);
   t5 = tetr (1, 2, 3, 4);

   return (fabsl (t1 - t2 - t3 - t4 - t5) < EPS);
 }


double tetr (int a, int b, int c, int d)
 {
   double x1 = xc [b] - xc [a], x2 = xc [c] - xc [a], x3 = xc [d] - xc [a];
   double y1 = yc [b] - yc [a], y2 = yc [c] - yc [a], y3 = yc [d] - yc [a];
   double z1 = zc [b] - zc [a], z2 = zc [c] - zc [a], z3 = zc [d] - zc [a];

   return (fabs (x1 * y2 * z3 + x3 * y1 * z2 + x2 * y3 * z1 -
                  x3 * y2 * z1 - x1 * y3 * z2 - x2 * y1 * z3));
 }
