type real=double;
     point=record
            x,y:real;
           end;
     line=record
            a,b,c:real;
        end;

const eps=1e-9;
	  inf=1e10;

var tr:array[1..100,0..2]of point;
    n,m,f1,f2:integer;
    mp,p1,p2:point;

function eq(a,b:real):boolean;
begin
	eq:=abs(a-b)<eps;
end;

function le(a,b:real):boolean;
begin
    le:=(a<b) or eq(a,b);
end;

function ls(a,b:real):boolean;
begin
	ls:=a<b-eps;
end;

function btw(a,b,c:real):boolean;
begin
	btw:=(le(a,b) and le(c,a)) or (le(b,a) and le(a,c));
end;

function btws(a,b,c:real):boolean;
begin
	btws:=(ls(a,b) and ls(c,a)) or (ls(b,a) and ls(a,c));
end;


procedure scan(p1,p2:point);
var c,f1,f2,f3:integer;
    p:array[1..300] of real;
    d:array[1..300] of shortint;
    r1,r2:real;

procedure sort(lo,hi:integer);
var l,h,r:integer;
	x,y:real;
begin
    l:=lo;h:=hi;x:=p[(lo+hi) div 2];

    while l<h do begin
        while (ls(p[l],x)) {or (eq(p[l],x) and (d[l]=1))} do inc(l);
        while (ls(x,p[h])) {or (eq(p[h],x) and (d[h]=-1))} do dec(h);
        y:=p[l];p[l]:=p[h];p[h]:=y;
        r:=d[l];d[l]:=d[h];d[h]:=r;
        inc(l);dec(h);
    end;

    if h>lo then sort(lo,h);
    if hi>l then sort(l,hi);

end;

function sq(p1,p2,p3:point):real;
begin
    sq:=abs((p1.y+p2.y)*(p2.x-p1.x)+(p2.y+p3.y)*(p3.x-p2.x)+(p3.y+p1.y)*(p1.x-p3.x))/2;
end;

function inside(p:point;n:integer):boolean;
var s1,s2:real;
	f1:integer;
begin
    s1:=sq(tr[n,0],tr[n,1],tr[n,2]);s2:=0;
    for f1:=0 to 2 do begin
    	s2:=s2+sq(tr[n,f1],tr[n,(f1+1) mod 3],p);
    end;
    inside:=eq(s1,s2);
end;

function u2o(p1,p2,p3,p4:point;var r:real):boolean;
var a1,a2,b1,b2,c1,c2,d,dx,dy,t1,t2:real;
begin
	a1:=p2.x-p1.x;
	a2:=p2.y-p1.y;
    b1:=p3.x-p4.x;
    b2:=p3.y-p4.y;
    c1:=p1.x-p3.x;
    c2:=p1.y-p3.y;
    d:=a1*b2-a2*b1;
    dx:=c1*b2-c2*b1;
    dy:=a1*c2-a2*c1;
    if not eq(0,d) then begin
        t1:=-dx/d;
        t2:=-dy/d;
{writeln(p1.x:3:3,', ',p1.y:3:3,' ',p2.x:3:3,', ',p2.y:3:3,' ',t1:6:6,' ',t2:6:6);
writeln(p3.x:3:3,', ',p3.y:3:3,' ',p4.x:3:3,', ',p4.y:3:3);}
        u2o:=btw(t1,0,1) and btw(t2,0,1);
        r:=t1;
        exit;
    end;
    u2o:=false;
end;


begin
{    writeln('scan ',p1.x:3:3,', ',p1.y:3:3,' ',p2.x:3:3,', ',p2.y:3:3);}
    c:=0;
    for f1:=1 to n do begin
{writeln;}
    	f3:=0;
        for f2:=0 to 1 do begin
            if u2o(p1,p2,tr[f1,f2],tr[f1,(f2+1) mod 3],r1) then begin
                inc(c);
                inc(f3);
                p[c]:=r1;d[c]:=0;
            end;
        end;
        if inside(p1,f1) then begin
            inc(c);
            inc(f3);
            p[c]:=0;d[c]:=0;
        end;
        if inside(p1,f1) then begin
            inc(c);
            inc(f3);
            p[c]:=1;d[c]:=0;
        end;
{writeln(f3);}
        if f3>0 then begin
            sort(c-f3+1,c);
            p[c-f3+2]:=p[c];
            c:=c-f3+2;
            d[c-1]:=1;
            d[c]:=-1;
        end;
    end;
    sort(1,c);
    for f1:=1 to c-1 do begin
        if eq(p[f1],p[f1+1]) and (d[f1]=-1) and (d[f1+1]=1) then begin
            d[f1]:=1;
            d[f1+1]:=-1;
        end;
    end;
{for f1:=1 to c do writeln(p[f1]:3:3,' ',d[f1]);}
    f3:=0;
    for f1:=1 to c do begin
        f3:=f3+d[f1];
        if f3>m then begin
            m:=f3;
            mp.x:=p1.x+p[f1]*(p2.x-p1.x);
            mp.y:=p1.y+p[f1]*(p2.y-p1.y);
        end;
    end;

end;

begin
    assign(input,'INPUT.TXT');
    assign(output,'OUTPUT.TXT');

    reset(input);
    rewrite(output);

    read(n);

    for f1:=1 to n do
        for f2:=0 to 2 do begin
            read(tr[f1,f2].x,tr[f1,f2].y);
        end;

    m:=0;
    for f1:=1 to n do
        for f2:=0 to 2 do scan(tr[f1,f2],tr[f1,(f2+1) mod 3]);
    writeln(mp.x:5:5,' ',mp.y:5:5);
    close(output);
end.
