#include <stdio.h>
#include <math.h>

int between( double x, double x1, double x2 )
{
  if (((x >= x1) && (x <= x2)) || ((x <= x1) && (x >= x2)))
    return 1;
  return 0;
}

int intersect( double *X, double *Y,
               double x11, double y11,
               double x12, double y12,
               double x21, double y21,
               double x22, double y22 )
{
  double A1 = y11 - y12, B1 = x12 - x11, C1 = -x11 * y12 + x12 * y11;
  double A2 = y21 - y22, B2 = x22 - x21, C2 = -x21 * y22 + x22 * y21;
  double d = A1 * B2 - A2 * B1,
         dx = C1 * B2 - C2 * B1,
         dy = A1 * C2 - A2 * C1;
  double x, y;
         
  if (d == 0)
    if ((dx == 0) && (dy == 0))
    {
      if (between(x21, x11, x12) && between(y21, y11, y12))
      {
        *X = x21;
        *Y = y21;
        return 1;
      }
      if (between(x22, x11, x12) && between(y22, y11, y12))
      {
        *X = x22;
        *Y = y22;
        return 1;
      }
      if (between(x11, x21, x22) && between(y11, y21, y22))
      {
        *X = x11;
        *Y = y11;
        return 1;
      }
      if (between(x12, x21, x22) && between(y12, y21, y22))
      {
        *X = x12;
        *Y = y12;
        return 1;
      }
      return 0;
    }
    else
      return 0;
  else
  {
    x = dx / d;
    y = dy / d;
    if (between(x, x11, x12) && between(y, y11, y12))
    {
      *X = x;
      *Y = y;
      return 1;
    }
    return 0;
  }
}

double sq( double X1, double Y1,
           double X2, double Y2,
           double X3, double Y3 )
{
  return fabs(X1 * Y2 + X2 * Y3 + X3 * Y1 - Y1 * X2 - Y2 * X3 - Y3 * X1);
}

int in( double X, double Y,
        double X1, double Y1,
        double X2, double Y2,
        double X3, double Y3 )
{
  return fabs(sq(X1, Y1, X2, Y2, X3, Y3)
              - sq(X, Y, X1, Y1, X2, Y2)
              - sq(X, Y, X2, Y2, X3, Y3)
              - sq(X, Y, X3, Y3, X1, Y1)) < 1e-7;
}

int main( void )
{
  int N, i, j, k, l, m;
  double x[100][4], y[100][4];
  int max = 0;
  double max_x, max_y;
  
  freopen("INPUT.TXT", "r", stdin);
  freopen("OUTPUT.TXT", "w", stdout);
  scanf("%i", &N);
  for (i = 0; i < N; i++)
  {
    for (j = 0; j < 3; j++)
      scanf("%lf %lf", &x[i][j], &y[i][j]);
    x[i][3] = x[i][0];
    y[i][3] = y[i][0];
  }
  for (i = 0; i < N; i++)
    for (j = 0; j < 3; j++)
      for (k = 0; k < N; k++)
        for (l = 0; l < 3; l++)
        {
          double X, Y;

          if (intersect(&X, &Y,
                        x[i][j], y[i][j], x[i][j + 1], y[i][j + 1],
                        x[k][l], y[k][l], x[k][l + 1], y[k][l + 1]))
          {
            int cnt = 0;

            for (m = 0; m < N; m++)
              if (in(X, Y, x[m][0], y[m][0], x[m][1], y[m][1], x[m][2], y[m][2]))
                cnt++;
            if (cnt > max)
            {
              max = cnt;
              max_x = X;
              max_y = Y;
            }
          }
        }
  printf("%g %g\n", max_x, max_y);
  return 0;
}

