#include <stdio.h>

double c[4][3];
double T[4];

#define maxcoord 100
#define eps 1

#define sqr(x) ((x) * (x))

double last_x, last_y, last_z;

int check( double x, double y, double z )
{
  int i;

  for (i = 0; i < 4; i++)
    if (sqr(x - c[i][0]) + sqr(y - c[i][1]) + sqr(z - c[i][2]) > sqr(T[i]))
      return 0;
  last_x = x;
  last_y = y;
  last_z = z;
  printf("%g %g %g %g %g %g %g\n", x, y, z, T[0], T[1], T[2], T[3]);
  return 1;
}

int found( double x1, double y1, double z1,
           double x2, double y2, double z2 )
{
  int i;
  double x, y, z;

  if (x2 - x1 < eps || y2 - y1 < eps || z2 - z1 < eps)
    return 0;
  for (i = 0; i < 4; i++)
    if (!((c[i][0] + T[i] >= x1) && (c[i][0] - T[i] <= x2)
          && (c[i][1] + T[i] >= y1) && (c[i][1] - T[i] <= y2)
          && (c[i][2] + T[i] >= z1) && (c[i][2] - T[i] <= z2)))
      return 0;
  if (check(x1, y1, z1)
      || check(x1, y1, z2)
      || check(x1, y2, z1)
      || check(x1, y2, z2)
      || check(x2, y1, z1)
      || check(x2, y1, z2)
      || check(x2, y2, z1)
      || check(x2, y2, z2))
    return 1;
  x = (x1 + x2) / 2;
  y = (y1 + y2) / 2;
  z = (z1 + z2) / 2;
  return found(x1, y1, z1, x, y, z)
         || found(x, y1, z1, x2, y, z)
         || found(x1, y, z1, x, y2, z)
         || found(x, y, z1, x2, y2, z)
         || found(x1, y1, z, x, y, z2)
         || found(x, y1, z, x2, y, z2)
         || found(x1, y, z, x, y2, z2)
         || found(x, y, z, x2, y2, z2);
}

int main( void )
{
  double t[4];
  int i, j;
  double minv = 0;
  double lo, hi;
  
  freopen("INPUT.TXT", "r", stdin);
  //freopen("OUTPUT.TXT", "w", stdout);
  for (i = 0; i < 4; i++)
    for (j = 0; j < 3; j++)
      scanf("%lf", &c[i][j]);
  t[0] = 0;
  for (i = 1; i < 4; i++)
  {
    scanf("%lf", &t[i]);
    if (t[i] < minv)
      minv = t[i];
  }
  for (i = 0; i < 4; i++)
    t[i] -= minv;
  lo = 0;
  hi = 1e7;
  while (lo + eps < hi)
  {
    double mi = (lo + hi) / 2;

    for (i = 0; i < 4; i++)
      T[i] = t[i] + mi;
    if (found(-maxcoord, -maxcoord, -maxcoord, maxcoord, maxcoord, maxcoord))
      hi = mi;
    else
      lo = mi;
  }
  printf("%.4f %.4f %.4f\n", last_x, last_y, last_z);
  return 0;
}

