{$ifdef check}
{$i+,q+,r+,s+,n+}
{$else}
{$i-,q-,r-,s-,n+}
{$endif}
uses sysutils;
type extended=single;
const eps=1e-5;
var f:text;
    x1,y1,x2,y2,x3,y3:array[1..100] of extended;
    i,j:integer;
    max:integer;
    maxx,maxy:extended;
    n:integer;
    tt:tdatetime;
    t:double absolute tt;
    t0:double;

procedure cross(x1,y1,x2,y2,x3,y3,x4,y4:extended;var xx,yy:extended);
var d:extended;
begin
d:=((y2-y1)*(x3-x4)-(x1-x2)*(y4-y3));
if abs(d)<eps then begin
   xx:=1e30;yy:=1e30;exit;{no cross}
end;
xx:=( (-y1*(x2-x1)+x1*(y2-y1))*(x3-x4)-(-y3*(x4-x3)+x3*(y4-y3))*(x1-x2) )/d;
yy:=((y2-y1)*(-y3*(x4-x3)+x3*(y4-y3))-(y4-y3)*(-y1*(x2-x1)+x1*(y2-y1)))/d;
end;

function isineq(a,b,c:extended):byte;
begin
if ((a-eps<b)and(b<c+eps))or((c-eps<b)and(b<a+eps)) then
   isineq:=1
else isineq:=0;
end;

function sq(x1,y1,x2,y2,x3,y3:extended):extended;
begin
sq:=abs(x1*y2-y1*x2+  x2*y3-y2*x3+  x3*y1-y3*x1)/2;
end;

function eq(a,b,c:extended):byte;
begin if (abs(a-b)<eps)and(abs(b-c)<eps) then eq:=1 else eq:=0; end;

function isin(xx,yy:extended;i:integer):byte;
begin
if abs(sq(x1[i],y1[i],x2[i],y2[i],x3[i],y3[i]))<eps then begin{bad triangle}
  if abs(sq(xx,yy,x1[i],y1[i],x2[i],y2[i])+sq(xx,yy,x2[i],y2[i],x3[i],y3[i])+
     sq(xx,yy,x3[i],y3[i],x1[i],y1[i]))>eps then begin isin:=0;exit; end;
     if ((isineq(x1[i],xx,x2[i])=1)and(isineq(y1[i],yy,y2[i])=1))or
        ((isineq(x2[i],xx,x3[i])=1)and(isineq(y2[i],yy,y3[i])=1))or
        ((isineq(x3[i],xx,x1[i])=1)and(isineq(y3[i],yy,y1[i])=1)) then isin:=1
     else isin:=0;
  exit;
end;
if abs(sq(x1[i],y1[i],x2[i],y2[i],x3[i],y3[i])-
  sq(xx,yy,x1[i],y1[i],x2[i],y2[i])-sq(xx,yy,x2[i],y2[i],x3[i],y3[i])-
  sq(xx,yy,x3[i],y3[i],x1[i],y1[i]))<eps
then isin:=1 else isin:=0;
end;

procedure check(x1,y1,x2,y2,x3,y3,x4,y4:extended);
var xx,yy:extended;
    i:integer;
    nall:integer;
begin
cross(x1,y1,x2,y2,x3,y3,x4,y4,xx,yy);
if xx>1e25 then exit;
if (isineq(x1,xx,x2)=0)or(isineq(x3,xx,x4)=0)
     or(isineq(y1,yy,y2)=0)or(isineq(y3,yy,y4)=0)
   then exit;
nall:=0;
for i:=1 to n do if isin(xx,yy,i)=1 then inc(nall);
if nall>max then begin
   max:=nall;
   maxx:=xx;maxy:=yy;
end;
end;

procedure checkver(xx,yy:extended);
var nall:integer;
    i:integer;
begin
nall:=0;
for i:=1 to n do if isin(xx,yy,i)=1 then inc(nall);
if nall>max then begin
   max:=nall;
   maxx:=xx;maxy:=yy;
end;
end;

begin tt:=now;t0:=t;
assign(f,'INPUT.TXT');reset(f);
read(f,n);
for i:=1 to n do read(f,x1[i],y1[i],x2[i],y2[i],x3[i],y3[i]);
max:=0;
for i:=1 to n do begin
    for j:=i+1 to n do begin
        check(x1[i],y1[i],x2[i],y2[i],x1[j],y1[j],x2[j],y2[j]);
        check(x1[i],y1[i],x2[i],y2[i],x2[j],y2[j],x3[j],y3[j]);
        check(x1[i],y1[i],x2[i],y2[i],x3[j],y3[j],x1[j],y1[j]);

        check(x2[i],y2[i],x3[i],y3[i],x1[j],y1[j],x2[j],y2[j]);
        check(x2[i],y2[i],x3[i],y3[i],x2[j],y2[j],x3[j],y3[j]);
        check(x2[i],y2[i],x3[i],y3[i],x3[j],y3[j],x1[j],y1[j]);

        check(x3[i],y3[i],x1[i],y1[i],x1[j],y1[j],x2[j],y2[j]);
        check(x3[i],y3[i],x1[i],y1[i],x2[j],y2[j],x3[j],y3[j]);
        check(x3[i],y3[i],x1[i],y1[i],x3[j],y3[j],x1[j],y1[j]);
    end;
    checkver(x1[i],y1[i]);
    checkver(x2[i],y2[i]);
    checkver(x3[i],y3[i]);
    if max=n then break;
    tt:=now;
    if t>t0+9/24/60/60 then break;
end;
assign(f,'OUTPUT.TXT');rewrite(f);
writeln(f,maxx:20:20,' ',maxy:20:20);
close(f);
end.
