{$I-,Q-,R-,S-,V-,X-}
uses sysutils;

const
  eps = 0.00001;

type
  tpoint = record
    x, y: extended;
  end;

  tline = record
    a, b, c: extended;
  end;

var
  n, c1, c2, c3, c4, c5, t, fin: byte;
  p: array[1..100, 0..2] of tpoint;
  i: array[1..100] of byte;
  o: array[1..100, 0..2] of tline;
  a, f: tpoint;
  breaktime: double;

procedure makeline(p1, p2: tpoint; var l: tline);
begin
  l.a := p1.y-p2.y; l.b := p2.x-p1.x;
  l.c := -(l.a*p1.x+l.b*p1.y);
end;

function le(a: real; b: extended): boolean;
begin
  le := (a < b) or (abs(a-b) < eps);
end;

function peresech(l1, l2: tline; var p: tpoint): boolean;
var
  d: extended;
begin
  d := l1.a*l2.b-l1.b*l2.a;
  if (abs(d) < eps) then begin
    peresech := false; exit;
  end else
    peresech := true;
  p.x := -(l1.c*l2.b-l1.b*l2.c)/d; p.y := -(l1.a*l2.c-l2.a*l1.c)/d;
end;

function between(a, b, c: tpoint): boolean;
begin
  if le((a.x-b.x)*(a.x-c.x), 0) and
     le((a.y-b.y)*(a.y-c.y), 0) then
    between := true
  else
    between := false;
end;

function s(a, b, c: tpoint): extended;
begin
  s := abs(0.5*(a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y)));
end;

begin
  breaktime := now+(9.5/(24*60*60));
  assign(input, 'INPUT.TXT'); reset(input);
  assign(output, 'OUTPUT.TXT'); rewrite(output);
  read(n); fillchar(i, sizeof(i), 0);
  for c1 := 1 to n do begin
    read(p[c1, 0].x, p[c1, 0].y, p[c1, 1].x, p[c1, 1].y,
         p[c1, 2].x, p[c1, 2].y);
    if abs(s(p[c1, 0], p[c1, 1], p[c1, 2])) < eps then begin
      i[c1] := 1;
    end;
  end;
  for c1 := 1 to n do begin
    makeline(p[c1, 0], p[c1, 1], o[c1, 0]);
    makeline(p[c1, 1], p[c1, 2], o[c1, 1]);
    makeline(p[c1, 2], p[c1, 0], o[c1, 2]);
  end;
  fin := 0;
  for c1 := 1 to n do begin
    for c2 := 0 to 2 do begin
       if now >= breaktime then begin
         writeln(f.x:1:4, ' ', f.y:1:4); close(output); halt;
       end;
       t := 0; a := p[c1, c2];
       for c5 := 1 to n do begin
         if (abs(s(a, p[c5, 1], p[c5, 2])+
             s(a, p[c5, 2], p[c5, 0])+
             s(a, p[c5, 1], p[c5, 0])-
             s(p[c5, 0], p[c5, 1], p[c5, 2])) < eps) and
             ((i[c5] = 0) or (between(a, p[c5, 0], p[c5, 1])) or
                             (between(a, p[c5, 1], p[c5, 2])) or
                             (between(a, p[c5, 2], p[c5, 0]))) then begin
           inc(t);
         end;
       end;
       if t > fin then begin
         fin := t; f := a;
       end;
    end;
  end;
  for c1 := 1 to n-1 do begin
    for c2 := 0 to 2 do begin
      for c3 := c1+1 to n do begin
        for c4 := 0 to 2 do begin
          if now >= breaktime then begin
            writeln(f.x:1:4, ' ', f.y:1:4); close(output); halt;
          end;
          if peresech(o[c1, c2], o[c3, c4], a) then begin
            if between(a, p[c1, c2], p[c1, (c2+1) mod 3]) and
               between(a, p[c3, c4], p[c3, (c4+1) mod 3]) then begin
              t := 0;
              for c5 := 1 to n do begin
                if (abs(s(a, p[c5, 1], p[c5, 2])+
                    s(a, p[c5, 2], p[c5, 0])+
                    s(a, p[c5, 1], p[c5, 0])-
                    s(p[c5, 0], p[c5, 1], p[c5, 2])) < eps) and
                    ((i[c5] = 0) or (between(a, p[c5, 0], p[c5, 1])) or
                                    (between(a, p[c5, 1], p[c5, 2])) or
                                    (between(a, p[c5, 2], p[c5, 0]))) then begin
                   inc(t);
                 end;
              end;
              if t > fin then begin
                fin := t; f := a;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
  writeln(f.x:1:4, ' ', f.y:1:4);
  close(output);
end.
