{$I-,Q-,R-,S-,V-,X-}
Program PointInTriangles;
Const
  InFile='INPUT.TXT';
  OutFile='OUTPUT.TXT';
  Eps=1E-8;
  MaxN=102;
  _Tri=0;
  _Otr=1;
  _Poi=2;
Type
  Real=Extended;
  TPoint=Record
    X,Y:Real;
  End;
  TLine=Record
    A,B,C:Real;
  End;
Var
  N:Byte;
  P:Array[1..MaxN,0..2]Of TPoint;
  L:Array[1..MaxN,0..2]Of TLine;
  IsL:Array[1..MaxN,0..2]Of Boolean;
  Kind:Array[1..MaxN]Of Byte;
  Bou:Array[1..MaxN]Of Record
    MiX,MiY,MaX,MaY:Real;
  End;
  Res:LongInt;
  ResP:TPoint;
Procedure Load;
Var
  I,J:LongInt;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  For I:=1 To N Do
    For J:=0 To 2 Do If Not SeekEOF Then Read(P[I][J].X,P[I][J].Y);
  Close(Input);
End;
Procedure LineByPoints(Var P1,P2:TPoint; Var L:TLine);
Var
  Z:Real;
Begin
  L.A:=P2.Y-P1.Y;
  L.B:=P1.X-P2.X;
  If Abs(L.A)<Eps Then Z:=L.B Else If Abs(L.B)<Eps Then Z:=L.A Else
    Z:=Sqrt(Sqr(L.A)+Sqr(L.B));
  L.A:=L.A/Z;
  L.B:=L.B/Z;
  L.C:=-(L.A*P1.X+L.B*P1.Y);
End;
Function Sign(A:Real):ShortInt;
Begin
  If Abs(A)<Eps Then Sign:=0 Else If A<0 Then Sign:=-1 Else Sign:=1;
End;
Function Side(Var L:TLine; Var P:TPoint):ShortInt;
Begin
  Side:=Sign(L.A*P.X+L.B*P.Y+L.C);
End;
Function PointsEq(Var P1,P2:TPoint):Boolean;
Begin
  PointsEq:=(Abs(P1.X-P2.X)<Eps) And (Abs(P1.Y-P2.Y)<Eps);
End;
Function CrossTwoLines(Var L1,L2:TLine; Var P:TPoint):Boolean;
Var
  Z:Real;
Begin
  CrossTwoLines:=False;
  Z:=L1.A*L2.B-L1.B*L2.A;
  If Abs(Z)<Eps Then Exit;
  P.X:=-(L1.C*L2.B-L1.B*L2.C)/Z;
  P.Y:=-(L1.A*L2.C-L1.C*L2.A)/Z;
  CrossTwoLines:=True;
End;
Procedure Check(Var PP:TPoint);
Var
  I,J:LongInt;
  Ok:Boolean;
  CNum:LongInt;
Begin
  CNum:=0;
  For I:=1 To N Do Begin
    Ok:=True;
    Case Kind[I] Of
      _Tri:
        For J:=0 To 2 Do If IsL[I][J] Then
          If Side(L[I][J],PP)=-1 Then Begin Ok:=False; Break; End;
      _Otr:Begin
        For J:=0 To 2 Do If IsL[I][J] Then
          If Side(L[I][J],PP)<>0 Then Begin Ok:=False; Break; End;
        If Ok Then With Bou[I] Do Begin
          If Sign(PP.X-MiX)*Sign(PP.X-MaX)=1 Then
            Ok:=False
          Else
            If Sign(PP.Y-MiY)*Sign(PP.Y-MaY)=1 Then
              Ok:=False;
        End;
      End;
      _Poi:Ok:=PointsEq(P[I][0],PP);
    End;
    If Ok Then Inc(CNum);
  End;
  If CNum>Res Then Begin
    Res:=CNum;
    ResP:=PP;
  End;
End;
Procedure Bounds(I:LongInt);
Var
  J:LongInt;
Begin
  With Bou[I] Do Begin
    MiX:=1E100;
    MiY:=1E100;
    MaX:=-1E100;
    MaY:=-1E100;
    For J:=0 To 2 Do Begin
      If P[I][J].X<MiX Then MiX:=P[I][J].X;
      If P[I][J].X>MaX Then MaX:=P[I][J].X;
      If P[I][J].Y<MiY Then MiY:=P[I][J].Y;
      If P[I][J].Y>MaY Then MaY:=P[I][J].Y;
    End;
  End;
End;
Procedure Solve;
Var
  I,J,II,JJ,I1,J1,II1,JJ1:LongInt;
  PP:TPoint;
Begin
  For I:=1 To N Do Begin
    For J:=0 To 2 Do Begin
      II:=(J+1) Mod 3;
      JJ:=(II+1) Mod 3;
      IsL[I][J]:=Not PointsEq(P[I][II],P[I][JJ]);
      If IsL[I][J] Then Begin
        LineByPoints(P[I][II],P[I][JJ],L[I][J]);
        If Side(L[I][J],P[I][J])=-1 Then With L[I][J] Do Begin
          A:=-A;
          B:=-B;
          C:=-C;
        End;
      End;
    End;
    If Not IsL[I][0] And Not IsL[I][1] And Not IsL[I][2] Then Begin Kind[I]:=_Poi; Continue; End;
    If Not IsL[I][0] Or Not IsL[I][1] Or Not IsL[I][2] Then Begin Kind[I]:=_Otr; Bounds(I); Continue; End;
    If Side(L[I][0],P[I][0])=0 Then Begin Kind[I]:=_Otr; Bounds(I); Continue; End;
    Kind[I]:=_Tri;
  End;
  Res:=-1;
  For I:=1 To N Do
    For J:=0 To 2 Do Check(P[I][J]);
  For I:=1 To N Do
    For J:=0 To 2 Do If IsL[I][J] Then Begin
      II:=(J+1) Mod 3;
      JJ:=(II+1) Mod 3;
      For I1:=1 To N Do
        For J1:=0 To 2 Do If IsL[I1,J1] Then Begin
          II1:=(J1+1) Mod 3;
          JJ1:=(II1+1) Mod 3;
          If Side(L[I1][J1],P[I][II])*Side(L[I1][J1],P[I][JJ])>-1 Then Continue;
          If Side(L[I][J],P[I1][II1])*Side(L[I][J],P[I1][JJ1])>-1 Then Continue;
          If Not CrossTwoLines(L[I][J],L[I1][J1],PP) Then Continue;
          Check(PP);
        End;
    End;
End;
Procedure Save;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(ResP.X:0:18,' ',ResP.Y:0:18);
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
