{$I+,Q+,R+,S+,V-,X-}
Program ColuredPlane;
Const
  InFile='input.txt';
  OutFile='output.txt';
  MaxN=22;
  MaxG=MaxN*MaxN Div 2;
  Shift=1E-2;
  Eps=1E-7;
Type
  TLine=Record
    A,B,C:Real;
  End;
  TPoint=Record
    X,Y:Real;
  End;
  TArea=Record
    B:Array[1..MaxN]Of ShortInt;
    M:TPoint;
  End;
  TAreaArr=Array[1..MaxG]Of TArea;
Var
  N:LongInt;
  L:Array[1..MaxN]Of TLine;
  NA:LongInt;
  A,Tmp:TAreaArr;
  Conn:Array[1..MaxG,1..MaxG]Of Boolean;
  NCr:LongInt;
  Cr:Array[1..MaxN]Of TPoint;
  Part:Array[1..MaxG]Of Byte;
  Front:Array[1..MaxG]Of LongInt;
  Prev:Array[1..MaxG]Of LongInt;
  Pair:Array[1..MaxG]Of LongInt;
  Mark:Array[1..MaxG]Of Boolean;
  Take:Array[1..MaxG]Of Boolean;
  NTake:LongInt;
  FrHead,FrTail:LongInt;
Procedure Load;
Var
  I:LongInt;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  For I:=1 To N Do If Not SeekEOF Then Read(L[I].A,L[I].B,L[I].C);
  Close(Input);
End;
Procedure LineByPoints(Var P1,P2:TPoint; Var L:TLine);
Var
  Z:Real;
Begin
  L.A:=P2.Y-P1.Y;
  L.B:=P1.X-P2.X;
  If Abs(L.A)<Eps Then Z:=L.B Else If Abs(L.B)<Eps Then Z:=L.A Else
    Z:=Sqrt(Sqr(L.A)+Sqr(L.B));
  L.A:=L.A/Z;
  L.B:=L.B/Z;
  L.C:=-(L.A*P1.X+L.B*P1.Y);
End;
Function Sign(A:Real; Eps:Real):ShortInt;
Begin
  If Abs(A)<Eps Then Sign:=0 Else If A<0 Then Sign:=-1 Else Sign:=1;
End;
Function Side(Var L:TLine; Var P:TPoint):ShortInt;
Begin
  Side:=Sign(L.A*P.X+L.B*P.Y+L.C,Shift);
End;
Function CrossTwoLines(Var L1,L2:TLine; Var P:TPoint):Boolean;
Var
  Z:Real;
Begin
  CrossTwoLines:=False;
  Z:=L1.A*L2.B-L1.B*L2.A;
  If Abs(Z)<Eps Then Exit;
  P.X:=-(L1.C*L2.B-L1.B*L2.C)/Z;
  P.Y:=-(L1.A*L2.C-L1.C*L2.A)/Z;
  CrossTwoLines:=True;
End;
Procedure AOL(Var L:TLine; Var P:TPoint);
Begin
  P.X:=-L.A*L.C/(Sqr(L.A)+Sqr(L.B));
  P.Y:=-L.B*L.C/(Sqr(L.A)+Sqr(L.B));
End;
Function AreaEmpty(Var A:TArea; FL:Byte):Boolean;
Var
  I,J,II:LongInt;
  P:TPoint;
  Ok:Boolean;
Begin
  If FL=1 Then Begin
    AreaEmpty:=False;
    AOL(L[1],A.M);
    A.M.X:=A.M.X+L[1].A*A.B[1]*2*Shift;
    A.M.Y:=A.M.Y+L[1].B*A.B[1]*2*Shift;
    Exit;
  End;
  If Side(L[FL],A.M)=A.B[FL] Then Begin
    AreaEmpty:=False;
    Exit;
  End;
  NCr:=0;
  For I:=1 To FL-1 Do If CrossTwoLines(L[I],L[FL],P) Then Begin
    Inc(NCr);
    Cr[NCr]:=P;
  End;
  If NCr=0 Then Begin
    AOL(L[FL],A.M);
    A.M.X:=A.M.X+L[FL].A*A.B[FL]*2*Shift;
    A.M.Y:=A.M.Y+L[FL].B*A.B[FL]*2*Shift;
    AreaEmpty:=False;
    For I:=1 To FL-1 Do If Side(L[I],A.M)<>A.B[I] Then AreaEmpty:=True;
    Exit;
  End;
  For I:=1 To NCr-1 Do
    For J:=I+1 To NCr Do Begin
      A.M.X:=(Cr[I].X+Cr[J].X)/2+L[FL].A*A.B[FL]*2*Shift;
      A.M.Y:=(Cr[I].Y+Cr[J].Y)/2+L[FL].B*A.B[FL]*2*Shift;
      Ok:=False;
      For II:=1 To FL-1 Do If Side(L[II],A.M)<>A.B[II] Then Ok:=True;
      If Not Ok Then Begin
        AreaEmpty:=False;
        Exit;
      End;
      A.M.X:=(2*Cr[I].X-Cr[J].X)+L[FL].A*A.B[FL]*2*Shift;
      A.M.Y:=(2*Cr[I].Y-Cr[J].Y)+L[FL].B*A.B[FL]*2*Shift;
      Ok:=False;
      For II:=1 To FL-1 Do If Side(L[II],A.M)<>A.B[II] Then Ok:=True;
      If Not Ok Then Begin
        AreaEmpty:=False;
        Exit;
      End;
      A.M.X:=(2*Cr[J].X-Cr[I].X)+L[FL].A*A.B[FL]*2*Shift;
      A.M.Y:=(2*Cr[J].Y-Cr[I].Y)+L[FL].B*A.B[FL]*2*Shift;
      Ok:=False;
      For II:=1 To FL-1 Do If Side(L[II],A.M)<>A.B[II] Then Ok:=True;
      If Not Ok Then Begin
        AreaEmpty:=False;
        Exit;
      End;
    End;
  AreaEmpty:=True;
End;
Procedure FillParts;
Var
  I,J:LongInt;
Begin
  FrHead:=2;
  FrTail:=1;
  Front[FrTail]:=1;
  FillChar(Part,SizeOf(Part),0);
  Part[1]:=1;
  While FrTail<FrHead Do Begin
    I:=Front[FrTail];
    Inc(FrTail);
    For J:=1 To NA Do
      If Conn[I][J] And (Part[J]=0) Then Begin
        Part[J]:=3-Part[I];
        Front[FrHead]:=J;
        Inc(FrHead);
      End;
  End;
End;
Procedure FindPairs;
Var
  I,J,K:LongInt;
  Found:Boolean;
Begin
  FillChar(Pair,SizeOf(Pair),0);
  For I:=1 To NA Do If Part[I]=1 Then Begin
    FrHead:=2;
    FrTail:=1;
    Front[1]:=I;
    FillChar(Mark,SizeOf(Mark),False);
    Prev[I]:=0;
    Mark[I]:=True;
    Found:=False;
    While FrTail<FrHead Do Begin
      J:=Front[FrTail];
      Inc(FrTail);
      For K:=1 To NA Do If Conn[J][K] And (((Part[K]=2) And (Pair[K]<>J)) Or ((Part[K]=1) And (Pair[K]=J))) And Not Mark[K] Then Begin
        Prev[K]:=J;
        If (Part[K]=2) And (Pair[K]=0) Then Begin FrTail:=FrHead; Found:=True; Break; End;
        Mark[K]:=True;
        Front[FrHead]:=K;
        Inc(FrHead);
      End;
    End;
    If Found Then Begin
      While K>0 Do Begin
        Pair[K]:=Prev[K];
        Pair[Prev[K]]:=K;
        K:=Prev[K];
        K:=Prev[K];
      End;
    End;
  End;
End;
Procedure FindCover;
Var
  I,J:LongInt;
Begin
  NTake:=0;
  FrHead:=1;
  FrTail:=1;
  FillChar(Mark,SizeOf(Mark),False);
  For I:=1 To NA Do If (Part[I]=1) And (Pair[I]=0) Then Begin
    Front[FrHead]:=I;
    Inc(FrHead);
    Mark[I]:=True;
  End;
  While FrTail<FrHead Do Begin
    I:=Front[FrTail];
    Inc(FrTail);
    For J:=1 To NA Do If (Conn[I][J]) And (((Part[I]=1) And (Pair[I]<>J)) Or ((Part[I]=2) And (Pair[I]=J))) And Not Mark[J] Then Begin
      Mark[J]:=True;
      Front[FrHead]:=J;
      Inc(FrHead);
    End;
  End;
  For I:=1 To NA Do If Mark[I] Xor (Part[I]=1) Then Begin
    Inc(NTake);
    Take[I]:=True;
  End;
End;
Procedure Solve;
Var
  ANew:TArea;
  NT,I,J,II:LongInt;
Begin
  NA:=1;
  FillChar(A[1],SizeOf(A[1]),0);
  A[1].M.X:=0;
  A[1].M.Y:=0;
  For I:=1 To N Do Begin
    NT:=0;
    For J:=1 To NA Do Begin
      ANew:=A[J];
      ANew.B[I]:=1;
      If Not AreaEmpty(ANew,I) Then Begin
        Inc(NT);
        Tmp[NT]:=ANew;
      End;
      ANew.B[I]:=-1;
      If Not AreaEmpty(ANew,I) Then Begin
        Inc(NT);
        Tmp[NT]:=ANew;
      End;
    End;
    NA:=NT;
    A:=Tmp;
  End;
  For I:=1 To NA Do
    For J:=I To NA Do Begin
      NT:=0;
      For II:=1 To N Do If A[I].B[II]<>A[J].B[II] Then Inc(NT);
      Conn[I][J]:=(NT=1);
      Conn[J][I]:=(NT=1);
    End;
  FillParts;
  FindPairs;
  FindCover;
End;
Procedure Save;
Var
  I:LongInt;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(NTake);
  For I:=1 To NA Do
    If Take[I] Then WriteLn(A[I].M.X:0:18,' ',A[I].M.Y:0:18);
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
