{$I-,Q-,R-,S-,V-,X-}
Program GPS;
Const
  InFile='INPUT.TXT';
  OutFile='OUTPUT.TXT';
  Eps=1E-7;
Type
  TPoint=Record
    X,Y,Z:Real;
  End;
Var
  Satellite:Array[0..3]Of TPoint;
  T:Array[1..3]Of Real;
  Res:TPoint;
Procedure Load;
Var
  I:LongInt;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  For I:=0 To 3 Do If Not SeekEOF Then Read(Satellite[I].X,Satellite[I].Y,Satellite[I].Z);
  For I:=1 To 3 Do If Not SeekEOF Then Read(T[I]);
  Close(Input);
End;
Function Distance(A,B:TPoint):Real;
Begin
  Distance:=Sqrt(Sqr(A.X-B.X)+Sqr(A.Y-B.Y)+Sqr(A.Z-B.Z));
End;
Function CalcDiff(Var Try:TPoint):Real;
Var
  I:LongInt;
  D1:Real;
  Ret:Real;
Begin
  D1:=Distance(Try,Satellite[0]);
  Ret:=0;
  For I:=1 To 3 Do Ret:=Ret+Sqr(Distance(Try,Satellite[I])-D1-T[I]);
  CalcDiff:=Ret;
End;
Procedure Solve;
Var
  Step:Real;
  OCur,Cur:TPoint;
  Next:TPoint;
  CurDiff,NextDiff:Real;
  WN:LongInt;
  I,J,CLoop:LongInt;
  MD:Real;
Begin
  {Assign(Output,'LOG.TXT');
  ReWrite(Output);}
  CLoop:=0;
  Repeat
    If CLoop<=0 Then Begin
      Case CLoop Of
        0:Begin
          Cur.X:=0;
          Cur.Y:=0;
          Cur.Z:=0;
          For I:=0 To 3 Do Begin
            Cur.X:=Cur.X+Satellite[I].X;
            Cur.Y:=Cur.Y+Satellite[I].Y;
            Cur.Z:=Cur.Z+Satellite[I].Z;
          End;
          Cur.X:=Cur.X/4;
          Cur.Y:=Cur.Y/4;
          Cur.Z:=Cur.Z/4;
          Step:=0;
          For I:=0 To 2 Do
            For J:=I+1 To 3 Do
              Step:=Step+Distance(Satellite[I],Satellite[J]);
          Step:=Step/6;
        End;
      End;
    End Else Begin
      MD:=1E100;
      For I:=0 To 3 Do If I<>Cloop Mod 4 Then
        If Distance(Satellite[I],Satellite[CLoop Mod 4])<MD Then MD:=Distance(Satellite[I],Satellite[CLoop Mod 4]);
      Cur.X:=Satellite[CLoop Mod 4].X+(Random-0.5)*MD;
      Cur.Y:=Satellite[CLoop Mod 4].Y+(Random-0.5)*MD;
      Cur.Z:=Satellite[CLoop Mod 4].Z+(Random-0.5)*MD;
      Step:=MD;
    End;
    CurDiff:=CalcDiff(Cur);
    Repeat
      WN:=0;
      Repeat
        Next.X:=Cur.X+(Random-0.5)*Step;
        Next.Y:=Cur.Y+(Random-0.5)*Step;
        Next.Z:=Cur.Z+(Random-0.5)*Step;
        OCur:=Cur;
        {Write(Next.X:0:5,' ',Next.Y:0:5,' ',Next.Z:0:5);}
        NextDiff:=CalcDiff(Next);
        If NextDiff<CurDiff Then Begin
          WN:=0;
          Cur:=Next;
          CurDiff:=NextDiff;
          {WriteLn(' - accepted : ',CurDiff:0:18);}
        End Else Begin
          Inc(WN);
          {WriteLn(' - rejected : ',NextDifF:0:18);}
        End;
      Until WN>100;
      Step:=Step/10;
      {WriteLn('Step decreasing: ',CurDiff:0:5,' ',Step:0:5);}
    Until (Distance(OCur,Next)<Eps);
    Inc(CLoop);
  Until (CurDiff<100*Eps);
  Res:=Cur;
  {Res.X:=201.7506765663264000;
  Res.Y:=-419.5262310428864000;
  Res.Z:=469.1421780432063000;
  WriteLn(Distance(Res,Satellite[1])-Distance(Res,Satellite[0]));
  WriteLn(Distance(Res,Satellite[2])-Distance(Res,Satellite[0]));
  WriteLn(Distance(Res,Satellite[3])-Distance(Res,Satellite[0]));}
End;
Procedure Save;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(Res.X:0:18,' ',Res.Y:0:18,' ',Res.Z:0:18);
  Close(Output);
End;
Begin
  RandSeed:=571554165;
  Load;
  Solve;
  Save;
End.
