{$I-,Q-,R-,S-,V-,X-}
type  float = extended;
const eps: float = 1e-10;
var
  n, b: longint;
  x, y: array [1..1000, 1..3] of float;
  xx, yy, bx, by: float;

function sq(const x1, y1, x2, y2, x3, y3: float): float;
begin
  sq := abs( (x2-x1)*(y3-y1) - ((y2-y1)*(x3-x1)));
end;

function d(const x1, y1, x2, y2: float): float;
begin
  d := sqrt(sqr(x1-x2) + sqr(y1-y2));
end;

function inside(k: integer): boolean;
var
  s, ss: float;
  a, b: integer;
begin
  inside := true;

  a := 1; b := 2;
  s := d(x[k,a],y[k,a],x[k,b],y[k,b])-(d(x[k,a],y[k,a],xx,yy)+d(xx,yy,x[k,b],y[k,b]));
  if (abs(s)<eps) then exit;
  a := 2; b := 3;
  s := d(x[k,a],y[k,a],x[k,b],y[k,b])-(d(x[k,a],y[k,a],xx,yy)+d(xx,yy,x[k,b],y[k,b]));
  if (abs(s)<eps) then exit;
  a := 3; b := 1;
  s := d(x[k,a],y[k,a],x[k,b],y[k,b])-(d(x[k,a],y[k,a],xx,yy)+d(xx,yy,x[k,b],y[k,b]));
  if (abs(s)<eps) then exit;

  s := sq(x[k,1],y[k,1],x[k,2],y[k,2],x[k,3],y[k,3]);
  ss := sq(xx,yy,x[k,2],y[k,2],x[k,3],y[k,3])+
        sq(x[k,1],y[k,1],xx,yy,x[k,3],y[k,3])+
        sq(x[k,1],y[k,1],x[k,2],y[k,2],xx,yy);

  if ((abs(s)>eps) and ((abs(s-ss)<eps))) then exit;

  inside := false;
end;

procedure Solve;
var
   i, j, k, cc: integer;
begin
  b := 0; bx := 0; by := 0;
  for i := 1 to n do for j := 1 to 3 do begin
    cc := 0; xx := x[i, j]; yy := y[i, j];
    for k := 1 to n do if (inside(k)) then inc(cc);
    if (cc>b) then begin
      b := cc; bx := xx; by := yy;
    end;
  end;
end;

procedure ReadAll;
var  i, j: integer;
begin
  Assign(Input, 'INPUT.TXT'); Reset(Input);

  Read(n);
  for i := 1 to n do for j := 1 to 3 do Read(x[i, j], y[i, j]);

  Close(Input);
end;

procedure Out;
begin
  Assign(Output, 'OUTPUT.TXT'); ReWrite(Output);

  WriteLn(bx:1:12, ' ', by:1:12);

  Close(Output);
end;

begin
  ReadAll;
  Solve;
  Out;
end.
