uses sysutils;
type
  tPoint=record x,y:double;is:boolean; end;
  tLine=record a,b,c:double;is:boolean; end;
var
  i,j:integer;
  best:
    record
      x,y:double;
      n:integer;
    end;
  fin,fout:text;
  tr:array[1..100,1..3]of tPoint;
  lin:array[1..100,1..3]of tLine;
  n:integer;
  inters:array[1..100]of integer;
  endTime:double;
procedure lineByPoints(p1,p2:tPoint;var l:tLine);
begin
  l.is:=false;
  if not (p1.is and p2.is) then exit;
  if abs(p1.x-p2.x)+abs(p1.y-p2.y)<0.000001 then exit;
  l.is:=true;
  l.a:=p1.y-p2.y;
  l.b:=p2.x-p1.x;
  l.c:=l.a*p1.x+l.b*p1.y;
end;
procedure linesIntersection(l1,l2:tLine;var p:tPoint);
var d,dx,dy:double;
begin
  p.is:=false;
  d:=l1.a*l2.b-l2.a*l1.b;
  if abs(d)<0.000001 then exit;
  p.x:=(l1.c*l2.b-l2.c*l1.b)/d;
  p.y:=(l1.a*l2.c-l1.c*l2.a)/d;
  p.is:=true;
end;
procedure pointsInterSection(p1,p2,p3,p4:tPoint;l1,l2:tLine;var p:tPoint);
var minx,maxx,miny,maxy:double;
begin
  minx:=p1.x;if p2.x<minx then minx:=p2.x;
  if p3.x<minx then minx:=p3.x;if p4.x<minx then minx:=p4.x;
  miny:=p1.y;if p2.y<miny then miny:=p2.y;
  if p3.y<miny then miny:=p3.y;if p4.y<miny then miny:=p4.y;
  maxx:=p1.x;if p2.x>maxx then maxx:=p2.x;
  if p3.x>maxx then maxx:=p3.x;if p4.x>maxx then maxx:=p4.x;
  maxy:=p1.y;if p2.y>maxy then maxy:=p2.y;
  if p3.y>maxy then maxy:=p3.y;if p4.y>maxy then maxy:=p4.y;
  linesInterSection(l1,l2,p);
  if p.x>maxx+0.000001 then p.is:=false;
  if p.x<minx-0.000001 then p.is:=false;
  if p.y>maxy+0.000001 then p.is:=false;
  if p.y<miny-0.000001 then p.is:=false;
end;
function trS2(x1,y1,x2,y2,x3,y3:double):double;
begin
  trS2:=abs((y1+y2)*(x2-x1)+(y2+y3)*(x3-x2)+(y3+y1)*(x1-x3));
end;
function ptInTr(x,y:double;n:integer):boolean;
begin
  if abs(
    trs2(tr[n,1].x,tr[n,1].y,tr[n,2].x,tr[n,2].y,tr[n,3].x,tr[n,3].y)-
    trs2(x,y,tr[n,2].x,tr[n,2].y,tr[n,3].x,tr[n,3].y)-
    trs2(tr[n,1].x,tr[n,1].y,x,y,tr[n,3].x,tr[n,3].y)-
    trs2(tr[n,1].x,tr[n,1].y,tr[n,2].x,tr[n,2].y,x,y)
    )<0.000001 then ptIntr:=true else ptIntr:=false;
end;
procedure preCompute;
var i,j:integer;
begin
  for j:=1 to n do
    for i:=1 to 3 do
      begin
        lineByPoints(tr[j,i],tr[j,(i mod 3)+1],lin[j,i]);
    end;
end;
procedure countInterSections;
var i,j,p,q:integer;
pt:tPoint;
begin
  for i:=1 to n do inters[i]:=0;
  for p:=1 to n do
    for q:=p+1 to n do
      for i:=1 to 3 do
        for j:=1 to 3 do
           begin
             pointsInterSection(tr[p,i],tr[p,(i mod 3) +1],tr[q,j],tr[q,(j mod 3)+1],lin[p,i],lin[q,j],pt);
             if pt.is then
               begin
                 inc(inters[p]);
                 inc(inters[q]);
               end;
           end;
end;
procedure qSort(l,r:integer);
var m:integer;i,j,k:integer;
tmpPt:tPoint;
tmpI:integer;
begin
  i:=l;j:=r;
  m:=inters[(l+r)div 2];
  repeat
    while inters[i]<m do inc(i);
    while inters[j]>m do dec(j);
    if i<=j then
      begin
        tmpI:=inters[i];inters[i]:=inters[j];inters[j]:=tmpI;
        for k:=1 to 3 do
          begin
            tmpPt:=tr[i,k];tr[i,k]:=tr[j,k];tr[j,k]:=tmpPt;
          end;
        inc(i);dec(j);
      end;
  until i>j;
  if j>l then qSort(l,j);
  if i<r then qSort(i,r);
end;
procedure checkTr(p,q:integer);
var i,j,k:integer;
p1,p2,p3,p4,pt:tPoint;
l1,l2:tline;
per:integer;
begin
  for i:=1 to 3 do
    begin
      if l1.is then
      for j:=1 to 3 do
        begin
          pointsInterSection(tr[p,i],tr[p,(i mod 3) +1],tr[q,j],tr[q,(j mod 3)+1],lin[p,i],lin[q,j],pt);
          per:=0;
          if pt.is then
            for k:=1 to n do
              begin
                if per+(n-k+1)<=best.n then break;
                if ptInTr(pt.x,pt.y,k) then inc(per);
              end;
          if per>best.n then
            begin
              best.n:=per;best.x:=pt.x;best.y:=pt.y;
            end;
        end;
    end;
end;
procedure checkPixelTr;
var i,j,k:integer;
pt:tpoint;
per:integer;
begin
  for i:=1 to n do
    for j:=1 to 3 do
      begin
        per:=0;
        pt:=tr[i,j];
        if pt.is then
          for k:=1 to n do
            begin
              if per+(n-k+1)<=best.n then break;
              if ptInTr(pt.x,pt.y,k) then inc(per);
            end;
        if per>best.n then
          begin
            best.n:=per;best.x:=pt.x;best.y:=pt.y;
          end;
      end;
end;
begin
  endTime:=now+1/(30*360);
  assign(fin,'INPUT.TXT');
  reset(fin);
  read(fin,n);
  for i:=1 to n do
    for j:=1 to 3 do
      begin
        read(fin,tr[i,j].x,tr[i,j].y);tr[i,j].is:=true;
      end;
  close(fin);
  best.n:=0;

  precompute;
  countInterSections;
  qSort(1,n);
  checkPixelTr;
  for i:=1 to n do
    begin
      if now>endTime then break;
      for j:=i+1 to n do checktr(i,j);
    end;
  assign(fout,'OUTPUT.TXT');
  rewrite(fout);
{  writeln(best.n);}
  writeln(fout,best.x:5:5,' ',best.y:5:5);
  close(fout);
end.