#include <stdio.h>

int N;
int L;
int K[1005];
int IsSol;

int S[205];
int H;

struct Number
{
  int L;
  int N[100];
} D[102][102], R;

void Null(Number &x)
{
  x.L = 0;
  for (int i = 0; i < 100; i++) x.N[i] = 0;
}

void Copy(Number &x, Number &y)
{
  x.L = y.L;
  for (int i = 0; i < 100; i++) x.N[i] = y.N[i];
}

int IsNull(Number &x)
{
  while(x.L > 0 && x.N[x.L-1] == 0) x.L--;
  return x.L == 0;
}

void Subst(Number &x, Number &y)
{
  int i, r = 0;
  for (i = 0; i < y.L; i++)
  {
    x.N[i] -= y.N[i] + r;
    if (x.N[i] < 0) {x.N[i] += 10; r = 1;}
    else r = 0;
  }
  while(r)
  {
    x.N[i]--;
    if (x.N[i] < 0) {x.N[i] += 10; r = 1;}
    else r = 0;
  }
  IsNull(x);
}

void AddMult(Number &r, Number &x, Number &y)
{
  int i, j;
  if (IsNull(x)) return;
  if (IsNull(y)) return;
  if (r.L < x.L + y.L - 1) r.L = x.L + y.L - 1;
  for (i = 0; i < x.L; i++)
  {
    for (j = 0; j < y.L; j++)
    {
      r.N[i+j] += x.N[i] * y.N[j];
      r.N[i+j+1] += r.N[i+j]/10;
      r.N[i+j] %= 10;
    }
    while(r.N[i+j] >= 10)
    {
      r.N[i+j+1] += r.N[i+j]/10;
      r.N[i+j] %= 10;
      j++;
    }
    if (r.N[i+j] && r.L <= i + j + 2) r.L = i + j + 2;
  }
}

void input()
{
  int i, j, ch;
  FILE *f = fopen("INPUT.TXT", "rt");
  fscanf(f, "%d", &N);
  do ch = fgetc(f); while(ch == ' ' || ch == '\n' || ch == '\t');
  L = 0;
  while(ch >= '0' && ch <= '9')
  {
    K[L++] = ch - '0';
    ch = fgetc(f);
  }
  for (i = 0, j = L-1; i < j; i++, j--)
  {
    ch = K[i];
    K[i] = K[j];
    K[j] = ch;
  }
  fclose(f);
}

void output()
{
  FILE *f = fopen("OUTPUT.TXT", "wt");
  if (IsSol)
  {
    int i;
    for (i = 0; i < 2*N; i++)
    {
      if (S[i]) fprintf(f, ")");
      else fprintf(f, "(");
    }
  }
  else fprintf(f, "No solution for this testcase.");
  fclose(f);
}

int main()
{
  int i, j, k;
  input();
  for (i = 0; i <= 100; i++) for (j = 0; j <= 100; j++) Null(D[i][j]);
  D[0][0].L = 1; D[0][0].N[0] = 1;
  for (i = 1; i <= N; i++)
  {
    for (j = 0; j < i; j++) AddMult(D[0][i], D[0][j], D[0][i - j - 1]);
    Copy(D[1][i], D[0][i]);
    for (j = 2; j <= i; j++)
    {
      Copy(D[j][i], D[j-1][i]);
      Subst(D[j][i], D[j-2][i-1]);
    }
  }
  while(L > 0 && K[L-1] == 0) L--;
  IsNull(D[0][N]);
  if (L < D[0][N].L) IsSol = 1;
  else if (L == D[0][N].L)
  {
    for (i = L - 1; i >= 0 && K[i] == D[0][N].N[i]; i--);
    if (i < 0) IsSol = 1;
    else if (K[i] < D[0][N].N[i]) IsSol = 1;
    else IsSol = 0;
  }
  else IsSol = 0;
  Null(R);
  R.L = L;
  for (i = 0; i < L; i++) R.N[i] = K[i];
  H = 0;
  for (k = 0; k < 2*N; k++)
  {
    if (H == 0) S[k] = 0;
    else
    {
      int u = H + 1, v = N - (k - H) / 2;
      IsNull(R);
      if (R.L < D[u][v].L) S[k] = 0;
      else if (R.L == D[u][v].L)
      {
        for (i = R.L - 1; i >= 0 && R.N[i] == D[u][v].N[i]; i--);
        if (i < 0) S[k] = 0;
        else if (R.N[i] < D[u][v].N[i]) S[k] = 0;
        else S[k] = 1;
      }
      else S[k] = 1;
      if (S[k])
      {
        Subst(R, D[u][v]);
      }
    }
    if (S[k]) H--; else H++;
  }
  output();
  return 0;
}
