#define LEN							16
#define MAX							128

#include <stdio.h>
#include <string.h>


void input ();
void solve ();
void output ();
void init (int * l, int n);
void add (int * a, int * b);
void sub (int * a, int * b);
int less (int * a, int * b);
void shift (int * a, int n);
void write (FILE * file, int * a);

int n, answer = 1, ptr = 0, k [1024], table [MAX] [MAX + MAX] [LEN];


main ()
 {
 	input ();

   if (answer)
    solve ();
    
   output ();
   
   return (0);
 }


void input ()
 {
 	FILE * file = fopen ("INPUT.TXT", "r");
   fscanf (file, "%d\n", & n);

   char chr = fgetc (file);
   init (k, 0);
   
   while ((chr >= '0') && (chr <= '9'))
    {
      shift (k, chr - '0');
      chr = fgetc (file);
      
      if (ptr ++ > 70)
       answer = 0;
    }
   
   fclose (file);
 }

 
void solve ()
 {
   init (table [0] [0], 1);
   init (table [0] [1], 1);

   for (int i = 2; i < MAX; i ++)
    init (table [0] [i], 0);

   for (int i = 1; i <= n; i ++)
    {
    	memcpy (table [i] [0], table [i - 1] [1], LEN << 2);

      for (int j = 2; j <= n; j += 2)
       {
	    	memcpy (table [i] [j], table [i - 1] [j - 1], LEN << 2);
         add (table [i] [j], table [i - 1] [j + 1]);
       }
       
      for (int j = 1; j <= n; j += 2)
       {
	    	memcpy (table [i] [j], table [i] [j - 1], LEN << 2);
         add (table [i] [j], table [i] [j + 1]);
       }
    }
 }

 
void output ()
 {
   int i = n, j = 0;

   FILE * file = fopen ("OUTPUT.TXT", "w");

   if ((! answer) || less (table [n] [0], k))
    fprintf (file, "No solution for this testcase.");
   else
    {
      while (i + j)
	    {
         if (j % 2)
          {
	   	   if (less (table [i] [j + 1], k))
   	       {
      	      sub (k, table [i] [j + 1]);
         	   fprintf (file, ")"); j --;
	          }
   	      else fprintf (file, "("), j ++;
          }
         else
          {
	   	   if (less (table [i - 1] [j + 1], k))
   	       {
      	      sub (k, table [i - 1] [j + 1]);
         	   fprintf (file, ")"); j --;
	          }
   	      else fprintf (file, "("), j ++;

            i --;
          }
	    }
    }
    
   fclose (file);
 }
 

void init (int * l, int n)
 {
 	memset (l, 0, LEN << 2);
   l [0] = n;
 }

 
void add (int * a, int * b)
 {
   int c = 0;

   for (int i = 0; i < LEN; i ++)
    {
    	c += a [i] + b [i];
      a [i] = c % 100000000;
      c /= 100000000;
    }
 }

 
void sub (int * a, int * b)
 {
   int c = 0;

   for (int i = 0; i < LEN; i ++)
    {
    	c += a [i] - b [i];
      a [i] = (100000000 + c) % 100000000;
      
      if (c < 0)
       {
         c /= 100000000;
         c --;
       }
      else c /= 100000000;
    }
 }

 
int less (int * a, int * b)
 {
 	for (int i = LEN - 1; i >= 0; i --)
    {
     if (a [i] < b [i]) return (1);
     if (a [i] > b [i]) return (0);
    }

   return (0);
 }


void shift (int * a, int n)
 {
   int c = 0;
   
   for (int i = 0; i < LEN; i ++)
    {
    	c += a [i] * 10;
      a [i] = c % 100000000;
      c /= 100000000;
    }

   a [0] += n;
 }



void write (FILE * file, int * a)
 {
   int flag = 0;
   
   for (int i = LEN - 1; i >= 0; i --)
    if (flag)
     fprintf (file, "%06d", a [i]);
    else if (a [i] || (i == 0))
     {
       fprintf (file, "%d", a [i]);
       flag = 1;
     }
 }

