{$I-,Q-,R-,S-,V-,X-}
Program BlackAndWhiteGraph;
Const
  InFile='INPUT.TXT';
  OutFile='OUTPUT.TXT';
  MaxN=502;
  MaxM=10002;
  _White=1;
  _Black=2;
  _Gray=3;
Type
  TPartArr=Array[1..MaxN]Of Word;
Var
  N,M:LongInt;
  Edge:Array[1..MaxM]Of Record A,B:Word; Color:Byte; End;
  Taken:Array[1..MaxM]Of Boolean;
  CurColor:LongInt;
  Part,Tmp:TPartArr;
  NTaken:LongInt;
  IsSol:Boolean;
Procedure Load;
Var
  I:LongInt;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N,M);
  For I:=1 To M Do
    If Not SeekEOF Then Read(Edge[I].A,Edge[I].B,Edge[I].Color);
  Close(Input);
End;
Procedure BasicTree;
Var
  I,J:LongInt;
Begin
  For I:=1 To M Do If Edge[I].Color=CurColor Then
    If Part[Edge[I].A]<>Part[Edge[I].B] Then Begin
      For J:=1 To N Do If (J<>Edge[I].B) And (Part[J]=Part[Edge[I].B]) Then Part[J]:=Part[Edge[I].A];
      Part[Edge[I].B]:=Part[Edge[I].A];
      Inc(NTaken);
      Taken[I]:=True;
    End;
End;
Function AllTheSamePart:Boolean;
Var
  I:LongInt;
Begin
  AllTheSamePart:=False;
  For I:=2 To N Do If Part[I]<>Part[1] Then Exit;
  AllTheSamePart:=True;
End;
Procedure Solve;
Var
  I:LongInt;
Begin
  NTaken:=0;
  FillChar(Taken,SizeOf(Taken),False);
  IsSol:=True;
  CurColor:=_Gray;
  For I:=1 To N Do Part[I]:=I;
  BasicTree;
  Tmp:=Part;
  CurColor:=_White;
  BasicTree;
  If Not AllTheSamePart Then Begin IsSol:=False; Exit; End;
  Part:=Tmp;
  CurColor:=_Black;
  BasicTree;
  If Not AllTheSamePart Then Begin IsSol:=False; Exit; End;
End;
Procedure Save;
Var
  I:LongInt;
  First:Boolean;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  If IsSol Then Begin
    WriteLn(M-NTaken);
    First:=True;
    For I:=1 To M Do If Not Taken[I] Then Begin
      If First Then First:=False Else Write(' ');
      Write(I);
    End;
    WriteLn;
  End Else WriteLn(-1);
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
